/**
 * A misc item taken from Ruby and handed to the kobold.
 */
function DragonLocket() {
    // PRIVATE MEMBERS \\       var private = "test";
    var that = this;

    var itemName = "Dragon Locket";
    var itemDescription = `Small, gold-plated, heart-shaped container hanging off an ornate metal chain,
                            with a spring-loaded mechanism that allows it to open and close.
                            Has a pristine, beautifully painted picture of an anthromorphic black dragon inside.`;
    var baseValue = 150;

    // PRIVATE FUNCTIONS \\     function privateFunction(){}

    // PUBLIC MEMBERS \\        this.public = "test";

    // ITEM-REQUIRED item-enum for construction purposes.
    this.id = ItemEnum.DRAGONLOCKET;
    // ITEM-REQUIRED type-enum for tooltip purposes.
    this.type = ItemTypeEnum.MISC;

    // PUBLIC FUNCTIONS \\      this.publicFunction = function(){};

    /**
     * ITEM-REQUIRED function.
     * Builds and returns the name of this item.
     * @param {boolean} caps Whether or not the name should be capitalized.
     * @returns {string} The name of this item.
     */
    this.name = function (caps) {
        var toReturn = caps ? itemName : itemName.toLowerCase();
        return toReturn;
    };

    /**
     * ITEM-REQUIRED function.
     * Builds and returns the description of this item.
     * @returns {string} The description of this item.
     */
    this.description = function () {
        return itemDescription;
    };

    /**
     * ITEM-REQUIRED function.
     * Calculates and returns the price (= value) of this item.
     * @returns {int} The price of this pair of pants, in coins.
     */
    this.price = function () {
        return baseValue;
    };

    /**
     * ITEM-REQUIRED function.
     * Builds and returns a custom tooltip style for this item.
     * @returns {string} The custom style.
     */
    this.toolTipStyle = function () {
        return "width: 265px;";
    };

    /**
     * ITEM-REQUIRED function.
     * Loads this object from a type-stripped version thereof.
     * @param {FancyGlasses-stripped} misc A FancyGlasses object, stripped of private members and all functions.
     */
    this.load = function (misc) {

    };
}
