/**
 * Farmer's maid ending.
 * @param {FarmerMaidController} controller The Varanar, Afternoon Three controller.
 */
function FarmerMaidDrunkDeclineLick(controller) {
    // PRIVATE MEMBERS \\       var private = "test";
    var that = this;
    var ctrl = controller;

    var reqChoice = FarmerMaidDrunkDeclineDadChoice.LICK;
    var reqController = ctrl.death;

    // PRIVATE FUNCTIONS \\     function privateFunction(){}

    /**
     * Builds and returns the content of this section.
     * @returns {string} The content.
     */
    function buildContent() {
        var name = ctrl.misc.name();
        var broom = ctrl.drunk.get() === FarmerMaidDrunkChoice.DECLINE;
        var toReturn = `[p]
                            You're [b]not[/b] going back there!
                            He has [b]no[/b] right to keep you.
                            You're [b]free[/b], and darnit, you've [b]earned[/b] your freedom!
                            Especially considering all the [b]horrible[/b] things he did to you.
                            You hope you'll [b]never[/b] have to see him [b]ever[/b] again!
                        [/p]
                        [p]
                            Tears flow liberally from your eyes.
                            Your words spent, you turn around and begin to walk away.
                            But Falco reaches out and coarsely [b]grabs[/b] one of your arms!
                            "[color=yellow]You're not going anywhere, [b]slave[/b]![/color]"
                            He begins to tug you back towards the house.
                        [/p]
                        [p]
                            Mustering all the strength and courage left in your battered body,
                            you [b]push[/b] the eagle away from you, tearing your arm from his grasp.
                            Fearing for your very life, you begin to run away, into the adjacent farmland,
                            as fast as your ${broom ? `aching loins` : `pregnant belly`} will allow.
                            The avian doesn't even bother to give chase.
                            Instead, he lets out a sharp whistle.
                            Instantly, his dog comes running out of the house.
                        [/p]
                        [p]
                            The bird points your way, and the canine bolts after you.
                            You give it your all.
                            You really do.
                            You try your hardest, pushing your body to its very limits,
                            but you simply can't outrun a feral dog.
                            Not while ${broom ? `internally hurt` : `pregnant`}.
                        [/p]
                        [p]
                            Realizing your fate is sealed,
                            you simply stop running.
                            You wouldn't have made it much further anyway.
                            Standing still, you turn around, facing Falco and his pet barreling towards you.
                            You look straight into the eagle's eyes,
                            as the canine [b]leaps[/b] at you, tearing open your throat with its powerful jaws and sharp fangs.
                        [/p]
                        [p]
                            You fall down backwards, into the mud.
                            You can't breathe.
                            Blood squirts from your neck.
                            Your arms are too weary and weak to quench the intense flow.
                            Darkness envelops the corners of your eyes.
                            On the exact same spot where Romeo met his end, so too do you face your demise.
                            But you die knowing you were free, if only for a moment.
                            And that is better than living the rest of your life as a slave.
                        [/p]
                        [p]
                            [c]
                                [b]
                                    Lion end.
                                [/b]
                            [/c]
                        [/p]
                        [p]
                            [nl]
                            [small]
                                You have reached one of Kobold Adventure's irreversible endings.
                                Your actions have sealed the fate of ${name}.
                                This is where their storyline ends.
                                By saving the game, you can review your timeline using the aStory feature available via the menu.
                                If you wish to tempt fate once more, reload an earlier save, or start a new game and try again.
                                Remember: all things, both good and bad, must always come to an end.
                                The journey is as important as the destination is.
                                Is heaven worth going through hell for?
                            [/small]
                        [/p]`;

        return global.parser.parse(toReturn);
    }


    // PUBLIC MEMBERS \\        this.public = "test";
    this.id = arguments.callee.name;

    // PUBLIC FUNCTIONS \\      this.publicFunction = function(){};

    /**
     * Builds and returns this part.
     * @param {boolean} invisible If passed and true, will give the entire section a display:none style.
     */
    this.build = function (invisible) {
        if (reqController && ((reqChoice && reqController.get() !== reqChoice) || (!reqChoice && !reqController.continued()))) {
            return "";
        }

        var part = `<div id="${that.id}" ${invisible ? 'style="display:none;"' : ""}>`;
        part += buildContent();
        part += `</div>`;
        return part;
    };

    /**
     * Registers all the required button listeners for this part.
     */
    this.registerListeners = function () {

    };
}
