/**
 * Farmer's maid ending.
 * @param {FarmerMaidController} controller The Varanar, Afternoon Three controller.
 */
function FarmerMaidTooFar(controller) {
    // PRIVATE MEMBERS \\       var private = "test";
    var that = this;
    var ctrl = controller;

    var reqChoice = false;
    var reqController = ctrl.daily;
    var subController = ctrl.toofar;
    var changeController = false;

    var firstId = arguments.callee.name + "ButtonOne";
    var secondId = arguments.callee.name + "ButtonTwo";
    var thirdId = arguments.callee.name + "ButtonThree";

    var firstNext = new FarmerMaidTooFarRun(ctrl);
    var secondNext = new FarmerMaidTooFarTell(ctrl);
    var thirdNext = new FarmerMaidTooFarConfront(ctrl);

    var firstChoice = FarmerMaidTooFarChoice.RUN;
    var secondChoice = FarmerMaidTooFarChoice.TELL;
    var thirdChoice = FarmerMaidTooFarChoice.CONFRONT;

    // PRIVATE FUNCTIONS \\     function privateFunction(){}

    /**
     * Builds and returns the content of this section.
     * @returns {string} The content.
     */
    function buildContent() {
        var toReturn = `[p]
                            After the day that marks the end of your first year of servitude,
                            the relationship between Falco and Juliet rapidly deteriorates into outright physical abuse.
                            One fateful afternoon, you walk in on the bird repeatedly burying his knuckles into the human's side while pounding her from behind.
                            She [b]begs[/b] for him to stop, but he mercilessly continues to batter her kidneys,
                            his blows intensifying the closer he gets to reaching his end, his climax marked by his mother's screams of pain.
                        [/p]
                        [p]
                            The eagle seems to have taken a liking to punching the woman while fucking her.
                            An extra outlet for all of his built-up frustration and years of bottled emotions, you reckon.
                            But you're no psychiatrist.
                            You must have walked in on them during the first time Falco turned to violence,
                            or maybe he simply doesn't care enough to muffle her bawling anymore.
                            Either way, loud pained grunts and agonized shouts become a daily affair.
                            While they never really bothered to hide themselves from you,
                            now all you have to do is follow the screams to find them fucking.
                        [/p]
                        [p]
                            At first, the avian only hits Juliet during sex,
                            the human writing it off as a [i]heat of the moment[/i] thing.
                            You can tell that she [b]hates[/b] it, and desperately wants to tell him to cut it out,
                            but she's become too intimidated of her own son to stand up to him.
                            It's only a few scratches and bruises.
                            Nothing she can't take.
                            What kind of woman [i]wouldn't[/i] let her child punch her while raping her?
                            R-right?
                        [/p]
                        [p]
                            Falco usually focusses on abusing her body, but as days go by, his mother's face grows less and less off-limits.
                            It starts with a few rougher-than-usual backhand slaps, but quickly escalates to full-on face-punches.
                            Juliet often leaves their sadistic get-togethers with a bloodied nose,
                            and her eyesockets are almost permanently battered black and blue.
                            You wonder how her husband hasn't noticed yet.
                            Maybe he figures, somewhat correctly, that she's being beaten by her secret lover.
                            That she's getting her comeuppance for cheating on him.
                        [/p]
                        [p]
                            Half a month of violence later, you find the avian using the woman's bloated tits as punching bags,
                            pinning her to the wall while beating her lactating udders until they grow [b]purple[/b],
                            squeezing her neck shut to choke out any resistance.
                            The strangling's a rather recent development,
                            but you've never seen him do it outside of missionary-position fucking.
                        [/p]
                        [p]
                            He isn't even hurting her because it excites him.
                            Not anymore, at least.
                            Now he's just doing it to prove a point.
                            You have no idea [i]what[/i] that point may be,
                            but it's the only explanation you can come up with for why he's acting this way.
                        [/p]
                        [p] 
                            The day after that, the boy repeats the process,
                            only this time he [b]bashes[/b] his mother's pregnant belly instead of her aching breasts.
                            Juliet's pleas for [b]mercy[/b] are like daggers through your heart,
                            especially when she gurgles out for him to think of the baby.
                            From where you're standing, it looks like he's specifically [b]trying[/b] to get rid of the child.
                            You want to intervene, but you fear what might happen to [b]you[/b] should you do so.
                            Either way, the cruel treatment is quickly getting out of hand.
                            Things can't go on like this.
                        [/p]
                        [p]
                            The third day in a row of hate-filled clobbering, his mom's face is Falco's target.
                            He [b]pummels[/b] her visage, beating both of her eyes fully shut.
                            You watch in horror from the kitchen doorway as he proceeds to beat her from side to side,
                            throwing hooks and haymakers at her cheeks.
                            One of her teeth gets knocked out of her mouth, and then with a sickening [i]snap[/i],
                            the woman's nose bends out of place, the bone broken.
                        [/p]
                        [p]
                            Falco keeps hitting her, over and over and over again.
                            You fear he might not stop until she's [b]dead[/b].
                            You don't want Juliet to die.
                            Your conscience would never let you live it down.
                            It's not only her fault that things have gotten this bad, but [b]yours[/b] as well.
                            You should have intervened, or told Romeo about this entire ordeal [b]months[/b] ago.
                            You need to step in [b]now[/b], or else it'll be too late.
                        [/p]
                        [p]
                            On the other hand, with Falco occupied with his mother,
                            and the man of the house not around,
                            you [i]could[/i] try to make a run for it.
                            Your injuries [i]have[/i] healed nicely.
                            And Romeo'll be too heartbroken when he sees his wife's sorry state
                            -- if she'll even be alive by the time he gets home -- to come after you.
                        [/p]`;

        return global.parser.parse(toReturn);
    }

    /**
     * Builds and returns the choice button.
     */
    function buildFirstChoice() {
        var disabled = subController.has() ? "disabled" : "";
        var isSelected = subController.get() === firstChoice;
        var selected = isSelected ? "selected" : "";
        var button = `<button class="button inlinechoice ${selected}" id="${firstId}" ${disabled}>Run away</button>`;

        var tooltip = global.parser.parse(`Use the lack of attention to slip away from the house, and escape your duties.`);
        var popupContainer = global.ui.makeToolTip(button, tooltip, false, false, "width: 160px;");
        // Re-wrap with proper positioning.
        button = `<div class="inlinechoice">`;
        button += popupContainer;
        button += `</div>`;

        return button;
    }

    /**
     * Builds and returns the choice button.
     */
    function buildSecondChoice() {
        var disabled = subController.has() ? "disabled" : "";
        var isSelected = subController.get() === secondChoice;
        var selected = isSelected ? "selected" : "";
        var button = `<button class="button inlinechoice ${selected}" id="${secondId}" ${disabled}>Tell dad</button>`;

        var tooltip = global.parser.parse(`Inform the father of the family of his son's [i]wild[/i] behavior.`);
        var popupContainer = global.ui.makeToolTip(button, tooltip, false, false, "width: 160px;");
        // Re-wrap with proper positioning.
        button = `<div class="inlinechoice">`;
        button += popupContainer;
        button += `</div>`;

        return button;
    }

    /**
     * Builds and returns the choice button.
     */
    function buildThirdChoice() {
        var disabled = subController.has() ? "disabled" : "";
        var isSelected = subController.get() === thirdChoice;
        var selected = isSelected ? "selected" : "";
        var button = `<button class="button inlinechoice ${selected}" id="${thirdId}" ${disabled}>Confront him</button>`;

        var tooltip = global.parser.parse(`Get in between the kid and his mother.`);
        var popupContainer = global.ui.makeToolTip(button, tooltip, false, false, "width: 160px;");
        // Re-wrap with proper positioning.
        button = `<div class="inlinechoice">`;
        button += popupContainer;
        button += `</div>`;

        return button;
    }

    /**
     * Builds and returns the choice of this section.
     * @returns {string} The choice of this section.
     */
    function buildChoice() {
        var choice = `<div class="choicecontainer"><div class="inlinechoiceheader">You:</div>`;
        choice += buildFirstChoice();
        choice += `<hr class="inlinechoiceseparator">`;
        choice += buildSecondChoice();
        choice += `<hr class="inlinechoiceseparator">`;
        choice += buildThirdChoice();
        choice += `</div>`;
        return choice;
    }

    /**
     * Disables all three buttons.
     */
    function disableButtons() {
        var buttons = [$("#" + firstId), $("#" + secondId), $("#" + thirdId)];
        buttons.forEach(function (button) {
            button.unbind();
            button.attr("disabled", true);
        });
    }

    /**
     * Loads and displays the next part.
     * @param {object} part Which part to load.
     */
    function loadNextPart(part) {
        var built = part.build(true);
        global.ui.appendBeforeFinisher(built, global.ui.genericHeaderId);
        $("#" + part.id).fadeIn(400);
        part.registerListeners();
    }

    /**
     * Adds a listener to the button.
     */
    function registerFirstListener() {
        $("#" + firstId).click(function () {
            $(this).addClass("selected");
            disableButtons();
            subController.set(firstChoice);
            loadNextPart(firstNext);
        });
    }

    /**
     * Adds a listener to the button.
     */
    function registerSecondListener() {
        $("#" + secondId).click(function () {
            $(this).addClass("selected");
            disableButtons();
            subController.set(secondChoice);
            loadNextPart(secondNext);
        });
    }

    /**
     * Adds a listener to the button.
     */
    function registerThirdListener() {
        $("#" + thirdId).click(function () {
            $(this).addClass("selected");
            disableButtons();
            subController.set(thirdChoice);
            loadNextPart(thirdNext);
        });
    }

    // PUBLIC MEMBERS \\        this.public = "test";
    this.id = arguments.callee.name;

    // PUBLIC FUNCTIONS \\      this.publicFunction = function(){};

    /**
     * Builds and returns this part.
     * @param {boolean} invisible If passed and true, will give the entire section a display:none style.
     */
    this.build = function (invisible) {
        if (reqController && ((reqChoice && reqController.get() !== reqChoice) || (!reqChoice && !reqController.continued()))) {
            return "";
        }

        var part = `<div id="${that.id}" ${invisible ? 'style="display:none;"' : ""}>`;
        part += buildContent();
        part += (changeController && changeController.change()) || "";
        part += buildChoice();
        part += `</div>`;
        part += firstNext.build();
        part += secondNext.build();
        part += thirdNext.build();
        return part;
    };

    /**
     * Registers all the required button listeners for this part.
     */
    this.registerListeners = function () {
        if (reqController && ((reqChoice && reqController.get() !== reqChoice) || (!reqChoice && !reqController.continued()))) {
            return;
        }

        firstNext.registerListeners();
        secondNext.registerListeners();
        thirdNext.registerListeners();

        if (subController.has()) {
            return;
        }

        registerFirstListener();
        registerSecondListener();
        registerThirdListener();
    };
}

var FarmerMaidTooFarChoice = {
    RUN: 1,
    TELL: 2,
    CONFRONT: 3
};
