/**
 * Swim section of the forest river.
 * @param {ForestRiverController} controller The Forest, River controller.
 */
function ForestRiverSwim(controller) {
    // PRIVATE MEMBERS \\       var private = "test";
    var that = this;
    var ctrl = controller;

    var reqChoice = ForestRiverArrivalChoice.SWIM;
    var reqController = ctrl.arrival;
    var subController = ctrl.swim;
    var changeController = false;

    var firstId = arguments.callee.name + "ButtonOne";
    var secondId = arguments.callee.name + "ButtonTwo";

    var firstNext = new ForestRiverStrip(ctrl);
    var secondNext = new ForestRiverNoStrip(ctrl);

    var firstChoice = ForestRiverSwimChoice.STRIP;
    var secondChoice = ForestRiverSwimChoice.NOSTRIP;

    // PRIVATE FUNCTIONS \\     function privateFunction(){}

    /**
     * Builds and returns the content of this section.
     * @returns {string} The content.
     */
    function buildContent() {
        var male = ctrl.misc.dick();
        var loincloth = ctrl.misc.underwear();
        var loinclothTooltip = global.kobold.inventory.createItemWithTooltip(loincloth);
        var pants = ctrl.misc.pants();
        var pantsTooltip = global.kobold.inventory.createItemWithTooltip(pants);
        var bra = ctrl.misc.bra();
        var braTooltip = global.kobold.inventory.createItemWithTooltip(bra);
        var toReturn = `[p]
                            You're not going to risk crossing the bridge.
                            It's too dangerous, and you don't feel comfortable putting your life in the hands of a poorly-built,
                            rotten, ramshackle construct!
                            Your next best option is to swim across.
                            You know you can make it, and while you've gotten [b]plenty[/b] of [i]exercise[/i] these past few days,
                            it'll be [b]nice[/b] to practice swimming for a bit, instead of walking and running away and jumping and climbing and crawling all the time.
                        [/p]
                        [p]
                            You walk up to the edge of the water, and dip your claws into the river.
                            [b]Ice cold[/b], as expected.
                            It's not like you intend to [i]linger[/i] in it, and it'll certainly [i]feel[/i] a lot warmer while you're swimming.
                            You've swum across the river before.
                            Never during the winter, and never this [i]late[/i], but still.
                            You're certain you'll be fine.
                        [/p]
                        [p]
                            If you keep your
                            ${male ? loinclothTooltip : pantsTooltip + ` and ` + braTooltip} on, then ${male ? `it` : `they`}'ll get soaked.
                            The water'll roll off of your scales with ease, but even if you wring it out, your clothing tends to remain wet for a long time still.
                            Wearing garments damp with freezing water on an evening as chilly as this one, is just [b]asking[/b] for trouble.
                            You could get [b]sick[/b] or even [b]freeze[/b] to death, if you don't make it somewhere warm before long.
                        [/p]
                        [p]
                            Keeping your clothes on will also making swimming a teensy bit harder, although you doubt that'll be the straw that breaks the kobold's back.
                            Plus, your kind isn't so [i]strict[/i] on clothing.
                            Sure, [i]most[/i] of you wear some scarce apparel, but a lot of kobolds tend to run around [b]naked[/b].
                            If you leave your clothes here, it's likely you'll never see them again, but that's not necessarily a big deal.
                            For once in your life, you have enough gold to buy yourself a new attire!
                            Although you shouldn't get ahead of yourself.
                            You still have a debt to pay off, after all.
                        [/p]`;

        return global.parser.parse(toReturn);
    }

    /**
     * Builds and returns the choice button.
     */
    function buildFirstChoice() {
        var disabled = subController.has() ? "disabled" : "";
        var isSelected = subController.get() === firstChoice;
        var selected = isSelected ? "selected" : "";
        var button = `<button class="button inlinechoice ${selected}" id="${firstId}" ${disabled}>Strip</button>`;

        var tooltip = global.parser.parse(`Your clothing will make it harder to swim.`);
        var popupContainer = global.ui.makeToolTip(button, tooltip, false, false, "width: 165px;");
        // Re-wrap with proper positioning.
        button = `<div class="inlinechoice">`;
        button += popupContainer;
        button += `</div>`;

        return button;
    }

    /**
     * Builds and returns the choice button.
     */
    function buildSecondChoice() {
        var disabled = subController.has() ? "disabled" : "";
        var isSelected = subController.get() === secondChoice;
        var selected = isSelected ? "selected" : "";
        var button = `<button class="button inlinechoice ${selected}" id="${secondId}" ${disabled}>Don't strip</button>`;

        var tooltip = global.parser.parse(`Waste not, want not.`);
        var popupContainer = global.ui.makeToolTip(button, tooltip, false, false, "width: 150px;");
        // Re-wrap with proper positioning.
        button = `<div class="inlinechoice">`;
        button += popupContainer;
        button += `</div>`;

        return button;
    }

    /**
     * Builds and returns the choice of this section.
     * @returns {string} The choice of this section.
     */
    function buildChoice() {
        var choice = `<div class="choicecontainer"><div class="inlinechoiceheader">You:</div>`;
        choice += buildFirstChoice();
        choice += `<hr class="inlinechoiceseparator">`;
        choice += buildSecondChoice();
        choice += `</div>`;
        return choice;
    }

    /**
     * Disables all three buttons.
     */
    function disableButtons() {
        var buttons = [$("#" + firstId), $("#" + secondId)];
        buttons.forEach(function (button) {
            button.unbind();
            button.attr("disabled", true);
        });
    }

    /**
     * Loads and displays the next part.
     * @param {object} part Which part to load.
     */
    function loadNextPart(part) {
        var built = part.build(true);
        global.ui.appendBeforeFinisher(built, global.ui.genericHeaderId);
        $("#" + part.id).fadeIn(400);
        part.registerListeners();
    }

    /**
     * Adds a listener to the button.
     */
    function registerFirstListener() {
        $("#" + firstId).click(function () {
            $(this).addClass("selected");
            disableButtons();
            subController.set(firstChoice);
            loadNextPart(firstNext);
        });
    }

    /**
     * Adds a listener to the button.
     */
    function registerSecondListener() {
        $("#" + secondId).click(function () {
            $(this).addClass("selected");
            disableButtons();
            subController.set(secondChoice);
            loadNextPart(secondNext);
        });
    }

    // PUBLIC MEMBERS \\        this.public = "test";
    this.id = arguments.callee.name;

    // PUBLIC FUNCTIONS \\      this.publicFunction = function(){};

    /**
     * Builds and returns this part.
     * @param {boolean} invisible If passed and true, will give the entire section a display:none style.
     */
    this.build = function (invisible) {
        if (reqController && ((reqChoice && reqController.get() !== reqChoice) || (!reqChoice && !reqController.continued()))) {
            return "";
        }

        var part = `<div id="${that.id}" ${invisible ? 'style="display:none;"' : ""}>`;
        part += buildContent();
        part += (changeController && changeController.change()) || "";
        part += buildChoice();
        part += `</div>`;
        part += firstNext.build();
        part += secondNext.build();
        return part;
    };

    /**
     * Registers all the required button listeners for this part.
     */
    this.registerListeners = function () {
        if (reqController && ((reqChoice && reqController.get() !== reqChoice) || (!reqChoice && !reqController.continued()))) {
            return;
        }

        firstNext.registerListeners();
        secondNext.registerListeners();

        if (subController.has()) {
            return;
        }

        registerFirstListener();
        registerSecondListener();
    };
}

var ForestRiverSwimChoice = {
    STRIP: 1,
    NOSTRIP: 2
};
