/**
 * Swim section of the forest river.
 * @param {ForestRiverController} controller The Forest, River controller.
 */
function ForestRiverMouthBite(controller) {
    // PRIVATE MEMBERS \\       var private = "test";
    var that = this;
    var ctrl = controller;

    var reqChoice = ForestRiverHandsStruggleChoice.BITE;
    var reqController = ctrl.struggle;
    var changeController = ctrl.bite;

    var nextSceneReady = ctrl.nextSceneReady;
    var nextSceneName = ctrl.nextSceneName;
    var nextFolderName = ctrl.nextSceneName;

    var continueId = arguments.callee.name + "ButtonOne";

    // PRIVATE FUNCTIONS \\     function privateFunction(){}

    /**
     * Builds and returns the content of this section.
     * @returns {string} The content.
     */
    function buildContent() {
        global.kobold.history.shared.forestToVaranar.riverBite = true;
        global.kobold.history.shared.forestToVaranar.riverKnockedOut = true;
        var toReturn = `[p]
                            You aren't going to suck anything.
                            In fact, you're going to make it so Goliath won't be raping [b]anyone[/b] else in the future!
                            Although he can't see, you flash your teeth in a threatening, predatory display of [b]danger[/b].
                            Eager for you to get started, the human presses his massive length against your face, rubbing the uncut tip against your cheek.
                            And that's when you strike.
                        [/p]
                        [p]
                            With a low, underwater growl, you [b]snap[/b] your jaws open and shut, your teeth [b]digging[/b] into the side of Goliath's girth,
                            [b]ripping[/b] and [b]tearing[/b] the flesh, [b]carving off[/b] an entire [b]chunk[/b] of his dick, which you prompty spit out into the water.
                            The clear river runs red, the bandit's inflated cock holding a massive amount of blood.
                            He [b]screams[/b] out in pain.
                            His first response is to try to [b]drown[/b] you, pushing you deeper underwater, away from his member,
                            but the [b]extreme[/b] agony causes his grip to rapidly weaken.
                        [/p]
                        [p]
                            Mere seconds after you struck your blow, you manage to escape Goliath's hold,
                            wrestling yourself away from his weakened grasp, putting some distance between the two of you before resurfacing.
                            The human is clutching his groin, trying but failing to stop the bleeding, looking ever-more pale.
                            His friends have no idea what's going on.
                            They look totally [b]clueless[/b].
                        [/p]
                        [p]
                            [big]"[color=green][b]SHOOT IT![/b][/color]"[/big]
                        [/p]
                        [p]
                            That command is the last you ever hear of Goliath.
                            Soon after uttering those words, he limply falls face-first into the water, passed out due to immense agony and bloodloss.
                            Carried forth on a pool of his own diluted blood, the river currents take his unconscious body downstream.
                            A few final bubbles of air escaping his lungs make you think he won't survive the trip, unless he miraculously wakes up before drowning.
                        [/p]
                        [p]
                            But you have no time to celebrate your victory over the enormous human.
                            His friends are already preparing to strike.
                            Before you can even [b]think[/b] of a plan to get out of this,
                            the slingshot-wielding thug lets loose the heavy, pointed projectile in between the prongs of his weapon.
                            His sharp rock shoots through the air with a slight arc to it,
                            before impacting heavily against your cranium.
                            You hear a loud [b]crack[/b], and it doesn't take a sharp mind to realize that it wasn't the stone that broke.
                            Your brain shakes back and forth in your barely intact skull,
                            and your worn out body succumbs to unconsciousness.
                        [/p]`;

        return global.parser.parse(toReturn);
    }

    /**
     * Builds and returns the continue button.
     */
    function buildChoice() {
        var disabled = ctrl.continued();
        var choice = `<div class="choicecontainer">`;
        choice += `<button class="button bigbutton continuebutton" id="${continueId}" ${disabled ? "disabled" : ""}>`;
        choice += `Continue &gt;&gt`;
        choice += `</button>`;
        choice += `</div>`;
        return choice;
    }

    /**
     * Disables all three buttons.
     */
    function disableButtons() {
        var buttons = [$("#" + continueId)];
        buttons.forEach(function (button) {
            button.unbind();
            button.attr("disabled", true);
        });
    }

    /**
     * Loads and displays the next scene.
     * @param {string} sceneName Name of the scene to load.
     * @param {string} folder Folder of the scene to load.
     */
    function loadNextPart(sceneName, folder) {
        global.ui.fadeOutContent(function () {
            global.sceneEnd();
            global.sceneLoader.loadScene(sceneName, folder);
        });
    }

    /**
     * Adds a listener to the button.
     */
    function registerContinueListener() {
        $("#" + continueId).click(function () {
            $(this).addClass("selected");
            disableButtons();
            ctrl.continue();
            loadNextPart(nextSceneName, nextFolderName);
        });
    }

    // PUBLIC MEMBERS \\        this.public = "test";
    this.id = arguments.callee.name;

    // PUBLIC FUNCTIONS \\      this.publicFunction = function(){};

    /**
     * Builds and returns this part.
     * @param {boolean} invisible If passed and true, will give the entire section a display:none style.
     */
    this.build = function (invisible) {
        if (reqController && ((reqChoice && reqController.get() !== reqChoice) || (!reqChoice && !reqController.continued()))) {
            return "";
        }

        ctrl.bgm.stopLoop();
        global.ui.applyTheme("varanar_indoor_knockout");
        var part = `<div id="${that.id}" ${invisible ? 'style="display:none;"' : ""}>`;
        part += buildContent();
        part += (changeController && changeController.change()) || "";
        part += buildChoice();
        if (!nextSceneReady) {
            part += `<span class="todo">There is no content beyond this point.</span>`;
        }
        part += `</div>`;
        return part;
    };

    /**
     * Registers all the required button listeners for this part.
     */
    this.registerListeners = function () {
        if (reqController && ((reqChoice && reqController.get() !== reqChoice) || (!reqChoice && !reqController.continued()))) {
            return;
        }

        if (ctrl.continued()) {
            return;
        }

        if (nextSceneReady) {
            registerContinueListener();
        }
    };
}
