/**
 * Ruby section of Varanar, Afternoon Three.
 * @param {AfternoonThreeRubyController} controller The Varanar, Afternoon Three controller.
 */
function AfternoonThreeRubyMeanReturn(controller) {
    // PRIVATE MEMBERS \\       var private = "test";
    var that = this;
    var ctrl = controller;

    var reqChoice = AfternoonThreeRubyMeanSexChoice.RETURN;
    var reqController = ctrl.meanSex;
    var changeController = ctrl.meanReturn;

    var nextSceneReady = ctrl.nextSceneReady;
    var nextSceneName = ctrl.nextSceneName;
    var nextFolderName = ctrl.nextFolderName;

    var continueId = arguments.callee.name + "ButtonOne";

    // PRIVATE FUNCTIONS \\     function privateFunction(){}

    /**
     * Builds and returns the content of this section.
     * @returns {string} The content.
     */
    function buildContent() {
        global.kobold.history.shared.varanar.dayThree.afternoon.rubyLocket = true;
        var naked = ctrl.misc.nude();
        var dickt3 = global.kobold.history.shared.varanar.dayThree.afternoon.rubyDickt3;
        var t1 = global.kobold.history.shared.varanar.dayThree.afternoon.rubyt1;
        var t2 = global.kobold.history.shared.varanar.dayThree.afternoon.rubyt2;
        var t3 = global.kobold.history.shared.varanar.dayThree.afternoon.rubyt3;
        var toReturn = ``;

        if (t1 || t2) {
            toReturn += `
                        [p]
                            Alright, alright.
                            You suppose you at least owe her as much as returning her heirloom,
                            after ${dickt3 ? `[b]fucking[/b] the shit out of her like you did` : `sating your lust on her body`}.
                            But you're not going to spare her feelings by keeping up the facade that the trinket is hidden away somewhere.
                            Instead, you pull the locket from your coin pouch in plain view, and toss it down on her chest.
                            She stares at her with a shocked look on her face, flabbergasted by the fact that you [b]tricked[/b] her into putting out for you!
                            With a smug smirk on your face, you ${!naked ? `grab your clothes` : `turn around`} and exit the hovel,
                            leaving the woman lying ${dickt3 ? `in a puddle of your spunk` : `on the filthy mattress`}.
                        [/p]
                        [p]
                            Outside and out of view, you ${!naked ? `quickly redress` : `catch some relatively fresh air`}.
                            Through the various overhead obstructions and light-blocking fabrics,
                            you notice the sky is slowly turning dark, and the sun is starting to set.
                            The afternoon is turning into an early winter night.
                            It's time to leave the kobold district.
                            You head for the mercantile quarter,
                            hoping to find somewhere warm to spend the night,
                            or at least another bitchy dragoness to blackmail.
                        [/p]`;
        } else {
            toReturn += `
                        [p]
                            Well, since she asked nicely.
                            And you [i]do[/i] suppose you at least owe her as much as returning her heirloom,
                            after ${dickt3 ? `[b]fucking[/b] the shit out of her like you did` : `sating your lust on her body`}.
                            Then again, she enjoyed that every bit as much as you did.
                            Oh well.
                        [/p]
                        [p]
                            You wander towards a corner of the shack, and squat down, appearing to rummage through the dirt.
                            Quickly and covertly retrieving the locket from your coinpouch,
                            you dutifully toss it towards the dragoness.
                            She catches the trinket mid-air, and with that, the bargain is concluded.
                            ${!naked ? `You quickly collect your gear.` : ``}
                            Scared that she might see through your facade,
                            you say a quick goodbye, and exit the hovel.
                        [/p]
                        [p]
                            Outside and out of view, you ${!naked ? `quickly redress` : `catch some relatively fresh air`}.
                            Through the various overhead obstructions and light-blocking fabrics,
                            you notice the sky is slowly turning dark, and the sun is starting to set.
                            The afternoon is turning into an early winter night.
                            It's time to leave the kobold district.
                            You head for the mercantile quarter,
                            hoping to find somewhere warm to spend the night,
                            or at least another bitchy dragoness to blackmail.
                        [/p]`;
        }

        return global.parser.parse(toReturn);
    }

    /**
     * Builds and returns the continue button.
     */
    function buildChoice() {
        var disabled = ctrl.continued();
        var choice = `<div class="choicecontainer">`;
        choice += `<button class="button bigbutton continuebutton" id="${continueId}" ${disabled ? "disabled" : ""}>`;
        choice += `Continue &gt;&gt`;
        choice += `</button>`;
        choice += `</div>`;
        return choice;
    }

    /**
     * Disables all three buttons.
     */
    function disableButtons() {
        var buttons = [$("#" + continueId)];
        buttons.forEach(function (button) {
            button.unbind();
            button.attr("disabled", true);
        });
    }

    /**
     * Loads and displays the next scene.
     * @param {string} sceneName Name of the scene to load.
     * @param {string} folder Folder of the scene to load.
     */
    function loadNextPart(sceneName, folder) {
        global.ui.fadeOutContent(function () {
            global.sceneEnd();
            global.sceneLoader.loadScene(sceneName, folder);
        });
    }

    /**
     * Adds a listener to the button.
     */
    function registerContinueListener() {
        $("#" + continueId).click(function () {
            $(this).addClass("selected");
            disableButtons();
            ctrl.continue();
            loadNextPart(nextSceneName, nextFolderName);
        });
    }

    // PUBLIC MEMBERS \\        this.public = "test";
    this.id = arguments.callee.name;

    // PUBLIC FUNCTIONS \\      this.publicFunction = function(){};

    /**
     * Builds and returns this part.
     * @param {boolean} invisible If passed and true, will give the entire section a display:none style.
     */
    this.build = function (invisible) {
        if (reqController && ((reqChoice && reqController.get() !== reqChoice) || (!reqChoice && !reqController.continued()))) {
            return "";
        }

        var part = `<div id="${that.id}" ${invisible ? 'style="display:none;"' : ""}>`;
        part += buildContent();
        part += (changeController && changeController.change()) || "";
        part += buildChoice();
        if (!nextSceneReady) {
            part += `<span class="todo">There is no content beyond this point.</span>`;
        }
        part += `</div>`;
        return part;
    };

    /**
     * Registers all the required button listeners for this part.
     */
    this.registerListeners = function () {
        if (reqController && ((reqChoice && reqController.get() !== reqChoice) || (!reqChoice && !reqController.continued()))) {
            return;
        }

        if (ctrl.continued()) {
            return;
        }

        if (nextSceneReady) {
            registerContinueListener();
        }
    };
}


