/**
 * Ruby section of Varanar, Afternoon Three.
 * @param {AfternoonThreeRubyController} controller The Varanar, Afternoon Three controller.
 */
function AfternoonThreeRubyBodyNice(controller) {
    // PRIVATE MEMBERS \\       var private = "test";
    var that = this;
    var ctrl = controller;

    var reqChoice = AfternoonThreeRubyBodyChoice.NICE;
    var reqController = ctrl.body;
    var subController = ctrl.nice;
    var changeController = false;

    var firstId = arguments.callee.name + "ButtonOne";
    var secondId = arguments.callee.name + "ButtonTwo";

    var firstNext = new AfternoonThreeRubyNiceAsk(ctrl);
    var secondNext = new AfternoonThreeRubyNiceCaress(ctrl);

    var firstChoice = AfternoonThreeRubyBodyNiceChoice.ASK;
    var secondChoice = AfternoonThreeRubyBodyNiceChoice.CARESS;

    // PRIVATE FUNCTIONS \\     function privateFunction(){}

    /**
     * Builds and returns the content of this section.
     * @returns {string} The content.
     */
    function buildContent() {
        global.kobold.history.shared.varanar.dayThree.afternoon.rubyBodyNice = true;
        var t1 = global.kobold.history.shared.varanar.dayThree.afternoon.rubyt1;
        var t2 = global.kobold.history.shared.varanar.dayThree.afternoon.rubyt2;
        var t3 = global.kobold.history.shared.varanar.dayThree.afternoon.rubyt3;
        var toReturn = ``;

        if (t1) {
            toReturn += `
                        [p]
                            Seeing how [b]extremely[/b] reluctant the dragoness is, with all the [b]crying[/b] and [b]trembling[/b],
                            your heart finally starts to soften a little.
                            Sure, she's a huge [b]bitch[/b] that probably deserved all of the hardships you've put her through so far,
                            but now it looks like she might have actually learned her lesson.
                            While you [b]are[/b] still very much so intent on [b]fucking[/b] her,
                            you don't see any point in continuing to be excessively cruel.
                        [/p]
                        [p]
                            Outside, you could barely notice, but while in a room with her,
                            you become aware that the lady has a distinct, cherry-like [i]fragrance[/i] lingering about her.
                            You're not sure if it's some sort of perfume, or a [i]natural[/i] thing.
                            Whatever it is, you like it.
                        [/p]
                        [p]
                            You grip her hand more firmly, while simultaneously pressing your other palm on the outside of her thigh,
                            gently rubbing up and down the side of her chubby frame.
                            She shivers in disgust.
                            "[color=cyan]Y-you filthy urchin! How [b]dare[/b] you make me go through this?![/color]"
                            You're starting to remember why you were mean to her to begin with.
                            Maybe you'll need to find a middle ground between being nice and being mean if you're going to bed the woman.
                        [/p]`;
        } else if (t2) {
            toReturn += `
                        [p]
                            You sort of [i]sympathize[/i] with the poor dragoness.
                            You can easily imagine yourself on her side of this [i]bargain[/i].
                            She's in a place she doesn't know too much about, about to lift her tail for a kobold she barely knows,
                            in return for something that was stolen from her.
                            Such an unlucky girl.
                            You shouldn't be too hard on her.
                        [/p]
                        [p]
                            Outside, you could barely notice, but while in a room with her,
                            you become aware that the lady has a distinct, cherry-like [i]fragrance[/i] lingering about her.
                            You're not sure if it's some sort of perfume, or a [i]natural[/i] thing.
                            Whatever it is, you like it.
                        [/p]
                        [p]
                            You grip her hand more firmly, while simultaneously pressing your other palm on the outside of her thigh,
                            gently rubbing up and down the side of her chubby frame.
                            She shivers in embarrassment.
                            "[color=cyan]T-this is so wrong... and with a [b]kobold[/b], too.[/color]"
                            Looks like you'll need to warm her up a bit to the idea of having sex with, well, with [b]you[/b].
                        [/p]`;
        } else {
            toReturn += `
                        [p]
                            Nah, you're probably just imagining things.
                            She's a princess. You have to treat her kindly.
                            Being mean would only serve to drive a wedge between the two of you.
                            Outside, you could barely notice, but while in a room with her,
                            you become aware that the lady has a distinct, cherry-like [i]fragrance[/i] lingering about her.
                            You're not sure if it's some sort of perfume, or a [i]natural[/i] thing.
                            Whatever it is, you like it.
                        [/p]
                        [p]
                            You grip her hand more firmly, while simultaneously pressing your other palm on the outside of her thigh,
                            gently rubbing up and down the side of her chubby frame.
                            She shivers in anticipation.
                            "[color=cyan]I hope you're as good in bed as you are at smooth-talking.[/color]"
                            You assure her that your tongue is good at [b]a lot[/b] of things.
                        [/p]`;
        }
        
        return global.parser.parse(toReturn);
    }

    /**
     * Builds and returns the choice button.
     */
    function buildFirstChoice() {
        var disabled = subController.has() ? "disabled" : "";
        var isSelected = subController.get() === firstChoice;
        var selected = isSelected ? "selected" : "";
        var button = `<button class="button inlinechoice ${selected}" id="${firstId}" ${disabled}>Ask</button>`;

        var tooltip = global.parser.parse(`Ask her to take off her clothes.`);
        var popupContainer = global.ui.makeToolTip(button, tooltip, false, false, "width: 140px;");
        // Re-wrap with proper positioning.
        button = `<div class="inlinechoice">`;
        button += popupContainer;
        button += `</div>`;

        return button;
    }

    /**
     * Builds and returns the choice button.
     */
    function buildSecondChoice() {
        var disabled = subController.has() ? "disabled" : "";
        var isSelected = subController.get() === secondChoice;
        var selected = isSelected ? "selected" : "";
        var button = `<button class="button inlinechoice ${selected}" id="${secondId}" ${disabled}>Help</button>`;

        var tooltip = global.parser.parse(`Caress her and help her get undressed.`);
        var popupContainer = global.ui.makeToolTip(button, tooltip, false, false, "width: 155px;");
        // Re-wrap with proper positioning.
        button = `<div class="inlinechoice">`;
        button += popupContainer;
        button += `</div>`;

        return button;
    }

    /**
     * Builds and returns the choice of this section.
     * @returns {string} The choice of this section.
     */
    function buildChoice() {
        var choice = `<div class="choicecontainer"><div class="inlinechoiceheader">You:</div>`;
        choice += buildFirstChoice();
        choice += `<hr class="inlinechoiceseparator">`;
        choice += buildSecondChoice();
        choice += `</div>`;
        return choice;
    }

    /**
     * Disables all three buttons.
     */
    function disableButtons() {
        var buttons = [$("#" + firstId), $("#" + secondId)];
        buttons.forEach(function (button) {
            button.unbind();
            button.attr("disabled", true);
        });
    }

    /**
     * Loads and displays the next part.
     * @param {object} part Which part to load.
     */
    function loadNextPart(part) {
        var built = part.build(true);
        global.ui.appendBeforeFinisher(built, global.ui.genericHeaderId);
        $("#" + part.id).fadeIn(400);
        part.registerListeners();
    }

    /**
     * Adds a listener to the button.
     */
    function registerFirstListener() {
        $("#" + firstId).click(function () {
            $(this).addClass("selected");
            disableButtons();
            subController.set(firstChoice);
            loadNextPart(firstNext);
        });
    }

    /**
     * Adds a listener to the button.
     */
    function registerSecondListener() {
        $("#" + secondId).click(function () {
            $(this).addClass("selected");
            disableButtons();
            subController.set(secondChoice);
            loadNextPart(secondNext);
        });
    }

    // PUBLIC MEMBERS \\        this.public = "test";
    this.id = arguments.callee.name;

    // PUBLIC FUNCTIONS \\      this.publicFunction = function(){};

    /**
     * Builds and returns this part.
     * @param {boolean} invisible If passed and true, will give the entire section a display:none style.
     */
    this.build = function (invisible) {
        if (reqController && ((reqChoice && reqController.get() !== reqChoice) || (!reqChoice && !reqController.continued()))) {
            return "";
        }

        var part = `<div id="${that.id}" ${invisible ? 'style="display:none;"' : ""}>`;
        part += buildContent();
        part += (changeController && changeController.change()) || "";
        part += buildChoice();
        part += `</div>`;
        part += firstNext.build();
        part += secondNext.build();
        return part;
    };

    /**
     * Registers all the required button listeners for this part.
     */
    this.registerListeners = function () {
        if (reqController && ((reqChoice && reqController.get() !== reqChoice) || (!reqChoice && !reqController.continued()))) {
            return;
        }

        firstNext.registerListeners();
        secondNext.registerListeners();

        if (subController.has()) {
            return;
        }

        registerFirstListener();
        registerSecondListener();
    };
}

var AfternoonThreeRubyBodyNiceChoice = {
    ASK: 1,
    CARESS: 2
};
