/**
 * Ruby section of Varanar, Afternoon Three.
 * @param {AfternoonThreeRubyController} controller The Varanar, Afternoon Three controller.
 */
function AfternoonThreeRubyKind(controller) {
    // PRIVATE MEMBERS \\       var private = "test";
    var that = this;
    var ctrl = controller;

    var reqChoice = AfternoonThreeRubyBargainChoice.WORDS;
    var reqController = ctrl.bargain;
    var subController = ctrl.kind;
    var changeController = ctrl.kind;

    var firstId = arguments.callee.name + "ButtonOne";
    var secondId = arguments.callee.name + "ButtonTwo";

    var firstNext = new AfternoonThreeRubyKindReturn(ctrl);
    var secondNext = new AfternoonThreeRubyKindMore(ctrl);

    var firstChoice = AfternoonThreeRubyKindChoice.RETURN;
    var secondChoice = AfternoonThreeRubyKindChoice.MORE;

    // PRIVATE FUNCTIONS \\     function privateFunction(){}

    /**
     * Builds and returns the content of this section.
     * @returns {string} The content.
     */
    function buildContent() {
        global.kobold.history.shared.varanar.dayThree.afternoon.rubyKindWords = true;
        var t1 = global.kobold.history.shared.varanar.dayThree.afternoon.rubyt1;
        var t2 = global.kobold.history.shared.varanar.dayThree.afternoon.rubyt2;
        var t3 = global.kobold.history.shared.varanar.dayThree.afternoon.rubyt3;
        var toReturn = ``;

        if (t1) {
            toReturn += `
                        [p]
                            You kind of [i]regret[/i] not having handed the dragoness the locket straight away.
                            That walk through the streets was [b]humiliating[/b].
                            Kobolds were staring at you.
                            And the worst thing about it is that the lady is entirely [b]oblivious[/b] to how much she was pissing everyone off.
                            It's time to teach her some manners.
                            And you'll start by forcing her to be [b]polite[/b], for once.
                        [/p]
                        [p]
                            Your resolve steeled, you turn to face the dragoness.
                            "[color=cyan]Well? It's [b]rude[/b] to keep a lady waiting.[/color]"
                            A slight, mischievous grin forms on your face.
                            You'll gladly go get the package for her.
                            All she has to do is say the [i]magic word[/i].
                            "[color=cyan]Magic word?![/color]" she bellows out.
                            "[color=cyan]What do I look like you, some kind of witch?!
                            I should have you [b]hanged[/b] for that remark![/color]"
                        [/p]
                        [p]
                            You groan as the woman begins to hurl a tirade of insults your way.
                            Is she really [b]this[/b] dense?
                            Is simple politeness such a foreign concept to her?
                            You cut her off mid-rant, by revealing that the word you wanted her to say was quite simple.
                            [i]Please[/i].
                            You want her to say [b]please[/b].
                            Does she think she can manage that, or will she find someone else willing to take orders and abuse?
                        [/p]
                        [p]
                            "[color=cyan]Oh.[/color]"
                            Her angry visage instantly turns a bit more [i]understanding[/i],
                            a little frightened even when you threaten to leave her by herself.
                            "[color=cyan]No!
                            You're not going [b]anywhere[/b] until you fetch my locket.
                            Fine.
                            I'll say it.[/color]"
                        [/p]
                        [p]
                            "[color=cyan]P-p-puh...[/color]" she stammers, struggling with the indignation of indulging a kobold's wishes.
                            Your turn to hound her a bit.
                            You impishly mention that you [i]don't have all day[/i].
                            "[color=cyan][b]I'm getting there![/b]
                            Give me a minute, you [b]cruel monster[/b].[/color]"
                            You chuckle ever so slightly.
                            You could get used to bullying dragonesses.
                        [/p]
                        [p]
                            The woman bites her lower lip, her eyes tearing up once more.
                            Then, finally, the one thing you wanted to hear is uttered:
                            "[color=cyan]Puh-leeeease?[/color]"
                            You barely refrain from laughing in her face,
                            your devilish smirk revealing your sadistic enjoyment.
                            Do you go fetch the locket, or do you continue to pester her?
                        [/p]`;
        } else if (t2) {
            toReturn += `
                        [p]
                            The dragoness is kind of [b]mean[/b].
                            While somewhat [i]tolerable[/i] when speaking to you,
                            it is [b]very[/b] clear that you are the [b]exception[/b], and not the rule.
                            She constantly berates and belittles kobolds as a whole.
                            And you don't think that's very appropriate.
                            It's time to teach her some manners.
                            And you start by asking her for the [b]magic word[/b].
                        [/p]
                        [p]
                            "[color=cyan]The magic...?[/color]" the lady stammers out, not quite understanding you at first.
                            Then, she suddenly realizes what you're asking of her.
                            "[color=cyan]Are you [b]serious[/b]?[/color]"
                            She thinks you're playing a joke or a prank on her.
                            But you resolutely shake your head yes.
                            You're dead-serious.
                        [/p]
                        [p]
                            The woman's face slowly sours.
                            "[color=cyan]How [b]dare[/b] you ask that of me?!
                            I should fetch the guards and have them throw you into the [b]dungeon[/b]![/color]"
                            You mention that she'll have a hard time finding city guards in the kobold district.
                            And hey, you're not [b]forcing[/b] her to do anything.
                            If she doesn't want to say it, then she can go into the hovel to reclaim her locket herself.
                        [/p]
                        [p]
                            The dragoness grumbles loudly.
                            You both know she's not going in there herself.
                            That leaves only one option.
                            And while it takes almost an entire minute,
                            her visage slowly transitions from a hateful glare to a reluctant, [b]defeated[/b] look.
                            "[color=cyan]Fine.[/color]" she speaks, breaking the tense silence.
                            "[color=cyan]Will you [b]please[/b] fetch my locket for me?[/color]"
                        [/p]`;
        } else {
            toReturn += `
                        [p]
                            While she was a little upset at first, the dragoness has been nothing but [b]nice[/b] to you.
                            Asking her for money or [i]other favors[/i] would be downright [b]rude[/b].
                            No, no.
                            An aspiring knight like yourself needs no monetary compensation.
                            All you need are some kind words to stroke your ego.
                        [/p]
                        [p]
                            But before you can even [b]ask[/b] the dragoness to ask [i]nicely[/i], she does so of her own volition!
                            "[color=cyan]Please, oh kind kobold?
                            Could you do this for me?[/color]"
                            Kind kobold?
                            You like the sound of that.
                            You like the sound of that [b]a lot[/b].
                            Especially coming from a dragoness.
                            A dragoness who claims to be a [b]princess[/b] nonetheless!
                        [/p]
                        [p]
                            Her praising words lift your spirit.
                            Should you ask for more, or will you go fetch the locket for her?
                        [/p]`;
        }

        return global.parser.parse(toReturn);
    }

    /**
     * Builds and returns the choice button.
     */
    function buildFirstChoice() {
        var disabled = subController.has() ? "disabled" : "";
        var isSelected = subController.get() === firstChoice;
        var selected = isSelected ? "selected" : "";
        var button = `<button class="button inlinechoice ${selected}" id="${firstId}" ${disabled}>Fetch it</button>`;

        var tooltip = global.parser.parse(`She's held up her part of the deal. Time for you to honor yours.`);
        var popupContainer = global.ui.makeToolTip(button, tooltip, false, false, "width: 180px;");
        // Re-wrap with proper positioning.
        button = `<div class="inlinechoice">`;
        button += popupContainer;
        button += `</div>`;

        return button;
    }

    /**
     * Builds and returns the choice button.
     */
    function buildSecondChoice() {
        var disabled = subController.has() ? "disabled" : "";
        var isSelected = subController.get() === secondChoice;
        var selected = isSelected ? "selected" : "";
        var button = `<button class="button inlinechoice ${selected}" id="${secondId}" ${disabled} disabled>Ask for more</button>`;

        var tooltip = global.parser.parse(`Tell her to keep going. She can manage more than that. [todo]Unavailable[/todo]`);
        var popupContainer = global.ui.makeToolTip(button, tooltip, false, false, "width: 180px;");
        // Re-wrap with proper positioning.
        button = `<div class="inlinechoice">`;
        button += popupContainer;
        button += `</div>`;

        return button;
    }

    /**
     * Builds and returns the choice of this section.
     * @returns {string} The choice of this section.
     */
    function buildChoice() {
        var choice = `<div class="choicecontainer"><div class="inlinechoiceheader">You:</div>`;
        choice += buildFirstChoice();
        choice += `<hr class="inlinechoiceseparator">`;
        choice += buildSecondChoice();
        choice += `</div>`;
        return choice;
    }

    /**
     * Disables all three buttons.
     */
    function disableButtons() {
        var buttons = [$("#" + firstId), $("#" + secondId)];
        buttons.forEach(function (button) {
            button.unbind();
            button.attr("disabled", true);
        });
    }

    /**
     * Loads and displays the next part.
     * @param {object} part Which part to load.
     */
    function loadNextPart(part) {
        var built = part.build(true);
        global.ui.appendBeforeFinisher(built, global.ui.genericHeaderId);
        $("#" + part.id).fadeIn(400);
        part.registerListeners();
    }

    /**
     * Adds a listener to the button.
     */
    function registerFirstListener() {
        $("#" + firstId).click(function () {
            $(this).addClass("selected");
            disableButtons();
            subController.set(firstChoice);
            loadNextPart(firstNext);
        });
    }

    /**
     * Adds a listener to the button.
     */
    function registerSecondListener() {
        $("#" + secondId).click(function () {
            $(this).addClass("selected");
            disableButtons();
            subController.set(secondChoice);
            loadNextPart(secondNext);
        });
    }

    // PUBLIC MEMBERS \\        this.public = "test";
    this.id = arguments.callee.name;

    // PUBLIC FUNCTIONS \\      this.publicFunction = function(){};

    /**
     * Builds and returns this part.
     * @param {boolean} invisible If passed and true, will give the entire section a display:none style.
     */
    this.build = function (invisible) {
        if (reqController && ((reqChoice && reqController.get() !== reqChoice) || (!reqChoice && !reqController.continued()))) {
            return "";
        }

        global.ui.imageBackground.hide();
        var part = `<div id="${that.id}" ${invisible ? 'style="display:none;"' : ""}>`;
        part += buildContent();
        part += (changeController && changeController.change()) || "";
        part += buildChoice();
        part += `</div>`;
        part += firstNext.build();
        part += secondNext.build();
        return part;
    };

    /**
     * Registers all the required button listeners for this part.
     */
    this.registerListeners = function () {
        if (reqController && ((reqChoice && reqController.get() !== reqChoice) || (!reqChoice && !reqController.continued()))) {
            return;
        }

        firstNext.registerListeners();
        secondNext.registerListeners();

        if (subController.has()) {
            return;
        }

        registerFirstListener();
        registerSecondListener();
    };
}

var AfternoonThreeRubyKindChoice = {
    RETURN: 1,
    MORE: 2
};
