

// SCENE UndergroundCave

// scenes\HamletDay2\UndergroundCave\mirror\succeed\dominance\sub\UndergroundCaveReflectionGetFuckedContinue.js

/**
 * Reflect section of the Underground Cave.
 * @param {UndergroundCaveController} controller The Underground Cave controller.
 */
function UndergroundCaveReflectionGetFuckedContinue(controller) {
    // PRIVATE MEMBERS \\       var private = "test";
    var that = this;
    var ctrl = controller;

    var reqChoice = false;
    var reqController = ctrl.preContinue;
    var changeController = ctrl.reflectSubContinue;

    var continueId = arguments.callee.name + "ButtonOne";

    // PRIVATE FUNCTIONS \\     function privateFunction(){}

    /**
     * Builds and returns the content of this section.
     * @returns {string} The content.
     */
    function buildContent() {
        var toReturn = `[p]
                            With the basilisk slowly drifting to sleep in a puddle of your combined fluids,
                            you decide it's time to find a way out of the cave.
                            You may return here, one day, but for now you must leave.
                            You begin to follow the river-branch, hoping it'll lead you to some kind of exit.
                        [/p]
                        [p]
                            You leisurely stroll alongside the water, until daylight comes into sight.
                            As you expected: the water [b]was[/b] a stale branch of the river!
                            Climbing out of the cave, you sit your butt down on the riverside dirt, and take a breather.
                            You feel like you've earned one.
                        [/p]
                        [p]
                            You've defied death more than once today.
                            You should consider yourself lucky to be alive.
                            The trip into the well was a harrowing experience.
                            You nearly got crushed, almost drowned, and after all of that,
                            you managed to have the time of your life getting fucked by a basilisk.
                            You doubt a lot of people can claim to have had sex with a mythological being, and much less still lived to tell the tale.
                        [/p]
                        [p]
                            You've gained a few personal memories that you'll undoubtedly find yourself masturbating to later,
                            along with some awesome stories to tell once you've grown old and wise.
                            Stories like the ones Seki used to tell you when you were little.
                            You went through all that trouble to get your mind off of him, and here you are reminiscing once more.
                            You just can't help yourself from clinging to times long gone.
                            Things were so much simpler back then.
                            You miss those days.
                        [/p]
                        [p]
                            The sun is slowly starting to set.
                            You drag yourself to your feet.
                            It's time to go.
                            Varanar isn't [i]that[/i] far off.
                            If your legs don't give out from underneath you, you might still make it there before nightfall.
                        [/p]`;

        return global.parser.parse(toReturn);
    }

    /**
     * Builds and returns the continue button.
     */
    function buildChoice() {
        var disabled = ctrl.continued();
        var choice = `<div class="choicecontainer">`;
        choice += `<button class="button bigbutton continuebutton" id="${continueId}" ${disabled ? "disabled" : ""}>`;
        choice += `Continue &gt;&gt`;
        choice += `</button>`;
        choice += `</div>`;
        return choice;
    }

    /**
     * Disables all three buttons.
     */
    function disableButtons() {
        var buttons = [$("#" + continueId)];
        buttons.forEach(function (button) {
            button.unbind();
            button.attr("disabled", true);
        });
    }

    /**
     * Loads and displays the next scene.
     * @param {string} sceneName Name of the scene to load.
     * @param {string} folder Folder of the scene to load.
     */
    function loadNextPart(sceneName, folder) {
        global.ui.fadeOutContent(function () {
            global.sceneEnd();
            global.sceneLoader.loadScene(sceneName, folder);
        });
    }

    /**
     * Adds a listener to the button.
     */
    function registerContinueListener() {
        $("#" + continueId).click(function () {
            $(this).addClass("selected");
            disableButtons();
            ctrl.continue();
            loadNextPart(ctrl.nextSceneName, ctrl.nextFolderName);
        });
    }

    // PUBLIC MEMBERS \\        this.public = "test";
    this.id = arguments.callee.name;

    // PUBLIC FUNCTIONS \\      this.publicFunction = function(){};

    /**
     * Builds and returns this part.
     * @param {boolean} invisible If passed and true, will give the entire section a display:none style.
     */
    this.build = function (invisible) {
        if (reqController && ((reqChoice && reqController.get() !== reqChoice) || (!reqChoice && !reqController.continued()))) {
            return "";
        }

        ctrl.bgm.stopLoop();
        global.ui.applyTheme("hamlet_day");
        var part = `<div id="${that.id}" ${invisible ? 'style="display:none;"' : ""}>`;
        part += buildContent();
        part += (changeController && changeController.change()) || "";
        part += buildChoice();
        if (!ctrl.nextSceneReady) {
            part += `<span class="todo">There is no content beyond this point.</span>`;
        }
        part += `</div>`;
        return part;
    };

    /**
     * Registers all the required button listeners for this part.
     */
    this.registerListeners = function () {
        if (reqController && ((reqChoice && reqController.get() !== reqChoice) || (!reqChoice && !reqController.continued()))) {
            return;
        }

        if (ctrl.continued()) {
            return;
        }

        if (ctrl.nextSceneReady) {
            registerContinueListener();
        }
    };
}

// END scenes\HamletDay2\UndergroundCave\mirror\succeed\dominance\sub\UndergroundCaveReflectionGetFuckedContinue.js

// scenes\HamletDay2\UndergroundCave\mirror\succeed\dominance\sub\UndergroundCaveReflectionGetFuckedInside.js

/**
 * Reflect section of the Underground Cave.
 * @param {UndergroundCaveController} controller The Underground Cave controller.
 */
function UndergroundCaveReflectionGetFuckedInside(controller) {
    // PRIVATE MEMBERS \\       var private = "test";
    var that = this;
    var ctrl = controller;

    var reqChoice = UndergroundCaveReflectionGetFuckedChoice.INSIDE;
    var reqController = ctrl.reflectSub;
    var setChoice = false;
    var subController = ctrl.preContinue;
    var changeController = ctrl.reflectInside;

    var continueId = arguments.callee.name + "ButtonOne";
    var next = new UndergroundCaveReflectionGetFuckedContinue(ctrl);

    // PRIVATE FUNCTIONS \\     function privateFunction(){}

    /**
     * Builds and returns the content of this section.
     * @returns {string} The content.
     */
    function buildContent() {
        global.kobold.history.shared.well.basiliskRodeCameInside = true;
        var dick = ctrl.misc.dick();
        var shirt = ctrl.misc.shirt();
        var pants = ctrl.misc.pants();
        var undies = ctrl.misc.underwear();

        var toReturn = ``;

        if (dick) {
            var virgin = ctrl.misc.analVirgin();
            toReturn += `
                        [p]
                            You [b]need[/b] this to continue, to [b]want[/b] the basilisk to [b]fuck you silly[/b],
                            to [b]pound you[/b] until you can barely even [b]walk[/b] anymore!
                            Even though you've already reached your end, this is the best feeling you've [b]ever[/b] felt in your entire life.
                            You want it to last [b]forever[/b]!
                            And while you know it'll eventually [i]stop[/i],
                            you intend to ride out every single second of it as though it is your last!
                        [/p]
                        [p]
                            A split second later you can feel it starting to happen.
                            The basilisk's member [b]twitches[/b] and [b]convulses[/b] inside of your ass.
                            Its loud hissing turns into a low-pitched growl, and the first of many ropes of hot,
                            thick, sticky cum squirts from its beastly length,
                            your senses soothed with the feeling of being [b]filled up[/b],
                            your battered mind [b]overloading[/b] with the sheer [b]taboo[/b] of letting a feral finish inside of your rear.
                        [/p]
                        [p]
                            Your brain completely short-circuiting, you begin to wildly [b]ride[/b] the basilisk's shaft once more,
                            intent on squeezing every single [b]drop[/b] of spunk and pleasure that you possibly can from its exotic prick.
                            Your tongue lolls out of your mouth in the same way the beast's did,
                            its [b]mind-breaking[/b] climax seemingly lasting for [b]minutes[/b],
                            minutes of absolute [b]ecstacy[/b] for both you and it.
                        [/p]
                        [p]
                            You lose all track of time, direction, and being.
                            You black out, your mind and body utterly overwhelmed by the sheer amount of pleasure you're feeling.
                            When you come to your senses, you find yourself lying on top of the monster's soft scales,
                            your belly slightly bulging from the sheer amount of cum inside of you, despite a lot of it already having flooded out.
                            Even more heady spunk is squirting on top of your body, covering you from head to toe,
                            ${shirt ? `completely soaking your ${global.kobold.inventory.createItemWithTooltip(shirt)},` : ``}
                            the basilisk's unmatched orgasm only [b]now[/b] starting to fade.
                        [/p]
                        [p]
                            Completely exhausted, you find yourself resting for a while in the warm, comforting care of your new feral [b]lover[/b],
                            idly taking in massive amounts of animalistic male pheromones with every breath.
                            You can feel the basilisk's strong chest comfortingly heaving up and down below you.
                            It's contently [i]purring[/i], its needs thoroughly sated.
                            What a [b]good boy[/b].
                        [/p]
                        [p]
                            As much as you'd like to make this cave your new home, you're afraid you simply can't.
                            Not yet, anyway.
                            As the cum on your scales starts to cool,
                            and the rational part of your brain slowly starts to kick in,
                            you realize that you have places to be and things to do.
                            With a loud sigh, you reluctantly roll off of the big lizard, who lets out a distinctly sad whimper.
                        [/p]
                        [p]
                            Trying to rise to your feet, you discover just how sore the intense fucking has left your entire body.
                            You're certain it'll fade in due time, though.
                            Despite having a rough time reaching the cave, you can say with a smile on your face that it was all worth it.
                            You thank the basilisk, though you doubt it understands, and give a small kiss on its snout.
                            Then, ${pants || undies ? `you redress, and` : `you`} prepare to leave.
                        [/p]`;
            if (virgin) {
                toReturn += `[p][c][b]You are no longer a virgin.[/b][/c][/p]`;
            }
        } else {
            var virgin = ctrl.misc.cuntVirgin();
            toReturn += `
                        [p]
                            You don't care anymore.
                            You don't care if you get pregnant, if the beast [b]breeds[/b] you,
                            if it mates you with and plants its seed deep inside of your womb.
                            You [b]need[/b] this to continue, to [b]want[/b] the basilisk to [b]fuck you silly[/b],
                            to [b]pound you[/b] until you can barely even [b]walk[/b] anymore!
                            This is the best feeling you've [b]ever[/b] felt in your entire life.
                            You want it to last [b]forever[/b]!
                            And while you know it'll eventually [i]stop[/i],
                            you intend to ride out every single second of it as though it is your last!
                        [/p]
                        [p]
                            Thinking about it, the risk of getting knocked up makes this even [b]more[/b] exciting.
                            Even more [b]taboo[/b].
                            A split second later you can feel it starting to happen.
                            The basilisk's member [b]twitches[/b] and [b]convulses[/b] inside of your cunt.
                            The tapered tip prods against your cervix, positioned perfectly for its load to shoot straight into your very womb.
                            Its loud hissing turns into a low-pitched growl, and the first of many ropes of hot,
                            thick, fertile feral cum squirts from its beastly length,
                            a second orgasm wracking your battered mind as the feeling of being [b]filled up[/b] sends you over the edge once more.
                        [/p]
                        [p]
                            Your brain completely short-circuiting, you begin to wildly [b]ride[/b] the basilisk's shaft once more,
                            intent on squeezing every single [b]drop[/b] of spunk and pleasure that you possibly can from its exotic prick.
                            Your tongue lolls out of your mouth in the same way the beast's did,
                            its [b]mind-breaking[/b] climax seemingly lasting for [b]minutes[/b],
                            minutes of absolute [b]ecstacy[/b] for both you and it.
                        [/p]
                        [p]
                            You lose all track of time, direction, and being.
                            You black out, your mind and body utterly overwhelmed by the sheer amount of pleasure you're feeling.
                            When you come to your senses, you find yourself lying atop the monster's soft scales,
                            your belly slightly bulging from the sheer amount of cum inside of you, despite a lot of it already having flooded out.
                            Even more heady spunk is squirting on top of your body, covering you from head to toe,
                            ${shirt ? `completely soaking your ${global.kobold.inventory.createItemWithTooltip(shirt)},` : ``}
                            the basilisk's unmatched orgasm only [b]now[/b] starting to fade.
                        [/p]
                        [p]
                            Completely exhausted, you find yourself resting for a while in the warm, comforting care of your new feral [b]lover[/b],
                            idly taking in massive amounts of male pheromones with every breath.
                            You can feel the basilisk's strong chest comfortingly heaving up and down below you.
                            It's contently [i]purring[/i], its needs thoroughly sated.
                            What a [b]good boy[/b].
                        [/p]
                        [p]
                            As much as you'd like to make this cave your new home, you're afraid you simply can't.
                            Not yet, anyway.
                            As the cum on your scales starts to cool,
                            and the rational part of your brain slowly starts to kick in,
                            you realize that you have places to be and things to do.
                            With a loud sigh, you reluctantly roll off of the big lizard, who lets out a distinctly sad whimper.
                        [/p]
                        [p]
                            Trying to rise to your feet, you discover just how sore the intense fucking has left your entire body.
                            You're certain it'll fade in due time, though.
                            Despite having a rough time reaching the cave, you can say with a smile on your face that it was all worth it.
                            You thank the basilisk, though you doubt it understands, and give a small kiss on its snout.
                            Then, ${pants || undies ? `you redress, and` : `you`} prepare to leave.
                        [/p]`;
            if (virgin) {
                toReturn += `[p][c][b]You are no longer a virgin.[/b][/c][/p]`;
            }
        }

        return global.parser.parse(toReturn);
    }

    /**
     * Builds and returns the choice button.
     */
    function buildNextChoice() {
        var disabled = subController.continued() ? "disabled" : "";
        var isSelected = subController.continued();
        var selected = isSelected ? "selected" : "";
        var button = `<button class="button inlinechoice ${selected}" id="${continueId}" ${disabled}>Continue</button>`;
        return button;
    }

    /**
     * Builds and returns the choice of this section.
     * @returns {string} The choice of this section.
     */
    function buildChoice() {
        var choice = `<div class="choicecontainer">`;
        choice += buildNextChoice();
        choice += `</div>`;
        return choice;
    }

    /**
     * Disables all three buttons.
     */
    function disableButtons() {
        var buttons = [$("#" + continueId)];
        buttons.forEach(function (button) {
            button.unbind();
            button.attr("disabled", true);
        });
    }

    /**
     * Loads and displays the next part.
     * @param {object} part Which part to load.
     */
    function loadNextPart(part) {
        var built = part.build(true);
        global.ui.appendBeforeFinisher(built, global.ui.genericHeaderId);
        $("#" + part.id).fadeIn(400);
        part.registerListeners();
    }

    /**
     * Adds a listener to the button.
     */
    function registerNextListener() {
        $("#" + continueId).click(function () {
            $(this).addClass("selected");
            disableButtons();
            setChoice ? subController.set(setChoice) : subController.continue();
            loadNextPart(next);
        });
    }

    // PUBLIC MEMBERS \\        this.public = "test";
    this.id = arguments.callee.name;

    // PUBLIC FUNCTIONS \\      this.publicFunction = function(){};

    /**
     * Builds and returns this part.
     * @param {boolean} invisible If passed and true, will give the entire section a display:none style.
     */
    this.build = function (invisible) {
        if (reqController && ((reqChoice && reqController.get() !== reqChoice) || (!reqChoice && !reqController.continued()))) {
            return "";
        }


        var part = `<div id="${that.id}" ${invisible ? 'style="display:none;"' : ""}>`;
        part += buildContent();
        part += (changeController && changeController.change()) || "";
        part += buildChoice();
        part += `</div>`;
        part += next.build();
        return part;
    };

    /**
     * Registers all the required button listeners for this part.
     */
    this.registerListeners = function () {
        if (reqController && ((reqChoice && reqController.get() !== reqChoice) || (!reqChoice && !reqController.continued()))) {
            return;
        }

        next.registerListeners();

        if (subController.continued()) {
            return;
        }

        registerNextListener();
    };
}

// END scenes\HamletDay2\UndergroundCave\mirror\succeed\dominance\sub\UndergroundCaveReflectionGetFuckedInside.js

// scenes\HamletDay2\UndergroundCave\mirror\succeed\dominance\sub\UndergroundCaveReflectionGetFuckedOutside.js

/**
 * Reflect section of the Underground Cave.
 * @param {UndergroundCaveController} controller The Underground Cave controller.
 */
function UndergroundCaveReflectionGetFuckedOutside(controller) {
    // PRIVATE MEMBERS \\       var private = "test";
    var that = this;
    var ctrl = controller;

    var reqChoice = UndergroundCaveReflectionGetFuckedChoice.OUTSIDE;
    var reqController = ctrl.reflectSub;
    var setChoice = false;
    var subController = ctrl.preContinue;
    var changeController = ctrl.reflectOutside;

    var continueId = arguments.callee.name + "ButtonOne";
    var next = new UndergroundCaveReflectionGetFuckedContinue(ctrl);

    // PRIVATE FUNCTIONS \\     function privateFunction(){}

    /**
     * Builds and returns the content of this section.
     * @returns {string} The content.
     */
    function buildContent() {
        var dick = ctrl.misc.dick();
        var shirt = ctrl.misc.shirt();
        var pants = ctrl.misc.pants();
        var undies = ctrl.misc.underwear();

        var toReturn = ``;

        if (dick) {
            var virgin = ctrl.misc.analVirgin();
            toReturn += `
                        [p]
                            In the throes of an explosive orgasm,
                            right as the basilisk is about to shoot its load,
                            you slide right off your bestial partner's dick!
                            Just in time, too.
                            The [b]moment[/b] the tip of its member leaves your ass,
                            a first rope of thick, hot, sticky feral cum squirts out, splattering against your own dick,
                            marking your length with the male's scent,
                            the heady, masculine smell inspiring you to pleasure yourself further.
                        [/p]
                        [p]
                            You lay yourself down on top of the monster's chest, your hand finds its way in between your legs,
                            and you begin to rapidly jerk your already spent member off whilst fingering your slightly gaping tailhole,
                            all in an effort to keep your rush of arousal going strong.
                            A fresh wave of [b]intoxicating[/b] basilisk spunk splatters across your chest.
                            You grind your dick against the base of its throbbing length,
                            coaxing even more semen from the lizard's cock,
                            although it would have obviously preferred to have finished inside of you instead of letting its massive load go to waste.
                        [/p]
                        [p]
                            Alas, despite every bit of stimulation available, your cock is spent,
                            and you fail to find your second wind.
                            Instead of focusing on masturbation, you find yourself lying still atop the monster's soft scales.
                            Even more heady spunk is squirting on top of your already soaked body, covering you from head to toe,
                            ${shirt ? `completely drenching your ${global.kobold.inventory.createItemWithTooltip(shirt)},` : ``}
                            the basilisk's unmatched orgasm only [b]now[/b] starting to fade.
                        [/p]
                        [p]
                            Completely exhausted, you find yourself resting for a while in the warm, comforting care of your new feral [b]lover[/b],
                            idly taking in massive amounts of animalistic male pheromones with every breath.
                            You can feel the basilisk's strong chest comfortingly heaving up and down below you.
                            It's contently [i]purring[/i], its needs thoroughly sated.
                            What a [b]good boy[/b].
                        [/p]
                        [p]
                            As much as you'd like to make this cave your new home, you're afraid you simply can't.
                            Not yet, anyway.
                            As the cum on your scales starts to cool,
                            and the rational part of your brain slowly starts to kick in,
                            you realize that you have places to be and things to do.
                            With a loud sigh, you reluctantly roll off of the big lizard, who lets out a distinctly sad whimper.
                        [/p]
                        [p]
                            Trying to rise to your feet, you discover just how sore the intense fucking has left your entire body.
                            You're certain it'll fade in due time, though.
                            Despite having a rough time reaching the cave, you can say with a smile on your face that it was all worth it.
                            You thank the basilisk, though you doubt it understands, and give a small kiss on its snout.
                            Then, ${pants || undies ? `you redress, and` : `you`} prepare to leave.
                        [/p]`;
            if (virgin) {
                toReturn += `[p][c][b]You are no longer a virgin.[/b][/c][/p]`;
            }
        } else {
            var virgin = ctrl.misc.cuntVirgin();
            toReturn += `
                        [p]
                            In the throes of an explosive orgasm,
                            right as the basilisk is about to shoot its load,
                            you slide right off your bestial partner's dick!
                            Just in time, too.
                            The [b]moment[/b] the tip of its member leaves your slit,
                            a first rope of thick, hot, fertile feral cum squirts out, splattering against your stomach,
                            its heady, masculine scent inspiring you to pleasure yourself further.
                        [/p]
                        [p]
                            You lay yourself down on top of the monster's chest, your hand finds its way in between your legs,
                            and you begin to rapidly rub and finger yourself to keep your rush of arousal going strong,
                            [b]screaming[/b] out in pleasure as a fresh wave of [b]intoxicating[/b] basilisk spunk splatters across your chest.
                            You grind your cunt against the base of its throbbing length,
                            coaxing even more semen from the lizard's cock,
                            although it would have obviously preferred to [b]breed[/b] you instead of letting its massive load go to waste.
                        [/p]
                        [p]
                            Everything is a blur, from that point onwards.
                            You might have reached a second climax, but you can't quite remember.
                            When you come to your senses, you find yourself still lying atop the monster's soft scales.
                            Even more heady spunk is squirting on top of your already soaked body, covering you from head to toe,
                            ${shirt ? `completely drenching your ${global.kobold.inventory.createItemWithTooltip(shirt)},` : ``}
                            the basilisk's unmatched orgasm only [b]now[/b] starting to fade.
                        [/p]
                        [p]
                            Completely exhausted, you find yourself resting for a while in the warm, comforting care of your new feral [b]lover[/b],
                            idly taking in massive amounts of male pheromones with every breath.
                            You can feel the basilisk's strong chest comfortingly heaving up and down below you.
                            It's contently [i]purring[/i], its needs thoroughly sated.
                            What a [b]good boy[/b].
                        [/p]
                        [p]
                            As much as you'd like to make this cave your new home, you're afraid you simply can't.
                            Not yet, anyway.
                            As the cum on your scales starts to cool,
                            and the rational part of your brain slowly starts to kick in,
                            you realize that you have places to be and things to do.
                            With a loud sigh, you reluctantly roll off of the big lizard, who lets out a distinctly sad whimper.
                        [/p]
                        [p]
                            Trying to rise to your feet, you discover just how sore the intense fucking has left your entire body.
                            You're certain it'll fade in due time, though.
                            Despite having a rough time reaching the cave, you can say with a smile on your face that it was all worth it.
                            You thank the basilisk, though you doubt it understands, and give a small kiss on its snout.
                            Then, ${pants || undies ? `you redress, and` : `you`} prepare to leave.
                        [/p]`;
            if (virgin) {
                toReturn += `[p][c][b]You are no longer a virgin.[/b][/c][/p]`;
            }
        }

        return global.parser.parse(toReturn);
    }

    /**
     * Builds and returns the choice button.
     */
    function buildNextChoice() {
        var disabled = subController.continued() ? "disabled" : "";
        var isSelected = subController.continued();
        var selected = isSelected ? "selected" : "";
        var button = `<button class="button inlinechoice ${selected}" id="${continueId}" ${disabled}>Continue</button>`;
        return button;
    }

    /**
     * Builds and returns the choice of this section.
     * @returns {string} The choice of this section.
     */
    function buildChoice() {
        var choice = `<div class="choicecontainer">`;
        choice += buildNextChoice();
        choice += `</div>`;
        return choice;
    }

    /**
     * Disables all three buttons.
     */
    function disableButtons() {
        var buttons = [$("#" + continueId)];
        buttons.forEach(function (button) {
            button.unbind();
            button.attr("disabled", true);
        });
    }

    /**
     * Loads and displays the next part.
     * @param {object} part Which part to load.
     */
    function loadNextPart(part) {
        var built = part.build(true);
        global.ui.appendBeforeFinisher(built, global.ui.genericHeaderId);
        $("#" + part.id).fadeIn(400);
        part.registerListeners();
    }

    /**
     * Adds a listener to the button.
     */
    function registerNextListener() {
        $("#" + continueId).click(function () {
            $(this).addClass("selected");
            disableButtons();
            setChoice ? subController.set(setChoice) : subController.continue();
            loadNextPart(next);
        });
    }

    // PUBLIC MEMBERS \\        this.public = "test";
    this.id = arguments.callee.name;

    // PUBLIC FUNCTIONS \\      this.publicFunction = function(){};

    /**
     * Builds and returns this part.
     * @param {boolean} invisible If passed and true, will give the entire section a display:none style.
     */
    this.build = function (invisible) {
        if (reqController && ((reqChoice && reqController.get() !== reqChoice) || (!reqChoice && !reqController.continued()))) {
            return "";
        }

        var part = `<div id="${that.id}" ${invisible ? 'style="display:none;"' : ""}>`;
        part += buildContent();
        part += (changeController && changeController.change()) || "";
        part += buildChoice();
        part += `</div>`;
        part += next.build();
        return part;
    };

    /**
     * Registers all the required button listeners for this part.
     */
    this.registerListeners = function () {
        if (reqController && ((reqChoice && reqController.get() !== reqChoice) || (!reqChoice && !reqController.continued()))) {
            return;
        }

        next.registerListeners();

        if (subController.continued()) {
            return;
        }

        registerNextListener();
    };
}

// END scenes\HamletDay2\UndergroundCave\mirror\succeed\dominance\sub\UndergroundCaveReflectionGetFuckedOutside.js

// scenes\HamletDay2\UndergroundCave\mirror\succeed\dominance\sub\UndergroundCaveReflectionGetFucked.js

/**
 * Stare section of the Underground Cave.
 * @param {UndergroundCaveController} controller The Underground Cave controller.
 */
function UndergroundCaveReflectionGetFucked(controller) {
    // PRIVATE MEMBERS \\       var private = "test";
    var that = this;
    var ctrl = controller;

    var reqChoice = UndergroundCaveReflectionDominanceChoice.SUB;
    var reqController = ctrl.reflectDominance;
    var subController = ctrl.reflectSub;
    var changeController = false;

    var firstId = arguments.callee.name + "ButtonOne";
    var secondId = arguments.callee.name + "ButtonTwo";

    var firstNext = new UndergroundCaveReflectionGetFuckedOutside(ctrl);
    var secondNext = new UndergroundCaveReflectionGetFuckedInside(ctrl);

    var firstChoice = UndergroundCaveReflectionGetFuckedChoice.OUTSIDE;
    var secondChoice = UndergroundCaveReflectionGetFuckedChoice.INSIDE;

    // PRIVATE FUNCTIONS \\     function privateFunction(){}

    /**
     * Builds and returns the content of this section.
     * @returns {string} The content.
     */
    function buildContent() {
        global.kobold.history.shared.well.basiliskRode = true;
        var dick = ctrl.misc.dick();
        var breasts = ctrl.misc.boobs();
        var pants = ctrl.misc.pants();
        var undies = ctrl.misc.underwear();

        var lowerPantsAndUndies = `and already naked`;

        if (pants) {
            lowerPantsAndUndies = `after lowering your ${global.kobold.inventory.createItemWithTooltip(pants)}`;
            if (undies) {
                lowerPantsAndUndies += ` and your ${global.kobold.inventory.createItemWithTooltip(undies)}`;
            }
        } else if (undies) {
            lowerPantsAndUndies = `after lowering your ${global.kobold.inventory.createItemWithTooltip(undies)}`;
        }

        var toReturn = `[p]
                            The basilisk is more of a [b]big wimp[/b] than a menacing predator.
                            You can't imagine you were ever scared of this subby [b]bitch[/b] to begin with.
                            It [i]did[/i] look pretty hostile at first, but you guess that's almost a [i]requirement[/i] for living in a place like this.
                            Now that the creature has realized you're not its prey, it has revealed its true, submissive nature.
                        [/p]
                        [p]
                            Thinking of this situation as a [i]reversal of power[/i] awakens lustful feelings deep inside of you.
                            You've had this recurring [i]wet dream[/i] a few times, where kobolds would stage an uprising,
                            and you'd find yourself in front of the [b]juiciest[/b] maiden in all of Varanar,
                            with ten of your kind holding her struggling, naked form down for you to [b]ravage[/b].
                            This is [b]exactly[/b] like that dream, only instead of a maiden, you have a [b]basilisk[/b] to quench your lust upon,
                            the uprising was more of a [b]staring contest[/b], and there aren't really any kobolds around to hold the monster still.
                        [/p]
                        [p]
                            Okay, in retrospect, this entire ordeal might not be very much like your dream after all.
                            Still, you were reminded of it, and that's enough to get your
                            ${dick ? `member to slowly start to harden within your cockslit` : `slit to slightly moisten`}.
                            You begin to imagine all the things you could do to the creature, now that you've subdued it.
                            While not so similar to your dream, having your way with a large, ferocious animal [b]does[/b] pique your interest.
                        [/p]`;

        if (dick) {
            var virgin = ctrl.misc.analVirgin();
            toReturn += `
                        [p]
                            Doubting you'll [b]ever[/b] get a second chance at fucking a basilisk, you decide to act on your impulses.
                            You begin to stroke the emerging tip of your member,
                            which rapidly grows erect, fueled by the dirty thoughts popping up in your mind.
                            Hearing the monster give another pathetic whine makes you realize that it is [b]desperately[/b] needy.
                            Must not have been able to find a mate all season long.
                            But you can fix that.
                        [/p]
                        [p]
                            Your shaft grows painfully hard at the sheer thought of the feral's large, throbbing member having been pent up for [b]months[/b].
                            Lust clouds your mind, preventing you from thinking about the consequences should things go awry.
                            Driven by desire, ${lowerPantsAndUndies}, your heart pounding and your breathing intensifying as you approach it.
                            You idly touch yourself a little,
                            inadvertently ending up spray a squirt of precum onto the basilisk's chin.
                            You watch heatedly as its tongue flicks out of its mouth, and greedily laps up your arousal staining its scales.
                            Its cock twitches, a small bead of its own pre at the tip signalling its readiness and eagerness.
                            It wants this.
                            It wants [b]you[/b].
                        [/p]
                        [p]
                            You straddle the beast, sitting down on its belly, its supple under-scales surprisingly warm to the touch.
                            You spread your legs, pressing the base of your cock against its frame, letting it feel your [b]heat[/b] in turn.
                            You can sense its entire body heaving up and down with every lustful breath it takes, its very heart excitedly beating.
                            You [b]wish[/b] kobolds were this [i]big[/i].
                        [/p]
                        [p]
                            Your fingers caress its scales, rubbing teasingly at its belly and sides.
                            Caressing soon turns to stroking, as you take hold of its shaft,
                            feeling it [b]throb[/b] in your palm while you move your hand up and down at an agonizingly slow pace.
                            It grunts in [b]pleasure[/b].
                            But you can tell that it wants [b]more[/b].
                            It [b]needs[/b] more.
                            A glob of heady precum squirts from the tip of its member, splattering directly onto your face,
                            [b]drenching[/b] your snout in the arousing scent of raw, feral male [b]potency[/b].
                            You, too, need this.
                        [/p]
                        [p]
                            You stand up again, wobbling on shaky feet, your dick harder than it's ever been.
                            Dizzy with lust from the inebriating, aphrodisiac-like liquid coating your face,
                            it takes some effort to properly position yourself over the basilisk's cock.
                            You grind your rear against its member,
                            lubricating your rear with its bountiful pre to ease the coming insertion.
                            The big beast [b]growls[/b] in [b]desire[/b] and [b]impatience[/b], and you can't help but mirror its sentiments.
                            One of your hands dips to the base of its shaft, to help hold it in place, while you use the other to help balance yourself with.
                            Then, with a long deep, lusty sigh, you begin to lower yourself onto the monster's length.
                        [/p]
                        [p]
                            You gasp out in pleasure, and a tiny bit of pain,
                            as you impale yourself on the the basilisk's warm, girthy manhood.
                            Your mind gets [b]flooded[/b] with need, your cock twitching.
                            It feels like you're about to cum on the spot.
                            It takes [b]all[/b] of your dwindling inhibitions to prevent yourself from trying to take the feral to the base.
                            Luckily, even while drunk with desire,
                            you realize that attempting to take a beast this [b]big[/b] in one go would be a [b]bad[/b] idea.  
                        [/p]
                        [p]
                            You come to a halt, after having only managed to take about a third of the basilisk's length on your own.
                            You barely manage to refrain from blowing your load from just putting it in for the first time.
                            You want [b]more[/b].
                            The lizard, too, is not yet satisfied.
                            It [b]bucks[/b] upwards, [b]ramming[/b] a few extra inches inside of you, sending waves of [b]pleasure[/b] coursing down your spine.
                            Your [b]whorish[/b] moans [b]echo[/b] throughout the cavern, your ass stuffed full to the very brim.
                            And the fun has only just begun.
                        [/p]
                        [p]
                            While your limbs feel [b]tingly[/b] and [b]numb[/b],
                            after [b]relishing[/b] in the feeling of the basilisk's cock for a few moments,
                            you find the strength to pull your way back up its shaft,
                            shuddering in ecstacy as each of its ridges pops from your rear like a set of beads.
                            Failing to hold yourself back, you let your body sink down again long before reaching the tip.
                            [b]Needing[/b] to be filled, you lower yourself [b]far[/b] faster this time,
                            [b]forcing[/b] half an inch extra into your already overly-full tailhole, your cock quivering in absolute [b]delight[/b].
                        [/p]
                        [p]
                            No longer needing to stabilize yourself, you begin fervently jerking your overly-sensitive member,
                            slightly humping against your own palm, which simultaneously causes you to pleasurably ride the well-hung lizard's tool.
                            Your small rocking motions, while enjoyable, aren't [b]nearly[/b] enough to get you off.
                            You begin to lift yourself up again, and getting the hang of things, you manage to raise yourself far faster than the last time,
                            pulling back a little further only to immediately slam down once more,
                            slowly settling into a rhythm, [b]milking[/b] the beast's shaft with your body,
                            riding it like the depraved, feral-fucking [b]slut[/b] that you are.
                        [/p]
                        [p]
                            The basilisk's cock proves every bit as [b]amazing[/b] as you imagined it would,
                            but the sheer [b]debasement[/b] of riding a feral creature in rut fuels your excitement.
                            You, a small and weak kobold,
                            usually preyed on by almost [b]everyone[/b] and [b]everything[/b] in the entire world,
                            are [b]on top[/b] of a [b]deadly monster[/b], which is entirely at the [b]mercy[/b] of your desires!
                            [b]You[/b] are the dominant and driving force of this animalistic [b]mating[/b],
                            and that thought drives you [b]wild[/b] with lust.
                            While you managed to avert it before, you can once again feel your premature end rapidly approaching.
                        [/p]
                        [p]
                            You let out another loud moan,
                            returning to rubbing the base of the creature's ridged member for a while,
                            your efforts rewarded by a hefty squirt of precum splattering against your insdies, further slickening your rear,
                            allowing you to pick up the pace one final time.
                        [/p]
                        [p]
                            The big reptile below you has all but gone [b]limp[/b] out of pleasure.
                            Its mouth hangs wide open, its tongue lolls out obscenely,
                            its hips are [b]struggling[/b] to hump up against you,
                            and one of its hind legs is absent-mindedly kicking air like it's nothing but an oversized [b]dog[/b]!
                            The once [b]mighty[/b] and [b]proud[/b] beast
                            has been reduced to little more than a meek [b]fucktoy[/b] for you to ride at your own behest.
                            And the thought of [i]breaking[/i] the basilisk, of reducing it to its most [b]base[/b] desires, that is what sends you over the edge.
                        [/p]
                        [p]
                            You only need to slide yourself down a few more times,
                            by now fitting more than [b]half[/b] of the monster's exotic dick inside you,
                            before reaching your end.
                            Every muscle in your meagre frame locks and tenses,
                            your cock [b]spasms[/b] wildly,
                            your internal balls [b]pump[/b] their contents through your shaft,
                            thick strands of your spunk squirting through the air before splattering down on the creature's tail,
                            and your eyes roll into the back of your head out of sheer [b]ecstacy[/b],
                            as a world-rocking orgasm hits your body hard.
                        [/p]
                        [p]
                            Even as your mind goes blank with pleasure,
                            you still realize the basilisk has not finished yet.
                            It hisses loudly, recovering enough of its vigor to start [b]wildly[/b] humping away at you once more,
                            outright [b]rutting[/b] your ass, sending spikes of pure [b]bliss[/b] shooting throughout overly-sensitive body!
                            It's close.
                            You know it is.
                        [/p]`;
        } else {
            var virgin = ctrl.misc.cuntVirgin();
            toReturn += `
                        [p]
                            Doubting you'll [b]ever[/b] get a second chance at fucking a basilisk, you decide to act on your impulses.
                            You begin to touch your own slit, which rapidly dampens, fueled by the dirty thoughts popping up in your mind.
                            Hearing the monster give another pathetic whine makes you realize that it is [b]desperately[/b] needy.
                            Must not have been able to find a mate all season long.
                            But you can fix that.
                        [/p]
                        [p]
                            Your thighs moisten at the sheer thought of the feral's large, throbbing member having been pent up for [b]months[/b].
                            Lust clouds your mind, preventing you from thinking about the consequences should things go awry.
                            Driven by desire, ${lowerPantsAndUndies}, your heart pounding and your breathing intensifying as you approach it.
                            Lust drips from your bare loins.
                            The scent of your own excitement fills the cave, inevitably caught by the basilisk as well.
                            It greedily huffs the air as its own arousal builds,
                            its cock twitching, a small bead of precum at the tip signalling its readiness and eagerness.
                            It wants this.
                            It wants [b]you[/b].
                        [/p]
                        [p]
                            You straddle the beast, sitting down on its belly, its supple under-scales surprisingly warm to the touch.
                            You spread your legs, pressing your slit against its frame, letting it feel your [b]heat[/b] in turn.
                            You can sense its entire body heaving up and down with every lustful breath it takes, its very heart excitedly beating.
                            You [b]wish[/b] kobolds were this [i]big[/i].
                        [/p]
                        [p]
                            Your fingers caress its scales, rubbing teasingly at its belly and sides.
                            Caressing soon turns to stroking, as you take hold of its shaft,
                            feeling it [b]throb[/b] in your palm while you move your hand up and down at an agonizingly slow pace.
                            It grunts in [b]pleasure[/b].
                            But you can tell that it wants [b]more[/b].
                            It [b]needs[/b] more.
                            A glob of heady precum squirts from the tip of its member, splattering directly onto your face,
                            [b]drenching[/b] your snout in the arousing scent of raw, feral male [b]potency[/b].
                            You, too, need this.
                        [/p]
                        [p]
                            You stand up again, wobbling on shaky feet, moisture dripping liberally down your cunt.
                            Dizzy with lust from the inebriating, aphrodisiac-like liquid coating your face,
                            it takes some effort to properly position yourself over the basilisk's cock.
                            You grind your loins against its member,
                            mixing your bountiful fluids together to form a suitable lubricant,
                            which you liberally coat your slit in to ease the coming insertion.
                            The big beast [b]growls[/b] in [b]desire[/b] and [b]impatience[/b], and you can't help but mirror its sentiments.
                            One of your hands dips to the base of its shaft, to help hold it in place, while you use the other to help balance yourself with.
                            Then, with a long deep, lusty sigh, you begin to lower yourself onto the monster's length.
                        [/p]
                        [p]
                            You gasp out in pleasure, and a tiny bit of pain,
                            as you impale yourself on the the basilisk's warm, girthy manhood.
                            ${virgin ? `Your virginity is taken, as signified by a trickle of blood running down the creature's member.` : ``}
                            Your mind gets [b]flooded[/b] with need.
                            It takes [b]all[/b] of your dwindling inhibitions to prevent yourself from trying to take the feral to the base.
                            Luckily, even while drunk with desire,
                            you realize that attempting to take a beast this [b]big[/b] in one go would be a [b]bad[/b] idea.    
                        [/p]
                        [p]
                            Copious amounts of female arousal leak down the basilisk's shaft, helping to lubricate the way.
                            Still, you only manage to take about a third of the its length on your own.
                            You want [b]more[/b].
                            The lizard, too, is not yet satisfied.
                            It [b]bucks[/b] upwards, [b]ramming[/b] a few extra inches inside of you,
                            its tip ending up poking and [b]prodding[/b] at your cervix, sending waves of [b]pleasure[/b] coursing down your spine.
                            Your [b]whorish[/b] moans [b]echo[/b] throughout the cavern, your cunt stuffed full to the very brim.
                            And the fun has only just begun.
                        [/p]
                        [p]
                            While your limbs feel [b]tingly[/b] and [b]numb[/b],
                            after [b]relishing[/b] in the feeling of the basilisk's cock for a few moments,
                            you find the strength to pull your way back up its shaft,
                            shuddering in ecstacy as each of its ridges wetly pops from your cunt.
                            Failing to hold yourself back, you let your body sink down again long before reaching the tip.
                            [b]Needing[/b] to be filled, you lower yourself [b]far[/b] faster this time,
                            [b]forcing[/b] half an inch extra into your already overly-full cunt, which quivers in absolute [b]delight[/b].
                        [/p]
                        [p]
                            No longer needing to stabilize yourself, you begin fervently toying with your ${breasts ? `breasts` : `flat chest`},
                            ${breasts ? `rubbing and squeezing them` : `rubbing your hands all over your tender scales`},
                            while simultaneously working to lift yourself up again.
                            Getting the hang of things, you manage to raise yourself faster than the last time,
                            pulling back a little further only to immediately slam down once more,
                            slowly settling into a rhythm, [b]milking[/b] the beast's shaft with your cunt,
                            riding it like the depraved, feral-fucking [b]slut[/b] that you are.
                        [/p]
                        [p]
                            The basilisk's cock proves every bit as [b]amazing[/b] as you imagined it would,
                            but the sheer [b]debasement[/b] of riding a feral creature in rut fuels your excitement.
                            You, a small and weak kobold,
                            usually preyed on by almost [b]everyone[/b] and [b]everything[/b] in the entire world,
                            are [b]on top[/b] of a [b]deadly monster[/b], which is entirely at the [b]mercy[/b] of your desires!
                            [b]You[/b] are the dominant and driving force of this animalistic [b]mating[/b],
                            and that thought drives you [b]wild[/b] with lust.
                            You can already feel your premature end rapidly approaching.
                        [/p]
                        [p]
                            You let out another loud moan,
                            returning to rubbing the base of the creature's ridged member for a while,
                            your efforts rewarded by a hefty squirt of precum splattering against your cervix, further slickening your insides,
                            allowing you to pick up the pace one final time.
                        [/p]
                        [p]
                            The big reptile below you has all but gone [b]limp[/b] out of pleasure.
                            Its mouth hangs wide open, its tongue lolls out obscenely,
                            its hips are [b]struggling[/b] to hump up against you,
                            and one of its hind legs is absent-mindedly kicking air like it's nothing but an oversized [b]dog[/b]!
                            The once [b]mighty[/b] and [b]proud[/b] beast
                            has been reduced to little more than a meek [b]fucktoy[/b] for you to ride at your own behest.
                            And the thought of [i]breaking[/i] the basilisk, of reducing it to its most [b]base[/b] desires, that is what sends you over the edge.
                        [/p]
                        [p]
                            You only need to slide yourself down a few more times,
                            by now fitting more than [b]half[/b] of the monster's exotic dick inside you,
                            before reaching your end.
                            Every muscle in your meagre frame locks and tenses,
                            your cunt [b]clenches[/b] down around the feral's girth,
                            your juices liberally [b]flood[/b] from your slit,
                            [b]soaking[/b] the remainder of the basilisk's cock,
                            a pool of feminine fluids forming at the very base,
                            and your eyes roll into the back of your head out of sheer [b]ecstacy[/b],
                            as a world-rocking orgasm hits your body hard.
                        [/p]
                        [p]
                            Even as your mind goes blank with pleasure,
                            you still realize the basilisk has not finished yet.
                            It hisses loudly, recovering enough of its vigor to start [b]wildly[/b] humping away at you once more,
                            outright [b]rutting[/b] you, sending spikes of pure [b]bliss[/b] shooting throughout overly-sensitive body,
                            [b]forcing[/b] your orgasm to go [b]on and on[/b]!
                            You know it's about to cum, but you [b]really[/b] don't want to pull off of it yet,
                            despite the rational part of your mind telling you [b]not[/b] to let it finish inside of you.
                        [/p]`;
        }

        return global.parser.parse(toReturn);
    }

    /**
     * Builds and returns the choice button.
     */
    function buildFirstChoice() {
        var disabled = subController.has() ? "disabled" : "";
        var isSelected = subController.get() === firstChoice;
        var selected = isSelected ? "selected" : "";
        var button = `<button class="button inlinechoice ${selected}" id="${firstId}" ${disabled}>Outside</button>`;

        var tooltip = global.parser.parse(`Finish it off some other way.`);
        var popupContainer = global.ui.makeToolTip(button, tooltip, false, false, "width: 190px;");
        // Re-wrap with proper positioning.
        button = `<div class="inlinechoice">`;
        button += popupContainer;
        button += `</div>`;

        return button;
    }

    /**
     * Builds and returns the choice button.
     */
    function buildSecondChoice() {
        var disabled = subController.has() ? "disabled" : "";
        var isSelected = subController.get() === secondChoice;
        var selected = isSelected ? "selected" : "";
        var button = `<button class="button inlinechoice ${selected}" id="${secondId}" ${disabled}>Inside</button>`;

        var tooltip = global.parser.parse(`Let it fill you up.`);
        var popupContainer = global.ui.makeToolTip(button, tooltip, false, false, "width: 190px;");
        // Re-wrap with proper positioning.
        button = `<div class="inlinechoice">`;
        button += popupContainer;
        button += `</div>`;

        return button;
    }

    /**
     * Builds and returns the choice of this section.
     * @returns {string} The choice of this section.
     */
    function buildChoice() {
        var choice = `<div class="choicecontainer"><div class="inlinechoiceheader">Make it cum:</div>`;
        choice += buildFirstChoice();
        choice += `<hr class="inlinechoiceseparator">`;
        choice += buildSecondChoice();
        choice += `</div>`;
        return choice;
    }

    /**
     * Disables all three buttons.
     */
    function disableButtons() {
        var buttons = [$("#" + firstId), $("#" + secondId)];
        buttons.forEach(function (button) {
            button.unbind();
            button.attr("disabled", true);
        });
    }

    /**
     * Loads and displays the next part.
     * @param {object} part Which part to load.
     */
    function loadNextPart(part) {
        var built = part.build(true);
        global.ui.appendBeforeFinisher(built, global.ui.genericHeaderId);
        $("#" + part.id).fadeIn(400);
        part.registerListeners();
    }

    /**
     * Adds a listener to the button.
     */
    function registerFirstListener() {
        $("#" + firstId).click(function () {
            $(this).addClass("selected");
            disableButtons();
            subController.set(firstChoice);
            loadNextPart(firstNext);
        });
    }

    /**
     * Adds a listener to the button.
     */
    function registerSecondListener() {
        $("#" + secondId).click(function () {
            $(this).addClass("selected");
            disableButtons();
            subController.set(secondChoice);
            loadNextPart(secondNext);
        });
    }

    // PUBLIC MEMBERS \\        this.public = "test";
    this.id = arguments.callee.name;

    // PUBLIC FUNCTIONS \\      this.publicFunction = function(){};

    /**
     * Builds and returns this part.
     * @param {boolean} invisible If passed and true, will give the entire section a display:none style.
     */
    this.build = function (invisible) {
        if (reqController && ((reqChoice && reqController.get() !== reqChoice) || (!reqChoice && !reqController.continued()))) {
            return "";
        }

        var part = `<div id="${that.id}" ${invisible ? 'style="display:none;"' : ""}>`;
        part += buildContent();
        part += (changeController && changeController.change()) || "";
        part += buildChoice();
        part += `</div>`;
        part += firstNext.build();
        part += secondNext.build();
        return part;
    };

    /**
     * Registers all the required button listeners for this part.
     */
    this.registerListeners = function () {
        if (reqController && ((reqChoice && reqController.get() !== reqChoice) || (!reqChoice && !reqController.continued()))) {
            return;
        }

        firstNext.registerListeners();
        secondNext.registerListeners();

        if (subController.has()) {
            return;
        }

        registerFirstListener();
        registerSecondListener();
    };
}

var UndergroundCaveReflectionGetFuckedChoice = {
    OUTSIDE: 1,
    INSIDE: 2
};

// END scenes\HamletDay2\UndergroundCave\mirror\succeed\dominance\sub\UndergroundCaveReflectionGetFucked.js

// scenes\HamletDay2\UndergroundCave\mirror\succeed\dominance\sex\UndergroundCaveReflectionSexContinue.js

/**
 * Reflect section of the Underground Cave.
 * @param {UndergroundCaveController} controller The Underground Cave controller.
 */
function UndergroundCaveReflectionSexContinue(controller) {
    // PRIVATE MEMBERS \\       var private = "test";
    var that = this;
    var ctrl = controller;

    var reqChoice = false;
    var reqController = ctrl.preContinue;
    var changeController = ctrl.reflectSexContinue;

    var continueId = arguments.callee.name + "ButtonOne";

    // PRIVATE FUNCTIONS \\     function privateFunction(){}

    /**
     * Builds and returns the content of this section.
     * @returns {string} The content.
     */
    function buildContent() {
        var dick = ctrl.misc.dick();
        var baseMale = ctrl.misc.baseGender() === GenderEnum.MALE;

        var toReturn = `[p]
                            With the basilisk shown its place,
                            and yourself asserted as the [b]alpha ${baseMale ? `male` : `female`}[/b],
                            you decide it's time to find a way out of the cave.
                            Leaving the feral to revel in post-orgasmic bliss, 
                            you begin to follow the river-branch, hoping it'll lead you to some kind of exit.
                        [/p]
                        [p]
                            You leisurely stroll alongside the water, until daylight comes into sight.
                            As you expected: the water [b]was[/b] a stale branch of the river!
                            Climbing out of the cave, you sit your butt down on the riverside dirt, and take a breather.
                            You feel like you've earned one.
                        [/p]
                        [p]
                            You've defied death more than once today.
                            You should consider yourself lucky to be alive.
                            The trip into the well was a harrowing experience.
                            You nearly got crushed, almost drowned, and after all of that,
                            you managed to ${dick ? `butt` : `finger`}fuck a basilisk into [i]willing[/i] submission.
                            You doubt a lot of people can claim to have had sex with a mythological being, and much less still lived to tell the tale.
                        [/p]
                        [p]
                            You've gained a few personal memories that you'll undoubtedly find yourself masturbating to later,
                            along with some awesome stories to tell once you've grown old and wise.
                            Stories like the ones Seki used to tell you when you were little.
                            You went through all that trouble to get your mind off of him, and here you are reminiscing once more.
                            You just can't help yourself from clinging to times long gone.
                            Things were so much simpler back then.
                            You miss those days.
                        [/p]
                        [p]
                            The sun is slowly starting to set.
                            You drag yourself to your feet.
                            It's time to go.
                            Varanar isn't [i]that[/i] far off.
                            If your legs don't give out from underneath you, you might still make it there before nightfall.
                        [/p]`;

        return global.parser.parse(toReturn);
    }

    /**
     * Builds and returns the continue button.
     */
    function buildChoice() {
        var disabled = ctrl.continued();
        var choice = `<div class="choicecontainer">`;
        choice += `<button class="button bigbutton continuebutton" id="${continueId}" ${disabled ? "disabled" : ""}>`;
        choice += `Continue &gt;&gt`;
        choice += `</button>`;
        choice += `</div>`;
        return choice;
    }

    /**
     * Disables all three buttons.
     */
    function disableButtons() {
        var buttons = [$("#" + continueId)];
        buttons.forEach(function (button) {
            button.unbind();
            button.attr("disabled", true);
        });
    }

    /**
     * Loads and displays the next scene.
     * @param {string} sceneName Name of the scene to load.
     * @param {string} folder Folder of the scene to load.
     */
    function loadNextPart(sceneName, folder) {
        global.ui.fadeOutContent(function () {
            global.sceneEnd();
            global.sceneLoader.loadScene(sceneName, folder);
        });
    }

    /**
     * Adds a listener to the button.
     */
    function registerContinueListener() {
        $("#" + continueId).click(function () {
            $(this).addClass("selected");
            disableButtons();
            ctrl.continue();
            loadNextPart(ctrl.nextSceneName, ctrl.nextFolderName);
        });
    }

    // PUBLIC MEMBERS \\        this.public = "test";
    this.id = arguments.callee.name;

    // PUBLIC FUNCTIONS \\      this.publicFunction = function(){};

    /**
     * Builds and returns this part.
     * @param {boolean} invisible If passed and true, will give the entire section a display:none style.
     */
    this.build = function (invisible) {
        if (reqController && ((reqChoice && reqController.get() !== reqChoice) || (!reqChoice && !reqController.continued()))) {
            return "";
        }

        ctrl.bgm.stopLoop();
        global.ui.applyTheme("hamlet_day");
        var part = `<div id="${that.id}" ${invisible ? 'style="display:none;"' : ""}>`;
        part += buildContent();
        part += (changeController && changeController.change()) || "";
        part += buildChoice();
        if (!ctrl.nextSceneReady) {
            part += `<span class="todo">There is no content beyond this point.</span>`;
        }
        part += `</div>`;
        return part;
    };

    /**
     * Registers all the required button listeners for this part.
     */
    this.registerListeners = function () {
        if (reqController && ((reqChoice && reqController.get() !== reqChoice) || (!reqChoice && !reqController.continued()))) {
            return;
        }

        if (ctrl.continued()) {
            return;
        }

        if (ctrl.nextSceneReady) {
            registerContinueListener();
        }
    };
}

// END scenes\HamletDay2\UndergroundCave\mirror\succeed\dominance\sex\UndergroundCaveReflectionSexContinue.js

// scenes\HamletDay2\UndergroundCave\mirror\succeed\dominance\sex\UndergroundCaveReflectionSex.js

/**
 * Reflect section of the Underground Cave.
 * @param {UndergroundCaveController} controller The Underground Cave controller.
 */
function UndergroundCaveReflectionSex(controller) {
    // PRIVATE MEMBERS \\       var private = "test";
    var that = this;
    var ctrl = controller;

    var reqChoice = UndergroundCaveReflectionDominanceChoice.SEX;
    var reqController = ctrl.reflectDominance;
    var setChoice = false;
    var subController = ctrl.preContinue;
    var changeController = ctrl.reflectSex;

    var continueId = arguments.callee.name + "ButtonOne";
    var next = new UndergroundCaveReflectionSexContinue(ctrl);

    // PRIVATE FUNCTIONS \\     function privateFunction(){}

    /**
     * Builds and returns the content of this section.
     * @returns {string} The content.
     */
    function buildContent() {
        global.kobold.history.shared.well.basiliskDomFucked = true;
        var dick = ctrl.misc.dick();
        var dick = ctrl.misc.dick();
        var pants = ctrl.misc.pants();
        var undies = ctrl.misc.underwear();
        var oralVirgin = ctrl.misc.oralVirgin();

        var lowerPantsAndUndies = `and already naked`;

        if (pants) {
            lowerPantsAndUndies = `after lowering your ${global.kobold.inventory.createItemWithTooltip(pants)}`;
            if (undies) {
                lowerPantsAndUndies += ` and your ${global.kobold.inventory.createItemWithTooltip(undies)}`;
            }
        } else if (undies) {
            lowerPantsAndUndies = `after lowering your ${global.kobold.inventory.createItemWithTooltip(undies)}`;
        }

        var toReturn = `[p]
                            The basilisk is more of a [b]big wimp[/b] than a menacing predator.
                            You can't imagine you were ever scared of this subby [b]bitch[/b] to begin with.
                            It [i]did[/i] look pretty hostile at first, but you guess that's required for living in a place like this.
                            Now that the creature has realized you're not its prey, it has revealed its true, submissive nature.
                        [/p]
                        [p]
                            Thinking of this situation as a [i]reversal of power[/i] awakens lustful feelings deep inside of you.
                            You've had this recurring [i]wet dream[/i] a few times, where kobolds would stage an uprising,
                            and you'd find yourself in front of the [b]juiciest[/b] maiden in all of Varanar,
                            with ten of your kind holding her struggling, naked form down for you to [b]ravage[/b].
                            This is [b]exactly[/b] like that dream, only instead of a maiden, you have a [b]basilisk[/b] to quench your lust upon,
                            the uprising was more of a [b]staring contest[/b], and there aren't really any kobolds around to hold the monster still.
                        [/p]
                        [p]
                            Okay, in retrospect, this entire ordeal might not be very much like your dream after all.
                            Still, you were reminded of it, and that's enough to get your
                            ${dick ? `member to slowly start to harden within your cockslit` : `slit to slightly moisten`}.
                            You begin to imagine all the things you could do to the creature, now that you've subdued it.
                            While not so similar to your dream, having your way with a large, ferocious animal [b]does[/b] pique your interest.
                        [/p]`;

        if (dick) {
            var virgin = ctrl.misc.dickVirgin();
            toReturn += `
                        [p]
                            Doubting you'll [b]ever[/b] get a second chance at molesting a basilisk, you decide to act on your impulses.
                            You begin to stroke the emerging tapered tip of your member,
                            which rapidly grows erect, fueled by the dirty thoughts popping up in your mind.
                            You want to fuck its stony ass, concealed underneath its tail.
                            You want to walk on the wild side, to tempt fate itself,
                            to see whether or not the beast still has enough [b]fight[/b] in it to resist, to [b]thrash around[/b] and [b]maim you[/b].
                        [/p]
                        [p]
                            This cute little, scale-covered, oversized [b]puppy[/b]?
                            Surely not.
                            After being half-petrified, it has become completely and utterly [b]tame[/b].
                            You bet the creature won't even [b]try[/b] to stop you from fucking its behind.
                            To prove your point, you reach down to scratch its chin.
                            Instead of fighting back in any form or shape,
                            it rumbles pleasantly underneath your touch, like a dog being pet.
                            Its maw opens wide, serpentine tongue lolling out.
                            The beast sways its tail from side to side, seductively wriggling its ass about.
                            While in reality it's simply [i]enjoying[/i] your scratching,
                            you prefer to interpret it like the crocodillian [b]offering[/b] itself to you.
                        [/p]
                        [p]
                            Lust clouds your mind, preventing you from thinking about the consequences should things go awry.
                            Driven by desire, ${lowerPantsAndUndies}, you approach the basilisk's backside,
                            and straddle the base of its tail, dropping to your knees on top of it.
                            Its member mere inches from your face, the creeping scent of a feral male in rut [b]fills[/b] your lungs.
                            The smell acts like an aphrodisiac, arousing you further, [b]enticing[/b] you to fuck the beast.
                        [/p]
                        [p]
                            With one of your hands, you begin to [b]toy[/b] with the basilisk's member,
                            giving it a few tentative squeezes and touches.
                            In return, you are rewarded with a thick, heady squirt of precum splattering from the tapered tip,
                            along the entire length of the monster's underside,
                            its potent fragrance adding to the already intoxicating aroma of male [b]lust[/b].
                            With your other hand, you begin to [i]probe[/i] around its rear.
                            It doesn't seem to mind one bit.
                        [/p]
                        [p]
                            After giving yourself a few much-needed strokes as well,
                            you line up the tip of your member with the basilisk's tailhole.
                            You immediately begin to apply pressure, pressing your tapered length into its overly tight rear.
                            Once past its relaxed, but still exceedingly tight sphincter,
                            you easily manage to ram the rest of your shaft inside, bottoming out in a single, smooth thrust.
                            The monster hisses, but it remains calm and submissive.
                            It stays in place, accepting its position as your [b]bitch[/b].
                            Just as planned.
                        [/p]
                        [p]
                            While the creature's exterior is hard, tough and cold, its insides are the exact opposite.
                            Warm, fleshy, and exceedingly tight,
                            almost what you imagine a human's ass to feel like, minus a bubbly butt to rest your groin against.
                            A pleasant surprise, and not an unwelcome one at that.
                            You lean forwards ever so slightly, almost pressing your chest up against the monster's length,
                            your snout almost [b]rubbing[/b] in the bauble of precum collected at the tip of its exotic cock.
                            While outright [b]huffing[/b] its enticing smell, you slowly begin to thrust in and out of the crocodillian's ass.
                        [/p]
                        [p]
                            The basilisk's tight insides prove to be quite pleasurable,
                            but the sheer [b]debasement[/b] of what you're doing drives your excitement through the roof.
                            You're [b]fucking[/b] a feral.
                            The untamed [b]beast[/b] has been completely [b]broken[/b], turned into your [b]bitch[/b].
                            And on top of all of this, you're tempting fate itself by ramming your dick into a creature that could easily [b]tear you apart[/b]!
                            Not that it shows any signs of [i]disliking[/i] what is happening.
                            If anything, its quivering shaft shows it wants this every bit as much as you do, if not even [b]more[/b].
                        [/p]
                        [p]
                            Closing your eyes for a moment, your mind briefly wanders back to the dream that inspired you to fuck the basilisk.
                            Snapping back to reality, however, you realize that this situation is [b]even better[/b] than what you imagined.
                            Having the [b]pleasure[/b] of dominating a [b]lethal beast[/b],
                            one that could [b]rip you to shreds[/b] were it not such a submissive [b]bitch[/b],
                            stirs your loins far more than the thought of raping a helpless damsel.
                            While you've only been absent-mindedly humping away at the big lizard's rear for a few seconds short of a minute,
                            you can already feel your premature end rapidly approaching.
                        [/p]
                        [p]
                            Lost in the heat of the moment, you press your lips against the tapered tip of the basilisk's cock,
                            taking the very end of its length into your mouth, suckling it like a needy [b]whore[/b],
                            collecting as much of its precum onto your tongue as you possibly can.
                            The intense [b]taste[/b] of basilisk dick entices you further,
                            its pre coating your tastebuds and spreading throughout your mouth makes you feel [b]lightheaded[/b] with [b]lust[/b].
                            While upping your pace, you begin to outright suck the beast off,
                            its lower body slowly humping back against your muzzle, its tailhole riding your dick in the process.
                        [/p]
                        [p]
                            You let out a lustful groan, rubbing one of your hands along the creature's soft underside.
                            You briefly consider giving it a few [b]spanks[/b], but you decide against that idea.
                            Instead, you wrap both of your hands around its girthy length,
                            and dutifully begin to [b]jerk off[/b] the large part of its shaft that you fail to fit in your mouth.
                            It's been a [b]good boy[/b], after all.
                            The fact that it doesn't resist, that it seems [b]willing[/b] to cooperate in all of this,
                            [b]that[/b] sends you over the edge.
                        [/p]
                        [p]
                            To your surprise, while you were just about to finish, the big creature reaches its end before you do!
                            A first wave of [b]thick[/b], [b]potent[/b] feral semen floods your mouth, driving you [b]wild[/b] with desire.
                            You give the beast's rear a few more rapid humps, before reaching your own climax.
                            Your member [b]pulses[/b] and [b]spasms[/b], spunk pumping from deep within your internal balls,
                            through your shaft, squirting directly inside of the monster's body.
                            You eagerly gulp down several waves of the basilisk's intoxicating jizz,
                            before removing your muzzle from its cock, letting the rest of its intense orgasm squirt along its own underbelly,
                            painting its own body a pearly white, leaving it a [b]very[/b] messy lizard.
                        [/p]
                        [p]
                            Your lust sated, and the entire contents of your nuts emptied deep within the big beast's body,
                            you pull your length from its butt, your cum immediately beginning to ooze from its hole,
                            staining the base of its tail, although there's not nearly as much of the stuff as there is on its upper body,
                            which is completely [b]soaked[/b].
                            You rise to your feet${pants || undies ? ` and redress` : ``},
                            observing the basilisk as it simply lies there in a dazed, hazy afterglow,
                            basking in pleasure, completely relaxed, its tongue lolling out of its mouth.
                            It's almost kind of adorable.
                            Too bad you can't stay here forever.
                        [/p]`;
            if (virgin) {
                toReturn += `[p][c][b]You are no longer a virgin.[/b][/c][/p]`;
            }
        } else {
            toReturn += `
                        [p]
                            Doubting you'll [b]ever[/b] get a second chance at molesting a basilisk, you decide to act on your impulses.
                            You begin to touch your own slit, which rapidly dampens, fueled by the dirty thoughts popping up in your mind.
                            You want to touch its stony ass, concealed underneath its tail.
                            You want to walk on the wild side, to tempt fate itself,
                            to see whether or not the beast still has enough [b]fight[/b] in it to resist, to [b]thrash around[/b] and [b]maim you[/b].
                        [/p]
                        [p]
                            This cute little, scale-covered, oversized [b]puppy[/b]?
                            Surely not.
                            After being half-petrified, it has become completely and utterly [b]tame[/b].
                            You bet the creature won't even [b]try[/b] to stop you from toying with its behind.
                            To prove your point, you reach down to scratch its chin.
                            Instead of fighting back in any form or shape,
                            it rumbles pleasantly underneath your touch, like a dog being pet.
                            Its maw opens wide, serpentine tongue lolling out.
                            The beast sways its tail from side to side, seductively wriggling its ass about.
                            While in reality it's simply [i]enjoying[/i] your scratching,
                            you prefer to interpret it like the crocodillian [b]offering[/b] itself to you.
                        [/p]
                        [p]
                            Lust clouds your mind, preventing you from thinking about the consequences should things go awry.
                            Driven by desire, ${lowerPantsAndUndies}, you approach the basilisk's backside,
                            and straddle its tail, dropping to your knees before lying flat down on top of it.
                            The base of the monster's member mere inches from your face, the creeping scent of a feral male in rut [b]fills[/b] your lungs.
                            The smell acts like an aphrodisiac, arousing you further, [b]enticing[/b] you to [i]play[/i] with the beast.
                        [/p]
                        [p]
                            With one of your hands, you begin to [b]toy[/b] with the basilisk's member,
                            giving it a few tentative squeezes and touches.
                            In return, you are rewarded with a thick, heady squirt of precum splattering from the tapered tip,
                            along the entire length of the monster's underside,
                            its potent fragrance adding to the already intoxicating aroma of male [b]lust[/b].
                            With your other hand, you begin to [i]probe[/i] around its rear.
                            It doesn't seem to mind one bit.
                        [/p]
                        [p]
                            Enticed, you grab hold of the basilisk cock, and slowly rub your comparatively small palm up and down the its shaft,
                            stroking its length at an agonizingly slow pace.
                            Wouldn't want it to finish [i]too soon[/i], now would you?
                            You have plenty more in store for the big beast.
                            Leaning your head in even closer, you press your muzzle not against its member, but against its tender rear.
                            Your tongue snakes out of your mouth, and in a fit of deviancy, you tentatively lick the creature's tailhole,
                            elliciting another lewd grunt from its muzzle.
                            Sterile and tasteless, apart from a remote hint of [i]sweat[/i], but the basilisk [i]did[/i] seem to like it.
                            Its member throbs in your hand, and it slowly starts to move its hips on its own,
                            humping against your palm.
                        [/p]
                        [p]
                            Again and again, you lap at the monster's rear, your tongue settling into a rhythm,
                            your saliva wettening its scales and lubing its hole, preparing it for what is to come.
                            The feral is blissfully unaware of your devious plans.
                            You strengthen your grip on its member, and increase the speed of your hand, properly jerking it off.
                            You can feel its precum slickening your palm, reducing friction,
                            making the entire ordeal even [b]more[/b] pleasurable for the crocodillian.
                        [/p]
                        [p]
                            Finally, with the beast completely lost in pleasure, you decide to move on to the [i]second[/i] phase of your plan.
                            With the large lizard fully relaxed, you pull your head back a little,
                            a few thick strings of saliva connecting your muzzle to its ass still.
                            You move your other hand to the creature's rear.
                            This is where the real fun begins.
                        [/p]
                        [p]
                            You press one of your fingers against the monster's tailhole, teasingly circling it, spreading your spit around.
                            Then, while simultaneously upping the pace of your frantic jerking once more,
                            you slide the digit into the feral's spit-lubed rear, ramming it inside of the basilisk to the very knuckle.
                            The large lizard is obviously surprised, but it remains calm and submissive, accepting its position as your [b]bitch[/b].
                            Or maybe it [b]likes[/b] its ass being played with.
                        [/p]
                        [p]
                            While continuing to firmly stroke the beast's ridged member,
                            you slide a second finger inside of its thoroughly lubricated behind,
                            and begin to pump both of the digits in and out of the creature's body, properly [b]fingering[/b] it while jerking it off,
                            sending spikes of pleasure coursing down its spine.
                            You doubt it's [b]ever[/b] felt anything like [b]this[/b] before.
                            And you're just getting [b]started[/b].
                        [/p]
                        [p]
                            Your mouth freed, you shuffle upwards along the basilisk's body,
                            bringing your snout to the very tip of its member, outright [b]huffing[/b] its potent, male aroma for a few moments.
                            Through its own humping, it inadvertently presses its tapered tip against your mouth,
                            rubbing a considerable bauble of collected precum off on your muzzle.
                            No longer able to contain your excitement,
                            you eagerly part your lips,
                            taking the very end of its length into your mouth, and start [b]suckling[/b] it like a needy [b]whore[/b],
                            collecting as much of the monster's precum onto your tongue as you possibly can.
                        [/p]
                        [p]
                            The intense [b]taste[/b] of basilisk dick makes you feel [b]lightheaded[/b] with [b]desire[/b].
                            The pungent pre coating your tastebuds and spreading throughout your mouth awakens a [b]lust[/b],   
                            a [b]craving[/b], a [b]need[/b] for the contents of its internal balls.
                            If it weren't for your fingers up its ass, you'd say the [b]feral[/b] was in complete control of this situation, and [b]not[/b] you.
                            You begin to rapidly stroke the remaining part of its member that you can't fit into your mouth.
                        [/p]
                        [p]
                            Its humping intensifies, the feral outright [b]fucking[/b] your face.
                            You can feel the its end approaching.
                            You up the intensity of your tailhole-fingering one last time, vigorously pumping your fingers in and out of its tight, warm body.
                            Its shaft twitches in your grasp.
                            Precum shoots down the back of your mouth, into your throat.
                            Its end is getting [b]very[/b] near.
                        [/p]
                        [p]
                            The big creature lets out a pleasured hiss as it reaches its climax,
                            rabidly humping away at your muzzle while a first wave of [b]thick[/b],
                            [b]potent[/b] feral semen floods your mouth, your brain [b]blanking out[/b] with desire.
                            You grind your loins against its stony tail, not quite pleasuring yourself properly,
                            but still slightly scratching the itch sucking off this [b]beast[/b] of male has awoken.
                            You eagerly gulp down several waves of the basilisk's intoxicating jizz,
                            before pulling your muzzle from its cock,
                            letting the rest of its intense orgasm squirt along its own underbelly,
                            painting its own body a pearly white, leaving it a [b]very[/b] messy lizard.
                        [/p]
                        [p]
                            You slide your fingers from the creature's rear.
                            Your belly filled, and the entire contents of the big beast's nuts emptied,
                            your job is done here.
                            That was [b]fun[/b].
                            You rise to your feet${pants || undies ? ` and redress` : ``}.
                            Before leaving, you take a moment to observe the basilisk as it simply lies there in a dazed, hazy afterglow,
                            basking in pleasure, completely relaxed, its tongue lolling out of its mouth.
                            It's almost kind of adorable.
                        [/p]`;
        }

        if (oralVirgin) {
            toReturn += `[p][c][b]You are no longer an oral virgin.[/b][/c][/p]`;
        }

        return global.parser.parse(toReturn);
    }

    /**
     * Builds and returns the choice button.
     */
    function buildNextChoice() {
        var disabled = subController.continued() ? "disabled" : "";
        var isSelected = subController.continued();
        var selected = isSelected ? "selected" : "";
        var button = `<button class="button inlinechoice ${selected}" id="${continueId}" ${disabled}>Continue</button>`;
        return button;
    }

    /**
     * Builds and returns the choice of this section.
     * @returns {string} The choice of this section.
     */
    function buildChoice() {
        var choice = `<div class="choicecontainer">`;
        choice += buildNextChoice();
        choice += `</div>`;
        return choice;
    }

    /**
     * Disables all three buttons.
     */
    function disableButtons() {
        var buttons = [$("#" + continueId)];
        buttons.forEach(function (button) {
            button.unbind();
            button.attr("disabled", true);
        });
    }

    /**
     * Loads and displays the next part.
     * @param {object} part Which part to load.
     */
    function loadNextPart(part) {
        var built = part.build(true);
        global.ui.appendBeforeFinisher(built, global.ui.genericHeaderId);
        $("#" + part.id).fadeIn(400);
        part.registerListeners();
    }

    /**
     * Adds a listener to the button.
     */
    function registerNextListener() {
        $("#" + continueId).click(function () {
            $(this).addClass("selected");
            disableButtons();
            setChoice ? subController.set(setChoice) : subController.continue();
            loadNextPart(next);
        });
    }

    // PUBLIC MEMBERS \\        this.public = "test";
    this.id = arguments.callee.name;

    // PUBLIC FUNCTIONS \\      this.publicFunction = function(){};

    /**
     * Builds and returns this part.
     * @param {boolean} invisible If passed and true, will give the entire section a display:none style.
     */
    this.build = function (invisible) {
        if (reqController && ((reqChoice && reqController.get() !== reqChoice) || (!reqChoice && !reqController.continued()))) {
            return "";
        }

        var part = `<div id="${that.id}" ${invisible ? 'style="display:none;"' : ""}>`;
        part += buildContent();
        part += (changeController && changeController.change()) || "";
        part += buildChoice();
        part += `</div>`;
        part += next.build();
        return part;
    };

    /**
     * Registers all the required button listeners for this part.
     */
    this.registerListeners = function () {
        if (reqController && ((reqChoice && reqController.get() !== reqChoice) || (!reqChoice && !reqController.continued()))) {
            return;
        }

        next.registerListeners();

        if (subController.continued()) {
            return;
        }

        registerNextListener();
    };
}

// END scenes\HamletDay2\UndergroundCave\mirror\succeed\dominance\sex\UndergroundCaveReflectionSex.js

// scenes\HamletDay2\UndergroundCave\mirror\succeed\dominance\oral\UndergroundCaveReflectionOralContinue.js

/**
 * Reflect section of the Underground Cave.
 * @param {UndergroundCaveController} controller The Underground Cave controller.
 */
function UndergroundCaveReflectionOralContinue(controller) {
    // PRIVATE MEMBERS \\       var private = "test";
    var that = this;
    var ctrl = controller;

    var reqChoice = false;
    var reqController = ctrl.preContinue;
    var changeController = ctrl.reflectOralContinue;

    var continueId = arguments.callee.name + "ButtonOne";

    // PRIVATE FUNCTIONS \\     function privateFunction(){}

    /**
     * Builds and returns the content of this section.
     * @returns {string} The content.
     */
    function buildContent() {
        var dick = ctrl.misc.dick();
        var baseMale = ctrl.misc.baseGender() === GenderEnum.MALE;

        var toReturn = `[p]
                            With the basilisk shown its place,
                            and yourself asserted as the [b]alpha ${baseMale ? `male` : `female`}[/b],
                            you decide it's time to find a way out of the cave.
                            Leaving the feral to enjoy the aftertaste of your ${dick ? `cum` : `feminine fluids`},
                            you begin to follow the river-branch, hoping it'll lead you to some kind of exit.
                        [/p]
                        [p]
                            The beast whines as you start to walk away, hoping it'd get some action itself, but luckily it does not follow you.
                            You leisurely stroll alongside the water, until daylight comes into sight.
                            As you expected: the water [b]was[/b] a stale branch of the river!
                            Climbing out of the cave, you sit your butt down on the riverside dirt, and take a breather.
                            You feel like you've earned one.
                        [/p]
                        [p]
                            You've defied death more than once today.
                            You should consider yourself lucky to be alive.
                            The trip into the well was a harrowing experience.
                            You nearly got crushed, almost drowned, and after all of that, you managed to facefuck a basilisk into [i]willing[/i] submission.
                            You doubt a lot of people can claim to have had sex with a mythological being, and much less still lived to tell the tale.
                        [/p]
                        [p]
                            You've gained a few personal memories that you'll undoubtedly find yourself masturbating to later,
                            along with some awesome stories to tell once you've grown old and wise.
                            Stories like the ones Seki used to tell you when you were little.
                            You went through all that trouble to get your mind off of him, and here you are reminiscing once more.
                            You just can't help yourself from clinging to times long gone.
                            Things were so much simpler back then.
                            You miss those days.
                        [/p]
                        [p]
                            The sun is slowly starting to set.
                            You drag yourself to your feet.
                            It's time to go.
                            Varanar isn't [i]that[/i] far off.
                            If your legs don't give out from underneath you, you might still make it there before nightfall.
                        [/p]`;

        return global.parser.parse(toReturn);
    }

    /**
     * Builds and returns the continue button.
     */
    function buildChoice() {
        var disabled = ctrl.continued();
        var choice = `<div class="choicecontainer">`;
        choice += `<button class="button bigbutton continuebutton" id="${continueId}" ${disabled ? "disabled" : ""}>`;
        choice += `Continue &gt;&gt`;
        choice += `</button>`;
        choice += `</div>`;
        return choice;
    }

    /**
     * Disables all three buttons.
     */
    function disableButtons() {
        var buttons = [$("#" + continueId)];
        buttons.forEach(function (button) {
            button.unbind();
            button.attr("disabled", true);
        });
    }

    /**
     * Loads and displays the next scene.
     * @param {string} sceneName Name of the scene to load.
     * @param {string} folder Folder of the scene to load.
     */
    function loadNextPart(sceneName, folder) {
        global.ui.fadeOutContent(function () {
            global.sceneEnd();
            global.sceneLoader.loadScene(sceneName, folder);
        });
    }

    /**
     * Adds a listener to the button.
     */
    function registerContinueListener() {
        $("#" + continueId).click(function () {
            $(this).addClass("selected");
            disableButtons();
            ctrl.continue();
            loadNextPart(ctrl.nextSceneName, ctrl.nextFolderName);
        });
    }

    // PUBLIC MEMBERS \\        this.public = "test";
    this.id = arguments.callee.name;

    // PUBLIC FUNCTIONS \\      this.publicFunction = function(){};

    /**
     * Builds and returns this part.
     * @param {boolean} invisible If passed and true, will give the entire section a display:none style.
     */
    this.build = function (invisible) {
        if (reqController && ((reqChoice && reqController.get() !== reqChoice) || (!reqChoice && !reqController.continued()))) {
            return "";
        }

        ctrl.bgm.stopLoop();
        global.ui.applyTheme("hamlet_day");
        var part = `<div id="${that.id}" ${invisible ? 'style="display:none;"' : ""}>`;
        part += buildContent();
        part += (changeController && changeController.change()) || "";
        part += buildChoice();
        if (!ctrl.nextSceneReady) {
            part += `<span class="todo">There is no content beyond this point.</span>`;
        }
        part += `</div>`;
        return part;
    };

    /**
     * Registers all the required button listeners for this part.
     */
    this.registerListeners = function () {
        if (reqController && ((reqChoice && reqController.get() !== reqChoice) || (!reqChoice && !reqController.continued()))) {
            return;
        }

        if (ctrl.continued()) {
            return;
        }

        if (ctrl.nextSceneReady) {
            registerContinueListener();
        }
    };
}

// END scenes\HamletDay2\UndergroundCave\mirror\succeed\dominance\oral\UndergroundCaveReflectionOralContinue.js

// scenes\HamletDay2\UndergroundCave\mirror\succeed\dominance\oral\UndergroundCaveReflectionOral.js

/**
 * Reflect section of the Underground Cave.
 * @param {UndergroundCaveController} controller The Underground Cave controller.
 */
function UndergroundCaveReflectionOral(controller) {
    // PRIVATE MEMBERS \\       var private = "test";
    var that = this;
    var ctrl = controller;

    var reqChoice = UndergroundCaveReflectionDominanceChoice.ORAL;
    var reqController = ctrl.reflectDominance;
    var setChoice = false;
    var subController = ctrl.preContinue;
    var changeController = ctrl.reflectOral;

    var continueId = arguments.callee.name + "ButtonOne";
    var next = new UndergroundCaveReflectionOralContinue(ctrl);

    // PRIVATE FUNCTIONS \\     function privateFunction(){}

    /**
     * Builds and returns the content of this section.
     * @returns {string} The content.
     */
    function buildContent() {
        global.kobold.history.shared.well.basiliskOral = true;
        var dick = ctrl.misc.dick();
        var pants = ctrl.misc.pants();
        var undies = ctrl.misc.underwear();

        var lowerPantsAndUndies = `and already naked`;

        if (pants) {
            lowerPantsAndUndies = `after lowering your ${global.kobold.inventory.createItemWithTooltip(pants)}`;
            if (undies) {
                lowerPantsAndUndies += ` and your ${global.kobold.inventory.createItemWithTooltip(undies)}`;
            }
        } else if (undies) {
            lowerPantsAndUndies = `after lowering your ${global.kobold.inventory.createItemWithTooltip(undies)}`;
        }

        var toReturn = `[p]
                            The basilisk is more of a [b]big wimp[/b] than a menacing predator.
                            You can't imagine you were ever scared of this subby [b]bitch[/b] to begin with.
                            It [i]did[/i] look pretty hostile at first, but you guess that's required for living in a place like this.
                            Now that the creature has realized you're not its prey, it has revealed its true, submissive nature.
                        [/p]
                        [p]
                            Thinking of this situation as a [i]reversal of power[/i] awakens lustful feelings deep inside of you.
                            You've had this recurring [i]wet dream[/i] a few times, where kobolds would stage an uprising,
                            and you'd find yourself in front of the [b]juiciest[/b] maiden in all of Varanar,
                            with ten of your kind holding her struggling, naked form down for you to [b]ravage[/b].
                            This is [b]exactly[/b] like that dream, only instead of a maiden, you have a [b]basilisk[/b] to quench your lust upon,
                            the uprising was more of a [b]staring contest[/b], and there aren't really any kobolds around to hold the monster still.
                        [/p]
                        [p]
                            Okay, in retrospect, this entire ordeal might not be very much like your dream after all.
                            Still, you were reminded of it, and that's enough to get your
                            ${dick ? `member to slowly start to harden within your cockslit` : `slit to slightly moisten`}.
                            You begin to imagine all the things you could do to the creature, now that you've subdued it.
                            While not so similar to your dream, having your way with a large, ferocious animal [b]does[/b] pique your interest.
                        [/p]`;

        if (dick) {
            var virgin = ctrl.misc.dickVirgin();
            toReturn += `
                        [p]
                            Doubting you'll [b]ever[/b] get a second chance at molesting a basilisk, you decide to act on your impulses.
                            You begin to stroke the emerging tapered tip of your member, which rapidly grows erect, fueled by the dirty thoughts popping up in your mind.
                            Its muzzle.
                            You want to fuck its muzzle, filled with sharp, pointy teeth.
                            You want to walk on the wild side, to tempt fate itself,
                            to see whether or not the beast still has enough [b]fight[/b] in it to resist, to [b]bite down[/b].
                        [/p]
                        [p]
                            This cute little, scale-covered, oversized [b]puppy[/b]?
                            Surely not.
                            After being half-petrified, it has become completely and utterly [b]tame[/b].
                            You bet the creature won't even [b]try[/b] to stop you from fucking its maw.
                            To prove your point, you reach down to scratch its chin.
                            Instead of fighting back in any form or shape,
                            it rumbles pleasantly underneath your touch, like a dog being pet.
                            Its tail slowly sways back and forth, and its maw opens wide, serpentine tongue lolling out.
                            While in reality it's simply [i]enjoying[/i] your scratching,
                            you prefer to interpret it like the crocodillian [b]offering[/b] its mouth for your length.
                        [/p]
                        [p]
                            As you remove your hand from its chin, the dog-like creature rolls back onto its feet,
                            its movements seeming a little more [i]fluid[/i] than before.
                            The petrification must be wearing off.
                        [/p]
                        [p]
                            Lust clouds your mind, preventing you from thinking about the consequences should things go awry.
                            Driven by desire, ${lowerPantsAndUndies}, you approach the basilisk's head, dropping to your knees directly in front of it,
                            your erect member mere inches away from the feral's snout.
                            Its mouth is still open, and the monster dares not look at you.
                            A perfect opportunity.
                        [/p]
                        [p]
                            You line up the tip of your member with the beast's mouth, and with a single, smooth roll of your hips,
                            you slide your length inside of its muzzle, the bottom of your shaft pleasantly rubbing alongside the basilisk's slender, forked tongue.
                            While the creature's exterior is hard, tough and cold, the insides of its mouth are the exact opposite.
                            Warm, fleshy, [b]wet[/b] with saliva, almost what you imagine a human's gums must feel like.
                            A pleasant surprise, and not an unwelcome one.
                        [/p]
                        [p]
                            The lizard doesn't seem to mind your dick being rammed into its gaping maw one bit.
                            Like it's [i]used[/i] to the the taste of kobold cock.
                            If you didn't know any better, you'd think it's even trying to [b]suckle[/b] at your member, and [b]probing[/b] your length with its tongue.
                            While you're certain these are all just natural reflexes,
                            and the beast has never done anything of the sort before, you can't help but imagine that it [b]has[/b].
                            You fantasize that it's completely and utterly submissive to you, a [b]slut[/b] eager to [b]please[/b].
                        [/p]
                        [p]
                            Lost in pleasure, you close your eyes and lean back ever so slightly,
                            while starting to thrust in and out of the monster's muzzle.
                            The sensation isn't [b]too[/b] pleasurable, but the sheer [b]debasement[/b] of what you're doing excites you to no end.
                            You're [b]fucking[/b] a feral.
                            The untamed [b]beast[/b] has been completely [b]broken[/b], turned into your [b]bitch[/b].
                            And on top of all of this, you're tempting fate itself by ramming your cock into a mouth full of sharp teeth!
                        [/p]
                        [p]
                            With your eyes closed, your mind briefly wanders back to the dream that inspired you to facefuck the basilisk.
                            Snapping back to reality, however, you realize that this situation is [b]even better[/b] than what you imagined.
                            Having the [b]pleasure[/b] of dominating a [b]lethal beast[/b],
                            one that could [b]rip you to shreds[/b] were it not so interested in [b]sucking your dick[/b],
                            stirs your loins far more than the thought of raping a helpless damsel.
                            While you've only been absent-mindedly humping away at the big lizard's maw for a few seconds short of a minute,
                            you can already feel your premature end rapidly approaching.
                        [/p]
                        [p]
                            You let out a lustful groan, rubbing one of your hands along the soft underside of the creature's muzzle,
                            poking at its sharp teeth with one of your fingers to remind yourself of the [b]arousing danger[/b] you're in.
                            The basilisk shows no signs of biting, though.
                            Either it doesn't know what's happening, or it's a [b]willing[/b] participant in all of this.
                            The thought of having reduced the once-proud crocodillian to an [b]eager[/b] cocksucker,
                            [b]that[/b] sends you over the edge.
                        [/p]
                        [p]
                            You give the beast's mouth a few more rapid thrusts, before reaching your end.
                            Your member [b]pulses[/b] and [b]spasms[/b], spunk pumping from deep within your internal balls,
                            through your shaft, squirting directly atop the monster's forked tongue.
                            You don't even need to hold it in place.
                            It deftly stays put, letting you empty the entire contents of your nuts into its muzzle.
                        [/p]
                        [p]
                            Your lust sated, you pull your cock from the big beast's maw.
                            It closes its jaws, and licks its lips, almost looking somewhat [i]pleased[/i], audibly gulping down your cum.
                            Maybe it [i]did[/i] want this.
                            Maybe basilisks [i]do[/i] suck eachother off during rut or something.
                            Whatever the case, you didn't get killed, and ended up getting your rocks off.
                            You'll chalk this one up as a win.
                            You rise to your feet${pants || undies ? ` and redress` : ``}.
                        [/p]`;

            if (virgin) {
                toReturn += `[p][c][b]You are no longer a virgin.[/b][/c][/p]`;
            }
        } else {
            toReturn += `
                        [p]
                            Doubting you'll [b]ever[/b] get a second chance at molesting a basilisk, you decide to act on your impulses.
                            You begin to touch your own slit, which rapidly dampens, fueled by the dirty thoughts popping up in your mind.
                            Its muzzle.
                            You want to ride its muzzle, filled with sharp, pointy teeth.
                            You want to walk on the wild side, to tempt fate itself,
                            to see whether or not the beast still has enough [b]fight[/b] in it to resist, to [b]bite[/b].
                        [/p]
                        [p]
                            This cute little, scale-covered, oversized [b]puppy[/b]?
                            Surely not.
                            After being half-petrified, it has become completely and utterly [b]tame[/b].
                            You bet the creature won't even [b]try[/b] to stop you from riding its maw.
                            To prove your point, you reach down to scratch its chin.
                            Instead of fighting back in any form or shape,
                            it rumbles pleasantly underneath your touch, like a dog being pet.
                            Its tail slowly sways back and forth, and its maw opens wide, serpentine tongue lolling out.
                            While in reality it's simply [i]enjoying[/i] your scratching,
                            you prefer to interpret it like the crocodillian [b]offering[/b] its [i]services[/i].
                        [/p]
                        [p]
                            As you remove your hand from its chin, the dog-like creature rolls back onto its feet,
                            its movements seeming a little more [i]fluid[/i] than before.
                            The petrification must be wearing off.
                        [/p]
                        [p]
                            Lust clouds your mind, preventing you from thinking about the consequences should things go awry.
                            Driven by desire, ${lowerPantsAndUndies}, you approach the basilisk's head, dropping to your knees directly in front of it,
                            your wet slit mere inches away from the feral's snout.
                            Its mouth is still open, and it dares not look at you.
                            A perfect opportunity.
                        [/p]
                        [p]
                            You gently pet the beast's head, and find it all too eager to comply,
                            easy to direct and willing to play along as you plant your lusty twat directly on top of its snout. 
                            The scent of a female lizard seems to rouse the creature from its passive, submissive stance.
                            Its nostrils flare, and its slender, forked tongue slips out to taste your arousal, 
                            lightly flicking along your most sensitive scales, before retracting into its massive, toothy maw once more.
                        [/p]
                        [p]
                            The feminine taste of an aroused kobold girl spreading throughout its mouth only encourages the feral further.
                            The basilisk's tongue flicks out again, pressing deeper into your folds this time, even slightly parting them,
                            collecting as much of your sweet feminine excitement as it possible can, before retracting the flexible organ once more.
                        [/p]
                        [p]
                            You let out a pleasured sigh as the basilisk begins to outright [b]lap[/b] at your slit,
                            licking you much like a common bear would steal honey from a beekeeping friar's storehouse:
                            greedily and speedily.
                            Like it's [b]eager[/b] to please its new [i]mate[/i].
                            Despite the creature's rock-like appearance, its tongue feels [b]warm[/b] and [b]wet[/b],
                            and the forked split at the end is just exotic enough to get your filthy mind [b]racing[/b].
                        [/p]
                        [p]
                            Lost in pleasure, you close your eyes and lean back ever so slightly,
                            slowly rubbing your crotch back and forth over the monster's muzzle while it continues to eat you out.
                            The sensation itself is pleasurable, but the sheer [b]debasement[/b] of what you're doing is what drives your excitement through the roof.
                            You're getting [b]licked[/b] by a [b]feral[/b].
                            The untamed [b]beast[/b] has been completely [b]broken[/b], turned into your [b]bitch[/b].
                            And on top of all of this, you're tempting fate itself by grinding your loins against a mouth full of sharp teeth!
                        [/p]
                        [p]
                            With your eyes closed, your mind briefly wanders back to the dream that inspired you to get the basilisk to lick you.
                            Snapping back to reality, however, you realize that this situation is [b]even better[/b] than what you imagined.
                            Having the [b]pleasure[/b] of dominating a [b]lethal beast[/b],
                            one that could [b]rip you to shreds[/b] were it not more interested in [i]serving you[/i],
                            stirs your loins far more than the thought of forcing a helpless damsel to eat you out.
                            While you've only been absent-mindedly humping away at the big lizard's lapping maw for a few seconds short of a minute,
                            you can already feel your premature end rapidly approaching.
                        [/p]
                        [p]
                            You let out a lustful groan, rubbing one of your hands along the soft underside of the creature's muzzle,
                            poking at its sharp teeth with one of your fingers to remind yourself of the [b]arousing danger[/b] you're in.
                            It [b]willingly[/b] digs its tongue into your cunt, scooping ever-deeper for more of your [b]delicious[/b] arousal.
                            It must be into this every bit as much as you are.
                        [/p]
                        [p]
                            You give the beast's mouth a few more rapid grinding humps, before reaching your end.
                            Your innards spasm around the monster's forked tongue, your excitement liberally dripping from your loins,
                            a small squirt coating the basilisk's stone face with feminine fluids.
                            The subservient crocodillian, instead of pulling back, envelops your slit with its muzzle,
                            collecting as much of the bittersweet, viscous, luke-warm arousal flooding from your cunt as it can,
                            longingly swallowing every single droplet, one mouthful at a time, all the while the creature's tongue continues to work its magic.
                        [/p]
                        [p]
                            Absolutely [b]loving[/b] the feeling of the pleasant aftercare, you stay in place and simply let the big beast lick away for a while.
                            When you finally [i]do[/i] pull back, it closes its jaws once more.
                            The monster lewdly licks its lips clean, as though [i]pleased[/i] about the job it did.
                            If you didn't know any better, you'd say the feral [b]wanted[/b] this almost as much as you did.
                            You don't know whether you should feel confused, insulted or [i]flattered[/i].
                            You rise to your feet${pants || undies ? ` and redress` : ``}.
                        [/p]`;
        }

        return global.parser.parse(toReturn);
    }

    /**
     * Builds and returns the choice button.
     */
    function buildNextChoice() {
        var disabled = subController.continued() ? "disabled" : "";
        var isSelected = subController.continued();
        var selected = isSelected ? "selected" : "";
        var button = `<button class="button inlinechoice ${selected}" id="${continueId}" ${disabled}>Continue</button>`;
        return button;
    }

    /**
     * Builds and returns the choice of this section.
     * @returns {string} The choice of this section.
     */
    function buildChoice() {
        var choice = `<div class="choicecontainer">`;
        choice += buildNextChoice();
        choice += `</div>`;
        return choice;
    }

    /**
     * Disables all three buttons.
     */
    function disableButtons() {
        var buttons = [$("#" + continueId)];
        buttons.forEach(function (button) {
            button.unbind();
            button.attr("disabled", true);
        });
    }

    /**
     * Loads and displays the next part.
     * @param {object} part Which part to load.
     */
    function loadNextPart(part) {
        var built = part.build(true);
        global.ui.appendBeforeFinisher(built, global.ui.genericHeaderId);
        $("#" + part.id).fadeIn(400);
        part.registerListeners();
    }

    /**
     * Adds a listener to the button.
     */
    function registerNextListener() {
        $("#" + continueId).click(function () {
            $(this).addClass("selected");
            disableButtons();
            setChoice ? subController.set(setChoice) : subController.continue();
            loadNextPart(next);
        });
    }

    // PUBLIC MEMBERS \\        this.public = "test";
    this.id = arguments.callee.name;

    // PUBLIC FUNCTIONS \\      this.publicFunction = function(){};

    /**
     * Builds and returns this part.
     * @param {boolean} invisible If passed and true, will give the entire section a display:none style.
     */
    this.build = function (invisible) {
        if (reqController && ((reqChoice && reqController.get() !== reqChoice) || (!reqChoice && !reqController.continued()))) {
            return "";
        }

        var part = `<div id="${that.id}" ${invisible ? 'style="display:none;"' : ""}>`;
        part += buildContent();
        part += (changeController && changeController.change()) || "";
        part += buildChoice();
        part += `</div>`;
        part += next.build();
        return part;
    };

    /**
     * Registers all the required button listeners for this part.
     */
    this.registerListeners = function () {
        if (reqController && ((reqChoice && reqController.get() !== reqChoice) || (!reqChoice && !reqController.continued()))) {
            return;
        }

        next.registerListeners();

        if (subController.continued()) {
            return;
        }

        registerNextListener();
    };
}

// END scenes\HamletDay2\UndergroundCave\mirror\succeed\dominance\oral\UndergroundCaveReflectionOral.js

// scenes\HamletDay2\UndergroundCave\mirror\succeed\dominance\UndergroundCaveReflectionDominance.js

/**
 * Reflect section of the Underground Cave.
 * @param {UndergroundCaveController} controller The Underground Cave controller.
 */
function UndergroundCaveReflectionDominance(controller) {
    // PRIVATE MEMBERS \\       var private = "test";
    var that = this;
    var ctrl = controller;

    var reqChoice = UndergroundCaveReflectionSucceedChoice.DOMINATE;
    var reqController = ctrl.reflectSucceed;
    var subController = ctrl.reflectDominance;
    var changeController = false;

    var firstId = arguments.callee.name + "ButtonOne";
    var secondId = arguments.callee.name + "ButtonTwo";
    var thirdId = arguments.callee.name + "ButtonThree";

    var firstNext = new UndergroundCaveReflectionOral(ctrl);
    var secondNext = new UndergroundCaveReflectionSex(ctrl);
    var thirdNext = new UndergroundCaveReflectionGetFucked(ctrl);

    var firstChoice = UndergroundCaveReflectionDominanceChoice.ORAL;
    var secondChoice = UndergroundCaveReflectionDominanceChoice.SEX;
    var thirdChoice = UndergroundCaveReflectionDominanceChoice.SUB;

    // PRIVATE FUNCTIONS \\     function privateFunction(){}

    /**
     * Builds and returns the content of this section.
     * @returns {string} The content.
     */
    function buildContent() {
        global.kobold.history.shared.well.basiliskDominated = true;
        var dick = ctrl.misc.dick();
        var toReturn = `[p]
                            The basilisk is already beaten.
                            There is no point to taking its life, or turning it into an ornament for that matter.
                            It has submitted to you.
                            You could just leave, but seeing the creature on its back brings some [i]unsavory[/i] thoughts to mind.
                        [/p]
                        [p]
                            You study the creature, going around it with the mirror-shard at the ready, in case it suddenly decides to fight back.
                            As your sight wanders over the crocodillian's underside, you become aware of its hard,
                            throbbing, fully erect draconic-looking member jutting out from its nethers, standing at attention like the mast of a large and scaly ship.
                            The beast isn't even trying to hide its arousal.
                            It must be in rut or something.
                            Maybe that's why it was so fiercely defending its lair.
                            Perhaps you've inadvertently taken part of some sort of a basilisk mating ritual.
                            Maybe you've even asserted yourself as the [b]dominant[/b] partner, by petrifying the monster.
                        [/p]
                        [p]
                            Lying there, panting slightly, with its cock brimming with lust, the once-terrifying feral almost looks [i]cute[/i].
                            Like a perfectly tamed and loyal pet, waiting for a [i]treat[/i].
                            The longer you look at it, the more often your eyes find their way back to its member.
                            While you were already planning on sating your lust on the basilisk,
                            its shameless display has cemented your desire.
                            ${dick ? `Your length hardens within your slit, the tapered tip peeking out already.` : `Your slit moistens in anticipation.`}
                        [/p]
                        [p]
                            The basilisk wants to mate.
                            Who are you to deny it?
                        [/p]`;

        return global.parser.parse(toReturn);
    }

    /**
     * Builds and returns the choice button.
     */
    function buildFirstChoice() {
        var disabled = subController.has() ? "disabled" : "";
        var isSelected = subController.get() === firstChoice;
        var selected = isSelected ? "selected" : "";
        var button = `<button class="button inlinechoice ${selected}" id="${firstId}" ${disabled}>Use its muzzle</button>`;

        var tooltip = global.parser.parse(`Time to facefuck a beast's mouth filled with sharp teeth. What could go wrong?`);
        var popupContainer = global.ui.makeToolTip(button, tooltip, false, false, "width: 200px;");
        // Re-wrap with proper positioning.
        button = `<div class="inlinechoice">`;
        button += popupContainer;
        button += `</div>`;

        return button;
    }

    /**
     * Builds and returns the choice button.
     */
    function buildSecondChoice() {
        var disabled = subController.has() ? "disabled" : "";
        var isSelected = subController.get() === secondChoice;
        var selected = isSelected ? "selected" : "";
        var button = `<button class="button inlinechoice ${selected}" id="${secondId}" ${disabled}>Fuck it</button>`;

        var male = ctrl.misc.dick();
        var tooltip = global.parser.parse(`Make the basilisk your [b]bitch[/b].`);
        if (!male) {
            tooltip = global.parser.parse(`Fingerfuck the basilisk's tailhole. Make it your [b]bitch[/b].`);
        }
        var popupContainer = global.ui.makeToolTip(button, tooltip, false, false, "width: 190px;");
        // Re-wrap with proper positioning.
        button = `<div class="inlinechoice">`;
        button += popupContainer;
        button += `</div>`;

        return button;
    }

    /**
     * Builds and returns the choice button.
     */
    function buildThirdChoice() {
        var disabled = subController.has() ? "disabled" : "";
        var isSelected = subController.get() === thirdChoice;
        var selected = isSelected ? "selected" : "";
        var button = `<button class="button inlinechoice ${selected}" id="${thirdId}" ${disabled}>Ride it</button>`;

        var tooltip = global.parser.parse(`The beast's erect member allures you. You wonder how it would feel inside of you.`);
        var popupContainer = global.ui.makeToolTip(button, tooltip, false, false, "width: 195px;");
        // Re-wrap with proper positioning.
        button = `<div class="inlinechoice">`;
        button += popupContainer;
        button += `</div>`;

        return button;
    }

    /**
     * Builds and returns the choice of this section.
     * @returns {string} The choice of this section.
     */
    function buildChoice() {
        var choice = `<div class="choicecontainer"><div class="inlinechoiceheader">You:</div>`;
        choice += buildFirstChoice();
        choice += `<hr class="inlinechoiceseparator">`;
        choice += buildSecondChoice();
        choice += `<hr class="inlinechoiceseparator">`;
        choice += buildThirdChoice();
        choice += `</div>`;
        return choice;
    }

    /**
     * Disables all three buttons.
     */
    function disableButtons() {
        var buttons = [$("#" + firstId), $("#" + secondId), $("#" + thirdId)];
        buttons.forEach(function (button) {
            button.unbind();
            button.attr("disabled", true);
        });
    }

    /**
     * Loads and displays the next part.
     * @param {object} part Which part to load.
     */
    function loadNextPart(part) {
        var built = part.build(true);
        global.ui.appendBeforeFinisher(built, global.ui.genericHeaderId);
        $("#" + part.id).fadeIn(400);
        part.registerListeners();
    }

    /**
     * Adds a listener to the button.
     */
    function registerFirstListener() {
        $("#" + firstId).click(function () {
            $(this).addClass("selected");
            disableButtons();
            subController.set(firstChoice);
            loadNextPart(firstNext);
        });
    }

    /**
     * Adds a listener to the button.
     */
    function registerSecondListener() {
        $("#" + secondId).click(function () {
            $(this).addClass("selected");
            disableButtons();
            subController.set(secondChoice);
            loadNextPart(secondNext);
        });
    }

    /**
     * Adds a listener to the button.
     */
    function registerThirdListener() {
        $("#" + thirdId).click(function () {
            $(this).addClass("selected");
            disableButtons();
            subController.set(thirdChoice);
            loadNextPart(thirdNext);
        });
    }

    // PUBLIC MEMBERS \\        this.public = "test";
    this.id = arguments.callee.name;

    // PUBLIC FUNCTIONS \\      this.publicFunction = function(){};

    /**
     * Builds and returns this part.
     * @param {boolean} invisible If passed and true, will give the entire section a display:none style.
     */
    this.build = function (invisible) {
        if (reqController && ((reqChoice && reqController.get() !== reqChoice) || (!reqChoice && !reqController.continued()))) {
            return "";
        }

        var part = `<div id="${that.id}" ${invisible ? 'style="display:none;"' : ""}>`;
        part += buildContent();
        part += (changeController && changeController.change()) || "";
        part += buildChoice();
        part += `</div>`;
        part += firstNext.build();
        part += secondNext.build();
        part += thirdNext.build();
        return part;
    };

    /**
     * Registers all the required button listeners for this part.
     */
    this.registerListeners = function () {
        if (reqController && ((reqChoice && reqController.get() !== reqChoice) || (!reqChoice && !reqController.continued()))) {
            return;
        }

        firstNext.registerListeners();
        secondNext.registerListeners();
        thirdNext.registerListeners();

        if (subController.has()) {
            return;
        }

        registerFirstListener();
        registerSecondListener();
        registerThirdListener();
    };
}

var UndergroundCaveReflectionDominanceChoice = {
    ORAL: 1,
    SEX: 2,
    SUB: 3
};

// END scenes\HamletDay2\UndergroundCave\mirror\succeed\dominance\UndergroundCaveReflectionDominance.js

// scenes\HamletDay2\UndergroundCave\mirror\succeed\leave\UndergroundCaveReflectionLeaveContinue.js

/**
 * Reflect section of the Underground Cave.
 * @param {UndergroundCaveController} controller The Underground Cave controller.
 */
function UndergroundCaveReflectionLeaveContinue(controller) {
    // PRIVATE MEMBERS \\       var private = "test";
    var that = this;
    var ctrl = controller;

    var reqChoice = false;
    var reqController = ctrl.preContinue;
    var changeController = ctrl.reflectLeaveContinue;

    var continueId = arguments.callee.name + "ButtonOne";

    // PRIVATE FUNCTIONS \\     function privateFunction(){}

    /**
     * Builds and returns the content of this section.
     * @returns {string} The content.
     */
    function buildContent() {
        var toReturn = `[p]
                            You run alongside the water as best you can,
                            scared the basilisk might chase after you still.
                            You nearly fall down, only barely managing to retain your balance, and decide to lower your pace to a brisk march instead.
                            A few minutes of expeditious walking later, daylight comes into sight.
                            As you expected: the water was a stale branch of the river!
                            Climbing out of the cave, you sit your butt down on the riverside dirt, and take a breather.
                            You feel like you've earned one.
                        [/p]
                        [p]
                            You find yourself close to the road to Varanar.
                            In fact, you believe you passed this very place earlier, when heading for the hamlet.
                            You never knew there was a cave here, but then again,
                            you've never really bothered to scour the edge of the river for points of interest.
                        [/p]
                        [p]
                            You've defied death more than once today.
                            You should consider yourself lucky to be alive.
                            The trip into the well was a harrowing experience.
                            You nearly got crushed, almost drowned, and after all of that, you managed to subdue a basilisk.
                            Or at least you [i]prevented[/i] it from [b]killing you[/b].
                        [/p]
                        [p]
                            You've gained a few awesome stories to tell once you've grown old and wise.
                            Stories like the ones Seki used to tell you when you were little.
                            You went through all that trouble to get your mind off of him, and here you are reminiscing once more.
                            You just can't help yourself from clinging to times long gone.
                            Things were so much simpler back then.
                            You miss those days.
                        [/p]
                        [p]
                            The sun is slowly starting to set.
                            You drag yourself to your feet.
                            It's time to go.
                            Varanar isn't [i]that[/i] far off.
                            If your legs don't give out from underneath you, you might still make it there before nightfall.
                        [/p]`;

        return global.parser.parse(toReturn);
    }

    /**
     * Builds and returns the continue button.
     */
    function buildChoice() {
        var disabled = ctrl.continued();
        var choice = `<div class="choicecontainer">`;
        choice += `<button class="button bigbutton continuebutton" id="${continueId}" ${disabled ? "disabled" : ""}>`;
        choice += `Continue &gt;&gt`;
        choice += `</button>`;
        choice += `</div>`;
        return choice;
    }

    /**
     * Disables all three buttons.
     */
    function disableButtons() {
        var buttons = [$("#" + continueId)];
        buttons.forEach(function (button) {
            button.unbind();
            button.attr("disabled", true);
        });
    }

    /**
     * Loads and displays the next scene.
     * @param {string} sceneName Name of the scene to load.
     * @param {string} folder Folder of the scene to load.
     */
    function loadNextPart(sceneName, folder) {
        global.ui.fadeOutContent(function () {
            global.sceneEnd();
            global.sceneLoader.loadScene(sceneName, folder);
        });
    }

    /**
     * Adds a listener to the button.
     */
    function registerContinueListener() {
        $("#" + continueId).click(function () {
            $(this).addClass("selected");
            disableButtons();
            ctrl.continue();
            loadNextPart(ctrl.nextSceneName, ctrl.nextFolderName);
        });
    }

    // PUBLIC MEMBERS \\        this.public = "test";
    this.id = arguments.callee.name;

    // PUBLIC FUNCTIONS \\      this.publicFunction = function(){};

    /**
     * Builds and returns this part.
     * @param {boolean} invisible If passed and true, will give the entire section a display:none style.
     */
    this.build = function (invisible) {
        if (reqController && ((reqChoice && reqController.get() !== reqChoice) || (!reqChoice && !reqController.continued()))) {
            return "";
        }

        ctrl.bgm.stopLoop();
        global.ui.applyTheme("hamlet_day");
        var part = `<div id="${that.id}" ${invisible ? 'style="display:none;"' : ""}>`;
        part += buildContent();
        part += (changeController && changeController.change()) || "";
        part += buildChoice();
        if (!ctrl.nextSceneReady) {
            part += `<span class="todo">There is no content beyond this point.</span>`;
        }
        part += `</div>`;
        return part;
    };

    /**
     * Registers all the required button listeners for this part.
     */
    this.registerListeners = function () {
        if (reqController && ((reqChoice && reqController.get() !== reqChoice) || (!reqChoice && !reqController.continued()))) {
            return;
        }

        if (ctrl.continued()) {
            return;
        }

        if (ctrl.nextSceneReady) {
            registerContinueListener();
        }
    };
}

// END scenes\HamletDay2\UndergroundCave\mirror\succeed\leave\UndergroundCaveReflectionLeaveContinue.js

// scenes\HamletDay2\UndergroundCave\mirror\succeed\leave\UndergroundCaveReflectionLeave.js

/**
 * Reflect section of the Underground Cave.
 * @param {UndergroundCaveController} controller The Underground Cave controller.
 */
function UndergroundCaveReflectionLeave(controller) {
    // PRIVATE MEMBERS \\       var private = "test";
    var that = this;
    var ctrl = controller;

    var reqChoice = UndergroundCaveReflectionSucceedChoice.LEAVE;
    var reqController = ctrl.reflectSucceed;
    var setChoice = false;
    var subController = ctrl.preContinue;
    var changeController = ctrl.reflectLeave;

    var continueId = arguments.callee.name + "ButtonOne";
    var next = new UndergroundCaveReflectionLeaveContinue(ctrl);

    // PRIVATE FUNCTIONS \\     function privateFunction(){}

    /**
     * Builds and returns the content of this section.
     * @returns {string} The content.
     */
    function buildContent() {
        var toReturn = `[p]
                            With the beast subdued, you have little reason to stick around.
                            You could probably [i]kill it[/i] or something,
                            but killing a defenceless, surrendering animal seems pointlessly cruel.
                            And you really don't want to tempt fate by trying anything [i]dumb[/i].
                        [/p]
                        [p]
                            You slowly back away from the basilisk,
                            holding the mirror shard up like a preacher would a crucifix in front of a vampire.
                            It doesn't move, instead staying in place, lying on its back, its tongue partially lolling out of its gaping maw.
                            The monster looks like it's playing dead, which is almost funny, in a way.
                        [/p]
                        [p]
                            You put some distance in between yourself and the crocodillian, backing off until its green-glowing eyes start to fade into the dark.
                            Despite no longer being able to see them, you can still picture those two intriguing emerald orbs in your head.
                            While the big reptile is no longer a threat to you, you don't think you'll ever be able to forget its terrifying, soul-gazing glare.
                            With the monster out of sight, you discard the glass shard, turn tail and flee.
                        [/p]`;
        return global.parser.parse(toReturn);
    }

    /**
     * Builds and returns the choice button.
     */
    function buildNextChoice() {
        var disabled = subController.continued() ? "disabled" : "";
        var isSelected = subController.continued();
        var selected = isSelected ? "selected" : "";
        var button = `<button class="button inlinechoice ${selected}" id="${continueId}" ${disabled}>Continue</button>`;
        return button;
    }

    /**
     * Builds and returns the choice of this section.
     * @returns {string} The choice of this section.
     */
    function buildChoice() {
        var choice = `<div class="choicecontainer">`;
        choice += buildNextChoice();
        choice += `</div>`;
        return choice;
    }

    /**
     * Disables all three buttons.
     */
    function disableButtons() {
        var buttons = [$("#" + continueId)];
        buttons.forEach(function (button) {
            button.unbind();
            button.attr("disabled", true);
        });
    }

    /**
     * Loads and displays the next part.
     * @param {object} part Which part to load.
     */
    function loadNextPart(part) {
        var built = part.build(true);
        global.ui.appendBeforeFinisher(built, global.ui.genericHeaderId);
        $("#" + part.id).fadeIn(400);
        part.registerListeners();
    }

    /**
     * Adds a listener to the button.
     */
    function registerNextListener() {
        $("#" + continueId).click(function () {
            $(this).addClass("selected");
            disableButtons();
            setChoice ? subController.set(setChoice) : subController.continue();
            loadNextPart(next);
        });
    }

    // PUBLIC MEMBERS \\        this.public = "test";
    this.id = arguments.callee.name;

    // PUBLIC FUNCTIONS \\      this.publicFunction = function(){};

    /**
     * Builds and returns this part.
     * @param {boolean} invisible If passed and true, will give the entire section a display:none style.
     */
    this.build = function (invisible) {
        if (reqController && ((reqChoice && reqController.get() !== reqChoice) || (!reqChoice && !reqController.continued()))) {
            return "";
        }


        var part = `<div id="${that.id}" ${invisible ? 'style="display:none;"' : ""}>`;
        part += buildContent();
        part += (changeController && changeController.change()) || "";
        part += buildChoice();
        part += `</div>`;
        part += next.build();
        return part;
    };

    /**
     * Registers all the required button listeners for this part.
     */
    this.registerListeners = function () {
        if (reqController && ((reqChoice && reqController.get() !== reqChoice) || (!reqChoice && !reqController.continued()))) {
            return;
        }

        next.registerListeners();

        if (subController.continued()) {
            return;
        }

        registerNextListener();
    };
}

// END scenes\HamletDay2\UndergroundCave\mirror\succeed\leave\UndergroundCaveReflectionLeave.js

// scenes\HamletDay2\UndergroundCave\mirror\succeed\petrify\UndergroundCaveReflectionPetrifyContinue.js

/**
 * Reflect section of the Underground Cave.
 * @param {UndergroundCaveController} controller The Underground Cave controller.
 */
function UndergroundCaveReflectionPetrifyContinue(controller) {
    // PRIVATE MEMBERS \\       var private = "test";
    var that = this;
    var ctrl = controller;

    var reqChoice = false;
    var reqController = ctrl.preContinue;
    var changeController = ctrl.reflectPetrifyContinue;

    var continueId = arguments.callee.name + "ButtonOne";

    // PRIVATE FUNCTIONS \\     function privateFunction(){}

    /**
     * Builds and returns the content of this section.
     * @returns {string} The content.
     */
    function buildContent() {
        var toReturn = `[p]
                            You did it!
                            You killed a deadly monster, all by yourself!
                            Just like a knight would do!
                            Somehow, you don't feel very [i]knightly[/i], though.
                            You should be proud of yourself, but for some reason, you aren't.
                            Maybe your actions weren't as [i]chivalrous[/i] as you would have liked,
                            but it's the outcome that matters, and not how you achieved it, right?
                            The ends justify the means.
                        [/p]
                        [p]
                            But then again, the basilisk had surrendered.
                            It was no longer intent on hurting you.
                            It even rolled belly-up to display its submissiveness.
                            And yet you still persisted in petrifying it to death.
                            Now you're confused.
                            Did you do the right thing?
                        [/p]
                        [p]
                            You honestly don't know anymore.
                            Does it even matter?
                            What's done is done.
                            If you hadn't killed the creature, some pompous knight in shining armor
                            -- with nothing left to prove, neither to himself, nor to the world --
                            would have strolled into this cave to add another tally to his already impressive list of slain monsters.
                            For someone properly armed and armored, this would have been a [b]chore[/b], a menial task barely even worthy of mention.
                            But for you, this is a feat you'll remember until the day you die.
                        [/p]
                        [p]
                            Your conviction bolstered, you wait for a few more minutes to make sure it's really [b]dead[/b],
                            before approaching the giant lizard once again.
                            Kneeling besides it, you figure it's time to take a trophy.
                            Something to remember this day by.
                            Something you can show to people, so they'll believe you when you tell them you singlehandedly killed a basilisk.
                            But what?
                        [/p]
                        [p]
                            While pondering, you run one of your hands over the deceased basilisk's exposed belly, now a lot [i]harder[/i] than what it used to be.
                            You briefly consider taking the entire [i]statue[/i] with you, but it's [b]far[/b] too heavy.
                            As your sight wanders over the monster's underbelly, you notice that its once-supple scales are not the only thing [i]hardened[/i].
                            The beast seems to have been [i]fully erect[/i] at the time of its death.
                            Its girthy, ridged and draconic-looking member stands fully erect, every bit as petrified as the rest of its body.
                            It must've been in rut or something.
                            Maybe that's why it was so fiercely defending its lair.
                        [/p]
                        [p]
                            You briefly consider [i]snapping off[/i] the dead monster's stone-turned dick,
                            but you figure it would be [b]very[/b] awkward to use [i]that[/i] as a token of your kill, let alone trying to [i]sell it[/i].
                        [/p]
                        [p]
                            Figuring there isn't anything else worthwhile to take, you decide it's time to find a way out of the cave.
                            Following the river-branch should lead you to some kind of exit.
                            Without the threat of the basilisk around, you don't even need the glass shard anymore.
                            You discard it, before leisurely strolling alongside the water, until daylight comes into sight.
                            As you expected: the water was a stale branch of the river!
                            Climbing out of the cave, you sit your butt down on the riverside dirt, and take a breather.
                            You feel like you've earned one.
                        [/p]
                        [p]
                            You've defied death more than once today.
                            You should consider yourself lucky to be alive.
                            The trip into the well was a harrowing experience.
                            You nearly got crushed, almost drowned, and after all of that, you managed to kill a basilisk by making it petrify itself!
                        [/p]
                        [p]
                            You've gained a few awesome stories to tell once you've grown old and wise.
                            Stories like the ones Seki used to tell you when you were little.
                            You went through all that trouble to get your mind off of him, and here you are reminiscing once more.
                            You just can't help yourself from clinging to times long gone.
                            Things were so much simpler back then.
                            You miss those days.
                        [/p]
                        [p]
                            The sun is slowly starting to set.
                            You drag yourself to your feet.
                            It's time to go.
                            Varanar isn't [i]that[/i] far off.
                            If your legs don't give out from underneath you, you might still make it there before nightfall.
                        [/p]`;

        return global.parser.parse(toReturn);
    }

    /**
     * Builds and returns the continue button.
     */
    function buildChoice() {
        var disabled = ctrl.continued();
        var choice = `<div class="choicecontainer">`;
        choice += `<button class="button bigbutton continuebutton" id="${continueId}" ${disabled ? "disabled" : ""}>`;
        choice += `Continue &gt;&gt`;
        choice += `</button>`;
        choice += `</div>`;
        return choice;
    }

    /**
     * Disables all three buttons.
     */
    function disableButtons() {
        var buttons = [$("#" + continueId)];
        buttons.forEach(function (button) {
            button.unbind();
            button.attr("disabled", true);
        });
    }

    /**
     * Loads and displays the next scene.
     * @param {string} sceneName Name of the scene to load.
     * @param {string} folder Folder of the scene to load.
     */
    function loadNextPart(sceneName, folder) {
        global.ui.fadeOutContent(function () {
            global.sceneEnd();
            global.sceneLoader.loadScene(sceneName, folder);
        });
    }

    /**
     * Adds a listener to the button.
     */
    function registerContinueListener() {
        $("#" + continueId).click(function () {
            $(this).addClass("selected");
            disableButtons();
            ctrl.continue();
            loadNextPart(ctrl.nextSceneName, ctrl.nextFolderName);
        });
    }

    // PUBLIC MEMBERS \\        this.public = "test";
    this.id = arguments.callee.name;

    // PUBLIC FUNCTIONS \\      this.publicFunction = function(){};

    /**
     * Builds and returns this part.
     * @param {boolean} invisible If passed and true, will give the entire section a display:none style.
     */
    this.build = function (invisible) {
        if (reqController && ((reqChoice && reqController.get() !== reqChoice) || (!reqChoice && !reqController.continued()))) {
            return "";
        }

        ctrl.bgm.stopLoop();
        global.ui.applyTheme("hamlet_day");
        var part = `<div id="${that.id}" ${invisible ? 'style="display:none;"' : ""}>`;
        part += buildContent();
        part += (changeController && changeController.change()) || "";
        part += buildChoice();
        if (!ctrl.nextSceneReady) {
            part += `<span class="todo">There is no content beyond this point.</span>`;
        }
        part += `</div>`;
        return part;
    };

    /**
     * Registers all the required button listeners for this part.
     */
    this.registerListeners = function () {
        if (reqController && ((reqChoice && reqController.get() !== reqChoice) || (!reqChoice && !reqController.continued()))) {
            return;
        }

        if (ctrl.continued()) {
            return;
        }

        if (ctrl.nextSceneReady) {
            registerContinueListener();
        }
    };
}

// END scenes\HamletDay2\UndergroundCave\mirror\succeed\petrify\UndergroundCaveReflectionPetrifyContinue.js

// scenes\HamletDay2\UndergroundCave\mirror\succeed\petrify\UndergroundCaveReflectionPetrify.js

/**
 * Reflect section of the Underground Cave.
 * @param {UndergroundCaveController} controller The Underground Cave controller.
 */
function UndergroundCaveReflectionPetrify(controller) {
    // PRIVATE MEMBERS \\       var private = "test";
    var that = this;
    var ctrl = controller;

    var reqChoice = UndergroundCaveReflectionSucceedChoice.PETRIFY;
    var reqController = ctrl.reflectSucceed;
    var setChoice = false;
    var subController = ctrl.preContinue;
    var changeController = ctrl.reflectPetrify;

    var continueId = arguments.callee.name + "ButtonOne";
    var next = new UndergroundCaveReflectionPetrifyContinue(ctrl);

    // PRIVATE FUNCTIONS \\     function privateFunction(){}

    /**
     * Builds and returns the content of this section.
     * @returns {string} The content.
     */
    function buildContent() {
        var toReturn = `[p]
                            Seeing an opportunity for greatness, you press your advantage.
                            You hold the mirror shard directly in front of the basilisk's eyes, [b]forcing[/b] it to stare at its own enchanting gaze.
                            You could probably just [b]rake open[/b] its throat instead, but you kind of [i]like[/i] turning its own weapon against the beast.
                            The creature tries to look away, but after a few seconds, its own alluring reflection captures its sight.
                            It lets out another whine, audibly scared.
                            This is clearly not what it expected – or hoped – to happen.
                        [/p]
                        [p]
                            The big reptile is too weak to resist now.
                            Too far gone already.
                            Its breathing grows slower, weaker.
                            Its flicking tongue grows limp.
                            Its bestial snout locks in place.
                            Its rocky scales lose whatever color they had, and the muscles underneath them stop moving.
                            Finally, as its breathing comes to a complete halt, its very eyes turn to stone, and then you know it is over.
                        [/p]
                        [p]
                            [c]
                                [b]
                                    You have killed the basilisk.
                                [/b]
                            [/c]
                        [/p]`;
        return global.parser.parse(toReturn);
    }

    /**
     * Builds and returns the choice button.
     */
    function buildNextChoice() {
        var disabled = subController.continued() ? "disabled" : "";
        var isSelected = subController.continued();
        var selected = isSelected ? "selected" : "";
        var button = `<button class="button inlinechoice ${selected}" id="${continueId}" ${disabled}>Continue</button>`;
        return button;
    }

    /**
     * Builds and returns the choice of this section.
     * @returns {string} The choice of this section.
     */
    function buildChoice() {
        var choice = `<div class="choicecontainer">`;
        choice += buildNextChoice();
        choice += `</div>`;
        return choice;
    }

    /**
     * Disables all three buttons.
     */
    function disableButtons() {
        var buttons = [$("#" + continueId)];
        buttons.forEach(function (button) {
            button.unbind();
            button.attr("disabled", true);
        });
    }

    /**
     * Loads and displays the next part.
     * @param {object} part Which part to load.
     */
    function loadNextPart(part) {
        var built = part.build(true);
        global.ui.appendBeforeFinisher(built, global.ui.genericHeaderId);
        $("#" + part.id).fadeIn(400);
        part.registerListeners();
    }

    /**
     * Adds a listener to the button.
     */
    function registerNextListener() {
        $("#" + continueId).click(function () {
            $(this).addClass("selected");
            disableButtons();
            setChoice ? subController.set(setChoice) : subController.continue();
            loadNextPart(next);
        });
    }

    // PUBLIC MEMBERS \\        this.public = "test";
    this.id = arguments.callee.name;

    // PUBLIC FUNCTIONS \\      this.publicFunction = function(){};

    /**
     * Builds and returns this part.
     * @param {boolean} invisible If passed and true, will give the entire section a display:none style.
     */
    this.build = function (invisible) {
        if (reqController && ((reqChoice && reqController.get() !== reqChoice) || (!reqChoice && !reqController.continued()))) {
            return "";
        }

        var part = `<div id="${that.id}" ${invisible ? 'style="display:none;"' : ""}>`;
        part += buildContent();
        part += (changeController && changeController.change()) || "";
        part += buildChoice();
        part += `</div>`;
        part += next.build();
        return part;
    };

    /**
     * Registers all the required button listeners for this part.
     */
    this.registerListeners = function () {
        if (reqController && ((reqChoice && reqController.get() !== reqChoice) || (!reqChoice && !reqController.continued()))) {
            return;
        }

        next.registerListeners();

        if (subController.continued()) {
            return;
        }

        registerNextListener();
    };
}

// END scenes\HamletDay2\UndergroundCave\mirror\succeed\petrify\UndergroundCaveReflectionPetrify.js

// scenes\HamletDay2\UndergroundCave\mirror\succeed\strike\UndergroundCaveReflectionStrikeContinue.js

/**
 * Reflect section of the Underground Cave.
 * @param {UndergroundCaveController} controller The Underground Cave controller.
 */
function UndergroundCaveReflectionStrikeContinue(controller) {
    // PRIVATE MEMBERS \\       var private = "test";
    var that = this;
    var ctrl = controller;

    var reqChoice = false;
    var reqController = ctrl.preContinue;
    var changeController = ctrl.reflectStrikeContinue;

    var continueId = arguments.callee.name + "ButtonOne";

    // PRIVATE FUNCTIONS \\     function privateFunction(){}

    /**
     * Builds and returns the content of this section.
     * @returns {string} The content.
     */
    function buildContent() {
        var toReturn = `[p]
                            You did it!
                            You killed a deadly monster, all by yourself!
                            Just like a knight would do!
                            Somehow, you don't feel very [i]knightly[/i], though.
                            You should be proud of yourself, but for some reason, you aren't.
                            Maybe your actions weren't as [i]chivalrous[/i] as you would have liked,
                            but it's the outcome that matters, and not how you achieved it, right?
                            The ends justify the means.
                        [/p]
                        [p]
                            But then again, the basilisk had surrendered.
                            It was no longer intent on hurting you.
                            It even rolled belly-up to display its submissiveness.
                            Now you're confused.
                            Did you do the right thing?
                        [/p]
                        [p]
                            You honestly don't know anymore.
                            Does it even matter?
                            What's done is done.
                            If you hadn't killed the creature, some pompous knight in shining armor
                            -- with nothing left to prove, neither to himself, nor to the world --
                            would have strolled into this cave to add another tally to his already impressive list of slain monsters.
                            For someone properly armed and armored, this would have been a [b]chore[/b], a menial task barely even worthy of mention.
                            But for you, this is a feat you'll remember until the day you die.
                        [/p]
                        [p]
                            Your conviction bolstered, you wait for a few more minutes to make sure it's really [b]dead[/b],
                            before approaching the giant lizard once again.
                            Kneeling besides it, you figure it's time to take a trophy.
                            Something to remember this day by.
                            Something you can show to people, so they'll believe you when you tell them you singlehandedly killed a basilisk.
                            But what?
                        [/p]
                        [p]
                            While pondering, you run one of your hands over the deceased basilisk's back.
                            Some of its scales seem to be rather [i]loose[/i].
                            You take hold of one with both of your hands, and with surprising ease, you manage to [b]tear[/b] the scale from the monster's backside.
                            Like plucking a chicken.
                            You repeat the process a couple of times,
                            until you have collected a suitable handful of ${global.kobold.inventory.createItemWithTooltip(new BasiliskScales())}
                            to take with as your prize for ridding the world of this horrible monstrosity.
                        [/p]
                        [p]
                            Your trophies collected, you decide it's time to find a way out of the cave.
                            Following the river-branch should lead you to some kind of exit.
                            Without the threat of the basilisk around, you don't even need the glass shard anymore.
                            You discard it, before leisurely strolling alongside the water, until daylight comes into sight.
                            As you expected: the water was a stale branch of the river!
                            Climbing out of the cave, you sit your butt down on the riverside dirt, and take a breather.
                            You feel like you've earned one.
                        [/p]
                        [p]
                            You've defied death more than once today.
                            You should consider yourself lucky to be alive.
                            The trip into the well was a harrowing experience.
                            You nearly got crushed, almost drowned, and after all of that, you managed to kill a basilisk.
                            It might not have been the most [i]honorable[/i] way of slaying the beast, but it was slain nonetheless.
                        [/p]
                        [p]
                            Besides the ${global.kobold.inventory.createItemWithTooltip(new BasiliskScales())} you [i]harvested[/i],
                            you've gained a few awesome stories to tell once you've grown old and wise.
                            Stories like the ones Seki used to tell you when you were little.
                            You went through all that trouble to get your mind off of him, and here you are reminiscing once more.
                            You just can't help yourself from clinging to times long gone.
                            Things were so much simpler back then.
                            You miss those days.
                        [/p]
                        [p]
                            The sun is slowly starting to set.
                            You drag yourself to your feet.
                            It's time to go.
                            Varanar isn't [i]that[/i] far off.
                            If your legs don't give out from underneath you, you might still make it there before nightfall.
                        [/p]`;

        return global.parser.parse(toReturn);
    }

    /**
     * Builds and returns the continue button.
     */
    function buildChoice() {
        var disabled = ctrl.continued();
        var choice = `<div class="choicecontainer">`;
        choice += `<button class="button bigbutton continuebutton" id="${continueId}" ${disabled ? "disabled" : ""}>`;
        choice += `Continue &gt;&gt`;
        choice += `</button>`;
        choice += `</div>`;
        return choice;
    }

    /**
     * Disables all three buttons.
     */
    function disableButtons() {
        var buttons = [$("#" + continueId)];
        buttons.forEach(function (button) {
            button.unbind();
            button.attr("disabled", true);
        });
    }

    /**
     * Loads and displays the next scene.
     * @param {string} sceneName Name of the scene to load.
     * @param {string} folder Folder of the scene to load.
     */
    function loadNextPart(sceneName, folder) {
        global.ui.fadeOutContent(function () {
            global.sceneEnd();
            global.sceneLoader.loadScene(sceneName, folder);
        });
    }

    /**
     * Adds a listener to the button.
     */
    function registerContinueListener() {
        $("#" + continueId).click(function () {
            $(this).addClass("selected");
            disableButtons();
            ctrl.continue();
            loadNextPart(ctrl.nextSceneName, ctrl.nextFolderName);
        });
    }

    // PUBLIC MEMBERS \\        this.public = "test";
    this.id = arguments.callee.name;

    // PUBLIC FUNCTIONS \\      this.publicFunction = function(){};

    /**
     * Builds and returns this part.
     * @param {boolean} invisible If passed and true, will give the entire section a display:none style.
     */
    this.build = function (invisible) {
        if (reqController && ((reqChoice && reqController.get() !== reqChoice) || (!reqChoice && !reqController.continued()))) {
            return "";
        }

        ctrl.bgm.stopLoop();
        global.ui.applyTheme("hamlet_day");
        var part = `<div id="${that.id}" ${invisible ? 'style="display:none;"' : ""}>`;
        part += buildContent();
        part += (changeController && changeController.change()) || "";
        part += buildChoice();
        if (!ctrl.nextSceneReady) {
            part += `<span class="todo">There is no content beyond this point.</span>`;
        }
        part += `</div>`;
        return part;
    };

    /**
     * Registers all the required button listeners for this part.
     */
    this.registerListeners = function () {
        if (reqController && ((reqChoice && reqController.get() !== reqChoice) || (!reqChoice && !reqController.continued()))) {
            return;
        }

        if (ctrl.continued()) {
            return;
        }

        if (ctrl.nextSceneReady) {
            registerContinueListener();
        }
    };
}

// END scenes\HamletDay2\UndergroundCave\mirror\succeed\strike\UndergroundCaveReflectionStrikeContinue.js

// scenes\HamletDay2\UndergroundCave\mirror\succeed\strike\UndergroundCaveReflectionStrike.js

/**
 * Reflect section of the Underground Cave.
 * @param {UndergroundCaveController} controller The Underground Cave controller.
 */
function UndergroundCaveReflectionStrike(controller) {
    // PRIVATE MEMBERS \\       var private = "test";
    var that = this;
    var ctrl = controller;

    var reqChoice = UndergroundCaveReflectionSucceedChoice.STRIKE;
    var reqController = ctrl.reflectSucceed;
    var setChoice = false;
    var subController = ctrl.preContinue;
    var changeController = ctrl.reflectFail;

    var continueId = arguments.callee.name + "ButtonOne";
    var next = new UndergroundCaveReflectionStrikeContinue(ctrl);

    // PRIVATE FUNCTIONS \\     function privateFunction(){}

    /**
     * Builds and returns the content of this section.
     * @returns {string} The content.
     */
    function buildContent() {
        var toReturn = `[p]
                            Seeing an opportunity for greatness, you decide to act on it.
                            While still brandishing the mirror shard with one hand, you move the other onto the monster's throat.
                            Expecting you to show it some mercy after it surrendered,
                            the basilisk's knows not what to do as you instead sink your sharp claws into its tender throat,
                            and rake open its windpipe in a single vicious [b]tear[/b].
                        [/p]
                        [p]
                            The beast's eyes shoot open wide.
                            It flips back upright, and limply thrashes its limbs around, hoping to mangle you, to take you down along with it,
                            but you manage to avoid most of its slow-paced rage by taking a quick step back.
                            While it continues to blindly rampage about, despite you having long cleared its imminent vicinity,
                            the basilisk's semi-petrified struggles soon die down.
                            Running out of air, its body slumps lifelessly down on the ground, in a pool of its own blood.
                            After one last, bloody gurgle, the big crocodillian closes its eyes, and drifts away into the afterlife.
                        [/p]
                        [p]
                            [c]
                                [b]You have killed the basilisk![/b]
                            [/c]
                        [/p]`;
        return global.parser.parse(toReturn);
    }

    /**
     * Builds and returns the choice button.
     */
    function buildNextChoice() {
        var disabled = subController.continued() ? "disabled" : "";
        var isSelected = subController.continued();
        var selected = isSelected ? "selected" : "";
        var button = `<button class="button inlinechoice ${selected}" id="${continueId}" ${disabled}>Continue</button>`;
        return button;
    }

    /**
     * Builds and returns the choice of this section.
     * @returns {string} The choice of this section.
     */
    function buildChoice() {
        var choice = `<div class="choicecontainer">`;
        choice += buildNextChoice();
        choice += `</div>`;
        return choice;
    }

    /**
     * Disables all three buttons.
     */
    function disableButtons() {
        var buttons = [$("#" + continueId)];
        buttons.forEach(function (button) {
            button.unbind();
            button.attr("disabled", true);
        });
    }

    /**
     * Loads and displays the next part.
     * @param {object} part Which part to load.
     */
    function loadNextPart(part) {
        var built = part.build(true);
        global.ui.appendBeforeFinisher(built, global.ui.genericHeaderId);
        $("#" + part.id).fadeIn(400);
        part.registerListeners();
    }

    /**
     * Adds a listener to the button.
     */
    function registerNextListener() {
        $("#" + continueId).click(function () {
            $(this).addClass("selected");
            disableButtons();
            setChoice ? subController.set(setChoice) : subController.continue();
            loadNextPart(next);
        });
    }

    // PUBLIC MEMBERS \\        this.public = "test";
    this.id = arguments.callee.name;

    // PUBLIC FUNCTIONS \\      this.publicFunction = function(){};

    /**
     * Builds and returns this part.
     * @param {boolean} invisible If passed and true, will give the entire section a display:none style.
     */
    this.build = function (invisible) {
        if (reqController && ((reqChoice && reqController.get() !== reqChoice) || (!reqChoice && !reqController.continued()))) {
            return "";
        }

        var part = `<div id="${that.id}" ${invisible ? 'style="display:none;"' : ""}>`;
        part += buildContent();
        part += (changeController && changeController.change()) || "";
        part += buildChoice();
        part += `</div>`;
        part += next.build();
        return part;
    };

    /**
     * Registers all the required button listeners for this part.
     */
    this.registerListeners = function () {
        if (reqController && ((reqChoice && reqController.get() !== reqChoice) || (!reqChoice && !reqController.continued()))) {
            return;
        }

        next.registerListeners();

        if (subController.continued()) {
            return;
        }

        registerNextListener();
    };
}

// END scenes\HamletDay2\UndergroundCave\mirror\succeed\strike\UndergroundCaveReflectionStrike.js

// scenes\HamletDay2\UndergroundCave\mirror\succeed\UndergroundCaveReflectionSucceed.js

/**
 * Reflect section of the Underground Cave.
 * @param {UndergroundCaveController} controller The Underground Cave controller.
 */
function UndergroundCaveReflectionSucceed(controller) {
    // PRIVATE MEMBERS \\       var private = "test";
    var that = this;
    var ctrl = controller;

    var reqChoice = false;
    var reqController = false;
    var subController = ctrl.reflectSucceed;
    var changeController = ctrl.reflectSucceed;

    var firstId = arguments.callee.name + "ButtonOne";
    var secondId = arguments.callee.name + "ButtonTwo";
    var thirdId = arguments.callee.name + "ButtonThree";
    var fourthId = arguments.callee.name + "ButtonFour";

    var firstNext = new UndergroundCaveReflectionStrike(ctrl);
    var secondNext = new UndergroundCaveReflectionLeave(ctrl);
    var thirdNext = new UndergroundCaveReflectionPetrify(ctrl);
    var fourthNext = new UndergroundCaveReflectionDominance(ctrl);

    var firstChoice = UndergroundCaveReflectionSucceedChoice.STRIKE;
    var secondChoice = UndergroundCaveReflectionSucceedChoice.LEAVE;
    var thirdChoice = UndergroundCaveReflectionSucceedChoice.PETRIFY;
    var fourthChoice = UndergroundCaveReflectionSucceedChoice.DOMINATE;

    // PRIVATE FUNCTIONS \\     function privateFunction(){}

    /**
     * Builds and returns the content of this section.
     * @returns {string} The content.
     */
    function buildContent() {
        global.kobold.history.shared.well.basiliskMirror = true;
        global.kobold.history.shared.well.basiliskMet = true;
        var toReturn = `[p]
                            Your mind races, even as your body freezes.
                            How are you supposed to respond?!
                            You can't look away.
                            If it's a predator, it might take that as a sign of weakness.
                            Still, you're too [b]afraid[/b] to boldly stare back.
                            Those eyes are pretty scary.
                            You're left in an impasse, your frailty showing regardless of whether or not you look at the eyes.
                        [/p]
                        [p]
                            Then a thought flashes through your head.
                            An idea.
                            You bought something, something that can help!
                            Something that'll allow you to combine the best of both worlds!
                            You're talking about the ${global.kobold.inventory.createItemWithTooltip(new SmallMirror())} in your backpack.
                            With it, you can give the monster something to stare at, without having to look at it yourself.
                            You're saved!
                        [/p]
                        [p]
                            A lot of animals get spooked by their own reflections.
                            Seki once told you that, anyway.
                            He mentioned [i]why[/i], but you can't really recall that part of his [i]lecture[/i].
                            Would the monster think you're its peer instead of prey, and thus leave you alone?
                            Or perhaps it'd find out that it's got a real nasty look on its face.
                            Either way, the mirror is your best bet.
                        [/p]
                        [p]
                            You keep your vision focused on the cavern wall, right next to the set of eyes staring at you,
                            trying to make it look like you [i]aren't[/i] afraid, without challenging the monster too much.
                            At the same time, you begin to look for the ${global.kobold.inventory.createItemWithTooltip(new SmallMirror())} on your person.
                        [/p]
                        [p]
                            Suddenly, your whole body jolts as something sharp pierces your fingertip!
                            A pained grunt escapes your muzzle.
                            Did you accidentally bump against an edgy stone?
                            No, it wasn't a rock.
                            Thanks to your haphazard adventure in the well,
                            your ${global.kobold.inventory.createItemWithTooltip(new SmallMirror())} seems to have broken into a million little pieces.
                            Must have gotten hit by some of the debris when the entire place came down on top of your head.
                            Your heart sinks.
                            Terror settles in, your best plan shattered.
                        [/p]
                        [p]
                            The creature in the dark scuttles closer, redoubling its stare.
                            You can remotely make out the outline of something [b]big[/b] and [b]scaly[/b].
                            You can feel it growing [i]impatient[/i], like it's almost done [i]playing[/i] with you.
                            No, no, no!
                            You have no choice [b]but[/b] to gaze directly into its eyes, putting on your bravest face to hopefully keep the monster at bay.
                        [/p]
                        [p]
                            Fueled by desperation, you scoop the broken pieces to your front.
                            They loudly [b]scrape[/b] across the stone floor.
                            Once repositioned, your hands keep searching through the broken mirror's shards.
                            You get cut several times more, but you barely even notice, your mind completely [b]clogged[/b] with fright.
                            Your fingers clench around several fragments, trying, but failing to find one big enough to [i]wield[/i].
                            All the while, the creature's stare [b]burns[/b] itself into your mind.
                        [/p]
                        [p]
                            You stubbornly cling to your plan.
                            Both your hands continue to fumble about the shards.
                            If you can find a large enough mirror-piece, you'll be [b]saved[/b]!
                            But it's no use.
                            All of the fragments are far too tiny, completely useless.
                            You can feel your fingertips growing slightly more [i]stiff[/i] and [i]rigid[/i],
                            a fact you attribute to the multitude of small cuts you've sustained.
                        [/p]
                        [p]
                            Right as you were about to give up hope, due to a combination of sheer [b]luck[/b] and skillful searching,
                            your digits stroke across a medium-sized smooth surface.
                            An intact piece!
                            Despite your hand hurting, you grip on to the intact mirror-piece,
                            the edges cutting into your scales as you arduously lift it up for the creature to see.
                        [/p]
                        ${global.ui.condSucc(`Agility and luck greater than 5`)}
                        [p]
                            The dim green glow radiated by the monster's eyes is reflected back onto itself, giving you a first look at what it [i]actually[/i] is.
                            At first, you can't even [i]identify[/i] it.
                            Before you stands a feral, quadrupedal lizard with large, protruding, rock-like scales and a sizeable maw filled with sharp, pointy teeth. 
                            A crocodilian with a stony hide.
                            You think Seki once told you a story about a beast like this.
                            Could it be... a basilisk?!
                        [/p]
                        [p]
                            Startled, you rise to your feet.
                            If Seki's tales are to be believed,
                            this creature has the ability to petrify anyone who dares to look at it!
                            That explains the sudden [i]stiffness[/i] you were feeling just now.
                            No wonder it has such enchanting eyes.
                        [/p]
                        [p]
                            The basilisk appears to be focusing all of its attention on the shard in your hands.
                            It seems perplexed by its own, reflected gaze, undoubtedly in the process of turning to stone itself.
                            You can't help but smirk a little.
                            You unintentionally outsmarted it even more than you thought you were!
                            You turned the beast's petrification against itself!
                            You feel like one of those heroes people write songs about,
                            matching horrifying monsters' evil tricks with your quick wit and bravery!
                        [/p]
                        [p]
                            Emboldened by the thought of being seen as a hero, you take a few steps forwards,
                            holding the shard in front of the feral the entire time, until you're naught but a few feet away from it.
                            This could still end horribly for you.
                            If you drop your guard for even a moment, or if the creature snaps from its enthrallment,
                            it could easily pounce on you and tear you to shreds.
                            Perhaps you advanced a little too [i]rashly[/i], but there's no backing out now.
                            You've committed to this [i]strategy[/i], and now you need to see it through.
                        [/p]
                        [p]
                            The crocodilian finally notices your approach.
                            It tries to attack you, visibly surprised that it can hardly move any of its own limbs.
                            The basilisk hisses loudly, but about halfway through, the hiss turns into a [i]whine[/i],
                            as the beast realizes that it can't fight like this.
                            Its harsh glare softens.
                            It's almost as though the monster looks kind of [i]sad[/i].
                            Does that mean you've [i]won[/i]?
                        [/p]
                        [p]
                            While you're still cautious and [i]on edge[/i],
                            the feral slowly moves its half-petrified limbs in an unexpected way.
                            Clumsily, and with great effort, it rolls over,
                            submissively exposing its vulnerable underside to you, whilst letting out a pitiful whimper.
                            There's no doubt about it, you've bested the basilisk into submission.
                        [/p]`;

        return global.parser.parse(toReturn);
    }

    /**
     * Builds and returns the choice button.
     */
    function buildFirstChoice() {
        var disabled = subController.has() ? "disabled" : "";
        var isSelected = subController.get() === firstChoice;
        var selected = isSelected ? "selected" : "";
        var button = `<button class="button inlinechoice ${selected}" id="${firstId}" ${disabled} style="width:200px;">Strike throat</button>`;

        var tooltip = global.parser.parse(`Finish the beast.`);
        var popupContainer = global.ui.makeToolTip(button, tooltip, false, false, "width: 190px;");
        // Re-wrap with proper positioning.
        button = `<div class="inlinechoice" style="width:200px;">`;
        button += popupContainer;
        button += `</div>`;

        return button;
    }

    /**
     * Builds and returns the choice button.
     */
    function buildSecondChoice() {
        var disabled = subController.has() ? "disabled" : "";
        var isSelected = subController.get() === secondChoice;
        var selected = isSelected ? "selected" : "";
        var button = `<button class="button inlinechoice ${selected}" id="${secondId}" ${disabled} style="width:200px;">Run</button>`;

        var tooltip = global.parser.parse(`Leave while you still can.`);
        var popupContainer = global.ui.makeToolTip(button, tooltip, false, false, "width: 190px;");
        // Re-wrap with proper positioning.
        button = `<div class="inlinechoice" style="width:200px;">`;
        button += popupContainer;
        button += `</div>`;

        return button;
    }

    /**
     * Builds and returns the choice button.
     */
    function buildThirdChoice() {
        var disabled = subController.has() ? "disabled" : "";
        var isSelected = subController.get() === thirdChoice;
        var selected = isSelected ? "selected" : "";
        var button = `<button class="button inlinechoice ${selected}" id="${thirdId}" ${disabled} style="width:200px;">Petrify it</button>`;

        var tooltip = global.parser.parse(`It can't resist forever.`);
        var popupContainer = global.ui.makeToolTip(button, tooltip, false, false, "width: 190px;");
        // Re-wrap with proper positioning.
        button = `<div class="inlinechoice" style="width:200px;">`;
        button += popupContainer;
        button += `</div>`;

        return button;
    }

    /**
     * Builds and returns the choice button.
     */
    function buildFourthChoice() {
        var disabled = subController.has() ? "disabled" : "";
        var isSelected = subController.get() === fourthChoice;
        var selected = isSelected ? "selected" : "";
        var button = `<button class="button inlinechoice ${selected}" id="${fourthId}" ${disabled} style="width:200px;">Assert dominance</button>`;

        var tooltip = global.parser.parse(`The beast has submitted to you. Time to claim what is rightfully yours.`);
        var popupContainer = global.ui.makeToolTip(button, tooltip, false, false, "width: 190px;");
        // Re-wrap with proper positioning.
        button = `<div class="inlinechoice" style="width:200px;">`;
        button += popupContainer;
        button += `</div>`;

        return button;
    }

    /**
     * Builds and returns the choice of this section.
     * @returns {string} The choice of this section.
     */
    function buildChoice() {
        var choice = `<div class="choicecontainer"><div class="inlinechoiceheader">You:</div>`;
        choice += `<div class="choicerow" style="margin-bottom: 10px;">`;
        choice += buildFirstChoice();
        choice += `<hr class="inlinechoiceseparator">`;
        choice += buildSecondChoice();
        choice += `</div>`;
        choice += `<div class="choicerow">`;
        choice += buildThirdChoice();
        choice += `<hr class="inlinechoiceseparator">`;
        choice += buildFourthChoice();
        choice += `</div>`;
        choice += `</div>`;
        return choice;
    }

    /**
     * Disables all three buttons.
     */
    function disableButtons() {
        var buttons = [$("#" + firstId), $("#" + secondId), $("#" + thirdId), $("#" + fourthId)];
        buttons.forEach(function (button) {
            button.unbind();
            button.attr("disabled", true);
        });
    }

    /**
     * Loads and displays the next part.
     * @param {object} part Which part to load.
     */
    function loadNextPart(part) {
        var built = part.build(true);
        global.ui.appendBeforeFinisher(built, global.ui.genericHeaderId);
        $("#" + part.id).fadeIn(400);
        part.registerListeners();
    }

    /**
     * Adds a listener to the button.
     */
    function registerFirstListener() {
        $("#" + firstId).click(function () {
            $(this).addClass("selected");
            disableButtons();
            subController.set(firstChoice);
            loadNextPart(firstNext);
        });
    }

    /**
     * Adds a listener to the button.
     */
    function registerSecondListener() {
        $("#" + secondId).click(function () {
            $(this).addClass("selected");
            disableButtons();
            subController.set(secondChoice);
            loadNextPart(secondNext);
        });
    }

    /**
     * Adds a listener to the button.
     */
    function registerThirdListener() {
        $("#" + thirdId).click(function () {
            $(this).addClass("selected");
            disableButtons();
            subController.set(thirdChoice);
            loadNextPart(thirdNext);
        });
    }

    /**
     * Adds a listener to the button.
     */
    function registerFourthListener() {
        $("#" + fourthId).click(function () {
            $(this).addClass("selected");
            disableButtons();
            subController.set(fourthChoice);
            loadNextPart(fourthNext);
        });
    }

    // PUBLIC MEMBERS \\        this.public = "test";
    this.id = arguments.callee.name;

    // PUBLIC FUNCTIONS \\      this.publicFunction = function(){};

    /**
     * Builds and returns this part.
     * @param {boolean} invisible If passed and true, will give the entire section a display:none style.
     */
    this.build = function (invisible) {
        if (reqController && ((reqChoice && reqController.get() !== reqChoice) || (!reqChoice && !reqController.continued()))) {
            return "";
        }

        global.ui.imageBackground.hide();
        var part = `<div id="${that.id}" ${invisible ? 'style="display:none;"' : ""}>`;
        part += buildContent();
        part += (changeController && changeController.change()) || "";
        part += buildChoice();
        part += `</div>`;
        part += firstNext.build();
        part += secondNext.build();
        part += thirdNext.build();
        part += fourthNext.build();
        return part;
    };

    /**
     * Registers all the required button listeners for this part.
     */
    this.registerListeners = function () {
        if (reqController && ((reqChoice && reqController.get() !== reqChoice) || (!reqChoice && !reqController.continued()))) {
            return;
        }

        firstNext.registerListeners();
        secondNext.registerListeners();
        thirdNext.registerListeners();
        fourthNext.registerListeners();

        if (subController.has()) {
            return;
        }

        registerFirstListener();
        registerSecondListener();
        registerThirdListener();
        registerFourthListener();
    };
}

var UndergroundCaveReflectionSucceedChoice = {
    STRIKE: 1,
    LEAVE: 2,
    PETRIFY: 3,
    DOMINATE: 4
};

// END scenes\HamletDay2\UndergroundCave\mirror\succeed\UndergroundCaveReflectionSucceed.js

// scenes\HamletDay2\UndergroundCave\mirror\fail\UndergroundCaveReflectionFail.js

/**
 * Reflect section of the Underground Cave.
 * @param {UndergroundCaveController} controller The Underground Cave controller.
 */
function UndergroundCaveReflectionFail(controller) {
    // PRIVATE MEMBERS \\       var private = "test";
    var that = this;
    var ctrl = controller;

    var reqChoice = false;
    var reqController = false;
    var subController = ctrl.stare;
    var changeController = ctrl.reflectFail;

    var continueId = arguments.callee.name + "ButtonOne";
    var next = new UndergroundCaveRelent(ctrl);

    // PRIVATE FUNCTIONS \\     function privateFunction(){}

    /**
     * Builds and returns the content of this section.
     * @returns {string} The content.
     */
    function buildContent() {
        global.kobold.history.shared.well.basiliskMet = true;
        global.kobold.history.shared.well.basiliskPetrified = true;
        var toReturn = `[p]
                            Your mind races, even as your body freezes.
                            How are you supposed to respond?!
                            You can't look away.
                            If it's a predator, it might take that as a sign of weakness.
                            Still, you're too [b]afraid[/b] to boldly stare back.
                            Those eyes are pretty scary.
                            You're left in an impasse, your frailty showing regardless of whether or not you look at the eyes.
                        [/p]
                        [p]
                            Then a thought flashes through your head.
                            An idea.
                            You bought something, something that can help!
                            Something that'll allow you to combine the best of both worlds!
                            You're talking about the ${global.kobold.inventory.createItemWithTooltip(new SmallMirror())} in your backpack.
                            With it, you can give the monster something to stare at, without having to look at it yourself.
                            You're saved!
                        [/p]
                        [p]
                            A lot of animals get spooked by their own reflections.
                            Seki once told you that, anyway.
                            He mentioned [i]why[/i], but you can't really recall that part of his [i]lecture[/i].
                            Would the monster think you're its peer instead of prey, and thus leave you alone?
                            Or perhaps it'd find out that it's got a real nasty look on its face.
                            Either way, the mirror is your best bet.
                        [/p]
                        [p]
                            You keep your vision focused on the cavern wall, right next to the set of eyes staring at you,
                            trying to make it look like you [i]aren't[/i] afraid, without challenging the monster too much.
                            At the same time, you begin to look for the ${global.kobold.inventory.createItemWithTooltip(new SmallMirror())} on your person.
                        [/p]
                        [p]
                            Suddenly, your whole body jolts as something sharp pierces your fingertip!
                            A pained grunt escapes your muzzle.
                            Did you accidentally bump against an edgy stone?
                            No, it wasn't a rock.
                            Thanks to your haphazard adventure in the well,
                            your ${global.kobold.inventory.createItemWithTooltip(new SmallMirror())} seems to have broken into a million little pieces.
                            Must have gotten hit by some of the debris when the entire place came down on top of your head.
                            Your heart sinks.
                            Terror settles in, your best plan shattered.
                        [/p]
                        [p]
                            The creature in the dark scuttles closer, redoubling its stare.
                            You can remotely make out the outline of something [b]big[/b] and [b]scaly[/b].
                            You can feel it growing [i]impatient[/i], like it's almost done [i]playing[/i] with you.
                            No, no, no!
                            You have no choice [b]but[/b] to gaze directly into its eyes, putting on your bravest face to hopefully keep the monster at bay.
                        [/p]
                        [p]
                            Fueled by desperation, you scoop the broken pieces to your front.
                            They loudly [b]scrape[/b] across the stone floor.
                            Once repositioned, your hands keep searching through the broken mirror's shards.
                            You get cut several times more, but you barely even notice, your mind completely [b]clogged[/b] with fright.
                            Your fingers clench around several fragments, trying, but failing to find one big enough to [i]wield[/i].
                            All the while, the creature's stare [b]burns[/b] itself into your mind.
                        [/p]
                        [p]
                            You stubbornly cling to your plan.
                            Both your hands continue to fumble about the shards.
                            If you can find a large enough mirror-piece, you'll be [b]saved[/b]!
                            But it's no use.
                            All of the fragments are far too tiny, completely useless.
                            You can feel your fingertips growing slightly more [i]stiff[/i] and [i]rigid[/i],
                            a fact you attribute to the multitude of small cuts you've sustained.
                            You doubt you could even properly [b]hold[/b] a shard at this point, even [i]if[/i] you managed to find one of sufficient size.
                        [/p]
                        ${global.ui.condFail(ctrl.misc.agility() < 6 ? `Agility below 6` : `Luck below 6`)}
                        [p]
                            Then you realize it's not [i]just[/i] your hands becoming numb.
                            [b]All[/b] of your extremities seem to be [i]unresponsive[/i].
                            As though half your body is [i]asleep[/i]!
                            Panic wells up inside you.
                            You try to rise to your feet, to flee as you should have done in the first place, but your legs refuse to function.
                            Your arms, too, appear to be frozen in place.
                        [/p]
                        [p]
                            You break eye contact with the monster.
                            You can't even turn your head away, your neck every bit as [i]stiff[/i] as your arms and legs.
                            Casting your gaze downwards, you notice your arms are [i]discolored[/i].
                            Your scales have become a dull grey instead of the usual green.
                        [/p]
                        [p]
                            Are you asleep?
                            Dreaming, perhaps?
                            Is this all a nightmare?
                            Did you never make it out of the well?
                            You try to open your mouth to scream, but even your muzzle isn't budging.
                            Staring at your own snout, you finally figure out what happened.
                            Your scales have turned to stone.
                            You've been petrified!
                        [/p]
                        [p]
                            You try every muscle in your body, to see which parts you can still move.
                            Your tongue is still in working order, although your mouth won't open.
                            Your eyes can dart around all they please, but your head itself is unmoving.
                            You retain [i]some[/i] form of control over your tail, the largest of your extremities still in some manner of working order.
                            Fingers are a no-go.
                            Entirely petrified.
                            Your toes, finally.
                            You can wriggle those around slightly, despite both your legs and your feet being locked in place.
                        [/p]
                        [p]
                            While most of your smaller organs and limbs are still fully functional,
                            your body as a whole is completely immobilized.
                            Shocked by this revelation, you barely even notice the creature you were so afraid of leaving its hole,
                            stepping out into the cave proper.
                            Your cross-eyed stare at your own muzzle slowly fading, you become aware of the large,
                            quadrupedal, rock-hided crocodillian standing right in front of you.
                            Your heart nearly skips a beat as you realize what you're dealing with here.
                            A [b]basilisk[/b]!
                        [/p]
                        [p]
                            Seki once told you stories about creatures that could petrify
                            anyone or anything unlucky enough to stare at them for prolonged periods of time,
                            but you thought he was just making things up!
                            You should have listened more carefully to the old bird!
                            On the bright side, while your fingers aren't fully petrified,
                            the small cuts you sustained while looking through the mirror shards have stopped bleeding,
                            probably sealed shut by your hardening scales.
                        [/p]`;
        return global.parser.parse(toReturn);
    }

    /**
     * Builds and returns the choice button.
     */
    function buildNextChoice() {
        var disabled = subController.continued() ? "disabled" : "";
        var isSelected = subController.continued();
        var selected = isSelected ? "selected" : "";
        var button = `<button class="button inlinechoice ${selected}" id="${continueId}" ${disabled}>Continue</button>`;
        return button;
    }

    /**
     * Builds and returns the choice of this section.
     * @returns {string} The choice of this section.
     */
    function buildChoice() {
        var choice = `<div class="choicecontainer">`;
        choice += buildNextChoice();
        choice += `</div>`;
        return choice;
    }

    /**
     * Disables all three buttons.
     */
    function disableButtons() {
        var buttons = [$("#" + continueId)];
        buttons.forEach(function (button) {
            button.unbind();
            button.attr("disabled", true);
        });
    }

    /**
     * Loads and displays the next part.
     * @param {object} part Which part to load.
     */
    function loadNextPart(part) {
        var built = part.build(true);
        global.ui.appendBeforeFinisher(built, global.ui.genericHeaderId);
        $("#" + part.id).fadeIn(400);
        part.registerListeners();
    }

    /**
     * Adds a listener to the button.
     */
    function registerNextListener() {
        $("#" + continueId).click(function () {
            $(this).addClass("selected");
            disableButtons();
            subController.set(UndergroundCaveStareChoice.RELENT);
            loadNextPart(next);
        });
    }

    // PUBLIC MEMBERS \\        this.public = "test";
    this.id = arguments.callee.name;

    // PUBLIC FUNCTIONS \\      this.publicFunction = function(){};

    /**
     * Builds and returns this part.
     * @param {boolean} invisible If passed and true, will give the entire section a display:none style.
     */
    this.build = function (invisible) {
        if (reqController && ((reqChoice && reqController.get() !== reqChoice) || (!reqChoice && !reqController.continued()))) {
            return "";
        }

        global.ui.imageBackground.hide();
        var part = `<div id="${that.id}" ${invisible ? 'style="display:none;"' : ""}>`;
        part += buildContent();
        part += (changeController && changeController.change()) || "";
        part += buildChoice();
        part += `</div>`;
        part += next.build();
        return part;
    };

    /**
     * Registers all the required button listeners for this part.
     */
    this.registerListeners = function () {
        if (reqController && ((reqChoice && reqController.get() !== reqChoice) || (!reqChoice && !reqController.continued()))) {
            return;
        }

        next.registerListeners();

        if (subController.continued()) {
            return;
        }

        registerNextListener();
    };
}

// END scenes\HamletDay2\UndergroundCave\mirror\fail\UndergroundCaveReflectionFail.js

// scenes\HamletDay2\UndergroundCave\mirror\UndergroundCaveReflection.js

/**
 * Reflect section of the Underground Cave.
 * @param {UndergroundCaveController} controller The Underground Cave controller.
 */
function UndergroundCaveReflection(controller) {
    // PRIVATE MEMBERS \\       var private = "test";
    var that = this;
    var ctrl = controller;

    var reqChoice = UndergroundCaveSurfaceChoice.MIRROR;
    var reqController = ctrl.surface;

    var toFail = new UndergroundCaveReflectionFail(ctrl);
    var toSuccess = new UndergroundCaveReflectionSucceed(ctrl);

    // PRIVATE FUNCTIONS \\     function privateFunction(){}

    /**
     * Checks whether the choice succeeded or failed.
     */
    function successCheck() {
        return ctrl.misc.agility() > 5 && ctrl.misc.luck() > 5;
    }

    // PUBLIC MEMBERS \\        this.public = "test";
    this.id = arguments.callee.name;

    // PUBLIC FUNCTIONS \\      this.publicFunction = function(){};

    /**
     * Builds and returns this part.
     * @param {boolean} invisible If passed and true, will give the entire section a display:none style.
     */
    this.build = function (invisible) {
        if (reqController && ((reqChoice && reqController.get() !== reqChoice) || (!reqChoice && !reqController.continued()))) {
            return "";
        }

        var part = `<div id="${that.id}" ${invisible ? 'style="display:none;"' : ""}>`;
        if (successCheck()) {
            part += toSuccess.build();
        } else {
            part += toFail.build();
        }
        part += `</div>`;
        return part;
    };

    /**
     * Registers all the required button listeners for this part.
     */
    this.registerListeners = function () {
        if (reqController && ((reqChoice && reqController.get() !== reqChoice) || (!reqChoice && !reqController.continued()))) {
            return;
        }

        if (successCheck()) {
            toSuccess.registerListeners();
        } else {
            toFail.registerListeners();
        }
    };
}

// END scenes\HamletDay2\UndergroundCave\mirror\UndergroundCaveReflection.js

// scenes\HamletDay2\UndergroundCave\fight\offence\fail\succeed\dominance\leave\UndergroundCaveDominanceLeave.js

/**
 * Fight section of the Underground Cave.
 * @param {UndergroundCaveController} controller The Underground Cave controller.
 */
function UndergroundCaveDominanceLeave(controller) {
    // PRIVATE MEMBERS \\       var private = "test";
    var that = this;
    var ctrl = controller;

    var reqChoice = false;
    var reqController = ctrl.preContinue;
    var changeController = ctrl.dominanceLeave;

    var continueId = arguments.callee.name + "ButtonOne";

    // PRIVATE FUNCTIONS \\     function privateFunction(){}

    /**
     * Builds and returns the content of this section.
     * @returns {string} The content.
     */
    function buildContent() {
        var dick = ctrl.misc.dick();
        var baseMale = ctrl.misc.baseGender() === GenderEnum.MALE;

        var choice = ctrl.dominance.get();
        var dominanceResult = "covered in your piss";
        if (choice === UndergroundCaveDominanceChoice.ORAL) {
            if (dick) {
                dominanceResult = "with your cum in its mouth";
            } else {
                dominanceResult = "to clean its muzzle";
            }
        } else if (choice === UndergroundCaveDominanceChoice.SEX) {
            if (dick) {
                dominanceResult = "leaking your spunk from its rear";
            } else {
                dominanceResult = "to bask in post-orgasmic bliss";
            }
        }

        var toReturn = `[p]
                            With the basilisk properly [b]dominated[/b],
                            and yourself asserted as the [b]alpha ${baseMale ? `male` : `female`}[/b],
                            you decide it's time to find a way out of the cave.
                            Leaving the feral ${dominanceResult}, you begin to follow the river-branch, hoping it'll lead you to some kind of exit.
                            You leisurely stroll alongside the water, until daylight comes into sight.
                            As you expected: the water [b]was[/b] a stale branch of the river!
                            Climbing out of the cave, you sit your butt down on the riverside dirt, and take a breather.
                            You feel like you've earned one.
                        [/p]
                        [p]
                            You've defied death more than once today.
                            You should consider yourself lucky to be alive.
                            The trip into the well was a harrowing experience.
                            You nearly got crushed, almost drowned, and after all of that, you managed to wrestle a basilisk into submission.
                            Toying with it afterwards might not have been absolutely [i]necessary[/i], but you feel like it's now learned its lesson.
                            The basilisk should be happy that you decided to [b]let it live[/b] instead of finishing it off for accosting you.
                        [/p]
                        [p]
                            You've gained a few personal memories that you'll undoubtedly find yourself masturbating to later,
                            along with some awesome stories to tell once you've grown old and wise.
                            Stories like the ones Seki used to tell you when you were little.
                            You went through all that trouble to get your mind off of him, and here you are reminiscing once more.
                            You just can't help yourself from clinging to times long gone.
                            Things were so much simpler back then.
                            You miss those days.
                        [/p]
                        [p]
                            The sun is slowly starting to set.
                            You drag yourself to your feet.
                            It's time to go.
                            Varanar isn't [i]that[/i] far off.
                            If your legs don't give out from underneath you, you might still make it there before nightfall.
                        [/p]`;

        return global.parser.parse(toReturn);
    }

    /**
     * Builds and returns the continue button.
     */
    function buildChoice() {
        var disabled = ctrl.continued();
        var choice = `<div class="choicecontainer">`;
        choice += `<button class="button bigbutton continuebutton" id="${continueId}" ${disabled ? "disabled" : ""}>`;
        choice += `Continue &gt;&gt`;
        choice += `</button>`;
        choice += `</div>`;
        return choice;
    }

    /**
     * Disables all three buttons.
     */
    function disableButtons() {
        var buttons = [$("#" + continueId)];
        buttons.forEach(function (button) {
            button.unbind();
            button.attr("disabled", true);
        });
    }

    /**
     * Loads and displays the next scene.
     * @param {string} sceneName Name of the scene to load.
     * @param {string} folder Folder of the scene to load.
     */
    function loadNextPart(sceneName, folder) {
        global.ui.fadeOutContent(function () {
            global.sceneEnd();
            global.sceneLoader.loadScene(sceneName, folder);
        });
    }

    /**
     * Adds a listener to the button.
     */
    function registerContinueListener() {
        $("#" + continueId).click(function () {
            $(this).addClass("selected");
            disableButtons();
            ctrl.continue();
            loadNextPart(ctrl.nextSceneName, ctrl.nextFolderName);
        });
    }

    // PUBLIC MEMBERS \\        this.public = "test";
    this.id = arguments.callee.name;

    // PUBLIC FUNCTIONS \\      this.publicFunction = function(){};

    /**
     * Builds and returns this part.
     * @param {boolean} invisible If passed and true, will give the entire section a display:none style.
     */
    this.build = function (invisible) {
        if (reqController && ((reqChoice && reqController.get() !== reqChoice) || (!reqChoice && !reqController.continued()))) {
            return "";
        }

        ctrl.bgm.stopLoop();
        global.ui.applyTheme("hamlet_day");
        var part = `<div id="${that.id}" ${invisible ? 'style="display:none;"' : ""}>`;
        part += buildContent();
        part += (changeController && changeController.change()) || "";
        part += buildChoice();
        if (!ctrl.nextSceneReady) {
            part += `<span class="todo">There is no content beyond this point.</span>`;
        }
        part += `</div>`;
        return part;
    };

    /**
     * Registers all the required button listeners for this part.
     */
    this.registerListeners = function () {
        if (reqController && ((reqChoice && reqController.get() !== reqChoice) || (!reqChoice && !reqController.continued()))) {
            return;
        }

        if (ctrl.continued()) {
            return;
        }

        if (ctrl.nextSceneReady) {
            registerContinueListener();
        }
    };
}

// END scenes\HamletDay2\UndergroundCave\fight\offence\fail\succeed\dominance\leave\UndergroundCaveDominanceLeave.js

// scenes\HamletDay2\UndergroundCave\fight\offence\fail\succeed\dominance\oral\UndergroundCaveOralSex.js

/**
 * Fight section of the Underground Cave.
 * @param {UndergroundCaveController} controller The Underground Cave controller.
 */
function UndergroundCaveOralSex(controller) {
    // PRIVATE MEMBERS \\       var private = "test";
    var that = this;
    var ctrl = controller;

    var reqChoice = false;
    var reqController = false;
    var subController = ctrl.preContinue;
    var changeController = ctrl.oral;

    var continueId = arguments.callee.name + "ButtonOne";
    var next = new UndergroundCaveDominanceLeave(ctrl);

    // PRIVATE FUNCTIONS \\     function privateFunction(){}

    /**
     * Builds and returns the content of this section.
     * @returns {string} The content.
     */
    function buildContent() {
        global.kobold.history.shared.well.basiliskOral = true;
        var dick = ctrl.misc.dick();
        var pants = ctrl.misc.pants();
        var undies = ctrl.misc.underwear();

        var lowerPantsAndUndies = `and already naked`;

        if (pants) {
            lowerPantsAndUndies = `after lowering your ${global.kobold.inventory.createItemWithTooltip(pants)}`;
            if (undies) {
                lowerPantsAndUndies += ` and your ${global.kobold.inventory.createItemWithTooltip(undies)}`;
            }
        } else if (undies) {
            lowerPantsAndUndies = `after lowering your ${global.kobold.inventory.createItemWithTooltip(undies)}`;
        }
        var toReturn = `[p]
                            At first, the basilisk seemed like a determined, lethal [b]killing machine[/b],
                            but now that you've wrestled the fight out of it, it seems to have become a lot more [b]passive[/b].
                            It knows it did something bad, and it realizes that you're about to punish it.
                            It's as though the monster was hiding its submissive nature under a veil of hostility.
                            Now the creature is more of a [b]big wimp[/b] than a menacing beast,
                            and you're the [b]bully[/b] about to [b]push it around[/b] in whatever way you please.
                        [/p]
                        [p]
                            Thinking of this situation as a [i]reversal of power[/i] awakens lustful feelings deep inside of you.
                            You've had this recurring [i]wet dream[/i] a few times, where kobolds would stage an uprising,
                            and you'd find yourself in front of the [b]juiciest[/b] maiden in all of Varanar,
                            with ten of your kind holding her struggling, naked form down for you to [b]ravage[/b].
                            This is [b]just[/b] like that dream, only instead of a maiden, you have a [b]basilisk[/b] to quench your lust upon,
                            the uprising was more of a [b]wrestling match[/b], and there aren't really any kobolds around to hold the monster still.
                        [/p]
                        [p]
                            Okay, in retrospect, this entire ordeal might not be very much like your dream after all.
                            Still, you were reminded of it, and that's enough to get your
                            ${dick ? `member to slowly start to harden within your cockslit` : `slit to slightly moisten`}.
                            You begin to imagine all the things you could do to the creature, now that you've subdued it.
                            While not so similar to your dream, having your way with a large, ferocious animal [b]does[/b] pique your interest.
                        [/p]`;

        if (dick) {
            var virgin = ctrl.misc.dickVirgin();
            toReturn += `
                        [p]
                            Doubting you'll [b]ever[/b] get a second chance at molesting a basilisk, you decide to act on your impulses.
                            You begin to stroke the emerging tapered tip of your member, which rapidly grows erect, fueled by the dirty thoughts popping up in your mind.
                            Its muzzle.
                            You want to fuck its muzzle, filled with sharp, pointy teeth.
                            You want to walk on the wild side, to tempt fate itself,
                            to see whether or not the beast still has enough [b]fight[/b] in it to resist, to [b]bite down[/b].
                        [/p]
                        [p]
                            You bet it won't.
                            You bet you've [b]broken[/b] it.
                            You bet it won't even [b]try[/b] to stop you from fucking its maw.
                            You've shown it that it's [b]not[/b] the boss around here.
                            You've overpowered it, despite all odds.
                            It won't resist.
                            Not after the [b]ass-whooping[/b] you gave it.
                            Not after it attacked you, so [b]certain[/b] that you'd be an easy prey.
                        [/p]
                        [p]
                            Lust clouds your mind, preventing you from thinking about the consequences should things go awry.
                            Driven by desire, ${lowerPantsAndUndies}, you approach the basilisk's head, dropping to your knees directly in front of it,
                            your erect member mere inches away from the feral's snout.
                            Its maw is still open, the monster panting heavily, not yet fully recovered from the intense tussle.
                            A perfect opportunity.
                        [/p]
                        [p]
                            You line up the tip of your member with the beast's mouth, and with a single, smooth roll of your hips,
                            you slide your length inside of its muzzle, the bottom of your shaft pleasantly rubbing alongside the basilisk's slender, forked tongue.
                            While the creature's exterior is hard, tough and cold, the insides of its mouth are the exact opposite.
                            Warm, fleshy, [b]wet[/b] with saliva, almost what you imagine a human's gums must feel like.
                            A pleasant surprise, and not an unwelcome one.
                        [/p]
                        [p]
                            Your dick being rammed into its gaping maw seems to rouse the lizard from its post-battle drowse.
                            Its eyes shoot wide open.
                            The taste of kobold cock spreading throughout its mouth, it quickly realizes what's going on.
                            The monster doesn't like it one bit.
                            It attempts to chomp down on your member, but your [b]girth[/b] is simply too large for it to be able to close its jaws properly!
                            Instead of biting you, the basilisk ends up pleasantly [b]nibbling[/b] on your shaft, giving the [i]illusion[/i] that it knows its place.
                        [/p]
                        ${global.ui.condSucc(`Big dick`)}
                        [p]
                            Luckily, the crocodillian is far too worn out to put up any other kind of resistance.
                            Lost in pleasure, you close your eyes and lean back ever so slightly,
                            while starting to thrust in and out of the monster's muzzle.
                            The sensation isn't [b]too[/b] pleasurable, but the sheer [b]debasement[/b] of what you're doing excites you to no end.
                            You're [b]fucking[/b] a feral.
                            The [b]beast[/b] that tried to murder you has been turned into your [b]bitch[/b].
                            You get to be the person on the [b]giving[/b] end of abuse, for once.
                            And on top of all of this, you're tempting fate itself by ramming your dick into a mouth full of sharp teeth!
                        [/p]
                        [p]
                            With your eyes closed, your mind briefly wanders back to the dream that inspired you to facefuck the basilisk.
                            Snapping back to reality, however, you realize that this situation is [b]even better[/b] than what you imagined.
                            Having the [b]pleasure[/b] of dominating a [b]lethal beast[/b],
                            one that could [b]rip you to shreds[/b] were it not too exhausted,
                            stirs your loins far more than the thought of raping a helpless damsel.
                            While you've only been absent-mindedly humping away at the big lizard's maw for a few seconds short of a minute,
                            you can already feel your premature end rapidly approaching.
                        [/p]
                        [p]
                            You let out a lustful groan, rubbing one of your hands along the soft underside of the creature's muzzle,
                            poking at its sharp teeth with one of your fingers to remind yourself of the [b]arousing danger[/b] you're in.
                            The basilisk shows no signs of biting, though.
                            While, in reality, its jaws are spread too wide for it chomp down,
                            you mistake its inability to bite you for [b]willingness[/b].
                            And the thought of having reduced the once-proud crocodillian to an [b]eager[/b] cocksucker,
                            [b]that[/b] sends you over the edge.
                        [/p]
                        [p]
                            You give the beast's mouth a few more rapid thrusts, before reaching your end.
                            Your member [b]pulses[/b] and [b]spasms[/b], spunk pumping from deep within your internal balls,
                            through your shaft, squirting directly atop the monster's forked tongue.
                            Clearly reluctant, or perhaps even outright [b]unwilling[/b], it tries to pull its head back,
                            but using both of your hands you firmly keep it in place for the entire duration of your orgasm,
                            forcing the feral to take your load in its muzzle.
                        [/p]
                        [p]
                            Your lust sated, you pull your cock from the big beast's maw.
                            It doesn't even bother trying to close its mouth, simply letting your jizz leak from its jaws,
                            the thick, creamy goop spilling out from in between the gaps in its teeth.
                            It looks almost kind of [b]sad[/b], but you both know that it got what it deserved.
                            It shouldn't have tried to murder you.
                            You rise to your feet${pants || undies ? ` and redress` : ``}.
                        [/p]`;
            if (virgin) {
                toReturn += `[p][c][b]You are no longer a virgin.[/b][/c][/p]`;
            }
        } else {
            toReturn += `
                        [p]
                            Doubting you'll [b]ever[/b] get a second chance at molesting a basilisk, you decide to act on your impulses.
                            You begin to touch your own slit, which rapidly dampens, fueled by the dirty thoughts popping up in your mind.
                            Its muzzle.
                            You want to ride its muzzle, filled with sharp, pointy teeth.
                            You want to walk on the wild side, to tempt fate itself,
                            to see whether or not the beast still has enough [b]fight[/b] in it to resist, to [b]bite[/b].
                        [/p]
                        [p]
                            You bet it won't.
                            You bet you've [b]broken[/b] it.
                            You bet it won't even [b]try[/b] to stop you from rubbing your cunt all over its maw.
                            You've shown it that it's [b]not[/b] the boss around here.
                            You've overpowered it, despite all odds.
                            It won't resist.
                            Not after the [b]ass-whooping[/b] you gave it.
                            Not after it attacked you, so [b]certain[/b] that you'd be an easy prey.
                        [/p]
                        [p]
                            Lust clouds your mind, preventing you from thinking about the consequences should things go awry.
                            Driven by desire, ${lowerPantsAndUndies}, you approach the basilisk's head, dropping to your knees directly in front of it,
                            your wet slit mere inches away from the feral's snout.
                            Its maw is still open, the monster panting heavily, not yet fully recovered from the intense tussle.
                            A perfect opportunity.
                        [/p]
                        [p]
                            You grab the beast's head, and tilt it up ever so slightly, allowing you to plant your eager twat directly on top of its snout.
                            The scent of a female lizard seems to rouse the creature from its post-battle drowse.
                            Its nostrils flare, and its slender, forked tongue slips out to [b]taste[/b] your arousal,
                            lightly flicking along your most sensitive scales, before retracting into its massive, toothy maw once more.
                        [/p]
                        [p]
                            The monster's eyes shoot wide open, staring up at you.
                            The feminine taste of an aroused kobold girl spreading throughout its mouth, it quickly realizes what's going on.
                            Furthermore, it seems to understand what is asked of it.
                            The basilisk's tongue flicks out again, pressing deeper into your folds this time, even slightly parting them,
                            collecting as much of your sweet feminine excitement as it possible can, before retracting the flexible organ once more.
                        [/p]
                        [p]
                            You let out a pleasured sigh as the basilisk begins to outright [b]lap[/b] at your slit,
                            licking you much like a common bear would steal honey from a beekeeping friar's storehouse:
                            greedily and speedily.
                            Despite the creature's rock-like appearance, its tongue feels [b]warm[/b] and [b]wet[/b],
                            and the forked split at the end is just exotic enough to get your filthy mind [b]racing[/b].
                        [/p]
                        [p]
                            Lost in pleasure, you close your eyes and lean back ever so slightly,
                            slowly rubbing your crotch back and forth over the monster's muzzle while it continues to eat you out.
                            The sensation itself is pleasurable, but the sheer [b]debasement[/b] of what you're doing is what drives your excitement through the roof.
                            You're getting [b]licked[/b] by a [b]feral[/b].
                            The [b]beast[/b] that tried to murder you has been turned into your [b]bitch[/b].
                            You get to be the person [b]getting licked[/b], instead of the submissive lizard being forced to service someone else.
                            And on top of all of this, you're tempting fate itself by grinding your loins against a mouth full of sharp teeth!
                        [/p]
                        [p]
                            With your eyes closed, your mind briefly wanders back to the dream that inspired you to get the basilisk to lick you.
                            Snapping back to reality, however, you realize that this situation is [b]even better[/b] than what you imagined.
                            Having the [b]pleasure[/b] of dominating a [b]lethal beast[/b],
                            one that could [b]rip you to shreds[/b] were it not too exhausted to fight,
                            stirs your loins far more than the thought of forcing a helpless damsel to eat you out.
                            While you've only been absent-mindedly humping away at the big lizard's lapping maw for a few seconds short of a minute,
                            you can already feel your premature end rapidly approaching.
                        [/p]
                        [p]
                            You let out a lustful groan, rubbing one of your hands along the soft underside of the creature's muzzle,
                            poking at its sharp teeth with one of your fingers to remind yourself of the [b]arousing danger[/b] you're in.
                            The basilisk shows no signs of biting, though.
                            It [b]willingly[/b] digs its tongue into your cunt, scooping ever-deeper for more of your [b]delicious[/b] arousal.
                            It must be into this every bit as much as you are.
                        [/p]
                        [p]
                            You give the beast's mouth a few more rapid grinding humps, before reaching your end.
                            Your innards spasm around the monster's forked tongue, your excitement liberally dripping from your loins,
                            a small squirt coating the basilisk's stone face with feminine fluids.
                            Surprised by the sudden torrent, the crocodillian tries to pull its head back,
                            but using both of your hands you firmly keep it in place for the entire duration of your orgasm.
                        [/p]
                        [p]
                            Getting over the initial [i]scare[/i], the feral begins to eagerly lap up as much of the viscous,
                            luke-warm liquid flooding from your slit as it can.
                            Absolutely [b]loving[/b] the feeling of the pleasant aftercare, you stay in place and simply let the big beast lick away for a while.
                            It lets out a loud whine when you finally [i]do[/i] pull back from its maw.
                            It looks almost kind of [b]sad[/b], but this [i]was[/i] supposed to be a [b]punishment[/b] instead of something you could both enjoy.
                            Oh well.
                            You rise to your feet${pants || undies ? ` and redress` : ``}.
                        [/p]`;
        }

        return global.parser.parse(toReturn);
    }

    /**
     * Builds and returns the choice button.
     */
    function buildNextChoice() {
        var disabled = subController.continued() ? "disabled" : "";
        var isSelected = subController.continued();
        var selected = isSelected ? "selected" : "";
        var button = `<button class="button inlinechoice ${selected}" id="${continueId}" ${disabled}>Continue</button>`;
        return button;
    }

    /**
     * Builds and returns the choice of this section.
     * @returns {string} The choice of this section.
     */
    function buildChoice() {
        var choice = `<div class="choicecontainer">`;
        choice += buildNextChoice();
        choice += `</div>`;
        return choice;
    }

    /**
     * Disables all three buttons.
     */
    function disableButtons() {
        var buttons = [$("#" + continueId)];
        buttons.forEach(function (button) {
            button.unbind();
            button.attr("disabled", true);
        });
    }

    /**
     * Loads and displays the next part.
     * @param {object} part Which part to load.
     */
    function loadNextPart(part) {
        var built = part.build(true);
        global.ui.appendBeforeFinisher(built, global.ui.genericHeaderId);
        $("#" + part.id).fadeIn(400);
        part.registerListeners();
    }

    /**
     * Adds a listener to the button.
     */
    function registerNextListener() {
        $("#" + continueId).click(function () {
            $(this).addClass("selected");
            disableButtons();
            subController.continue();
            loadNextPart(next);
        });
    }

    // PUBLIC MEMBERS \\        this.public = "test";
    this.id = arguments.callee.name;

    // PUBLIC FUNCTIONS \\      this.publicFunction = function(){};

    /**
     * Builds and returns this part.
     * @param {boolean} invisible If passed and true, will give the entire section a display:none style.
     */
    this.build = function (invisible) {
        if (reqController && ((reqChoice && reqController.get() !== reqChoice) || (!reqChoice && !reqController.continued()))) {
            return "";
        }

        var part = `<div id="${that.id}" ${invisible ? 'style="display:none;"' : ""}>`;
        part += buildContent();
        part += (changeController && changeController.change()) || "";
        part += buildChoice();
        part += `</div>`;
        part += next.build();
        return part;
    };

    /**
     * Registers all the required button listeners for this part.
     */
    this.registerListeners = function () {
        if (reqController && ((reqChoice && reqController.get() !== reqChoice) || (!reqChoice && !reqController.continued()))) {
            return;
        }

        next.registerListeners();

        if (subController.continued()) {
            return;
        }

        registerNextListener();
    };
}

// END scenes\HamletDay2\UndergroundCave\fight\offence\fail\succeed\dominance\oral\UndergroundCaveOralSex.js

// scenes\HamletDay2\UndergroundCave\fight\offence\fail\succeed\dominance\oral\UndergroundCaveBite.js

/**
 * Fight section of the Underground Cave.
 * @param {UndergroundCaveController} controller The Underground Cave controller.
 */
function UndergroundCaveBite(controller) {
    // PRIVATE MEMBERS \\       var private = "test";
    var that = this;
    var ctrl = controller;

    var reqChoice = false;
    var reqController = false;

    var continueId = arguments.callee.name + "ButtonOne";

    var idsToRemove = [
        "UndergroundCaveBite",
        "UndergroundCaveOral",
        "UndergroundCaveDominance",
        "UndergroundCaveWrestlingWin",
        "UndergroundCaveWrestling",
        "UndergroundCaveOffence",
        "UndergroundCaveFight",
        "UndergroundCaveResistSucceed",
        "UndergroundCaveResist",
        "UndergroundCaveStare",
        "UndergroundCaveAvert",
        "UndergroundCaveSurface"
    ];

    // PRIVATE FUNCTIONS \\     function privateFunction(){}

    /**
     * Builds and returns the content of this section.
     * @returns {string} The content.
     */
    function buildContent() {
        var toReturn = `[p]
                            At first, the basilisk seemed like a determined, lethal [b]killing machine[/b],
                            but now that you've wrestled the fight out of it, it seems to have become a lot more [b]passive[/b].
                            It knows it did something bad, and it realizes that you're about to punish it.
                            It's as though the monster was hiding its submissive nature under a veil of hostility.
                            Now the creature is more of a [b]big wimp[/b] than a menacing beast,
                            and you're the [b]bully[/b] about to [b]push it around[/b] in whatever way you please.
                        [/p]
                        [p]
                            Thinking of this situation as a [i]reversal of power[/i] awakens lustful feelings deep inside of you.
                            You've had this recurring [i]wet dream[/i] a few times, where kobolds would stage an uprising,
                            and you'd find yourself in front of the [b]juiciest[/b] maiden in all of Varanar,
                            with ten of your kind holding her struggling, naked form down for you to [b]ravage[/b].
                            This is [b]just[/b] like that dream, only instead of a maiden, you have a [b]basilisk[/b] to quench your lust upon,
                            the uprising was more of a [b]wrestling match[/b], and there aren't really any kobolds around to hold the monster still.
                        [/p]
                        [p]
                            Okay, in retrospect, this entire ordeal might not be very much like your dream after all.
                            Still, you were reminded of it, and that's enough to get your member to slowly start to harden within your cockslit.
                            You begin to imagine all the things you could do to the creature, now that you've subdued it.
                            While not so similar to your dream, having your way with a large, ferocious animal [b]does[/b] pique your interest.
                        [/p]
                        [p]
                            Doubting you'll [b]ever[/b] get a second chance at molesting a basilisk, you decide to act on your impulses.
                            You begin to stroke the emerging tapered tip of your member, which rapidly grows erect, fueled by the dirty thoughts popping up in your mind.
                            Its muzzle.
                            You want to fuck its muzzle, filled with sharp, pointy teeth.
                            You want to walk on the wild side, to tempt fate itself,
                            to see whether or not the beast still has enough [b]fight[/b] in it to resist, to [b]bite down[/b].
                        [/p]
                        [p]
                            You bet it doesn't.
                            You bet you've [b]broken[/b] it.
                            You bet it won't even [b]try[/b] to stop you from fucking its maw.
                            You've shown it that it's [b]not[/b] the boss around here.
                            You've overpowered it, despite all odds.
                            It won't resist.
                            Not after the [b]ass-whooping[/b] you gave it.
                            Not after it attacked you, so [b]certain[/b] that you'd be an easy prey.
                        [/p]
                        [p]
                            Lust clouds your mind, preventing you from thinking about the consequences should things go awry.
                            Driven by desire, you approach the basilisk's head, dropping to your knees directly in front of it,
                            your erect member mere inches away from the feral's snout.
                            Its maw is still open, the monster panting heavily, not yet fully recovered from the intense tussle.
                            A perfect opportunity.
                        [/p]
                        [p]
                            You line up the tip of your member with the beast's mouth, and with a single, smooth roll of your hips,
                            you slide your length inside of its muzzle, the bottom of your shaft pleasantly rubbing alongside the basilisk's slender, forked tongue.
                            While the creature's exterior is hard, tough and cold, the insides of its mouth are the exact opposite.
                            Warm, fleshy, [b]wet[/b] with saliva, almost what you imagine a human's gums must feel like.
                            A pleasant surprise, and not an unwelcome one.
                        [/p]
                        [p]
                            Your dick being rammed into its gaping maw seems to rouse the lizard from its post-battle drowse.
                            Its eyes shoot wide open.
                            The taste of kobold cock spreading throughout its mouth, it quickly realizes what's going on.
                            The monster doesn't like it one bit.
                            Lost in pleasure, you close your eyes and lean back ever so slightly.
                            Then, a loud [b]snap[/b], like the sound of teeth clattering together, echoes throughout the cave.
                            Opening your eyes, you stare down at your groin, to find the entire tip missing, bitten off by the basilisk's snapping jaws.
                        [/p]
                        ${global.ui.condFail(`Small dick`)}
                        [p]
                            The remaining fleshy stump protruding from your slit liberally squirts blood atop the crocodillian's muzzle.
                            You stare in horror at your mangled groin.
                            An immense pain, unlike anything you've ever felt before, shoots up your spine.
                            Your sight fades, and you tumble to the ground, unconscious.
                            Spurred by the taste of blood and fresh kobold meat, the basilisk rises to its feet,
                            [b]rips[/b] apart your stomach with its sharp claws, and feasts upon your entrails.
                            You don't wake up again.
                        [/p]
                        [p]
                            [c]
                                [b]
                                    Bite end.
                                [/b]
                            [/c]
                        [/p]`;

        return global.parser.parse(toReturn);
    }

    /**
     * Builds and returns the continue button.
     */
    function buildChoice() {
        var choice = `<div class="choicecontainer">`;
        choice += `<button class="button bigbutton continuebutton" style="margin-left: auto; position: relative; float: right;" id="${continueId}">`;
        choice += `&lt;&lt Revert`;
        choice += `</button>`;
        choice += `</div>`;
        return choice;
    }

    /**
     * Disables all three buttons.
     */
    function disableButtons() {
        var buttons = [$("#" + continueId)];
        buttons.forEach(function (button) {
            button.unbind();
            button.attr("disabled", true);
        });
    }

    /**
     * Loads and displays the next part.
     * @param {object} part Which part to load.
     */
    function loadNextPart(part) {
        var built = part.build(true);
        global.ui.appendBeforeFinisher(built, global.ui.genericHeaderId);
        $("#" + part.id).fadeIn(400, function () {
            var main = $("#main");
            main.scrollTop(main[0].scrollHeight - main.height() - 5); // Fix scrolling
        });
        part.registerListeners();
    }

    /**
     * Adds a listener to the button.
     */
    function registerContinueListener() {
        $("#" + continueId).click(function () {
            $(this).addClass("selected");
            disableButtons();
            ctrl.misc.unsetAll();
            ctrl.dominance.undo();
            ctrl.dominance.unset();
            ctrl.wrestleWin.undo();
            ctrl.wrestleWin.unset();
            ctrl.fight.unset();
            ctrl.resistSucceed.undo();
            ctrl.resistSucceed.unset();
            ctrl.stare.undo();
            ctrl.stare.unset();
            ctrl.avert.undo();
            ctrl.avert.unset()
            ctrl.surface.undo();
            ctrl.surface.unset();
            for (var i = 0; i < idsToRemove.length; i++) {
                $("#" + idsToRemove[i]).remove();
            }
            loadNextPart(ctrl.fragments.surface);
        });
    }

    // PUBLIC MEMBERS \\        this.public = "test";
    this.id = arguments.callee.name;

    // PUBLIC FUNCTIONS \\      this.publicFunction = function(){};

    /**
     * Builds and returns this part.
     * @param {boolean} invisible If passed and true, will give the entire section a display:none style.
     */
    this.build = function (invisible) {
        if (reqController && ((reqChoice && reqController.get() !== reqChoice) || (!reqChoice && !reqController.continued()))) {
            return "";
        }

        var part = `<div id="${that.id}" ${invisible ? 'style="display:none;"' : ""}>`;
        part += buildContent();
        part += buildChoice();
        part += `</div>`;
        return part;
    };

    /**
     * Registers all the required button listeners for this part.
     */
    this.registerListeners = function () {
        if (reqController && ((reqChoice && reqController.get() !== reqChoice) || (!reqChoice && !reqController.continued()))) {
            return;
        }

        registerContinueListener();
    };
}

// END scenes\HamletDay2\UndergroundCave\fight\offence\fail\succeed\dominance\oral\UndergroundCaveBite.js

// scenes\HamletDay2\UndergroundCave\fight\offence\fail\succeed\dominance\oral\UndergroundCaveOral.js

/**
 * Fight section of the Underground Cave.
 * @param {UndergroundCaveController} controller The Underground Cave controller.
 */
function UndergroundCaveOral(controller) {
    // PRIVATE MEMBERS \\       var private = "test";
    var that = this;
    var ctrl = controller;

    var reqChoice = UndergroundCaveDominanceChoice.ORAL;
    var reqController = ctrl.dominance;

    var toFail = new UndergroundCaveOralSex(ctrl);
    var toSuccess = new UndergroundCaveBite(ctrl);

    // PRIVATE FUNCTIONS \\     function privateFunction(){}

    /**
     * Checks whether the choice succeeded or failed.
     */
    function successCheck() {
        var dick = ctrl.misc.dick();
        return dick && dick < SizeEnum.LARGE;
    }

    // PUBLIC MEMBERS \\        this.public = "test";
    this.id = arguments.callee.name;

    // PUBLIC FUNCTIONS \\      this.publicFunction = function(){};

    /**
     * Builds and returns this part.
     * @param {boolean} invisible If passed and true, will give the entire section a display:none style.
     */
    this.build = function (invisible) {
        if (reqController && ((reqChoice && reqController.get() !== reqChoice) || (!reqChoice && !reqController.continued()))) {
            return "";
        }

        var part = `<div id="${that.id}" ${invisible ? 'style="display:none;"' : ""}>`;
        if (successCheck()) {
            part += toSuccess.build();
        } else {
            part += toFail.build();
        }
        part += `</div>`;
        return part;
    };

    /**
     * Registers all the required button listeners for this part.
     */
    this.registerListeners = function () {
        if (reqController && ((reqChoice && reqController.get() !== reqChoice) || (!reqChoice && !reqController.continued()))) {
            return;
        }

        if (successCheck()) {
            toSuccess.registerListeners();
        } else {
            toFail.registerListeners();
        }
    };
}

// END scenes\HamletDay2\UndergroundCave\fight\offence\fail\succeed\dominance\oral\UndergroundCaveOral.js

// scenes\HamletDay2\UndergroundCave\fight\offence\fail\succeed\dominance\pee\UndergroundCavePee.js

/**
 * Fight section of the Underground Cave.
 * @param {UndergroundCaveController} controller The Underground Cave controller.
 */
function UndergroundCavePee(controller) {
    // PRIVATE MEMBERS \\       var private = "test";
    var that = this;
    var ctrl = controller;

    var reqChoice = UndergroundCaveDominanceChoice.PEE;
    var reqController = ctrl.dominance;
    var subController = ctrl.preContinue;
    var changeController = ctrl.pee;

    var continueId = arguments.callee.name + "ButtonOne";
    var next = new UndergroundCaveDominanceLeave(ctrl);

    // PRIVATE FUNCTIONS \\     function privateFunction(){}

    /**
     * Builds and returns the content of this section.
     * @returns {string} The content.
     */
    function buildContent() {
        global.kobold.history.shared.well.basiliskPeed = true;
        var dick = ctrl.misc.dick();
        var pants = ctrl.misc.pants();
        var undies = ctrl.misc.underwear();
        var wellDrown = global.kobold.history.shared.well.drowned;

        var lowerPantsAndUndies = `Already naked`;

        if (pants) {
            lowerPantsAndUndies = `After lowering your ${global.kobold.inventory.createItemWithTooltip(pants)}`;
            if (undies) {
                lowerPantsAndUndies += ` and your ${global.kobold.inventory.createItemWithTooltip(undies)}`;
            }
        } else if (undies) {
            lowerPantsAndUndies = `After lowering your ${global.kobold.inventory.createItemWithTooltip(undies)}`;
        }

        var toReturn = `[p]
                            A big dog.
                            That's all it is.
                            A [b]puppy[/b] that intended to [b]bite[/b] its ${dick ? `master` : `mistress`}.
                            While you don't know much about canine interactions,
                            and most of what you [i]do[/i] know is based off of hearsay and [i]calculated guesses[/i],
                            you [i]think[/i] they show dominance by [i]pissing[/i] on one another.
                            The alpha male pees on the beta, the beta pees on the omega, and so on and so forth.
                            Or was that how they marked their territory?
                            You can't quite remember.
                        [/p]
                        [p]
                            It doesn't matter anyway.
                            You've gulped down a lot of water in the past hour or so,
                            in the process of nearly drowning${wellDrown ? ` more than once` : ``},
                            and you feel like you need to take a leak.
                            The basilisk has deserved a punishment, and you intend to deliver.
                        [/p]
                        [p]
                            ${lowerPantsAndUndies}, you take up position next to the monster's slumped down body.
                            You spread your legs, stick out your groin,
                            and slightly ${dick ? `pry your cockslit open` : `spread your folds`} using two of your fingers.
                            With a relieved sigh, you release your budding bladder,
                            a stream of watery piss squirting from your ${dick ? `slit` : `urethra`},
                            arcing through the air before splattering down onto the feral's stone back. 
                        [/p]
                        [p]
                            The basilisk groans in discontent as it feels the warm liquid soiling its body.
                            It knows fully well what you're doing, but it doesn't resist.
                            It [b]knows[/b] that it [b]deserves[/b] this punishment.
                            And you've only gotten [b]started[/b].
                        [/p]
                        [p]
                            You redirect your groin, wetting the upper half of the creature's body while the stream travels over its head, towards its muzzle.
                            The lizard hisses angrily, but it is far too exhausted to even attempt to stop you.
                            It simply lays there as you empty the entire contents of your bladder over its face,
                            its angry eyes closing in resignation, or perhaps to prevent any splatter from getting into them.
                        [/p]
                        [p]
                            You feel [b]powerful[/b], taking a piss on a mythological being several times your weight.
                            Like you [b]own it[/b].
                            Like it's [b]your bitch[/b].
                            And to be frank, you [b]did[/b] beat it in a straight-up fight.
                            It [b]is[/b] your [b]bitch[/b].
                            You have every right to feel accomplished.
                            And you have every right to reap the spoils of your labour, however you see fit.
                        [/p]
                        [p]
                            Sensing the end of your leak approaching, you wildly rock your hips from side to side,
                            splattering urine all over the basilisk's body, from the tip of its snout to the base of its tail.
                            Your stream of piss rapidly weakens, and soon fades into a series of droplets dripping from your loins.
                            Satisfied, and convinced the basilisk now knows its place, ${pants || undies ? `you redress, and` : `you`} prepare to leave the cave.
                        [/p]`;

        return global.parser.parse(toReturn);
    }

    /**
     * Builds and returns the choice button.
     */
    function buildNextChoice() {
        var disabled = subController.continued() ? "disabled" : "";
        var isSelected = subController.continued();
        var selected = isSelected ? "selected" : "";
        var button = `<button class="button inlinechoice ${selected}" id="${continueId}" ${disabled}>Continue</button>`;
        return button;
    }

    /**
     * Builds and returns the choice of this section.
     * @returns {string} The choice of this section.
     */
    function buildChoice() {
        var choice = `<div class="choicecontainer">`;
        choice += buildNextChoice();
        choice += `</div>`;
        return choice;
    }

    /**
     * Disables all three buttons.
     */
    function disableButtons() {
        var buttons = [$("#" + continueId)];
        buttons.forEach(function (button) {
            button.unbind();
            button.attr("disabled", true);
        });
    }

    /**
     * Loads and displays the next part.
     * @param {object} part Which part to load.
     */
    function loadNextPart(part) {
        var built = part.build(true);
        global.ui.appendBeforeFinisher(built, global.ui.genericHeaderId);
        $("#" + part.id).fadeIn(400);
        part.registerListeners();
    }

    /**
     * Adds a listener to the button.
     */
    function registerNextListener() {
        $("#" + continueId).click(function () {
            $(this).addClass("selected");
            disableButtons();
            subController.continue();
            loadNextPart(next);
        });
    }

    // PUBLIC MEMBERS \\        this.public = "test";
    this.id = arguments.callee.name;

    // PUBLIC FUNCTIONS \\      this.publicFunction = function(){};

    /**
     * Builds and returns this part.
     * @param {boolean} invisible If passed and true, will give the entire section a display:none style.
     */
    this.build = function (invisible) {
        if (reqController && ((reqChoice && reqController.get() !== reqChoice) || (!reqChoice && !reqController.continued()))) {
            return "";
        }

        var part = `<div id="${that.id}" ${invisible ? 'style="display:none;"' : ""}>`;
        part += buildContent();
        part += (changeController && changeController.change()) || "";
        part += buildChoice();
        part += `</div>`;
        part += next.build();
        return part;
    };

    /**
     * Registers all the required button listeners for this part.
     */
    this.registerListeners = function () {
        if (reqController && ((reqChoice && reqController.get() !== reqChoice) || (!reqChoice && !reqController.continued()))) {
            return;
        }

        next.registerListeners();

        if (subController.continued()) {
            return;
        }

        registerNextListener();
    };
}

// END scenes\HamletDay2\UndergroundCave\fight\offence\fail\succeed\dominance\pee\UndergroundCavePee.js

// scenes\HamletDay2\UndergroundCave\fight\offence\fail\succeed\dominance\sex\UndergroundCaveFuck.js

/**
 * Fight section of the Underground Cave.
 * @param {UndergroundCaveController} controller The Underground Cave controller.
 */
function UndergroundCaveFuck(controller) {
    // PRIVATE MEMBERS \\       var private = "test";
    var that = this;
    var ctrl = controller;

    var reqChoice = UndergroundCaveDominanceChoice.SEX;
    var reqController = ctrl.dominance;
    var subController = ctrl.preContinue;
    var changeController = ctrl.sex;

    var continueId = arguments.callee.name + "ButtonOne";
    var next = new UndergroundCaveDominanceLeave(ctrl);

    // PRIVATE FUNCTIONS \\     function privateFunction(){}

    /**
     * Builds and returns the content of this section.
     * @returns {string} The content.
     */
    function buildContent() {
        global.kobold.history.shared.well.basiliskDomFucked = true;
        var dick = ctrl.misc.dick();
        var dick = ctrl.misc.dick();
        var pants = ctrl.misc.pants();
        var undies = ctrl.misc.underwear();

        var lowerPantsAndUndies = `and already naked`;

        if (pants) {
            lowerPantsAndUndies = `after lowering your ${global.kobold.inventory.createItemWithTooltip(pants)}`;
            if (undies) {
                lowerPantsAndUndies += ` and your ${global.kobold.inventory.createItemWithTooltip(undies)}`;
            }
        } else if (undies) {
            lowerPantsAndUndies = `after lowering your ${global.kobold.inventory.createItemWithTooltip(undies)}`;
        }
        var toReturn = `[p]
                            At first, the basilisk seemed like a determined, lethal [b]killing machine[/b],
                            but now that you've wrestled the fight out of it, it seems to have become a lot more [b]passive[/b].
                            It knows it did something bad, and it realizes that you're about to punish it.
                            It's as though the monster was hiding its submissive nature under a veil of hostility.
                            Now the creature is more of a [b]big wimp[/b] than a menacing beast,
                            and you're the [b]bully[/b] about to [b]push it around[/b] in whatever way you please.
                        [/p]
                        [p]
                            Thinking of this situation as a [i]reversal of power[/i] awakens lustful feelings deep inside of you.
                            You've had this recurring [i]wet dream[/i] a few times, where kobolds would stage an uprising,
                            and you'd find yourself in front of the [b]juiciest[/b] maiden in all of Varanar,
                            with ten of your kind holding her struggling, naked form down for you to [b]ravage[/b].
                            This is [b]just[/b] like that dream, only instead of a maiden, you have a [b]basilisk[/b] to quench your lust upon,
                            the uprising was more of a [b]wrestling match[/b], and there aren't really any kobolds around to hold the monster still.
                        [/p]
                        [p]
                            Okay, in retrospect, this entire ordeal might not be very much like your dream after all.
                            Still, you were reminded of it, and that's enough to get your
                            ${dick ? `member to start to harden within your cockslit` : `slit to slightly moisten`}.
                            You begin to imagine all the things you could do to the creature, now that you've subdued it.
                            While not so similar to your dream, having your way with a large, ferocious animal [b]does[/b] pique your interest.
                        [/p]`;

        if (dick) {
            var virgin = ctrl.misc.dickVirgin();
            toReturn += `
                        [p]
                            Doubting you'll [b]ever[/b] get a second chance at molesting a basilisk, you decide to act on your impulses.
                            You begin to stroke the emerging tapered tip of your member, which rapidly grows erect, fueled by the dirty thoughts popping up in your mind.
                            You want to fuck its stony ass, concealed underneath its tail.
                            You want to walk on the wild side, to tempt fate itself,
                            to see whether or not the beast still has enough [b]fight[/b] in it to resist, to [b]thrash around[/b] and [b]maim you[/b].
                        [/p]
                        [p]
                            You bet it won't.
                            You bet you've [b]broken[/b] it.
                            You bet it won't even [b]try[/b] to stop you from pounding its butt.
                            You've shown it that it's [b]not[/b] the boss around here.
                            You've overpowered it, despite all odds.
                            It won't resist.
                            Not after the [b]ass-whooping[/b] you gave it.
                            Not after it attacked you, so [b]certain[/b] that you'd be an easy prey.
                        [/p]
                        [p]
                            Lust clouds your mind, preventing you from thinking about the consequences should things go awry.
                            Driven by desire, ${lowerPantsAndUndies}, you approach the basilisk's backside,
                            dropping to your knees directly behind it, at the base of its tail.
                            The monster is panting heavily, not yet fully recovered from the intense tussle.
                            A perfect opportunity.
                        [/p]
                        [p]
                            Using both your hands, you lift up the basilisk's heavy tail, revealing its smooth backside, along with its loins.
                            Oddly enough, the crocodillian seems to be aroused [i]already[/i].
                            Its girthy, ridged and draconic-looking member hangs fully erect below its soft underbelly.
                            It must be in rut or something.
                            Maybe that's why it was so fiercely defending its lair.
                            Or perhaps it's just a natural born [b]slut[/b].
                            That last option, while the least probable, is also the most exciting.
                            You think you'll go with that one.
                        [/p]
                        [p]
                            Once lifted, you manage to hold the beast's tail up using only one hand.
                            With the other, you begin to [i]probe[/i] around its rear.
                            At least the underside is [b]far[/b] more [i]soft[/i] than its back.
                            In fact, you think you might actually end up [b]enjoying[/b] this.
                        [/p]
                        [p]
                            After giving yourself a few more strokes, you line up the tip of your member with the basilisk's tailhole.
                            You immediately begin to apply pressure, pressing your tapered length into its overly tight rear.
                            Once past its clenching sphincter, you easily manage to ram the rest of your length inside, bottoming out in a single, smooth thrust.
                            The monster hisses, but it does not fight back.
                            It stays in place, accepting its position as your [b]bitch[/b].
                            Just as planned.
                        [/p]
                        [p]
                            While the creature's exterior is hard, tough and cold, its insides are the exact opposite.
                            Warm, fleshy, and exceedingly tight, almost what you imagine a human's ass to feel like, minus a bubbly butt to rest your groin against.
                            A pleasant surprise, and not an unwelcome one at that.
                            You lean back ever so slightly, and slowly begin to thrust in and out of the crocodillian's ass.
                            Luckily, it is far too worn out to put up any other kind of resistance.
                            Or maybe it really [b]does[/b] like this.
                        [/p]
                        [p]
                            The basilisk's tight insides prove to be quite pleasurable,
                            but the sheer [b]debasement[/b] of what you're doing drives your excitement through the roof.
                            You're [b]fucking[/b] a feral.
                            The [b]beast[/b] that tried to murder you has been turned into your [b]bitch[/b].
                            You get to be the person on the [b]giving[/b] end of abuse, for once.
                            And on top of all of this, you're tempting fate itself by ramming your dick into a creature that could easily [b]tear you apart[/b]!
                        [/p]
                        [p]
                            Closing your eyes for a moment, your mind briefly wanders back to the dream that inspired you to abuse the basilisk.
                            Snapping back to reality, however, you realize that this situation is [b]even better[/b] than what you imagined.
                            Having the [b]pleasure[/b] of dominating a [b]lethal beast[/b],
                            one that could [b]rip you to shreds[/b] were it not too exhausted,
                            stirs your loins far more than the thought of raping a helpless damsel.
                            While you've only been absent-mindedly humping away at the big lizard's rear for a few seconds short of a minute,
                            you can already feel your premature end rapidly approaching.
                        [/p]
                        [p]
                            You let out a lustful groan, rubbing your free hand along the creature's soft underside.
                            You consider jerking it off as you fuck it, but you decide against giving it pleasure.
                            This is supposed to be a [b]punishment[/b], after all.
                            Instead, you grab onto its thigh, upping the intensity of your thrusts.
                            The fact that it doesn't resist,
                            the [b]thought[/b] of having reduced the once-proud crocodillian to an [b]eager[/b] tail-lifter,
                            [b]that[/b] sends you over the edge.
                        [/p]
                        [p]
                            You give the beast's rear a few more rapid humps, before reaching your end.
                            Your member [b]pulses[/b] and [b]spasms[/b], spunk pumping from deep within your internal balls,
                            through your shaft, squirting directly inside of the monster's body.
                            Clearly reluctant, or perhaps even outright [b]unwilling[/b], it tries to shuffle forwards,
                            but using both of your hands you firmly keep it in place for the entire duration of your orgasm.
                        [/p]
                        [p]
                            Your lust sated, you pull your cock from the big beast's butt, and let go of its tail.
                            It's almost kind of [b]sad[/b] to leave the basilisk without getting it off, too,
                            but you both know that it hasn't [b]earned[/b] that right.
                            It shouldn't have tried to murder you.
                            If it hadn't, maybe you'd seen fit to give it a pity-handjob after finishing.
                            You rise to your feet${pants || undies ? ` and redress` : ``}.
                        [/p]`;
            if (virgin) {
                toReturn += `[p][c][b]You are no longer a virgin.[/b][/c][/p]`;
            }
        } else {
            toReturn += `
                        [p]
                            Doubting you'll [b]ever[/b] get a second chance at molesting a basilisk, you decide to act on your impulses.
                            You begin to touch your own slit, which rapidly dampens, fueled by the dirty thoughts popping up in your mind.
                            You want to touch its stony ass, concealed underneath its tail.
                            You want to walk on the wild side, to tempt fate itself,
                            to see whether or not the beast still has enough [b]fight[/b] in it to resist, to [b]thrash around[/b] and [b]maim you[/b].
                        [/p]
                        [p]
                            You bet it won't.
                            You bet you've [b]broken[/b] it.
                            You bet it won't even [b]try[/b] to stop you from ramming your fingers up its butt.
                            You've shown it that it's [b]not[/b] the boss around here.
                            You've overpowered it, despite all odds.
                            It won't resist.
                            Not after the [b]ass-whooping[/b] you gave it.
                            Not after it attacked you, so [b]certain[/b] that you'd be an easy prey.
                        [/p]
                        [p]
                            Lust clouds your mind, preventing you from thinking about the consequences should things go awry.
                            Driven by desire, you approach the basilisk's backside,
                            dropping to your knees directly behind it, at the base of its tail.
                            The monster is panting heavily, not yet fully recovered from the intense tussle.
                            A perfect opportunity.
                        [/p]
                        [p]
                            Using both your hands, you lift up the basilisk's heavy tail, revealing its smooth backside, along with its loins.
                            Oddly enough, the crocodillian seems to be aroused [i]already[/i].
                            Its girthy, ridged and draconic-looking member hangs fully erect below its soft underbelly.
                            It must be in rut or something.
                            Maybe that's why it was so fiercely defending its lair.
                            Or perhaps it's a natural born [b]slut[/b].
                            That last option, while the least probable, is also the most exciting.
                            You think you'll go with that one.
                        [/p]
                        [p]
                            Once lifted, you manage to hold the beast's tail up using only one hand.
                            You don't [i]solely[/i] intend to finger its butt, though.
                            You'll need [b]both[/b] your hands for what you have in store.
                            Intent on making the creature a bit more [i]cooperative[/i],
                            you gingerly grab hold of its cock, and slowly rub your comparatively small palm up and down the basilisk's shaft,
                            stroking its length at an agonizingly slow pace.
                        [/p]
                        [p]
                            The feral lets out a surprised, but remotely [i]pleased[/i] grunt.
                            A viscous, heady squirt of precum shoots from the tapered tip of its member.
                            The scent of the stuff in [i]inebriating[/i], like a potent aphrodisiac in its own right.
                            The monster doesn't seem quite comfortable enough to willingly keep its tail raised yet,
                            but you know exactly how to spur it on.
                        [/p]
                        [p]
                            Leaning your head in close, you press your muzzle against the beast's rear.
                            Your tongue snakes out of your mouth, and in a fit of deviancy, you tentatively lick the creature's tailhole,
                            elliciting another confused, but far from upset grunt from its muzzle.
                            Sterile and tasteless, apart from a remote hint of [i]sweat[/i], but the basilisk [i]did[/i] seem to like it.
                            Its member throbs in your hand, and it slowly starts to move its hips on its own,
                            humping against your palm.
                            Just a little bit more.
                        [/p]
                        [p]
                            Again and again, you lap at the monster's rear, your tongue settling into a rhythm,
                            your saliva wettening its scales and lubing its hole, preparing it for what is to come.
                            The feral is blissfully unaware of your devious plans.
                            You strengthen your grip on its member, and increase the speed of your hand, properly jerking it off.
                            You can feel its precum slickening your palm, reducing friction, making the entire ordeal even [b]more[/b] pleasurable for the crocodillian.
                        [/p]
                        [p]
                            Finally, with the beast completely lost in pleasure, you get what you were after:
                            a burden is lifted off your hand, the basilisk willingly keeping its tail lifted,
                            granting you access to its loins [i]without[/i] needing to work for it.
                            [b]Perfect[/b].
                            With the large lizard fully relaxed, you pull your head back a little,
                            a few thick strings of saliva connecting your muzzle to its ass still.
                            You move your now-free hand to the creature's rear.
                            This is where the real fun begins.
                        [/p]
                        [p]
                            You press one of your fingers against the monster's tailhole, teasingly circling it, spreading your spit around.
                            Then, while simultaneously upping the pace of your frantic jerking once more,
                            you slide the digit into the feral's spit-lubed rear, ramming it inside of the basilisk to the very knuckle.
                            The large lizard is obviously startled.
                            Its legs frantically shuffle about, but after the initial panic subsides, it decides to remain in place.
                            It [b]knows[/b] it deserves this.
                            Or perhaps it's [i]confused[/i] about what's going on.
                            Or maybe it [b]likes it[/b].
                        [/p]
                        [p]
                            While continuing to firmly stroke the beast's ridged member,
                            you slide a second finger inside of its thoroughly lubricated behind,
                            and begin to pump both of the digits in and out of the creature's body, properly [b]fingering[/b] it while jerking it off,
                            sending mixed messages of both [b]submission[/b] and [b]pleasure[/b] coursing down its spine.
                        [/p]
                        [p]
                            You can feel the feral's end approaching.
                            It begins to thrust against your hand once more,
                            at the same time unintentionally [b]riding[/b] your fingers,
                            even more mixed messages filling its mind.
                            Its shaft twitches in your grasp.
                            Its end is getting [b]very[/b] near.
                        [/p]
                        [p]
                            In order to get a rise out of the basilisk, you hold the hand wrapped around its member perfectly still,
                            while continuing to deftly molest its rear.
                            [b]Needing[/b] to get off, it [b]wildly[/b] humps against your slickened palm,
                            outright [b]fucking[/b] your hand.
                            With a pleasured hiss, the monster reaches its climax,
                            but feeling exceptionally cruel, you let go of its cock the [b]moment[/b] it finishes,
                            leaving the draconic-looking length to spasm and squirm unattended,
                            the beast's orgasm driven on solely by the stimulation of its rear end being fingered.
                        [/p]
                        [p]
                            Wave after wave of fragrant feral spunk splatters against the stone cavern floor.
                            The basilisk desperately humps against [b]nothing[/b], trying but failing to find any pleasure,
                            eventually resorting to grinding its cock against the ground, rubbing its length through its own puddle of cum.
                            Satisfied with this [i]punishment[/i], you pull your fingers from the lizard's ass,
                            and rise to your feet once more${pants || undies ? ` before redressing` : ``}.
                        [/p]`;
        }

        return global.parser.parse(toReturn);
    }

    /**
     * Builds and returns the choice button.
     */
    function buildNextChoice() {
        var disabled = subController.continued() ? "disabled" : "";
        var isSelected = subController.continued();
        var selected = isSelected ? "selected" : "";
        var button = `<button class="button inlinechoice ${selected}" id="${continueId}" ${disabled}>Continue</button>`;
        return button;
    }

    /**
     * Builds and returns the choice of this section.
     * @returns {string} The choice of this section.
     */
    function buildChoice() {
        var choice = `<div class="choicecontainer">`;
        choice += buildNextChoice();
        choice += `</div>`;
        return choice;
    }

    /**
     * Disables all three buttons.
     */
    function disableButtons() {
        var buttons = [$("#" + continueId)];
        buttons.forEach(function (button) {
            button.unbind();
            button.attr("disabled", true);
        });
    }

    /**
     * Loads and displays the next part.
     * @param {object} part Which part to load.
     */
    function loadNextPart(part) {
        var built = part.build(true);
        global.ui.appendBeforeFinisher(built, global.ui.genericHeaderId);
        $("#" + part.id).fadeIn(400);
        part.registerListeners();
    }

    /**
     * Adds a listener to the button.
     */
    function registerNextListener() {
        $("#" + continueId).click(function () {
            $(this).addClass("selected");
            disableButtons();
            subController.continue();
            loadNextPart(next);
        });
    }

    // PUBLIC MEMBERS \\        this.public = "test";
    this.id = arguments.callee.name;

    // PUBLIC FUNCTIONS \\      this.publicFunction = function(){};

    /**
     * Builds and returns this part.
     * @param {boolean} invisible If passed and true, will give the entire section a display:none style.
     */
    this.build = function (invisible) {
        if (reqController && ((reqChoice && reqController.get() !== reqChoice) || (!reqChoice && !reqController.continued()))) {
            return "";
        }

        var part = `<div id="${that.id}" ${invisible ? 'style="display:none;"' : ""}>`;
        part += buildContent();
        part += (changeController && changeController.change()) || "";
        part += buildChoice();
        part += `</div>`;
        part += next.build();
        return part;
    };

    /**
     * Registers all the required button listeners for this part.
     */
    this.registerListeners = function () {
        if (reqController && ((reqChoice && reqController.get() !== reqChoice) || (!reqChoice && !reqController.continued()))) {
            return;
        }

        next.registerListeners();

        if (subController.continued()) {
            return;
        }

        registerNextListener();
    };
}

// END scenes\HamletDay2\UndergroundCave\fight\offence\fail\succeed\dominance\sex\UndergroundCaveFuck.js

// scenes\HamletDay2\UndergroundCave\fight\offence\fail\succeed\dominance\UndergroundCaveDominance.js

/**
 * Fight section of the Underground Cave.
 * @param {UndergroundCaveController} controller The Underground Cave controller.
 */
function UndergroundCaveDominance(controller) {
    // PRIVATE MEMBERS \\       var private = "test";
    var that = this;
    var ctrl = controller;

    var reqChoice = UndergroundCaveWrestlingWinChoice.DOMINANCE;
    var reqController = ctrl.wrestleWin;
    var subController = ctrl.dominance;
    var changeController = false;

    var firstId = arguments.callee.name + "ButtonOne";
    var secondId = arguments.callee.name + "ButtonTwo";
    var thirdId = arguments.callee.name + "ButtonThree";

    var firstNext = new UndergroundCavePee(ctrl);
    var secondNext = new UndergroundCaveOral(ctrl);
    var thirdNext = new UndergroundCaveFuck(ctrl);

    var firstChoice = UndergroundCaveDominanceChoice.PEE;
    var secondChoice = UndergroundCaveDominanceChoice.ORAL;
    var thirdChoice = UndergroundCaveDominanceChoice.SEX;

    // PRIVATE FUNCTIONS \\     function privateFunction(){}

    /**
     * Builds and returns the content of this section.
     * @returns {string} The content.
     */
    function buildContent() {
        global.kobold.history.shared.well.basiliskDominated = true;
        var toReturn = `[p]
                            The basilisk is already beaten.
                            There is no point to taking its life.
                            It has submitted to you.
                            Still, you feel like it hasn't learned its lesson yet.
                            It probably won't turn aggressive after you release it from your chokehold,
                            but you imagine that, in time, it might return to its kobold-attacking ways.
                            You think you know exactly what it'll take to prevent that.
                            You need to show the stony lizard who's boss.
                        [/p]
                        [p]
                            You slowly release your grip on the monster's throat.
                            It immediately begins to gasp for air, taking a few deep breaths.
                            You roll off of the beast, and rise to your feet.
                            It looks up at you, submissiveness clear on its face, like a dog that knows it wronged its master.
                            And like a dog, you need to rub its defeat in its face, to make sure it'll never forget this day.
                            You need to assert your dominance over it, in a way that it'll remember for [b]years[/b] to come.
                        [/p]`;

        return global.parser.parse(toReturn);
    }

    /**
     * Builds and returns the choice button.
     */
    function buildFirstChoice() {
        var disabled = subController.has() ? "disabled" : "";
        var isSelected = subController.get() === firstChoice;
        var selected = isSelected ? "selected" : "";
        var button = `<button class="button inlinechoice ${selected}" id="${firstId}" ${disabled}>Pee on it</button>`;

        var tooltip = global.parser.parse(`Display your dominance the way canines do.`);
        var popupContainer = global.ui.makeToolTip(button, tooltip, false, false, "width: 190px;");
        // Re-wrap with proper positioning.
        button = `<div class="inlinechoice">`;
        button += popupContainer;
        button += `</div>`;

        return button;
    }

    /**
     * Builds and returns the choice button.
     */
    function buildSecondChoice() {
        var disabled = subController.has() ? "disabled" : "";
        var isSelected = subController.get() === secondChoice;
        var selected = isSelected ? "selected" : "";
        var button = `<button class="button inlinechoice ${selected}" id="${secondId}" ${disabled}>Use its muzzle</button>`;

        var tooltip = global.parser.parse(`Time to facefuck a beast's mouth filled with sharp teeth. What could go wrong?`);
        var popupContainer = global.ui.makeToolTip(button, tooltip, false, false, "width: 200px;");
        // Re-wrap with proper positioning.
        button = `<div class="inlinechoice">`;
        button += popupContainer;
        button += `</div>`;

        return button;
    }

    /**
     * Builds and returns the choice button.
     */
    function buildThirdChoice() {
        var disabled = subController.has() ? "disabled" : "";
        var isSelected = subController.get() === thirdChoice;
        var selected = isSelected ? "selected" : "";
        var button = `<button class="button inlinechoice ${selected}" id="${thirdId}" ${disabled}>Fuck it</button>`;

        var male = ctrl.misc.dick();
        var tooltip = global.parser.parse(`Make the basilisk your [b]bitch[/b].`);
        if(!male) {
            tooltip = global.parser.parse(`Fingerfuck the basilisk's tailhole. Make it your [b]bitch[/b].`);
        }
        var popupContainer = global.ui.makeToolTip(button, tooltip, false, false, "width: 190px;");
        // Re-wrap with proper positioning.
        button = `<div class="inlinechoice">`;
        button += popupContainer;
        button += `</div>`;

        return button;
    }

    /**
     * Builds and returns the choice of this section.
     * @returns {string} The choice of this section.
     */
    function buildChoice() {
        var choice = `<div class="choicecontainer"><div class="inlinechoiceheader">You:</div>`;
        choice += buildFirstChoice();
        choice += `<hr class="inlinechoiceseparator">`;
        choice += buildSecondChoice();
        choice += `<hr class="inlinechoiceseparator">`;
        choice += buildThirdChoice();
        choice += `</div>`;
        return choice;
    }

    /**
     * Disables all three buttons.
     */
    function disableButtons() {
        var buttons = [$("#" + firstId), $("#" + secondId), $("#" + thirdId)];
        buttons.forEach(function (button) {
            button.unbind();
            button.attr("disabled", true);
        });
    }

    /**
     * Loads and displays the next part.
     * @param {object} part Which part to load.
     */
    function loadNextPart(part) {
        var built = part.build(true);
        global.ui.appendBeforeFinisher(built, global.ui.genericHeaderId);
        $("#" + part.id).fadeIn(400);
        part.registerListeners();
    }

    /**
     * Adds a listener to the button.
     */
    function registerFirstListener() {
        $("#" + firstId).click(function () {
            $(this).addClass("selected");
            disableButtons();
            subController.set(firstChoice);
            loadNextPart(firstNext);
        });
    }

    /**
     * Adds a listener to the button.
     */
    function registerSecondListener() {
        $("#" + secondId).click(function () {
            $(this).addClass("selected");
            disableButtons();
            subController.set(secondChoice);
            loadNextPart(secondNext);
        });
    }

    /**
     * Adds a listener to the button.
     */
    function registerThirdListener() {
        $("#" + thirdId).click(function () {
            $(this).addClass("selected");
            disableButtons();
            subController.set(thirdChoice);
            loadNextPart(thirdNext);
        });
    }

    // PUBLIC MEMBERS \\        this.public = "test";
    this.id = arguments.callee.name;

    // PUBLIC FUNCTIONS \\      this.publicFunction = function(){};

    /**
     * Builds and returns this part.
     * @param {boolean} invisible If passed and true, will give the entire section a display:none style.
     */
    this.build = function (invisible) {
        if (reqController && ((reqChoice && reqController.get() !== reqChoice) || (!reqChoice && !reqController.continued()))) {
            return "";
        }

        var part = `<div id="${that.id}" ${invisible ? 'style="display:none;"' : ""}>`;
        part += buildContent();
        part += (changeController && changeController.change()) || "";
        part += buildChoice();
        part += `</div>`;
        part += firstNext.build();
        part += secondNext.build();
        part += thirdNext.build();
        return part;
    };

    /**
     * Registers all the required button listeners for this part.
     */
    this.registerListeners = function () {
        if (reqController && ((reqChoice && reqController.get() !== reqChoice) || (!reqChoice && !reqController.continued()))) {
            return;
        }

        firstNext.registerListeners();
        secondNext.registerListeners();
        thirdNext.registerListeners();

        if (subController.has()) {
            return;
        }

        registerFirstListener();
        registerSecondListener();
        registerThirdListener();
    };
}

var UndergroundCaveDominanceChoice = {
    PEE: 1,
    ORAL: 2,
    SEX: 3
};

// END scenes\HamletDay2\UndergroundCave\fight\offence\fail\succeed\dominance\UndergroundCaveDominance.js

// scenes\HamletDay2\UndergroundCave\fight\offence\fail\succeed\go\UndergroundCaveLetGoLeave.js

/**
 * Fight section of the Underground Cave.
 * @param {UndergroundCaveController} controller The Underground Cave controller.
 */
function UndergroundCaveLetGoLeave(controller) {
    // PRIVATE MEMBERS \\       var private = "test";
    var that = this;
    var ctrl = controller;

    var reqChoice = false;
    var reqController = ctrl.preContinue;
    var changeController = ctrl.letGoLeave;

    var continueId = arguments.callee.name + "ButtonOne";

    // PRIVATE FUNCTIONS \\     function privateFunction(){}

    /**
     * Builds and returns the content of this section.
     * @returns {string} The content.
     */
    function buildContent() {
        var toReturn = `[p]
                            You and the basilisk slake your thirst, communally lapping at the cool water for nearly an entire minute on end.
                            Finishing a little bit before it does, you rise to your feet.
                            Noticing you've stopped drinking, it follows suit, seemingly standing at attention, awaiting your next [i]command[/i].
                            But no order comes.
                            You have no interest in being the creature's master.
                            You just want to get out of here already.
                        [/p]
                        [p]
                            You start following the river-branch, hoping it'll lead you to some kind of exit.
                            The monster tags along, scuttling after you, like a trained dog that doesn't even need a leash to know its place.
                            Not feeling threatened by it, you take your time to leisurely stroll alongside the water, until daylight comes into sight.
                            As you expected: it was a stale branch of the river!
                            Climbing out of the cave, you sit your butt down on the riverside dirt, and take a breather.
                            You feel like you've earned one.
                        [/p]
                        [p]
                            The basilisk, which followed you until the cave-entrance, stares at your seated frame from the darkness of the cavern's interior.
                            It seems [b]scared[/b] of the sunlight, perhaps unable to weather it.
                            You give it a dismissive wave, wordlessly ordering it to go back home.
                            It utters a loud whine, hesitating to follow your command,
                            but after a bit of what you can only imagine to be [i]pouting[/i],
                            the creature rejectedly turns its tail, and saunters back into its lair. 
                        [/p]
                        [p]
                            You could have used a basilisk companion, especially one that knows its place.
                            But since it can't travel during the day,
                            and seeing as you'd have a hard time explaining to the guards of Varanar why you're trying to bring a [b]lethal beast[/b] into the city at night,
                            you figure it'd be best to leave the monster here.
                            It's better off without you anyway.
                            Around you, it'd just end up getting killed.
                            Besides, you can barely even scrounge up enough food to feed yourself,
                            let alone a feral several times your weight.
                        [/p]
                        [p]
                            You've defied death more than once today.
                            You should consider yourself lucky to be alive.
                            The trip into the well was a harrowing experience.
                            You nearly got crushed, almost drowned, and after all of that, you managed to wrestle and tame a basilisk.
                            You doubt there's other kobolds that can claim they tussled with a mythological beast and [b]won[/b].
                        [/p]
                        [p]
                            You've gained a few awesome stories to tell once you've grown old and wise.
                            Stories like the ones Seki used to tell you when you were little.
                            You went through all that trouble to get your mind off of him, and here you are reminiscing once more.
                            You just can't help yourself from clinging to times long gone.
                            Things were so much simpler back then.
                            You miss those days.
                        [/p]
                        [p]
                            The sun is slowly starting to set.
                            You drag yourself to your feet.
                            It's time to go.
                            Varanar isn't [i]that[/i] far off.
                            If your legs don't give out from underneath you, you might still make it there before nightfall.
                        [/p]`;

        return global.parser.parse(toReturn);
    }

    /**
     * Builds and returns the continue button.
     */
    function buildChoice() {
        var disabled = ctrl.continued();
        var choice = `<div class="choicecontainer">`;
        choice += `<button class="button bigbutton continuebutton" id="${continueId}" ${disabled ? "disabled" : ""}>`;
        choice += `Continue &gt;&gt`;
        choice += `</button>`;
        choice += `</div>`;
        return choice;
    }

    /**
     * Disables all three buttons.
     */
    function disableButtons() {
        var buttons = [$("#" + continueId)];
        buttons.forEach(function (button) {
            button.unbind();
            button.attr("disabled", true);
        });
    }

    /**
     * Loads and displays the next scene.
     * @param {string} sceneName Name of the scene to load.
     * @param {string} folder Folder of the scene to load.
     */
    function loadNextPart(sceneName, folder) {
        global.ui.fadeOutContent(function () {
            global.sceneEnd();
            global.sceneLoader.loadScene(sceneName, folder);
        });
    }

    /**
     * Adds a listener to the button.
     */
    function registerContinueListener() {
        $("#" + continueId).click(function () {
            $(this).addClass("selected");
            disableButtons();
            ctrl.continue();
            loadNextPart(ctrl.nextSceneName, ctrl.nextFolderName);
        });
    }

    // PUBLIC MEMBERS \\        this.public = "test";
    this.id = arguments.callee.name;

    // PUBLIC FUNCTIONS \\      this.publicFunction = function(){};

    /**
     * Builds and returns this part.
     * @param {boolean} invisible If passed and true, will give the entire section a display:none style.
     */
    this.build = function (invisible) {
        if (reqController && ((reqChoice && reqController.get() !== reqChoice) || (!reqChoice && !reqController.continued()))) {
            return "";
        }

        ctrl.bgm.stopLoop();
        global.ui.applyTheme("hamlet_day");
        var part = `<div id="${that.id}" ${invisible ? 'style="display:none;"' : ""}>`;
        part += buildContent();
        part += (changeController && changeController.change()) || "";
        part += buildChoice();
        if (!ctrl.nextSceneReady) {
            part += `<span class="todo">There is no content beyond this point.</span>`;
        }
        part += `</div>`;
        return part;
    };

    /**
     * Registers all the required button listeners for this part.
     */
    this.registerListeners = function () {
        if (reqController && ((reqChoice && reqController.get() !== reqChoice) || (!reqChoice && !reqController.continued()))) {
            return;
        }

        if (ctrl.continued()) {
            return;
        }

        if (ctrl.nextSceneReady) {
            registerContinueListener();
        }
    };
}

// END scenes\HamletDay2\UndergroundCave\fight\offence\fail\succeed\go\UndergroundCaveLetGoLeave.js

// scenes\HamletDay2\UndergroundCave\fight\offence\fail\succeed\go\UndergroundCaveLetGo.js

/**
 * Fight section of the Underground Cave.
 * @param {UndergroundCaveController} controller The Underground Cave controller.
 */
function UndergroundCaveLetGo(controller) {
    // PRIVATE MEMBERS \\       var private = "test";
    var that = this;
    var ctrl = controller;

    var reqChoice = UndergroundCaveWrestlingWinChoice.GO;
    var reqController = ctrl.wrestleWin;
    var subController = ctrl.preContinue;
    var changeController = ctrl.letGo;

    var continueId = arguments.callee.name + "ButtonOne";
    var next = new UndergroundCaveLetGoLeave(ctrl);

    // PRIVATE FUNCTIONS \\     function privateFunction(){}

    /**
     * Builds and returns the content of this section.
     * @returns {string} The content.
     */
    function buildContent() {
        var toReturn = `[p]
                            The basilisk is already beaten.
                            There is no point to taking its life.
                            It has submitted to you.
                            You hope it won't turn aggressive once more after you release it,
                            but you don't really want to take its life either.
                        [/p]
                        [p]
                            Despite doubt growing in the back of your mind, you slowly release your grip on the monster's throat.
                            It immediately begins to gasp for air, taking a few deep breaths.
                            At least it doesn't immediately appear hostile.
                            If it wanted to continue fighting, it'd have thrown you off its back by now.
                            You roll off of the beast, and exhaustedly rise to your feet.
                            It looks up at you, submissiveness clear on its face, like a dog that knows it wronged its master.
                            This cave must be its lair or something.
                            It was just trying to protect its territory.
                        [/p]
                        [p]
                            You give the basilisk a short, understanding nod, before gesturing towards the water.
                            You could sure use a drink after a fight like that, and you've no doubt that it, too, is thirsty.
                            The both of you walk towards the water.
                            At its edge, you drop to your hands and knees.
                            Together with the monster you were fighting not a minute ago,
                            you lower your head to the surface of the water,
                            and the both of you start greedily lapping up the fresh, revitalizing liquid.
                        [/p]`;

        return global.parser.parse(toReturn);
    }

    /**
     * Builds and returns the choice button.
     */
    function buildNextChoice() {
        var disabled = subController.continued() ? "disabled" : "";
        var isSelected = subController.continued();
        var selected = isSelected ? "selected" : "";
        var button = `<button class="button inlinechoice ${selected}" id="${continueId}" ${disabled}>Continue</button>`;
        return button;
    }

    /**
     * Builds and returns the choice of this section.
     * @returns {string} The choice of this section.
     */
    function buildChoice() {
        var choice = `<div class="choicecontainer">`;
        choice += buildNextChoice();
        choice += `</div>`;
        return choice;
    }

    /**
     * Disables all three buttons.
     */
    function disableButtons() {
        var buttons = [$("#" + continueId)];
        buttons.forEach(function (button) {
            button.unbind();
            button.attr("disabled", true);
        });
    }

    /**
     * Loads and displays the next part.
     * @param {object} part Which part to load.
     */
    function loadNextPart(part) {
        var built = part.build(true);
        global.ui.appendBeforeFinisher(built, global.ui.genericHeaderId);
        $("#" + part.id).fadeIn(400);
        part.registerListeners();
    }

    /**
     * Adds a listener to the button.
     */
    function registerNextListener() {
        $("#" + continueId).click(function () {
            $(this).addClass("selected");
            disableButtons();
            subController.continue();
            loadNextPart(next);
        });
    }

    // PUBLIC MEMBERS \\        this.public = "test";
    this.id = arguments.callee.name;

    // PUBLIC FUNCTIONS \\      this.publicFunction = function(){};

    /**
     * Builds and returns this part.
     * @param {boolean} invisible If passed and true, will give the entire section a display:none style.
     */
    this.build = function (invisible) {
        if (reqController && ((reqChoice && reqController.get() !== reqChoice) || (!reqChoice && !reqController.continued()))) {
            return "";
        }

        var part = `<div id="${that.id}" ${invisible ? 'style="display:none;"' : ""}>`;
        part += buildContent();
        part += (changeController && changeController.change()) || "";
        part += buildChoice();
        part += `</div>`;
        part += next.build();
        return part;
    };

    /**
     * Registers all the required button listeners for this part.
     */
    this.registerListeners = function () {
        if (reqController && ((reqChoice && reqController.get() !== reqChoice) || (!reqChoice && !reqController.continued()))) {
            return;
        }

        next.registerListeners();

        if (subController.continued()) {
            return;
        }

        registerNextListener();
    };
}

// END scenes\HamletDay2\UndergroundCave\fight\offence\fail\succeed\go\UndergroundCaveLetGo.js

// scenes\HamletDay2\UndergroundCave\fight\offence\fail\succeed\snap\UndergroundCaveSnapLeave.js

/**
 * Fight section of the Underground Cave.
 * @param {UndergroundCaveController} controller The Underground Cave controller.
 */
function UndergroundCaveSnapLeave(controller) {
    // PRIVATE MEMBERS \\       var private = "test";
    var that = this;
    var ctrl = controller;

    var reqChoice = false;
    var reqController = ctrl.preContinue;
    var changeController = ctrl.snapLeave;

    var continueId = arguments.callee.name + "ButtonOne";

    // PRIVATE FUNCTIONS \\     function privateFunction(){}

    /**
     * Builds and returns the content of this section.
     * @returns {string} The content.
     */
    function buildContent() {
        var toReturn = `[p]
                            You did it.
                            You won.
                            You killed the monster.
                            Just like a knight would do!
                            Somehow, you don't feel very [i]knightly[/i], though.
                            You should be proud of yourself, but for some reason, you aren't.
                            Maybe your actions weren't as [i]chivalrous[/i] as you would have liked,
                            but it's the outcome that matters, and not how you achieved it, right?
                            The ends justify the means.
                        [/p]
                        [p]
                            But then again, the basilisk was just a simple beast minding its own business.
                            You were intruding on its territory.
                            You could have probably left and it wouldn't have harmed you at all.
                            Now you're confused.
                            Did you do the right thing?
                        [/p]
                        [p]
                            You honestly don't know anymore.
                            Does it even matter?
                            What's done is done.
                            If you hadn't killed the creature, some pompous knight in shining armor
                            -- with nothing left to prove, neither to himself, nor to the world --
                            would have strolled into this cave to add another tally to his already impressive list of slain monsters.
                            For someone properly armed and armored, this would have been a [b]chore[/b], a menial task barely even worthy of mention.
                            But for you, this is a feat you'll remember until the day you die.
                        [/p]
                        [p]
                            Your conviction bolstered, you exhaustedly roll off of the lizard.
                            After resting for a few minutes, you kneel besides it.
                            You figure it'd be best to take a trophy.
                            Something to remember this day by.
                            Something you can show to people, so they'll believe you when you tell them you singlehandedly killed a basilisk.
                            But what?
                        [/p]
                        [p]
                            While pondering, you run one of your hands over the deceased basilisk's back.
                            Some of its scales seem to be rather [i]loose[/i].
                            You take hold of one with both of your hands, and with surprising ease, you manage to [b]tear[/b] the scale from the monster's backside.
                            Like plucking a chicken.
                            You repeat the process a couple of times,
                            until you have collected a suitable handful of ${global.kobold.inventory.createItemWithTooltip(new BasiliskScales())}
                            to take with as your prize for ridding the world of this horrible monstrosity.
                        [/p]
                        [p]
                            Your trophies collected, you decide it's time to find a way out of the cave.
                            Following the river-branch should lead you to some kind of exit.
                            Without the threat of the basilisk around, you don't even need to [b]swim[/b].
                            You leisurely stroll alongside the water, until daylight comes into sight.
                            As you expected: the water was a stale branch of the river!
                            Climbing out of the cave, you sit your butt down on the riverside dirt, and take a breather.
                            You feel like you've earned one.
                        [/p]
                        [p]
                            You've defied death more than once today.
                            You should consider yourself lucky to be alive.
                            The trip into the well was a harrowing experience.
                            You nearly got crushed, almost drowned, and after all of that, you managed to kill a basilisk.
                            It might not have been the most [i]honorable[/i] way of slaying the beast, but it was slain nonetheless.
                        [/p]
                        [p]
                            Besides the ${global.kobold.inventory.createItemWithTooltip(new BasiliskScales())} you [i]harvested[/i],
                            you've gained a few awesome stories to tell once you've grown old and wise.
                            Stories like the ones Seki used to tell you when you were little.
                            You went through all that trouble to get your mind off of him, and here you are reminiscing once more.
                            You just can't help yourself from clinging to times long gone.
                            Things were so much simpler back then.
                            You miss those days.
                        [/p]
                        [p]
                            The sun is slowly starting to set.
                            You drag yourself to your feet.
                            It's time to go.
                            Varanar isn't [i]that[/i] far off.
                            If your legs don't give out from underneath you, you might still make it there before nightfall.
                        [/p]`;

        return global.parser.parse(toReturn);
    }

    /**
     * Builds and returns the continue button.
     */
    function buildChoice() {
        var disabled = ctrl.continued();
        var choice = `<div class="choicecontainer">`;
        choice += `<button class="button bigbutton continuebutton" id="${continueId}" ${disabled ? "disabled" : ""}>`;
        choice += `Continue &gt;&gt`;
        choice += `</button>`;
        choice += `</div>`;
        return choice;
    }

    /**
     * Disables all three buttons.
     */
    function disableButtons() {
        var buttons = [$("#" + continueId)];
        buttons.forEach(function (button) {
            button.unbind();
            button.attr("disabled", true);
        });
    }

    /**
     * Loads and displays the next scene.
     * @param {string} sceneName Name of the scene to load.
     * @param {string} folder Folder of the scene to load.
     */
    function loadNextPart(sceneName, folder) {
        global.ui.fadeOutContent(function () {
            global.sceneEnd();
            global.sceneLoader.loadScene(sceneName, folder);
        });
    }

    /**
     * Adds a listener to the button.
     */
    function registerContinueListener() {
        $("#" + continueId).click(function () {
            $(this).addClass("selected");
            disableButtons();
            ctrl.continue();
            loadNextPart(ctrl.nextSceneName, ctrl.nextFolderName);
        });
    }

    // PUBLIC MEMBERS \\        this.public = "test";
    this.id = arguments.callee.name;

    // PUBLIC FUNCTIONS \\      this.publicFunction = function(){};

    /**
     * Builds and returns this part.
     * @param {boolean} invisible If passed and true, will give the entire section a display:none style.
     */
    this.build = function (invisible) {
        if (reqController && ((reqChoice && reqController.get() !== reqChoice) || (!reqChoice && !reqController.continued()))) {
            return "";
        }

        ctrl.bgm.stopLoop();
        global.ui.applyTheme("hamlet_day");
        var part = `<div id="${that.id}" ${invisible ? 'style="display:none;"' : ""}>`;
        part += buildContent();
        part += (changeController && changeController.change()) || "";
        part += buildChoice();
        if (!ctrl.nextSceneReady) {
            part += `<span class="todo">There is no content beyond this point.</span>`;
        }
        part += `</div>`;
        return part;
    };

    /**
     * Registers all the required button listeners for this part.
     */
    this.registerListeners = function () {
        if (reqController && ((reqChoice && reqController.get() !== reqChoice) || (!reqChoice && !reqController.continued()))) {
            return;
        }

        if (ctrl.continued()) {
            return;
        }

        if (ctrl.nextSceneReady) {
            registerContinueListener();
        }
    };
}

// END scenes\HamletDay2\UndergroundCave\fight\offence\fail\succeed\snap\UndergroundCaveSnapLeave.js

// scenes\HamletDay2\UndergroundCave\fight\offence\fail\succeed\snap\UndergroundCaveSnap.js

/**
 * Fight section of the Underground Cave.
 * @param {UndergroundCaveController} controller The Underground Cave controller.
 */
function UndergroundCaveSnap(controller) {
    // PRIVATE MEMBERS \\       var private = "test";
    var that = this;
    var ctrl = controller;

    var reqChoice = UndergroundCaveWrestlingWinChoice.SNAP;
    var reqController = ctrl.wrestleWin;
    var subController = ctrl.preContinue;
    var changeController = ctrl.snap;

    var continueId = arguments.callee.name + "ButtonOne";
    var next = new UndergroundCaveSnapLeave(ctrl);

    // PRIVATE FUNCTIONS \\     function privateFunction(){}

    /**
     * Builds and returns the content of this section.
     * @returns {string} The content.
     */
    function buildContent() {
        var toReturn = `[p]
                            While it is already beaten, you can [b]not[/b] allow the basilisk to live.
                            [b]It[/b] attacked [i]you[/i], not the other way around.
                            Unless you finish it off right here, and right now,
                            it'll continue to [b]terrorize[/b] whoever may wander into this cave.
                            It's a foul [b]beast[/b], and as an aspiring knight to be, it is your [b]duty[/b] to put an end to it.
                        [/p]
                        [p]
                            You don't stop squeezing down, denying the monster any fresh air at all.
                            With the last bit of breath remaining in its lungs, it manages to utter a whine, [b]begging[/b] you to spare its life.
                            But you can't do that.
                            It tried to [b]kill you[/b], and it failed to do the job.
                            If the tables were turned, it wouldn't show you mercy.
                            It'd [b]rip out your guts[/b] and eat them in front of you.
                        [/p]
                        [p]
                            Despite growing doubts inside of your mind, you continue to choke out the big lizard.
                            The creature is nearing its end.
                            You know it.
                            It knows it.
                            But still, it does not resist.
                            Like it realizes its time has come.
                            Like it understands that there is nothing left it can do to stop a kobold as determined as you are.
                            It's almost sad, in a way.
                        [/p]
                        [p]
                            The basilisk's body slowly grows limp underneath you.
                            Its big, enthralling eyes close.
                            Its head lifelessly slumps down to the ground.
                            It is over.
                        [/p]
                        [p]
                            [c]
                                [b]You have killed the basilisk.[/b]
                            [/c]
                        [/p]`;

        return global.parser.parse(toReturn);
    }

    /**
     * Builds and returns the choice button.
     */
    function buildNextChoice() {
        var disabled = subController.continued() ? "disabled" : "";
        var isSelected = subController.continued();
        var selected = isSelected ? "selected" : "";
        var button = `<button class="button inlinechoice ${selected}" id="${continueId}" ${disabled}>Continue</button>`;
        return button;
    }

    /**
     * Builds and returns the choice of this section.
     * @returns {string} The choice of this section.
     */
    function buildChoice() {
        var choice = `<div class="choicecontainer">`;
        choice += buildNextChoice();
        choice += `</div>`;
        return choice;
    }

    /**
     * Disables all three buttons.
     */
    function disableButtons() {
        var buttons = [$("#" + continueId)];
        buttons.forEach(function (button) {
            button.unbind();
            button.attr("disabled", true);
        });
    }

    /**
     * Loads and displays the next part.
     * @param {object} part Which part to load.
     */
    function loadNextPart(part) {
        var built = part.build(true);
        global.ui.appendBeforeFinisher(built, global.ui.genericHeaderId);
        $("#" + part.id).fadeIn(400);
        part.registerListeners();
    }

    /**
     * Adds a listener to the button.
     */
    function registerNextListener() {
        $("#" + continueId).click(function () {
            $(this).addClass("selected");
            disableButtons();
            subController.continue();
            loadNextPart(next);
        });
    }

    // PUBLIC MEMBERS \\        this.public = "test";
    this.id = arguments.callee.name;

    // PUBLIC FUNCTIONS \\      this.publicFunction = function(){};

    /**
     * Builds and returns this part.
     * @param {boolean} invisible If passed and true, will give the entire section a display:none style.
     */
    this.build = function (invisible) {
        if (reqController && ((reqChoice && reqController.get() !== reqChoice) || (!reqChoice && !reqController.continued()))) {
            return "";
        }

        var part = `<div id="${that.id}" ${invisible ? 'style="display:none;"' : ""}>`;
        part += buildContent();
        part += (changeController && changeController.change()) || "";
        part += buildChoice();
        part += `</div>`;
        part += next.build();
        return part;
    };

    /**
     * Registers all the required button listeners for this part.
     */
    this.registerListeners = function () {
        if (reqController && ((reqChoice && reqController.get() !== reqChoice) || (!reqChoice && !reqController.continued()))) {
            return;
        }

        next.registerListeners();

        if (subController.continued()) {
            return;
        }

        registerNextListener();
    };
}

// END scenes\HamletDay2\UndergroundCave\fight\offence\fail\succeed\snap\UndergroundCaveSnap.js

// scenes\HamletDay2\UndergroundCave\fight\offence\fail\succeed\UndergroundCaveWrestlingWin.js

/**
 * Fight section of the Underground Cave.
 * @param {UndergroundCaveController} controller The Underground Cave controller.
 */
function UndergroundCaveWrestlingWin(controller) {
    // PRIVATE MEMBERS \\       var private = "test";
    var that = this;
    var ctrl = controller;

    var reqChoice = false;
    var reqController = false;
    var subController = ctrl.wrestleWin;
    var changeController = ctrl.wrestleWin;

    var firstId = arguments.callee.name + "ButtonOne";
    var secondId = arguments.callee.name + "ButtonTwo";
    var thirdId = arguments.callee.name + "ButtonThree";

    var firstNext = new UndergroundCaveSnap(ctrl);
    var secondNext = new UndergroundCaveLetGo(ctrl);
    var thirdNext = new UndergroundCaveDominance(ctrl);

    var firstChoice = UndergroundCaveWrestlingWinChoice.SNAP;
    var secondChoice = UndergroundCaveWrestlingWinChoice.GO;
    var thirdChoice = UndergroundCaveWrestlingWinChoice.DOMINANCE;

    // PRIVATE FUNCTIONS \\     function privateFunction(){}

    /**
     * Builds and returns the content of this section.
     * @returns {string} The content.
     */
    function buildContent() {
        var toReturn = `[p]
                            The basilisk thinks it's tough.
                            And, admittedly, being made out of mostly stone, it most likely [b]is[/b].
                            Heck, it probably weighs several times more than you do.
                            But you have something it doesn't.
                            You have evolved [b]beyond[/b] being a [b]petty lizard[/b].
                            It might be able to swing its brute limbs around with unmatched ferocity,
                            but what you lack in strength, you make up for in wits.
                        [/p]
                        ${global.ui.condFail(`No weapon`)}
                        [p]
                            Your brain kicks into overdrive, a million thoughts flashing by in the blink of an eye.
                            Its hide is made out of rock.
                            You can't [b]hit it[/b], you'd just end up breaking your hand.
                            Your claws won't penetrate stone.
                            You don't have a weapon to use, and there aren't any loose rocks around.
                            You could try to lure it into the water, but that's a longshot at best.
                            Besides, it [i]might[/i] be able to swim.
                            That leaves only one option.
                            And it's [b]risky[/b].
                        [/p]
                        [p]
                            After a tense moment of inactivity, the monster suddenly [b]charges[/b] at you, bursting into a sprint.
                            It tries to bite you, but you deftly step to the side, avoiding its barreling frame.
                            The creature's powerful jaws snap shut, catching nothing but air.
                            You spot the perfect opportunity.
                            Here it goes.
                            All or nothing.
                        [/p]
                        [p]
                            You [b]leap[/b] on top of the crocodillian's back, instantly grabbing its throat in a choke-hold.
                            The bottom of the beast feels a lot [b]squishier[/b] than the top.
                            Perhaps its soft belly is its weak spot?
                        [/p]
                        [p]
                            You are in the [b]perfect[/b] position.
                            While on top of the basilisk, it can't hit you with its claws, it can't smack you with its tail, nor can it bite you.
                            Instead of outright accosting you, the monster begins to thrash about, wildly shaking its body in an attempt to throw you off.
                            You hold on for dear life, wrapping a second arm around the creature's neck, squeezing its windpipe shut while clinging to its back.
                        [/p]
                        [p]
                            Realizing you aren't going to let go like this, the basilisk switches tactics.
                            For a few moments, it seemingly calms down, its muscles tangibly [b]tensing[/b].
                            Right as thought it was on the verge of [b]surrendering[/b],
                            the beast [b]rolls[/b] onto its side, and then onto its back,
                            [b]crushing[/b] you beneath its heavy, stone frame.
                        [/p]
                        [p]
                            You [b]scream[/b] out in pain, but you do [b]not[/b] let go.
                            The torment lasts for all but a second, the basilisk continuing to roll around,
                            returning to its feet before tumbling to its back yet again,
                            [b]squishing[/b] you between its rocky hide and the stone cavern floor a second time.
                            No wonder they call this the [b]death roll[/b].
                        [/p]
                        ${global.ui.condSucc(`Strength and endurance greater than 6`)}
                        [p]
                            The massive monster rolls around three, no, [b]four[/b] times before grinding to a halt.
                            Despite everything, you've managed to stay on top of it, but only [b]barely[/b].
                            [b]Every[/b] part of your body [b]hurts[/b].
                            You can't handle any more.
                            You feel like if the monster rolls onto its back one more time, you'll [b]break[/b].
                        [/p]
                        [p]
                            You are breathing heavily.
                            It, too, [b]tries[/b] to catch some breath, but your forearm is still deftly blocking the creature's windpipe.
                            While it's done rolling, for now, it still does [b]not[/b] yield.
                            You [b]need[/b] to end this [b]now[/b].
                            If it gathers enough energy to start rolling again, you won't survive.
                        [/p]
                        [p]
                            Keeping one arm around the basilisk's neck,
                            you begin to wantonly [b]punch[/b] its underside with the other,
                            repeatedly bashing the feral from the bottom of its maw to its soft and vulnerable belly.
                            After about half a minute more of choking it while hitting it with your fist,
                            the beast finally slumps down to the ground, letting out a submissive whimper.
                        [/p]
                        [p]
                            [c]
                                [b]You have beaten the basilisk![/b]
                            [/c]
                        [/p]`;

        return global.parser.parse(toReturn);
    }

    /**
     * Builds and returns the choice button.
     */
    function buildFirstChoice() {
        var disabled = subController.has() ? "disabled" : "";
        var isSelected = subController.get() === firstChoice;
        var selected = isSelected ? "selected" : "";
        var button = `<button class="button inlinechoice ${selected}" id="${firstId}" ${disabled}>Kill it</button>`;

        var tooltip = global.parser.parse(`This has gone on for long enough. End the basilisk.`);
        var popupContainer = global.ui.makeToolTip(button, tooltip, false, false, "width: 190px;");
        // Re-wrap with proper positioning.
        button = `<div class="inlinechoice">`;
        button += popupContainer;
        button += `</div>`;

        return button;
    }

    /**
     * Builds and returns the choice button.
     */
    function buildSecondChoice() {
        var disabled = subController.has() ? "disabled" : "";
        var isSelected = subController.get() === secondChoice;
        var selected = isSelected ? "selected" : "";
        var button = `<button class="button inlinechoice ${selected}" id="${secondId}" ${disabled}>Let it go</button>`;

        var tooltip = global.parser.parse(`The fight's over. You won. There's no need to murder the creature.`);
        var popupContainer = global.ui.makeToolTip(button, tooltip, false, false, "width: 190px;");
        // Re-wrap with proper positioning.
        button = `<div class="inlinechoice">`;
        button += popupContainer;
        button += `</div>`;

        return button;
    }

    /**
     * Builds and returns the choice button.
     */
    function buildThirdChoice() {
        var disabled = subController.has() ? "disabled" : "";
        var isSelected = subController.get() === thirdChoice;
        var selected = isSelected ? "selected" : "";
        var button = `<button class="button inlinechoice ${selected}" id="${thirdId}" ${disabled} style="width:200px;">Assert dominance</button>`;

        var male = ctrl.misc.dick() ? "male" : "female";
        var tooltip = global.parser.parse(`The fight is over. You won. Time to assert yourself as the alpha ${male}.`);
        var popupContainer = global.ui.makeToolTip(button, tooltip, false, false, "width: 190px;");
        // Re-wrap with proper positioning.
        button = `<div class="inlinechoice" style="width:200px;">`;
        button += popupContainer;
        button += `</div>`;

        return button;
    }

    /**
     * Builds and returns the choice of this section.
     * @returns {string} The choice of this section.
     */
    function buildChoice() {
        var choice = `<div class="choicecontainer"><div class="inlinechoiceheader">You:</div>`;
        choice += buildFirstChoice();
        choice += `<hr class="inlinechoiceseparator">`;
        choice += buildSecondChoice();
        choice += `<hr class="inlinechoiceseparator">`;
        choice += buildThirdChoice();
        choice += `</div>`;
        return choice;
    }

    /**
     * Disables all three buttons.
     */
    function disableButtons() {
        var buttons = [$("#" + firstId), $("#" + secondId), $("#" + thirdId)];
        buttons.forEach(function (button) {
            button.unbind();
            button.attr("disabled", true);
        });
    }

    /**
     * Loads and displays the next part.
     * @param {object} part Which part to load.
     */
    function loadNextPart(part) {
        var built = part.build(true);
        global.ui.appendBeforeFinisher(built, global.ui.genericHeaderId);
        $("#" + part.id).fadeIn(400);
        part.registerListeners();
    }

    /**
     * Adds a listener to the button.
     */
    function registerFirstListener() {
        $("#" + firstId).click(function () {
            $(this).addClass("selected");
            disableButtons();
            subController.set(firstChoice);
            loadNextPart(firstNext);
        });
    }

    /**
     * Adds a listener to the button.
     */
    function registerSecondListener() {
        $("#" + secondId).click(function () {
            $(this).addClass("selected");
            disableButtons();
            subController.set(secondChoice);
            loadNextPart(secondNext);
        });
    }

    /**
     * Adds a listener to the button.
     */
    function registerThirdListener() {
        $("#" + thirdId).click(function () {
            $(this).addClass("selected");
            disableButtons();
            subController.set(thirdChoice);
            loadNextPart(thirdNext);
        });
    }

    // PUBLIC MEMBERS \\        this.public = "test";
    this.id = arguments.callee.name;

    // PUBLIC FUNCTIONS \\      this.publicFunction = function(){};

    /**
     * Builds and returns this part.
     * @param {boolean} invisible If passed and true, will give the entire section a display:none style.
     */
    this.build = function (invisible) {
        if (reqController && ((reqChoice && reqController.get() !== reqChoice) || (!reqChoice && !reqController.continued()))) {
            return "";
        }

        var part = `<div id="${that.id}" ${invisible ? 'style="display:none;"' : ""}>`;
        part += buildContent();
        part += (changeController && changeController.change()) || "";
        part += buildChoice();
        part += `</div>`;
        part += firstNext.build();
        part += secondNext.build();
        part += thirdNext.build();
        return part;
    };

    /**
     * Registers all the required button listeners for this part.
     */
    this.registerListeners = function () {
        if (reqController && ((reqChoice && reqController.get() !== reqChoice) || (!reqChoice && !reqController.continued()))) {
            return;
        }

        firstNext.registerListeners();
        secondNext.registerListeners();
        thirdNext.registerListeners();

        if (subController.has()) {
            return;
        }

        registerFirstListener();
        registerSecondListener();
        registerThirdListener();
    };
}

var UndergroundCaveWrestlingWinChoice = {
    SNAP: 1,
    GO: 2,
    DOMINANCE: 3
};

// END scenes\HamletDay2\UndergroundCave\fight\offence\fail\succeed\UndergroundCaveWrestlingWin.js

// scenes\HamletDay2\UndergroundCave\fight\offence\fail\fail\UndergroundCavePetrificationRape.js

/**
 * Fight section of the Underground Cave.
 * @param {UndergroundCaveController} controller The Underground Cave controller.
 */
function UndergroundCavePetrificationRape(controller) {
    // PRIVATE MEMBERS \\       var private = "test";
    var that = this;
    var ctrl = controller;

    var reqChoice = false;
    var reqController = false;

    var continueId = arguments.callee.name + "ButtonOne";

    var idsToRemove = [
        "UndergroundCavePetrificationRape",
        "UndergroundCaveWrestling",
        "UndergroundCaveOffence",
        "UndergroundCaveFight",
        "UndergroundCaveResistSucceed",
        "UndergroundCaveResist",
        "UndergroundCaveStare",
        "UndergroundCaveAvert",
        "UndergroundCaveSurface"
    ];

    // PRIVATE FUNCTIONS \\     function privateFunction(){}

    /**
     * Builds and returns the content of this section.
     * @returns {string} The content.
     */
    function buildContent() {
        var pants = ctrl.misc.pants();
        var undies = ctrl.misc.underwear();
        var dick = ctrl.misc.dick();
        var vaginalVirgin = ctrl.misc.cuntVirgin();
        var slitVirgin = ctrl.misc.cockslitVirgin();
        var virgin = (dick && slitVirgin) || (!dick && vaginalVirgin);
        var toReturn = `[p]
                            The basilisk thinks it's tough.
                            And, admittedly, being made out of mostly stone, it most likely [b]is[/b].
                            Heck, it probably weighs several times more than you do.
                            But you have something it doesn't.
                            You have evolved [b]beyond[/b] being a [b]petty lizard[/b].
                            It might be able to swing its brute limbs around with unmatched ferocity,
                            but what you lack in strength, you make up for in wits.
                        [/p]
                        ${global.ui.condFail(`No weapon`)}
                        [p]
                            Your brain kicks into overdrive, a million thoughts flashing by in the blink of an eye.
                            Its hide is made out of rock.
                            You can't [b]hit it[/b], you'd end up breaking your hand.
                            Your claws won't penetrate stone.
                            You don't have a weapon to use, and there aren't any loose rocks around.
                            You could try to lure it into the water, but that's a longshot at best.
                            Besides, it [i]might[/i] be able to swim.
                            That leaves only one option.
                            And it's [b]risky[/b].
                        [/p]
                        [p]
                            After a tense moment of inactivity, the monster suddenly [b]charges[/b] at you, bursting into a sprint.
                            It tries to bite you, but you deftly step to the side, avoiding its barreling frame.
                            The creature's powerful jaws snap shut, catching nothing but air.
                            You spot the perfect opportunity.
                            Here it goes.
                            All or nothing.
                        [/p]
                        [p]
                            You [b]leap[/b] on top of the crocodillian's back, instantly grabbing its throat in a choke-hold.
                            The bottom of the beast feels a lot [b]squishier[/b] than the top.
                            Perhaps its soft belly is its weak spot?
                        [/p]
                        [p]
                            You are in the [b]perfect[/b] position.
                            While on top of the basilisk, it can't hit you with its claws, it can't smack you with its tail, nor can it bite you.
                            Instead of outright accosting you, the monster begins to thrash about, wildly shaking its body in an attempt to throw you off.
                            You hold on for dear life, wrapping a second arm around the creature's neck, squeezing its windpipe shut while clinging to its back.
                        [/p]
                        [p]
                            Realizing you aren't going to let go like this, the basilisk switches tactics.
                            For a few moments, it seemingly calms down, its muscles tangibly [b]tensing[/b].
                            Right as thought it was on the verge of [b]surrendering[/b],
                            the beast [b]rolls[/b] onto its side, and then onto its back,
                            [b]crushing[/b] you beneath its heavy, stone frame.
                        [/p]
                        [p]
                            You [b]scream[/b] out in pain, but you do [b]not[/b] let go.
                            The torment lasts for all but a second, the basilisk continuing to roll around,
                            returning to its feet before tumbling to its back yet again,
                            [b]squishing[/b] you between its rocky hide and the stone cavern floor a second time.
                            No wonder they call this the [b]death roll[/b].
                        [/p]
                        ${global.ui.condFail(ctrl.misc.strength() < 6 ? `Strength below 6` : `Endurance below 6`)}
                        [p]
                            You can't hold on.
                            Not much longer.
                            Your entire body [b]hurts[/b].
                            Your arms are growing weak.
                            ${pants ? `Your ${global.kobold.inventory.createItemWithTooltip(pants)} 
                            ${undies ? `and ${global.kobold.inventory.createItemWithTooltip(undies)}` : ``} have been torn to shreds in the struggle.` : `
                            ${undies ? `Your ${global.kobold.inventory.createItemWithTooltip(undies)} have been torn to shreds in the struggle.` : ``}`}
                            You feel like if the monster rolls onto its back one more time, you'll [b]break[/b].
                        [/p]
                        [p]
                            And it does just that.
                            For a third time, the basilisk crushes you beneath its stony back and the cavern floor.
                            Your weary limbs can no longer hold on.
                            Your arms unwrap from its throat.
                            The crocodillian has successfully thrown you off of its back.
                            you lay limply on the ground, completely dazed, no longer in any condition to fight,
                            while the beast rolls off of you, and gets back on its feet. 
                        [/p]
                        [p]
                            The creature crawls on top of you, pinning you to the ground by placing its front paws atop your shoulders,
                            resting its immense weight atop your fragile frame.
                            Its razor-sharp claws mere inches away from your throat, you don't [b]dare[/b] to struggle.
                            For the first time, you get a good look at the feral's underside, and what you see inspires [b]dread[/b].
                            The lizard is visibly aroused, its girthy, ridged and draconic-looking member hanging fully erect below its soft underbelly.
                            It must be in rut or something.
                            [i]Oh no.[/i]
                        [/p]
                        [p]
                            ${pants || undies ? `Having lost your below-waist clothing during the intense struggle, nothing` : `Nothing`}
                            stands in between the monstrosity's throbbing length, and your tender${virgin ? `, virginal` : ``} ${dick ? `cockslit` : `slit`}.
                            Before you even have the [b]chance[/b] to protest, it [b]rams[/b] itself forwards, the tapered tip of its member instantly finding its mark,
                            agonizingly ${dick ? `penetrating a hole that was never meant to be fucked` : `spreading your folds`},
                            [b]forcing[/b] over half of its ridged member inside of your body in a single thrust,
                            stretching you well beyond what your body was made to take.
                        [/p]
                        [p]
                            You cry out in pain, meekly kicking your legs to no avail.
                            The basilisk wastes no time, immediately starting to hump away at a rapid pace,
                            pounding you in an animalistic fashion, its girthy cock practically [b]tearing[/b] you apart.
                            It isn't long until the beast manages to bottom out.
                            ${dick ? `The tip of its member prods against your own flaccid length, threatening to [b]crush[/b] it with every wild thrust.` : `
                            The tip of its member prods against your cervix, threatening to force itself even deeper with every wild thrust.`}
                        [/p]
                        [p]
                            Distressed, and in immense pain, you try to find something, [b]anything[/b] to take your mind off of what is happening,
                            to be able to [b]escape[/b] reality.
                            After frantically looking around for [b]any[/b] way out of the basilisk's mating grip,
                            your sight falls upon its enchanting green eyes once more.
                            They captivate your aching mind, ensnaring every fiber of your being.
                            The feral returns your stare, gazing deep into your very [b]soul[/b].
                        [/p]
                        [p]
                            Within seconds, you can feel your limbs swiftly turning to stone.
                            The transformation is far more than scale-deep, your very flesh itself hardening, even your [b]bones[/b] petrifying.
                            Snapping back to reality, you try to [b]scream[/b] for help,
                            but find your muzzle having turned rock solid, frozen in place, unable to open.
                            Your arms.
                            Your legs.
                            Your tail.
                            You can't move any of them.
                        [/p]
                        [p]
                            The petrification creeps from your extremities onto your torso, like a [b]blight[/b] crawling over your scales.
                            You can feel it overtake your groin, slowly turning inch after inch of your slit into stone, and not just externally.
                            The coarseness of the hard surface surrounding its member doesn't seem to bother the lizard one bit.
                            It continues to wildly thrust its lower body, pistoning its member in and out of your petrified ${dick ? `cockslit` : `cunt`},
                            copious amounts of its own precum slickening the otherwise extremely [b]rough[/b] fuck.
                        [/p]
                        [p]
                            The contour of your entire body has turned to rock.
                            You can sense your innards, your vital organs themselves, slowly starting to change.
                            Retaining the slightest bit of sensibility in your loins, you can feel the big beast's end rapidly approaching,
                            its member pulsing and twitching inside of your stone slit.
                            The last thing you experience before your very heart itself is petrified,
                            is a first squirt of thick, potent basilisk cum splattering against your ${dick ? `flaccid member` : `cervix`},
                            one final indignation before your conscience fades.
                        [/p]
                        [hl]
                        [p]
                            Months pass.
                            Years, maybe even?
                            Decades?
                            The cave remains undisturbed, its brand new kobold statue preserved throughout the ages, permanent crotch-gape and all.
                            A warning sign to all intruders.
                            A testament to the basilisk's might.
                            But while [i]well[/i]-hidden, nothing can remain unexplored forever.
                            Especially not something this close to Varanar.
                            On a day that was bound to come,
                            a trio of particularly rowdy fellows from the nearby hamlet stumbles upon the cavern while poaching near the forest's edge.
                        [/p]
                        [p]
                            "[color=green]Hey, look![/color]" a deep, masculine voice reverberates across the cavern.
                            "[color=green]A statue of a kobold! Looks pretty lifelike.[/color]"
                            The human's two companions, only now catching up to him, stare at the promiscuous sculpture.
                            "[color=red]That's not a statue, you dumbass.[/color]" the least naive of the three speaks.
                            "[color=red]It's [b]obviously[/b] a [b]urinal[/b].[/color]"
                        [/p]
                        [p]
                            The third member of the party steps forward, leaning down and audibly [b]sniffing[/b] the air around the effigy.
                            "[color=blue]It [b]smells[/b] like a urinal alright. When's the last time this thing was [b]cleaned[/b]?! Ten years ago?[/color]"
                            The group bursts out into a short fit of laughter.
                            When the hilarity dies down, an interest proposition is made:
                            "[color=green]Five coins says you won't pee in it.[/color]"
                            "[color=red]You're on![/color]"
                        [/p]
                        [p]
                            The challenged human takes position in between the statue's spread legs.
                            Lowering his trousers, he deftly begins to take a leak into the petrified kobold's gaping ${dick ? `cockslit` : `cunt`},
                            his urine washing out the absolutely [b]revolting[/b] goop formed by basilisk spunk fermenting for more than a [b]decade[/b].
                            The disgusting sludge is replaced by fresh, warm, dark-yellow human piss,
                            the far less viscous liquid filling the statue's hole up to the [b]brim[/b] and then some,
                            like a [b]goblet[/b] overflowing with foul ale.
                        [/p]
                        [p]
                            The unwanted intrusion and the marking of territory did not go unnoticed.
                            From various dark holes in the walls, not one but [b]three[/b] sets of deep-green eyes stare at the invaders.
                            The family had grown since the last time they had a visitor.
                            The young one was getting hungry.
                            Dinner was served, and not a month too soon.
                        [/p]
                        [p]
                            [c]
                                [b]
                                    Art end.
                                [/b]
                            [/c]
                        [/p]`;

        return global.parser.parse(toReturn);
    }

    /**
     * Builds and returns the continue button.
     */
    function buildChoice() {
        var choice = `<div class="choicecontainer">`;
        choice += `<button class="button bigbutton continuebutton" style="margin-left: auto; position: relative; float: right;" id="${continueId}">`;
        choice += `&lt;&lt Revert`;
        choice += `</button>`;
        choice += `</div>`;
        return choice;
    }

    /**
     * Disables all three buttons.
     */
    function disableButtons() {
        var buttons = [$("#" + continueId)];
        buttons.forEach(function (button) {
            button.unbind();
            button.attr("disabled", true);
        });
    }

    /**
     * Loads and displays the next part.
     * @param {object} part Which part to load.
     */
    function loadNextPart(part) {
        var built = part.build(true);
        global.ui.appendBeforeFinisher(built, global.ui.genericHeaderId);
        $("#" + part.id).fadeIn(400, function () {
            var main = $("#main");
            main.scrollTop(main[0].scrollHeight - main.height() - 5); // Fix scrolling
        });
        part.registerListeners();
    }

    /**
     * Adds a listener to the button.
     */
    function registerContinueListener() {
        $("#" + continueId).click(function () {
            $(this).addClass("selected");
            disableButtons();
            ctrl.misc.unsetAll();
            ctrl.fight.unset();
            ctrl.resistSucceed.undo();
            ctrl.resistSucceed.unset();
            ctrl.stare.undo();
            ctrl.stare.unset();
            ctrl.avert.undo();
            ctrl.avert.unset();
            ctrl.surface.undo();
            ctrl.surface.unset();
            for (var i = 0; i < idsToRemove.length; i++) {
                $("#" + idsToRemove[i]).remove();
            }
            loadNextPart(ctrl.fragments.surface);
        });
    }

    // PUBLIC MEMBERS \\        this.public = "test";
    this.id = arguments.callee.name;

    // PUBLIC FUNCTIONS \\      this.publicFunction = function(){};

    /**
     * Builds and returns this part.
     * @param {boolean} invisible If passed and true, will give the entire section a display:none style.
     */
    this.build = function (invisible) {
        if (reqController && ((reqChoice && reqController.get() !== reqChoice) || (!reqChoice && !reqController.continued()))) {
            return "";
        }

        var part = `<div id="${that.id}" ${invisible ? 'style="display:none;"' : ""}>`;
        part += buildContent();
        part += buildChoice();
        part += `</div>`;
        return part;
    };

    /**
     * Registers all the required button listeners for this part.
     */
    this.registerListeners = function () {
        if (reqController && ((reqChoice && reqController.get() !== reqChoice) || (!reqChoice && !reqController.continued()))) {
            return;
        }

        registerContinueListener();
    };
}

// END scenes\HamletDay2\UndergroundCave\fight\offence\fail\fail\UndergroundCavePetrificationRape.js

// scenes\HamletDay2\UndergroundCave\fight\offence\fail\UndergroundCaveWrestling.js

/**
 * Fight section of the Underground Cave.
 * @param {UndergroundCaveController} controller The Underground Cave controller.
 */
function UndergroundCaveWrestling(controller) {
    // PRIVATE MEMBERS \\       var private = "test";
    var that = this;
    var ctrl = controller;

    var reqChoice = false;
    var reqController = false;

    var toFail = new UndergroundCavePetrificationRape(ctrl);
    var toSuccess = new UndergroundCaveWrestlingWin(ctrl);

    // PRIVATE FUNCTIONS \\     function privateFunction(){}

    /**
     * Checks whether the choice succeeded or failed.
     */
    function successCheck() {
        return ctrl.misc.strength() >= 6 && ctrl.misc.endurance() >= 6;
    }

    // PUBLIC MEMBERS \\        this.public = "test";
    this.id = arguments.callee.name;

    // PUBLIC FUNCTIONS \\      this.publicFunction = function(){};

    /**
     * Builds and returns this part.
     * @param {boolean} invisible If passed and true, will give the entire section a display:none style.
     */
    this.build = function (invisible) {
        if (reqController && ((reqChoice && reqController.get() !== reqChoice) || (!reqChoice && !reqController.continued()))) {
            return "";
        }

        var part = `<div id="${that.id}" ${invisible ? 'style="display:none;"' : ""}>`;
        if (successCheck()) {
            part += toSuccess.build();
        } else {
            part += toFail.build();
        }
        part += `</div>`;
        return part;
    };

    /**
     * Registers all the required button listeners for this part.
     */
    this.registerListeners = function () {
        if (reqController && ((reqChoice && reqController.get() !== reqChoice) || (!reqChoice && !reqController.continued()))) {
            return;
        }

        if (successCheck()) {
            toSuccess.registerListeners();
        } else {
            toFail.registerListeners();
        }
    };
}

// END scenes\HamletDay2\UndergroundCave\fight\offence\fail\UndergroundCaveWrestling.js

// scenes\HamletDay2\UndergroundCave\fight\offence\succeed\UndergroundCaveOffenceLoot.js

/**
 * Fight section of the Underground Cave.
 * @param {UndergroundCaveController} controller The Underground Cave controller.
 */
function UndergroundCaveOffenceLoot(controller) {
    // PRIVATE MEMBERS \\       var private = "test";
    var that = this;
    var ctrl = controller;

    var reqChoice = false;
    var reqController = ctrl.preContinue;
    var changeController = ctrl.offenceLoot;

    var continueId = arguments.callee.name + "ButtonOne";

    // PRIVATE FUNCTIONS \\     function privateFunction(){}

    /**
     * Builds and returns the content of this section.
     * @returns {string} The content.
     */
    function buildContent() {
        var weapon = ctrl.misc.weapon();
        var toReturn = `[p]
                            You did it.
                            You won.
                            You killed the monster.
                            Just like a knight would do!
                            Somehow, you don't feel very [i]knightly[/i], though.
                            You should be proud of yourself, but for some reason, you aren't.
                            Maybe your actions weren't as [i]chivalrous[/i] as you would have liked,
                            but it's the outcome that matters, and not how you achieved it, right?
                            The ends justify the means.
                        [/p]
                        [p]
                            But then again, the basilisk was just a simple beast minding its own business.
                            You were intruding on its territory, and not the other way around.
                            You could have probably left and it wouldn't have harmed you at all.
                            Now you're confused.
                            Did you do the right thing?
                        [/p]
                        [p]
                            You honestly don't know anymore.
                            Does it even matter?
                            What's done is done.
                            If you hadn't killed the creature, some pompous knight in shining armor
                            -- with nothing left to prove, neither to himself, nor to the world --
                            would have strolled into this cave to add another tally to his already impressive list of slain monsters.
                            For someone properly armed and armored, this would have been a [b]chore[/b], a menial task barely even worthy of mention.
                            But for you, this is a feat you'll remember until the day you die.
                        [/p]
                        [p]
                            Your conviction bolstered, you wipe the blood off your ${global.kobold.inventory.createItemWithTooltip(weapon)}.
                            You kneel besides the lizard.
                            You figure it'd be best to take a trophy.
                            Something to remember this day by.
                            Something you can show to people, so they'll believe you when you tell them you singlehandedly killed a basilisk.
                            But what?
                        [/p]
                        [p]
                            While pondering, you run one of your hands over the deceased basilisk's back.
                            Some of its scales seem to be rather [i]loose[/i].
                            You take hold of one with both of your hands, and with surprising ease, you manage to [b]tear[/b] the scale from the monster's backside.
                            Like plucking a chicken.
                            You repeat the process a couple of times,
                            until you have collected a suitable handful of ${global.kobold.inventory.createItemWithTooltip(new BasiliskScales())}
                            to take with as your prize for ridding the world of this horrible monstrosity.
                        [/p]
                        [p]
                            Your trophies collected, you decide it's time to find a way out of the cave.
                            Following the river-branch should lead you to some kind of exit.
                            Without the threat of the basilisk around, you don't even need to [b]swim[/b].
                            You leisurely stroll alongside the water, until daylight comes into sight.
                            As you expected: the water was a stale branch of the river!
                            Climbing out of the cave, you sit your butt down on the riverside dirt, and take a breather.
                            You feel like you've earned one.
                        [/p]
                        [p]
                            You've defied death more than once today.
                            You should consider yourself lucky to be alive.
                            The trip into the well was a harrowing experience.
                            You nearly got crushed, almost drowned, and after all of that, you managed to kill a basilisk.
                            It might not have been the most [i]honorable[/i] way of slaying the beast, but it was slain nonetheless.
                        [/p]
                        [p]
                            Besides the ${global.kobold.inventory.createItemWithTooltip(new BasiliskScales())} you [i]harvested[/i],
                            you've gained a few awesome stories to tell once you've grown old and wise.
                            Stories like the ones Seki used to tell you when you were little.
                            You went through all that trouble to get your mind off of him, and here you are reminiscing once more.
                            You just can't help yourself from clinging to times long gone.
                            Things were so much simpler back then.
                            You miss those days.
                        [/p]
                        [p]
                            The sun is slowly starting to set.
                            You drag yourself to your feet.
                            It's time to go.
                            Varanar isn't [i]that[/i] far off.
                            If your legs don't give out from underneath you, you might still make it there before nightfall.
                        [/p]`;

        return global.parser.parse(toReturn);
    }

    /**
     * Builds and returns the continue button.
     */
    function buildChoice() {
        var disabled = ctrl.continued();
        var choice = `<div class="choicecontainer">`;
        choice += `<button class="button bigbutton continuebutton" id="${continueId}" ${disabled ? "disabled" : ""}>`;
        choice += `Continue &gt;&gt`;
        choice += `</button>`;
        choice += `</div>`;
        return choice;
    }

    /**
     * Disables all three buttons.
     */
    function disableButtons() {
        var buttons = [$("#" + continueId)];
        buttons.forEach(function (button) {
            button.unbind();
            button.attr("disabled", true);
        });
    }

    /**
     * Loads and displays the next scene.
     * @param {string} sceneName Name of the scene to load.
     * @param {string} folder Folder of the scene to load.
     */
    function loadNextPart(sceneName, folder) {
        global.ui.fadeOutContent(function () {
            global.sceneEnd();
            global.sceneLoader.loadScene(sceneName, folder);
        });
    }

    /**
     * Adds a listener to the button.
     */
    function registerContinueListener() {
        $("#" + continueId).click(function () {
            $(this).addClass("selected");
            disableButtons();
            ctrl.continue();
            loadNextPart(ctrl.nextSceneName, ctrl.nextFolderName);
        });
    }

    // PUBLIC MEMBERS \\        this.public = "test";
    this.id = arguments.callee.name;

    // PUBLIC FUNCTIONS \\      this.publicFunction = function(){};

    /**
     * Builds and returns this part.
     * @param {boolean} invisible If passed and true, will give the entire section a display:none style.
     */
    this.build = function (invisible) {
        if (reqController && ((reqChoice && reqController.get() !== reqChoice) || (!reqChoice && !reqController.continued()))) {
            return "";
        }

        ctrl.bgm.stopLoop();
        global.ui.applyTheme("hamlet_day");
        var part = `<div id="${that.id}" ${invisible ? 'style="display:none;"' : ""}>`;
        part += buildContent();
        part += (changeController && changeController.change()) || "";
        part += buildChoice();
        if (!ctrl.nextSceneReady) {
            part += `<span class="todo">There is no content beyond this point.</span>`;
        }
        part += `</div>`;
        return part;
    };

    /**
     * Registers all the required button listeners for this part.
     */
    this.registerListeners = function () {
        if (reqController && ((reqChoice && reqController.get() !== reqChoice) || (!reqChoice && !reqController.continued()))) {
            return;
        }

        if (ctrl.continued()) {
            return;
        }

        if (ctrl.nextSceneReady) {
            registerContinueListener();
        }
    };
}

// END scenes\HamletDay2\UndergroundCave\fight\offence\succeed\UndergroundCaveOffenceLoot.js

// scenes\HamletDay2\UndergroundCave\fight\offence\succeed\UndergroundCaveOffenceWin.js

/**
 * Fight section of the Underground Cave.
 * @param {UndergroundCaveController} controller The Underground Cave controller.
 */
function UndergroundCaveOffenceWin(controller) {
    // PRIVATE MEMBERS \\       var private = "test";
    var that = this;
    var ctrl = controller;

    var reqChoice = false;
    var reqController = false;
    var subController = ctrl.preContinue;
    var changeController = ctrl.offenceWin;

    var continueId = arguments.callee.name + "ButtonOne";
    var next = new UndergroundCaveOffenceLoot(ctrl);

    // PRIVATE FUNCTIONS \\     function privateFunction(){}

    /**
     * Builds and returns the content of this section.
     * @returns {string} The content.
     */
    function buildContent() {
        global.kobold.history.shared.well.basiliskKilled = true;
        var weapon = ctrl.misc.weapon();
        var blunt = weapon.blunt();
        var stab = weapon.stab();
        var slash = weapon.slash();
        var toReturn = `[p]
                            The basilisk thinks it's tough.
                            And, admittedly, being made out of mostly stone, it most likely [b]is[/b].
                            Heck, it probably weighs several times more than you do.
                            But you have something it doesn't.
                            You have evolved [b]beyond[/b] being a [b]petty lizard[/b].
                            You have [b]thumbs[/b] and [b]hands[/b] instead of [b]paws[/b] and forelegs.
                            Unlike the monster, you can manipulate tools, do cartwheels, and most importantly: you can wield weapons.
                        [/p]
                        [p]
                            You brandish your ${global.kobold.inventory.createItemWithTooltip(weapon)}, the beast seemingly [b]hesitating[/b], but not exactly [i]backing down[/i] upon seeing it.
                            While its claws may be sharper than yours, and its body might be better protected,
                            you still feel like [b]you[/b] have the upper hand in this engagement.
                            Whether or not your self-confidence is well-placed, you will soon find out.
                        [/p]
                        [p]
                            The crocodillian suddenly bursts into a sprint, barreling towards you with its maw wide open, clearly intent on [b]biting you[/b].
                            You dodge to the side.
                            It follows up with a swipe that you only [b]barely[/b] manage to avoid.
                            Another attempted bite, but this time, the creature makes a critical mistake!
                            It leaves its head wide open to a counterattack, its muzzle scraping past your leg, missing your tender scales by less than an inch!
                        [/p]
                        [p]
                            Seeing an opportunity, you decide to capitalize on it.
                            You thrust your ${global.kobold.inventory.createItemWithTooltip(weapon)} downwards,
                            ${stab ? `plunging` : `swinging`} it towards the basilisk's head.
                            Through some kind of [b]miracle[/b], your weapon ends up directly
                            ${blunt ? `impacting against` : `${slash ? `slashing through` : `piercing through`}`}
                            one of the monster's large eyeballs,
                            the delicate organ audibly [b]popping[/b] with a loud, wet [b]squish[/b].
                            Critical hit!
                            You quickly retract your weapon, and take a small step back.
                        [/p]
                        ${global.ui.condSucc(global.kobold.inventory.createItemWithTooltip(weapon, true))}
                        [p]
                            The lizard recoils, clearly in extreme [b]pain[/b], blood [b]gushing[/b] from its eyesocket, along with [i]eye goop[/i].
                            It [b]screeches[/b] out a mixture between a threatening hiss, a pathetic whine and a call for help.
                            But no help comes.
                            This is between it and you.
                            And you've just tasted [b]blood[/b] in the water.
                        [/p]
                        [p]
                            Growing desperate, the wounded feral lashes out once more.
                            Now without depth perception, it poses little threat to you.
                            It snaps its jaws long before its muzzle has reached your legs, it swipes at nothing but [b]air[/b],
                            and you can feel it growing weaker with every passing second, its already sluggish movement slowing down to a crawl.
                        [/p]
                        [p]
                            At this point, finishing the beast off would be a [b]mercy killing[/b].
                            It can barely even stands on its legs anymore, overtaken by sheer agony.
                            As you approach, it tries to meekly swipe at you, but instead falls down flat on its face, in a small puddle of its own blood.
                            It hisses softly, pretending to act menacingly, but you both know it's at the end of its rope.
                        [/p]
                        [p]
                            You ready your ${global.kobold.inventory.createItemWithTooltip(weapon)} directly above the monster's head.
                            It whines, [b]begging[/b] you to spare its life.
                            But you can't do that.
                            It attacked you.
                            It tried to [b]kill you[/b].
                            If you let it live, someone else might fall prey to it.
                            It's a foul [b]beast[/b], and as an aspiring knight-to-be, it is your duty to rid the world of it.
                            Besides, it wouldn't survive out here with just one eye.
                            You're not taking its life, you're putting it out of its misery.
                        [/p]
                        [p]
                            Despite growing doubts inside of your mind, you decide to go through with your actions.
                            You face your head the other way, and in one fluid stroke, you
                            ${blunt ? `bash the creature's head in, its skull fracturing open with a gut-wrenching [b]crack[/b]` : `${slash ? `
                            slash the back of the creature's neck, severing its spine` : `sink your weapon directly into the creature's brain`}`}.
                            Its whining slowly dies down.
                            Its one remaining eye closes.
                            Its ragged breathing stops.
                            The basilisk is dead.
                        [/p]
                        [p]
                            [c]
                                [b]You have killed the basilisk![/b]
                            [/c]
                        [/p]`;

        return global.parser.parse(toReturn);
    }

    /**
     * Builds and returns the choice button.
     */
    function buildNextChoice() {
        var disabled = subController.continued() ? "disabled" : "";
        var isSelected = subController.continued();
        var selected = isSelected ? "selected" : "";
        var button = `<button class="button inlinechoice ${selected}" id="${continueId}" ${disabled}>Continue</button>`;
        return button;
    }

    /**
     * Builds and returns the choice of this section.
     * @returns {string} The choice of this section.
     */
    function buildChoice() {
        var choice = `<div class="choicecontainer">`;
        choice += buildNextChoice();
        choice += `</div>`;
        return choice;
    }

    /**
     * Disables all three buttons.
     */
    function disableButtons() {
        var buttons = [$("#" + continueId)];
        buttons.forEach(function (button) {
            button.unbind();
            button.attr("disabled", true);
        });
    }

    /**
     * Loads and displays the next part.
     * @param {object} part Which part to load.
     */
    function loadNextPart(part) {
        var built = part.build(true);
        global.ui.appendBeforeFinisher(built, global.ui.genericHeaderId);
        $("#" + part.id).fadeIn(400);
        part.registerListeners();
    }

    /**
     * Adds a listener to the button.
     */
    function registerNextListener() {
        $("#" + continueId).click(function () {
            $(this).addClass("selected");
            disableButtons();
            subController.continue();
            loadNextPart(next);
        });
    }

    // PUBLIC MEMBERS \\        this.public = "test";
    this.id = arguments.callee.name;

    // PUBLIC FUNCTIONS \\      this.publicFunction = function(){};

    /**
     * Builds and returns this part.
     * @param {boolean} invisible If passed and true, will give the entire section a display:none style.
     */
    this.build = function (invisible) {
        if (reqController && ((reqChoice && reqController.get() !== reqChoice) || (!reqChoice && !reqController.continued()))) {
            return "";
        }

        var part = `<div id="${that.id}" ${invisible ? 'style="display:none;"' : ""}>`;
        part += buildContent();
        part += (changeController && changeController.change()) || "";
        part += buildChoice();
        part += `</div>`;
        part += next.build();
        return part;
    };

    /**
     * Registers all the required button listeners for this part.
     */
    this.registerListeners = function () {
        if (reqController && ((reqChoice && reqController.get() !== reqChoice) || (!reqChoice && !reqController.continued()))) {
            return;
        }

        next.registerListeners();

        if (subController.continued()) {
            return;
        }

        registerNextListener();
    };
}

// END scenes\HamletDay2\UndergroundCave\fight\offence\succeed\UndergroundCaveOffenceWin.js

// scenes\HamletDay2\UndergroundCave\fight\offence\UndergroundCaveOffence.js

/**
 * Fight section of the Underground Cave.
 * @param {UndergroundCaveController} controller The Underground Cave controller.
 */
function UndergroundCaveOffence(controller) {
    // PRIVATE MEMBERS \\       var private = "test";
    var that = this;
    var ctrl = controller;

    var reqChoice = UndergroundCaveFightChoice.OFFENCE;
    var reqController = ctrl.fight;

    var toFail = new UndergroundCaveWrestling(ctrl);
    var toSuccess = new UndergroundCaveOffenceWin(ctrl);

    // PRIVATE FUNCTIONS \\     function privateFunction(){}

    /**
     * Checks whether the choice succeeded or failed.
     */
    function successCheck() {
        return ctrl.misc.weapon();
    }

    // PUBLIC MEMBERS \\        this.public = "test";
    this.id = arguments.callee.name;

    // PUBLIC FUNCTIONS \\      this.publicFunction = function(){};

    /**
     * Builds and returns this part.
     * @param {boolean} invisible If passed and true, will give the entire section a display:none style.
     */
    this.build = function (invisible) {
        if (reqController && ((reqChoice && reqController.get() !== reqChoice) || (!reqChoice && !reqController.continued()))) {
            return "";
        }

        var part = `<div id="${that.id}" ${invisible ? 'style="display:none;"' : ""}>`;
        if (successCheck()) {
            part += toSuccess.build();
        } else {
            part += toFail.build();
        }
        part += `</div>`;
        return part;
    };

    /**
     * Registers all the required button listeners for this part.
     */
    this.registerListeners = function () {
        if (reqController && ((reqChoice && reqController.get() !== reqChoice) || (!reqChoice && !reqController.continued()))) {
            return;
        }

        if (successCheck()) {
            toSuccess.registerListeners();
        } else {
            toFail.registerListeners();
        }
    };
}

// END scenes\HamletDay2\UndergroundCave\fight\offence\UndergroundCaveOffence.js

// scenes\HamletDay2\UndergroundCave\fight\defence\eyepatch\UndergroundCaveDefenceLeave.js

/**
 * Fight section of the Underground Cave.
 * @param {UndergroundCaveController} controller The Underground Cave controller.
 */
function UndergroundCaveDefenceLeave(controller) {
    // PRIVATE MEMBERS \\       var private = "test";
    var that = this;
    var ctrl = controller;

    var reqChoice = false;
    var reqController = ctrl.preContinue;
    var changeController = ctrl.defenceLeave;

    var continueId = arguments.callee.name + "ButtonOne";

    // PRIVATE FUNCTIONS \\     function privateFunction(){}

    /**
     * Builds and returns the content of this section.
     * @returns {string} The content.
     */
    function buildContent() {
        var name = ctrl.misc.name();
        var toReturn = `[p]
                            With the basilisk no longer around, you take a closer look at your aching hand.
                            One of your fingers is all kinds of [b]fucked up[/b].
                            While you don't think it [b]broke[/b], it's definitely [b]dislocated[/b].
                            You've had this happen once before, a few years back when you fell out of a tree.
                            There's only one way to fix this, and it isn't pretty.
                        [/p]
                        [p]
                            Dreading what is to come, you gingerly take hold of the awkwardly-angled digit.
                            It hurts just to [b]touch[/b] it.
                            Come on, ${name}, you have to be [b]brave[/b].
                            You need to fix this [b]right now[/b], or it'll only get worse.
                            You close your eyes.
                            You grit your teeth.
                            You can do this.
                            Just think about something else.
                        [/p]
                        [p]
                            [big]
                                [color=red][b]SNAP[/b][/color]
                            [/big]
                        [/p]
                        [p]
                            With one firm yank, you [b]tug[/b] your dislocated finger back into place,
                            your bones agonizingly [b]grinding[/b] against one another before coming to rest in their normal position.
                            You [b]scream[/b] out in pain, your shriek echoing throughout the cavern as you collapse to your knees.
                            Tears drip down onto the stone floor below.
                            It hurt [b]so[/b] much.
                            You are hyperventilating.
                            The sickening snapping sound it made is [b]burned[/b] into your mind.
                            You feel like you're about to throw up.
                        [/p]
                        [p]
                            Holding your fixed hand by the wrist, you inspect it anew through your teary vision.
                            Your finger seems to be in its correct position once more.
                            You can painfully move it, but you'd prefer to keep it still right now.
                            You swallow deeply.
                            Your breathing stabilizes.
                            The worst of the pain is over.
                        [/p]
                        [p]
                            You slowly rise to your feet.
                            While still hurting, you need to get out of here, before the monster comes back for a second round.
                            You start walking alongside the water, hoping it'll lead you to an exit.
                            You go as fast as you can without falling down, the terrain uneven and cluttered with various stalagmites and rocks.
                            Ever so often, you stop to test your finger, but never for more than a couple of seconds.
                        [/p]
                        [p]
                            Before long, daylight comes into view.
                            As you expected: it was a stale branch of the river.
                            Climbing out of the cave, you sit your weary butt down on the riverside dirt, and take a breather.
                            You feel like you've earned one.
                            You can move your finger again, somewhat, but it'll need a bit more time before it stops aching completely.
                        [/p]
                        [p]
                            You've defied death more than once today.
                            You should consider yourself lucky to be alive.
                            The trip into the well was a harrowing experience.
                            You nearly got crushed, almost drowned, and ended up punching a basilisk in the face.
                            How many kobolds can say they did that?
                            Probably not a lot, since even your kind isn't dumb enough to hit a mythological rock monster without putting on a pair of steel gloves first.
                        [/p]
                        [p]
                            You've gained a few awesome stories to tell once you've grown old and wise.
                            Stories like the ones Seki used to tell you when you were little.
                            You went through all that trouble to get your mind off of him, and here you are reminiscing once more.
                            You just can't help yourself from clinging to times long gone.
                            Things were so much simpler back then.
                            You miss those days.
                        [/p]
                        [p]
                            The sun is slowly starting to set.
                            You drag yourself to your feet.
                            It's time to go.
                            Varanar isn't [i]that[/i] far off.
                            If your legs don't give out from underneath you, you might still make it there before nightfall.
                            And hopefully your finger'll have healed a bit more by then.
                        [/p]`;

        return global.parser.parse(toReturn);
    }

    /**
     * Builds and returns the continue button.
     */
    function buildChoice() {
        var disabled = ctrl.continued();
        var choice = `<div class="choicecontainer">`;
        choice += `<button class="button bigbutton continuebutton" id="${continueId}" ${disabled ? "disabled" : ""}>`;
        choice += `Continue &gt;&gt`;
        choice += `</button>`;
        choice += `</div>`;
        return choice;
    }

    /**
     * Disables all three buttons.
     */
    function disableButtons() {
        var buttons = [$("#" + continueId)];
        buttons.forEach(function (button) {
            button.unbind();
            button.attr("disabled", true);
        });
    }

    /**
     * Loads and displays the next scene.
     * @param {string} sceneName Name of the scene to load.
     * @param {string} folder Folder of the scene to load.
     */
    function loadNextPart(sceneName, folder) {
        global.ui.fadeOutContent(function () {
            global.sceneEnd();
            global.sceneLoader.loadScene(sceneName, folder);
        });
    }

    /**
     * Adds a listener to the button.
     */
    function registerContinueListener() {
        $("#" + continueId).click(function () {
            $(this).addClass("selected");
            disableButtons();
            ctrl.continue();
            loadNextPart(ctrl.nextSceneName, ctrl.nextFolderName);
        });
    }

    // PUBLIC MEMBERS \\        this.public = "test";
    this.id = arguments.callee.name;

    // PUBLIC FUNCTIONS \\      this.publicFunction = function(){};

    /**
     * Builds and returns this part.
     * @param {boolean} invisible If passed and true, will give the entire section a display:none style.
     */
    this.build = function (invisible) {
        if (reqController && ((reqChoice && reqController.get() !== reqChoice) || (!reqChoice && !reqController.continued()))) {
            return "";
        }

        ctrl.bgm.stopLoop();
        global.ui.applyTheme("hamlet_day");
        var part = `<div id="${that.id}" ${invisible ? 'style="display:none;"' : ""}>`;
        part += buildContent();
        part += (changeController && changeController.change()) || "";
        part += buildChoice();
        if (!ctrl.nextSceneReady) {
            part += `<span class="todo">There is no content beyond this point.</span>`;
        }
        part += `</div>`;
        return part;
    };

    /**
     * Registers all the required button listeners for this part.
     */
    this.registerListeners = function () {
        if (reqController && ((reqChoice && reqController.get() !== reqChoice) || (!reqChoice && !reqController.continued()))) {
            return;
        }

        if (ctrl.continued()) {
            return;
        }

        if (ctrl.nextSceneReady) {
            registerContinueListener();
        }
    };
}

// END scenes\HamletDay2\UndergroundCave\fight\defence\eyepatch\UndergroundCaveDefenceLeave.js

// scenes\HamletDay2\UndergroundCave\fight\defence\eyepatch\UndergroundCaveDefenceDoNot.js

/**
 * Fight section of the Underground Cave.
 * @param {UndergroundCaveController} controller The Underground Cave controller.
 */
function UndergroundCaveDefenceDoNot(controller) {
    // PRIVATE MEMBERS \\       var private = "test";
    var that = this;
    var ctrl = controller;

    var reqChoice = UndergroundCaveDefencePatchChoice.DO_NOT;
    var reqController = ctrl.defencePatch;
    var subController = ctrl.preContinue;
    var changeController = false;

    var continueId = arguments.callee.name + "ButtonOne";
    var next = new UndergroundCaveDefenceLeave(ctrl);

    // PRIVATE FUNCTIONS \\     function privateFunction(){}

    /**
     * Builds and returns the content of this section.
     * @returns {string} The content.
     */
    function buildContent() {
        var toReturn = `[p]
                            Do not take the eyepatch.
                        [/p]`;
        return global.parser.parse(toReturn);
    }

    /**
     * Builds and returns the choice button.
     */
    function buildNextChoice() {
        var disabled = subController.continued() ? "disabled" : "";
        var isSelected = subController.continued();
        var selected = isSelected ? "selected" : "";
        var button = `<button class="button inlinechoice ${selected}" id="${continueId}" ${disabled}>Continue</button>`;
        return button;
    }

    /**
     * Builds and returns the choice of this section.
     * @returns {string} The choice of this section.
     */
    function buildChoice() {
        var choice = `<div class="choicecontainer">`;
        choice += buildNextChoice();
        choice += `</div>`;
        return choice;
    }

    /**
     * Disables all three buttons.
     */
    function disableButtons() {
        var buttons = [$("#" + continueId)];
        buttons.forEach(function (button) {
            button.unbind();
            button.attr("disabled", true);
        });
    }

    /**
     * Loads and displays the next part.
     * @param {object} part Which part to load.
     */
    function loadNextPart(part) {
        var built = part.build(true);
        global.ui.appendBeforeFinisher(built, global.ui.genericHeaderId);
        $("#" + part.id).fadeIn(400);
        part.registerListeners();
    }

    /**
     * Adds a listener to the button.
     */
    function registerNextListener() {
        $("#" + continueId).click(function () {
            $(this).addClass("selected");
            disableButtons();
            subController.continue();
            loadNextPart(next);
        });
    }

    // PUBLIC MEMBERS \\        this.public = "test";
    this.id = arguments.callee.name;

    // PUBLIC FUNCTIONS \\      this.publicFunction = function(){};

    /**
     * Builds and returns this part.
     * @param {boolean} invisible If passed and true, will give the entire section a display:none style.
     */
    this.build = function (invisible) {
        if (reqController && ((reqChoice && reqController.get() !== reqChoice) || (!reqChoice && !reqController.continued()))) {
            return "";
        }

        var part = `<div id="${that.id}" ${invisible ? 'style="display:none;"' : ""}>`;
        part += buildContent();
        part += (changeController && changeController.change()) || "";
        part += buildChoice();
        part += `</div>`;
        part += next.build();
        return part;
    };

    /**
     * Registers all the required button listeners for this part.
     */
    this.registerListeners = function () {
        if (reqController && ((reqChoice && reqController.get() !== reqChoice) || (!reqChoice && !reqController.continued()))) {
            return;
        }

        next.registerListeners();

        if (subController.continued()) {
            return;
        }

        registerNextListener();
    };
}

// END scenes\HamletDay2\UndergroundCave\fight\defence\eyepatch\UndergroundCaveDefenceDoNot.js

// scenes\HamletDay2\UndergroundCave\fight\defence\eyepatch\UndergroundCaveDefenceTake.js

/**
 * Doggo section of the Underground Cave.
 * @param {UndergroundCaveController} controller The Underground Cave controller.
 */
function UndergroundCaveDefenceTake(controller) {
    // PRIVATE MEMBERS \\       var private = "test";
    var that = this;
    var ctrl = controller;

    var reqChoice = UndergroundCaveDefencePatchChoice.TAKE;
    var reqController = ctrl.defencePatch;
    var subController = ctrl.preContinue;
    var changeController = ctrl.defencePatchTake;

    var continueId = arguments.callee.name + "ButtonOne";
    var next = new UndergroundCaveDefenceLeave(ctrl);

    // PRIVATE FUNCTIONS \\     function privateFunction(){}

    /**
     * Builds and returns the content of this section.
     * @returns {string} The content.
     */
    function buildContent() {
        var toReturn = `[p]
                            Take the eyepatch. No basilisk around.
                        [/p]`;
        return global.parser.parse(toReturn);
    }

    /**
     * Builds and returns the choice button.
     */
    function buildNextChoice() {
        var disabled = subController.continued() ? "disabled" : "";
        var isSelected = subController.continued();
        var selected = isSelected ? "selected" : "";
        var button = `<button class="button inlinechoice ${selected}" id="${continueId}" ${disabled}>Continue</button>`;
        return button;
    }

    /**
     * Builds and returns the choice of this section.
     * @returns {string} The choice of this section.
     */
    function buildChoice() {
        var choice = `<div class="choicecontainer">`;
        choice += buildNextChoice();
        choice += `</div>`;
        return choice;
    }

    /**
     * Disables all three buttons.
     */
    function disableButtons() {
        var buttons = [$("#" + continueId)];
        buttons.forEach(function (button) {
            button.unbind();
            button.attr("disabled", true);
        });
    }

    /**
     * Loads and displays the next part.
     * @param {object} part Which part to load.
     */
    function loadNextPart(part) {
        var built = part.build(true);
        global.ui.appendBeforeFinisher(built, global.ui.genericHeaderId);
        $("#" + part.id).fadeIn(400);
        part.registerListeners();
    }

    /**
     * Adds a listener to the button.
     */
    function registerNextListener() {
        $("#" + continueId).click(function () {
            $(this).addClass("selected");
            disableButtons();
            subController.continue();
            loadNextPart(next);
        });
    }

    // PUBLIC MEMBERS \\        this.public = "test";
    this.id = arguments.callee.name;

    // PUBLIC FUNCTIONS \\      this.publicFunction = function(){};

    /**
     * Builds and returns this part.
     * @param {boolean} invisible If passed and true, will give the entire section a display:none style.
     */
    this.build = function (invisible) {
        if (reqController && ((reqChoice && reqController.get() !== reqChoice) || (!reqChoice && !reqController.continued()))) {
            return "";
        }

        var part = `<div id="${that.id}" ${invisible ? 'style="display:none;"' : ""}>`;
        part += buildContent();
        part += (changeController && changeController.change()) || "";
        part += buildChoice();
        part += `</div>`;
        part += next.build();
        return part;
    };

    /**
     * Registers all the required button listeners for this part.
     */
    this.registerListeners = function () {
        if (reqController && ((reqChoice && reqController.get() !== reqChoice) || (!reqChoice && !reqController.continued()))) {
            return;
        }

        next.registerListeners();

        if (subController.continued()) {
            return;
        }

        registerNextListener();
    };
}

// END scenes\HamletDay2\UndergroundCave\fight\defence\eyepatch\UndergroundCaveDefenceTake.js

// scenes\HamletDay2\UndergroundCave\fight\defence\eyepatch\UndergroundCaveDefencePatch.js

/**
 * Doggo section of the Underground Cave.
 * @param {UndergroundCaveController} controller The Underground Cave controller.
 */
function UndergroundCaveDefencePatch(controller) {
    // PRIVATE MEMBERS \\       var private = "test";
    var that = this;
    var ctrl = controller;

    var reqChoice = false;
    var reqController = ctrl.defence;
    var subController = ctrl.defencePatch;
    var changeController = false;

    var firstId = arguments.callee.name + "ButtonOne";
    var secondId = arguments.callee.name + "ButtonTwo";

    var firstNext = new UndergroundCaveBasiTake(ctrl);
    var secondNext = new UndergroundCaveBasiDoNot(ctrl);

    var firstChoice = UndergroundCaveDefencePatchChoice.TAKE;
    var secondChoice = UndergroundCaveDefencePatchChoice.DO_NOT;

    // PRIVATE FUNCTIONS \\     function privateFunction(){}

    /**
     * Builds and returns the content of this section.
     * @returns {string} The content.
     */
    function buildContent() {
        var toReturn = `[p]
                            Stumble upon eyepatch. Take it or leave it. No basilisk.
                        [/p]`;

        return global.parser.parse(toReturn);
    }

    /**
     * Builds and returns the choice button.
     */
    function buildFirstChoice() {
        var disabled = subController.has() ? "disabled" : "";
        var isSelected = subController.get() === firstChoice;
        var selected = isSelected ? "selected" : "";
        var button = `<button class="button inlinechoice ${selected}" id="${firstId}" ${disabled}>Take it</button>`;

        var tooltip = global.parser.parse(`Take the eyepatch.`);
        var popupContainer = global.ui.makeToolTip(button, tooltip, false, false, "width: 190px;");
        // Re-wrap with proper positioning.
        button = `<div class="inlinechoice">`;
        button += popupContainer;
        button += `</div>`;

        return button;
    }

    /**
     * Builds and returns the choice button.
     */
    function buildSecondChoice() {
        var disabled = subController.has() ? "disabled" : "";
        var isSelected = subController.get() === secondChoice;
        var selected = isSelected ? "selected" : "";
        var button = `<button class="button inlinechoice ${selected}" id="${secondId}" ${disabled}>Do not</button>`;

        var tooltip = global.parser.parse(`Leave it.`);
        var popupContainer = global.ui.makeToolTip(button, tooltip, false, false, "width: 190px;");
        // Re-wrap with proper positioning.
        button = `<div class="inlinechoice">`;
        button += popupContainer;
        button += `</div>`;

        return button;
    }

    /**
     * Builds and returns the choice of this section.
     * @returns {string} The choice of this section.
     */
    function buildChoice() {
        var choice = `<div class="choicecontainer"><div class="inlinechoiceheader">You:</div>`;
        choice += buildFirstChoice();
        choice += `<hr class="inlinechoiceseparator">`;
        choice += buildSecondChoice();
        choice += `</div>`;
        return choice;
    }

    /**
     * Disables all three buttons.
     */
    function disableButtons() {
        var buttons = [$("#" + firstId), $("#" + secondId)];
        buttons.forEach(function (button) {
            button.unbind();
            button.attr("disabled", true);
        });
    }

    /**
     * Loads and displays the next part.
     * @param {object} part Which part to load.
     */
    function loadNextPart(part) {
        var built = part.build(true);
        global.ui.appendBeforeFinisher(built, global.ui.genericHeaderId);
        $("#" + part.id).fadeIn(400);
        part.registerListeners();
    }

    /**
     * Adds a listener to the button.
     */
    function registerFirstListener() {
        $("#" + firstId).click(function () {
            $(this).addClass("selected");
            disableButtons();
            subController.set(firstChoice);
            loadNextPart(firstNext);
        });
    }

    /**
     * Adds a listener to the button.
     */
    function registerSecondListener() {
        $("#" + secondId).click(function () {
            $(this).addClass("selected");
            disableButtons();
            subController.set(secondChoice);
            loadNextPart(secondNext);
        });
    }

    // PUBLIC MEMBERS \\        this.public = "test";
    this.id = arguments.callee.name;

    // PUBLIC FUNCTIONS \\      this.publicFunction = function(){};

    /**
     * Builds and returns this part.
     * @param {boolean} invisible If passed and true, will give the entire section a display:none style.
     */
    this.build = function (invisible) {
        if (reqController && ((reqChoice && reqController.get() !== reqChoice) || (!reqChoice && !reqController.continued()))) {
            return "";
        }

        var part = `<div id="${that.id}" ${invisible ? 'style="display:none;"' : ""}>`;
        part += buildContent();
        part += (changeController && changeController.change()) || "";
        part += buildChoice();
        part += `</div>`;
        part += firstNext.build();
        part += secondNext.build();
        return part;
    };

    /**
     * Registers all the required button listeners for this part.
     */
    this.registerListeners = function () {
        if (reqController && ((reqChoice && reqController.get() !== reqChoice) || (!reqChoice && !reqController.continued()))) {
            return;
        }

        firstNext.registerListeners();
        secondNext.registerListeners();

        if (subController.has()) {
            return;
        }

        registerFirstListener();
        registerSecondListener();
    };
}

var UndergroundCaveDefencePatchChoice = {
    TAKE: 1,
    DO_NOT: 2
};

// END scenes\HamletDay2\UndergroundCave\fight\defence\eyepatch\UndergroundCaveDefencePatch.js

// scenes\HamletDay2\UndergroundCave\fight\defence\UndergroundCaveDefence.js

/**
 * Fight section of the Underground Cave.
 * @param {UndergroundCaveController} controller The Underground Cave controller.
 */
function UndergroundCaveDefence(controller) {
    // PRIVATE MEMBERS \\       var private = "test";
    var that = this;
    var ctrl = controller;

    var reqChoice = UndergroundCaveFightChoice.DEFENCE;
    var reqController = ctrl.fight;
    var subController = ctrl.preContinue;
    var changeController = ctrl.defence;

    var continueId = arguments.callee.name + "ButtonOne";
    var next = new UndergroundCaveDefenceLeave(ctrl);

    // PRIVATE FUNCTIONS \\     function privateFunction(){}

    /**
     * Builds and returns the content of this section.
     * @returns {string} The content.
     */
    function buildContent() {
        global.kobold.history.shared.well.basiliskFingerDislocated = true;
        var toReturn = `[p]
                            It's [i]only[/i] a feral lizard.
                            If you can dodge its swipes and bites, then surely it will tire out soon, right?
                            All you need to do is [b]not get hit[/b].
                            A basilisk relies on its targets to be [b]petrified[/b], so it shouldn't be able to hit you if you keep moving.
                            At least you hope so.
                            You [b]really[/b] hope so.
                        [/p]
                        [p]
                            While you're still mid-thought, the beast suddenly bursts out into a [b]sprint[/b] towards you.
                            You only [b]barely[/b] manage to pull your left leg back before its teeth sink into your scales, avoiding the lethal bite with a speedy side-step.
                            Angrily, the monster swipes at you with its claws.
                            You take a step backwards to avoid getting hit, ending up at the edge of the pool of liquid you crawled out of.
                            The creature's barrage of attacks [b]keep coming[/b].
                        [/p]
                        [p]
                            Determined to drive you into the water, it follows up with another attempt at biting you.
                            No longer able to retreat, you instead roll to the side,
                            using your innate flexibility and the freedom of motion granted by bipedal movement to stay one step ahead of the rock-clad crocodillian.
                        [/p]
                        [p]
                            Coming out of your roll, you lower into a defensive pose, and hold still for a moment.
                            You and the basilisk are panting,
                            but your water-side duel is not over yet.
                            You both have fight left in you.
                            Although you [b]wish[/b] it would [b]give up[/b] and [b]walk away[/b] already.
                            Surely a skinny kobold like yourself, with barely any meat to pick at, isn't worth a lengthy brawl, right?
                        [/p]
                        [p]
                            Apparently you're wrong.
                            The brief respite is broken.
                            The furious feral lashes at you, turning to the side to swing its rock-hard tail, using it as a weighty whip.
                            Seeing an opening, you tumble not backwards, but [b]forwards[/b],
                            elegantly jumping over the lizard's tail, surprising both it and yourself as you end up directly in front of its drooling maw.
                        [/p]
                        [p]
                            The basilisk is unsure how to react.
                            It could bite you, but it hesitates.
                            You, too, hadn't thought this far ahead.
                            Your mind freezing up, you do the first thing that pops into your brain.
                            You curl your hand into a fist, and bash bash the crocodillian's snout, outright [b]punching[/b] the front of the animal's muzzle.
                        [/p]
                        [p]
                            [big]
                                [color=red][b]CRACK[/b][/color]
                            [/big]
                        [/p]
                        [p]
                            [b]Ow[/b]!!
                            You clutch your hand.
                            It [b]hurts[/b].
                            It feels like you just [b]hit[/b] a [b]rock[/b]!
                            You think something [b]broke[/b], and it wasn't the basilisk's nose.
                        [/p]
                        [p]
                            Still, despite having barely scratched it, the beast recoils as though it's been struck by a mortal wound.
                            You must have frightened it or something.
                            Shown it that you [b]can[/b] and you [b]will[/b] hurt it.
                            Even if you end up hurting yourself [b]even more[/b].
                            You aren't afraid of fighting a pyrrhic battle to the death.
                            A fight in which [b]both[/b] sides lose.
                            And that scares the monster.
                            Or maybe it's just smart enough to know when to run away.
                            It hisses loudly, before turning tail and scampering off back to the hole it came from.
                        [/p]
                        [p]
                            [c]
                                [b]You have scared off the basilisk![/b]
                            [/c]
                        [/p]`;
        return global.parser.parse(toReturn);
    }

    /**
     * Builds and returns the choice button.
     */
    function buildNextChoice() {
        var disabled = subController.continued() ? "disabled" : "";
        var isSelected = subController.continued();
        var selected = isSelected ? "selected" : "";
        var button = `<button class="button inlinechoice ${selected}" id="${continueId}" ${disabled}>Continue</button>`;
        return button;
    }

    /**
     * Builds and returns the choice of this section.
     * @returns {string} The choice of this section.
     */
    function buildChoice() {
        var choice = `<div class="choicecontainer">`;
        choice += buildNextChoice();
        choice += `</div>`;
        return choice;
    }

    /**
     * Disables all three buttons.
     */
    function disableButtons() {
        var buttons = [$("#" + continueId)];
        buttons.forEach(function (button) {
            button.unbind();
            button.attr("disabled", true);
        });
    }

    /**
     * Loads and displays the next part.
     * @param {object} part Which part to load.
     */
    function loadNextPart(part) {
        var built = part.build(true);
        global.ui.appendBeforeFinisher(built, global.ui.genericHeaderId);
        $("#" + part.id).fadeIn(400);
        part.registerListeners();
    }

    /**
     * Adds a listener to the button.
     */
    function registerNextListener() {
        $("#" + continueId).click(function () {
            $(this).addClass("selected");
            disableButtons();
            subController.continue();
            loadNextPart(next);
        });
    }

    // PUBLIC MEMBERS \\        this.public = "test";
    this.id = arguments.callee.name;

    // PUBLIC FUNCTIONS \\      this.publicFunction = function(){};

    /**
     * Builds and returns this part.
     * @param {boolean} invisible If passed and true, will give the entire section a display:none style.
     */
    this.build = function (invisible) {
        if (reqController && ((reqChoice && reqController.get() !== reqChoice) || (!reqChoice && !reqController.continued()))) {
            return "";
        }

        var part = `<div id="${that.id}" ${invisible ? 'style="display:none;"' : ""}>`;
        part += buildContent();
        part += (changeController && changeController.change()) || "";
        part += buildChoice();
        part += `</div>`;
        part += next.build();
        return part;
    };

    /**
     * Registers all the required button listeners for this part.
     */
    this.registerListeners = function () {
        if (reqController && ((reqChoice && reqController.get() !== reqChoice) || (!reqChoice && !reqController.continued()))) {
            return;
        }

        next.registerListeners();

        if (subController.continued()) {
            return;
        }

        registerNextListener();
    };
}

// END scenes\HamletDay2\UndergroundCave\fight\defence\UndergroundCaveDefence.js

// scenes\HamletDay2\UndergroundCave\fight\observe\UndergroundCaveObserve.js

/**
 * Fight section of the Underground Cave.
 * @param {UndergroundCaveController} controller The Underground Cave controller.
 */
function UndergroundCaveObserve(controller) {
    // PRIVATE MEMBERS \\       var private = "test";
    var that = this;
    var ctrl = controller;

    var reqChoice = UndergroundCaveFightChoice.OBSERVE;
    var reqController = ctrl.fight;
    var changeController = false;

    var continueId = arguments.callee.name + "ButtonOne";

    var idsToRemove = [
        "UndergroundCaveObserve",
        "UndergroundCaveFight",
        "UndergroundCaveResistSucceed",
        "UndergroundCaveResist",
        "UndergroundCaveStare",
        "UndergroundCaveAvert",
        "UndergroundCaveSurface"
    ];

    // PRIVATE FUNCTIONS \\     function privateFunction(){}

    /**
     * Builds and returns the content of this section.
     * @returns {string} The content.
     */
    function buildContent() {
        var petri = ctrl.stare.get();
        var toReturn = `[p]
                            You need to be well-aware of the slippery lizard's actions.
                            One wrong move, and you could very well end up injured or even [b]dead[/b].
                            Before committing to actual combat, you decide to [i]study[/i] the basilisk first.
                            If you know how it moves, you'll be better able to avoid its blows.
                            At least in theory.
                        [/p]
                        [p]
                            You keep some distance between the creature and you, taking a step back whenever it tries to close the gap.
                            While slow in general, you note that it can burst into short, speedy sprints.
                            You don't allow it close enough to test out your theory, but you imagine its attacks must be somewhat similar:
                            slow in general, with some lightning-fast shots mixed in.
                            While the former will probably [b]not[/b] be a major threat, it is latter that you fear the most.
                            A simple flick of its tail, for instance, could push you off balance, after which you'll be easy prey for the beast.
                        [/p]
                        [p]
                            While observing the basilisk, you find your sight drifting towards its eyes over and over again.
                            The creature's bright irises dance and twirl, like a smidgen of milk in a bowl of soup that's being constantly stirred.
                            It's [b]intriguing[/b].
                            [b]Hypnotizing[/b].
                            The entire cave feels like a pitch-black [b]void[/b] with the eyes at its very center.
                            While you know you shouldn't, you can't help [b]but[/b] gaze into the abyss.
                            Before long, you find yourself [i]lost[/i] in the alluring, mind-emptying void that is the creature's stare${petri ? ` yet again` : ``}.
                        [/p]`;

        if (petri) {
            toReturn += `
                        [p]
                            This time, instead of taking several minutes, you find yourself starting to petrify within [b]seconds[/b].
                            Feeling threatened, the basilisk must have upped its game.
                            Your mind [b]screams[/b] for you to look away, but your body fails to heed the mental beckoning,
                            your panicking thoughts drowned out by [b]emptiness[/b], brought about by the mere sight of the emerald eyes in front of you.
                            Instead of averting your gaze, you keep blankly staring as a rock-like texture overtakes your extremities.
                            Your limbs petrify, and before you know it, you are frozen in place for a second time.
                        [/p]`;
        } else {
            toReturn += ` 
                        [p]
                            Within seconds, you can start to feel your limbs stiffen, your scales rapidly turning to stone.
                            Your mind [b]screams[/b] for you to look away, but your body fails to heed the mental beckoning,
                            your panicking thoughts drowned out by [b]emptiness[/b], brought about by the mere sight of the emerald eyes in front of you.
                            Instead of averting your gaze, you keep blankly staring as a rock-like texture overtakes your extremities.
                            Your limbs petrify, and before you know it, you are frozen in place.
                        [/p]`;
        }

        toReturn += `   [p]
                            But you aren't out of your trance yet.
                            Even though the entire exterior of your body has already turned to stone, you simply keep staring.
                            You feel the petrification dig [b]deeper[/b], your very flesh becoming cold, hard rock.
                            The basilisk's eyes prove [i]comforting[/i], dulling your aching mind while your very bones fossilize.
                        [/p]
                        [p]
                            Right before the intrusive blight reaches your vital organs, the basilisk suddenly breaks eyecontact, and surges forwards, towards you.
                            No longer having the sweet, hypnotizing, relieving comfort of staring into its eyes, you find yourself [b]panicking[/b].
                            You can barely [b]breathe[/b], your rock-hard chest keeping your lungs permanently compressed.
                            Your heart has a hard time pumping, almost completely encased in stone.
                            Many of your veins have slipped shut.
                            Whatever feeling you still had in your hands and your feet soon fades, blood circulation entirely cut off.
                        [/p]
                        [p]
                            Luckily, your agony is short-lived.
                            The monster viciously [b]rakes[/b] at one of your petrified legs,
                            its incredibly sharp and powerful claws [b]easily[/b] tearing through the hard, yet brittle rock,
                            ripping out an entire chunk of stone, completely [b]severing[/b] your foot from the rest of your body.
                        [/p]
                        [p]
                            You feel no pain, yet your mind is flooded with [b]terror[/b].
                            An intense [b]fear[/b] of death washes over you, which only intesifies as you realize you [b]aren't[/b] [i]stable[/i] anymore.
                            With one foot no longer supporting you, and no way to readjust the other, your body slowly starts to topple to the side.
                            You feel sick to your stomach, not even able to utter a scream as you tumble to the ground, your fate sealed.
                            The last thing you hear, before losing consciousness, 
                            is the sound of your own body [b]shattering[/b] against the cavern floor,
                            breaking into a million pieces.
                        [/p]
                        [p]
                            As the debris of your stone-turned body settles down,
                            the basilisk immediately begins picking through it for the tender,
                            juicy innards that were trapped within the stone shell.
                            It's not every day that the beast could have such a feast.
                            While the organs are succulent,
                            the few small morsels of unpetrified flesh that the monster can find, sate it the most.
                            No wonder humans butcher kobolds.
                            Their meat really [b]is[/b] a delicacy, to feral and anthro alike.
                        [/p]
                        [p]
                            [c]
                                [b]
                                    Rock end.
                                [/b]
                            [/c]
                        [/p]`;

        return global.parser.parse(toReturn);
    }

    /**
     * Builds and returns the continue button.
     */
    function buildChoice() {
        var choice = `<div class="choicecontainer">`;
        choice += `<button class="button bigbutton continuebutton" style="margin-left: auto; position: relative; float: right;" id="${continueId}">`;
        choice += `&lt;&lt Revert`;
        choice += `</button>`;
        choice += `</div>`;
        return choice;
    }

    /**
     * Disables all three buttons.
     */
    function disableButtons() {
        var buttons = [$("#" + continueId)];
        buttons.forEach(function (button) {
            button.unbind();
            button.attr("disabled", true);
        });
    }

    /**
     * Loads and displays the next part.
     * @param {object} part Which part to load.
     */
    function loadNextPart(part) {
        var built = part.build(true);
        global.ui.appendBeforeFinisher(built, global.ui.genericHeaderId);
        $("#" + part.id).fadeIn(400, function () {
            var main = $("#main");
            main.scrollTop(main[0].scrollHeight - main.height() - 5); // Fix scrolling
        });
        part.registerListeners();
    }

    /**
     * Adds a listener to the button.
     */
    function registerContinueListener() {
        $("#" + continueId).click(function () {
            $(this).addClass("selected");
            disableButtons();
            ctrl.misc.unsetAll();
            ctrl.fight.unset();
            ctrl.resistSucceed.undo();
            ctrl.resistSucceed.unset();
            ctrl.stare.undo();
            ctrl.stare.unset();
            ctrl.avert.undo();
            ctrl.avert.unset();
            ctrl.surface.undo();
            ctrl.surface.unset();
            for (var i = 0; i < idsToRemove.length; i++) {
                $("#" + idsToRemove[i]).remove();
            }
            loadNextPart(ctrl.fragments.surface);
        });
    }

    // PUBLIC MEMBERS \\        this.public = "test";
    this.id = arguments.callee.name;

    // PUBLIC FUNCTIONS \\      this.publicFunction = function(){};

    /**
     * Builds and returns this part.
     * @param {boolean} invisible If passed and true, will give the entire section a display:none style.
     */
    this.build = function (invisible) {
        if (reqController && ((reqChoice && reqController.get() !== reqChoice) || (!reqChoice && !reqController.continued()))) {
            return "";
        }

        var part = `<div id="${that.id}" ${invisible ? 'style="display:none;"' : ""}>`;
        part += buildContent();
        part += buildChoice();
        part += `</div>`;
        return part;
    };

    /**
     * Registers all the required button listeners for this part.
     */
    this.registerListeners = function () {
        if (reqController && ((reqChoice && reqController.get() !== reqChoice) || (!reqChoice && !reqController.continued()))) {
            return;
        }

        registerContinueListener();
    };
}

// END scenes\HamletDay2\UndergroundCave\fight\observe\UndergroundCaveObserve.js

// scenes\HamletDay2\UndergroundCave\fight\UndergroundCaveFight.js

/**
 * Fight section of the Underground Cave.
 * @param {UndergroundCaveController} controller The Underground Cave controller.
 */
function UndergroundCaveFight(controller) {
    // PRIVATE MEMBERS \\       var private = "test";
    var that = this;
    var ctrl = controller;

    var reqChoice = UndergroundCaveAvertChoice.FIGHT;
    var reqController = ctrl.avert;
    var subController = ctrl.fight;
    var changeController = false;

    var firstId = arguments.callee.name + "ButtonOne";
    var secondId = arguments.callee.name + "ButtonTwo";
    var thirdId = arguments.callee.name + "ButtonThree";

    var firstNext = new UndergroundCaveDefence(ctrl);
    var secondNext = new UndergroundCaveOffence(ctrl);
    var thirdNext = new UndergroundCaveObserve(ctrl);

    var firstChoice = UndergroundCaveFightChoice.DEFENCE;
    var secondChoice = UndergroundCaveFightChoice.OFFENCE;
    var thirdChoice = UndergroundCaveFightChoice.OBSERVE;

    // PRIVATE FUNCTIONS \\     function privateFunction(){}

    /**
     * Builds and returns the content of this section.
     * @returns {string} The content.
     */
    function buildContent() {
        global.kobold.history.shared.well.basiliskFought = true;
        var toReturn = ``;

        if (ctrl.avert.get()) {
            toReturn += `
                        [p]
                            Whatever the beast's intentions, you [b]aren't[/b] going to be an easy prey.
                            Whether it wants to [b]gorge[/b] on your [b]flesh[/b], simply [b]kill you[/b] for intruding on its territory,
                            or if it has a [b]hungry brood[/b] somewhere in the hole it crawled out of, you won't go down without a fight.
                            You drop into a combat stance, and mentally prepare yourself for battle.
                            Noticing your hostility, the crocodillian hisses loudly, and assumes a threatening pose.
                            [i]It's on.[/i]
                        [/p]`;
        } else {
            toReturn += `
                        [p]
                            Pushing your mind to its very limit, you manage to move your second hand as well.
                            The basilisk, while a mindless creature, is visibly in fightened awe as you slowly rise to your feet,
                            a wave of green scales starting from each of your extremities, rolling over the stony grey that overtaken you,
                            washing it away like it was never even present.
                        [/p]
                        [p]
                            Able to move unhindered once again, you drop into a combat stance.
                            The creature hisses loudly, assuming a threatening pose.
                            The two of you have a score to settle.
                            And neither of you are going down without a fight.
                        [/p]`;
        }

        return global.parser.parse(toReturn);
    }

    /**
     * Builds and returns the choice button.
     */
    function buildFirstChoice() {
        var disabled = subController.has() ? "disabled" : "";
        var isSelected = subController.get() === firstChoice;
        var selected = isSelected ? "selected" : "";
        var button = `<button class="button inlinechoice ${selected}" id="${firstId}" ${disabled}>Defence</button>`;

        var tooltip = global.parser.parse(`Make sure that thing doesn't hit you. Retalliate whenever possible.`);
        var popupContainer = global.ui.makeToolTip(button, tooltip, false, false, "width: 190px;");
        // Re-wrap with proper positioning.
        button = `<div class="inlinechoice">`;
        button += popupContainer;
        button += `</div>`;

        return button;
    }

    /**
     * Builds and returns the choice button.
     */
    function buildSecondChoice() {
        var disabled = subController.has() ? "disabled" : "";
        var isSelected = subController.get() === secondChoice;
        var selected = isSelected ? "selected" : "";
        var button = `<button class="button inlinechoice ${selected}" id="${secondId}" ${disabled}>Offence</button>`;

        var tooltip = global.parser.parse(`Kill it before it can kill you.`);
        var popupContainer = global.ui.makeToolTip(button, tooltip, false, false, "width: 190px;");
        // Re-wrap with proper positioning.
        button = `<div class="inlinechoice">`;
        button += popupContainer;
        button += `</div>`;

        return button;
    }

    /**
     * Builds and returns the choice button.
     */
    function buildThirdChoice() {
        var disabled = subController.has() ? "disabled" : "";
        var isSelected = subController.get() === thirdChoice;
        var selected = isSelected ? "selected" : "";
        var button = `<button class="button inlinechoice ${selected}" id="${thirdId}" ${disabled}>Observing</button>`;

        var tooltip = global.parser.parse(`Keep a very watchful eye on the basilisk. See if there's a pattern to its movements.`);
        var popupContainer = global.ui.makeToolTip(button, tooltip, false, false, "width: 190px;");
        // Re-wrap with proper positioning.
        button = `<div class="inlinechoice">`;
        button += popupContainer;
        button += `</div>`;

        return button;
    }

    /**
     * Builds and returns the choice of this section.
     * @returns {string} The choice of this section.
     */
    function buildChoice() {
        var choice = `<div class="choicecontainer"><div class="inlinechoiceheader">You focus on:</div>`;
        choice += buildFirstChoice();
        choice += `<hr class="inlinechoiceseparator">`;
        choice += buildSecondChoice();
        choice += `<hr class="inlinechoiceseparator">`;
        choice += buildThirdChoice();
        choice += `</div>`;
        return choice;
    }

    /**
     * Disables all three buttons.
     */
    function disableButtons() {
        var buttons = [$("#" + firstId), $("#" + secondId), $("#" + thirdId)];
        buttons.forEach(function (button) {
            button.unbind();
            button.attr("disabled", true);
        });
    }

    /**
     * Loads and displays the next part.
     * @param {object} part Which part to load.
     */
    function loadNextPart(part) {
        var built = part.build(true);
        global.ui.appendBeforeFinisher(built, global.ui.genericHeaderId);
        $("#" + part.id).fadeIn(400);
        part.registerListeners();
    }

    /**
     * Adds a listener to the button.
     */
    function registerFirstListener() {
        $("#" + firstId).click(function () {
            $(this).addClass("selected");
            disableButtons();
            subController.set(firstChoice);
            loadNextPart(firstNext);
        });
    }

    /**
     * Adds a listener to the button.
     */
    function registerSecondListener() {
        $("#" + secondId).click(function () {
            $(this).addClass("selected");
            disableButtons();
            subController.set(secondChoice);
            loadNextPart(secondNext);
        });
    }

    /**
     * Adds a listener to the button.
     */
    function registerThirdListener() {
        $("#" + thirdId).click(function () {
            $(this).addClass("selected");
            disableButtons();
            subController.set(thirdChoice);
            loadNextPart(thirdNext);
        });
    }

    // PUBLIC MEMBERS \\        this.public = "test";
    this.id = arguments.callee.name;

    // PUBLIC FUNCTIONS \\      this.publicFunction = function(){};

    /**
     * Builds and returns this part.
     * @param {boolean} invisible If passed and true, will give the entire section a display:none style.
     */
    this.build = function (invisible) {
        if (reqController && ((reqChoice && reqController.get() !== reqChoice) || (!reqChoice && !reqController.continued()))) {
            return "";
        }

        var part = `<div id="${that.id}" ${invisible ? 'style="display:none;"' : ""}>`;
        part += buildContent();
        part += (changeController && changeController.change()) || "";
        part += buildChoice();
        part += `</div>`;
        part += firstNext.build();
        part += secondNext.build();
        part += thirdNext.build();
        return part;
    };

    /**
     * Registers all the required button listeners for this part.
     */
    this.registerListeners = function () {
        if (reqController && ((reqChoice && reqController.get() !== reqChoice) || (!reqChoice && !reqController.continued()))) {
            return;
        }

        firstNext.registerListeners();
        secondNext.registerListeners();
        thirdNext.registerListeners();

        if (subController.has()) {
            return;
        }

        registerFirstListener();
        registerSecondListener();
        registerThirdListener();
    };
}

var UndergroundCaveFightChoice = {
    DEFENCE: 1,
    OFFENCE: 2,
    OBSERVE: 3
};

// END scenes\HamletDay2\UndergroundCave\fight\UndergroundCaveFight.js

// scenes\HamletDay2\UndergroundCave\avert\still\eyepatch\UndergroundCaveBasiLeave.js

/**
 * Doggo section of the Underground Cave.
 * @param {UndergroundCaveController} controller The Underground Cave controller.
 */
function UndergroundCaveBasiLeave(controller) {
    // PRIVATE MEMBERS \\       var private = "test";
    var that = this;
    var ctrl = controller;

    var reqChoice = false;
    var reqController = ctrl.preContinue;
    var changeController = ctrl.basiLeave;

    var continueId = arguments.callee.name + "ButtonOne";

    // PRIVATE FUNCTIONS \\     function privateFunction(){}

    /**
     * Builds and returns the content of this section.
     * @returns {string} The content.
     */
    function buildContent() {
        var doggoChoice = ctrl.doggo.get();
        var treats = doggoChoice === ctrl.choices.doggo.FEED;
        var act = "petting";
        if (doggoChoice === ctrl.choices.doggo.FEED) {
            act = "feeding";
        }
        if(doggoChoice === ctrl.choices.doggo.FETCH) {
            act = "playing fetch with";
        }
        var toReturn = `[p]
                            After a few more minutes of walking, the two of you reach the entrance to the cave.
                            As you expected: the water was a stale branch of the river!
                            Climbing out of the cavern, you sit your butt down on the riverside dirt, and take a breather.
                            You feel like you've earned one.
                        [/p]
                        [p]
                            Uttering an exhausted sigh, you realize your basilisk buddy didn't follow you out here.
                            Looking back at the cave, you can see the creature staring at you from the shade.
                            It tentatively pokes one of its legs out into the sunlight, but with a loud hiss, quickly retracts the limb once more.
                            You figure it can't stand the sun, or something like that.
                            The beast stares at you longingly, before letting out a sad whine.
                            Hanging its head, it turns around and ventures back into the cave.
                        [p]
                            You consider going after the basilisk for a [b]proper[/b] goodbye, but you figure this way is for the best.
                            You can't stick around this cave forever, and even if you [b]did[/b] wait until nightfall,
                            the guards of Varanar would [b]never[/b] let such a monster into the city, no matter how well-behaved it is.
                            Maybe you'll return one day, with some ${treats ? `more` : ``} tasty treats for it to eat.
                        [/p]
                        [p]
                            Who are you kidding?
                            You can't even properly feed yourself, let alone a monster twice your weight.
                            You hope it'll be okay.
                            If a knight finds this cave, you fear your new friend won't last long.
                            But it's managed to survive until now, as have you.
                            With some luck, the both of you'll be just fine.
                        [/p]
                        [p]
                            The trip into the well was a harrowing experience.
                            You defied death more than once, but meeting the basilisk was all worth it.
                            You've never really owned a [i]pet[/i].
                            You wonder if that [i]hearty[/i] and [i]wholesome[/i] feeling you felt when ${act} the basilisk is how pet-owners feel all the time.
                        [/p]
                        [p]
                            Besides a friend, you've gained a few awesome stories to tell once you've grown old and wise.
                            Stories like the ones Seki used to tell you when you were little.
                            You went through all that trouble to get your mind off of him, and here you are reminiscing once more.
                            You just can't help yourself from clinging to times long gone.
                            Things were so much simpler back then.
                            You miss those days.
                        [/p]
                        [p]
                            You find yourself close to the road to Varanar.
                            In fact, you believe you passed this very place earlier, when heading for the hamlet.
                            You never knew there was a cave here, but then again,
                            you've never really bothered to scour the edge of the river for points of interest.
                        [/p]
                        [p]
                            The sun is slowly starting to set.
                            You drag yourself to your feet.
                            It's time to go.
                            The capital isn't [i]that[/i] far off.
                            If your legs don't give out from underneath you, you might still make it there before nightfall.
                        [/p]`;

        return global.parser.parse(toReturn);
    }

    /**
     * Builds and returns the continue button.
     */
    function buildChoice() {
        var disabled = ctrl.continued();
        var choice = `<div class="choicecontainer">`;
        choice += `<button class="button bigbutton continuebutton" id="${continueId}" ${disabled ? "disabled" : ""}>`;
        choice += `Continue &gt;&gt`;
        choice += `</button>`;
        choice += `</div>`;
        return choice;
    }

    /**
     * Disables all three buttons.
     */
    function disableButtons() {
        var buttons = [$("#" + continueId)];
        buttons.forEach(function (button) {
            button.unbind();
            button.attr("disabled", true);
        });
    }

    /**
     * Loads and displays the next scene.
     * @param {string} sceneName Name of the scene to load.
     * @param {string} folder Folder of the scene to load.
     */
    function loadNextPart(sceneName, folder) {
        global.ui.fadeOutContent(function () {
            global.sceneEnd();
            global.sceneLoader.loadScene(sceneName, folder);
        });
    }

    /**
     * Adds a listener to the button.
     */
    function registerContinueListener() {
        $("#" + continueId).click(function () {
            $(this).addClass("selected");
            disableButtons();
            ctrl.continue();
            loadNextPart(ctrl.nextSceneName, ctrl.nextFolderName);
        });
    }

    // PUBLIC MEMBERS \\        this.public = "test";
    this.id = arguments.callee.name;

    // PUBLIC FUNCTIONS \\      this.publicFunction = function(){};

    /**
     * Builds and returns this part.
     * @param {boolean} invisible If passed and true, will give the entire section a display:none style.
     */
    this.build = function (invisible) {
        if (reqController && ((reqChoice && reqController.get() !== reqChoice) || (!reqChoice && !reqController.continued()))) {
            return "";
        }

        ctrl.bgm.stopLoop();
        global.ui.applyTheme("hamlet_day");
        var part = `<div id="${that.id}" ${invisible ? 'style="display:none;"' : ""}>`;
        part += buildContent();
        part += (changeController && changeController.change()) || "";
        part += buildChoice();
        if (!ctrl.nextSceneReady) {
            part += `<span class="todo">There is no content beyond this point.</span>`;
        }
        part += `</div>`;
        return part;
    };

    /**
     * Registers all the required button listeners for this part.
     */
    this.registerListeners = function () {
        if (reqController && ((reqChoice && reqController.get() !== reqChoice) || (!reqChoice && !reqController.continued()))) {
            return;
        }

        if (ctrl.continued()) {
            return;
        }

        if (ctrl.nextSceneReady) {
            registerContinueListener();
        }
    };
}

// END scenes\HamletDay2\UndergroundCave\avert\still\eyepatch\UndergroundCaveBasiLeave.js

// scenes\HamletDay2\UndergroundCave\avert\still\eyepatch\UndergroundCaveBasiDoNot.js

/**
 * Doggo section of the Underground Cave.
 * @param {UndergroundCaveController} controller The Underground Cave controller.
 */
function UndergroundCaveBasiDoNot(controller) {
    // PRIVATE MEMBERS \\       var private = "test";
    var that = this;
    var ctrl = controller;

    var reqChoice = UndergroundCaveBasiPatchChoice.DO_NOT;
    var reqController = ctrl.basiPatch;
    var subController = ctrl.preContinue;
    var changeController = false;

    var continueId = arguments.callee.name + "ButtonOne";
    var next = new UndergroundCaveBasiLeave(ctrl);

    // PRIVATE FUNCTIONS \\     function privateFunction(){}

    /**
     * Builds and returns the content of this section.
     * @returns {string} The content.
     */
    function buildContent() {
        var toReturn = `[p]
                            An eyepatch is useless to a kobold like you.
                            Your night vision is already as good as it's ever going to get.
                            While you kind of like the way this thing looks,
                            you're not a fan of losing [i]depth perception[/i].
                            You toss it back down to the ground, where you found it, and the two of you continue on your way.
                            You've no idea whether intentional or not, but your crocodillian friend steps on top of the piece of leather you just threw away,
                            the basilisk's sharp claws completely shredding the eyepatch to oblivion.
                        [/p]`;
        return global.parser.parse(toReturn);
    }

    /**
     * Builds and returns the choice button.
     */
    function buildNextChoice() {
        var disabled = subController.continued() ? "disabled" : "";
        var isSelected = subController.continued();
        var selected = isSelected ? "selected" : "";
        var button = `<button class="button inlinechoice ${selected}" id="${continueId}" ${disabled}>Continue</button>`;
        return button;
    }

    /**
     * Builds and returns the choice of this section.
     * @returns {string} The choice of this section.
     */
    function buildChoice() {
        var choice = `<div class="choicecontainer">`;
        choice += buildNextChoice();
        choice += `</div>`;
        return choice;
    }

    /**
     * Disables all three buttons.
     */
    function disableButtons() {
        var buttons = [$("#" + continueId)];
        buttons.forEach(function (button) {
            button.unbind();
            button.attr("disabled", true);
        });
    }

    /**
     * Loads and displays the next part.
     * @param {object} part Which part to load.
     */
    function loadNextPart(part) {
        var built = part.build(true);
        global.ui.appendBeforeFinisher(built, global.ui.genericHeaderId);
        $("#" + part.id).fadeIn(400);
        part.registerListeners();
    }

    /**
     * Adds a listener to the button.
     */
    function registerNextListener() {
        $("#" + continueId).click(function () {
            $(this).addClass("selected");
            disableButtons();
            subController.continue();
            loadNextPart(next);
        });
    }

    // PUBLIC MEMBERS \\        this.public = "test";
    this.id = arguments.callee.name;

    // PUBLIC FUNCTIONS \\      this.publicFunction = function(){};

    /**
     * Builds and returns this part.
     * @param {boolean} invisible If passed and true, will give the entire section a display:none style.
     */
    this.build = function (invisible) {
        if (reqController && ((reqChoice && reqController.get() !== reqChoice) || (!reqChoice && !reqController.continued()))) {
            return "";
        }

        var part = `<div id="${that.id}" ${invisible ? 'style="display:none;"' : ""}>`;
        part += buildContent();
        part += (changeController && changeController.change()) || "";
        part += buildChoice();
        part += `</div>`;
        part += next.build();
        return part;
    };

    /**
     * Registers all the required button listeners for this part.
     */
    this.registerListeners = function () {
        if (reqController && ((reqChoice && reqController.get() !== reqChoice) || (!reqChoice && !reqController.continued()))) {
            return;
        }

        next.registerListeners();

        if (subController.continued()) {
            return;
        }

        registerNextListener();
    };
}

// END scenes\HamletDay2\UndergroundCave\avert\still\eyepatch\UndergroundCaveBasiDoNot.js

// scenes\HamletDay2\UndergroundCave\avert\still\eyepatch\UndergroundCaveBasiTake.js

/**
 * Doggo section of the Underground Cave.
 * @param {UndergroundCaveController} controller The Underground Cave controller.
 */
function UndergroundCaveBasiTake(controller) {
    // PRIVATE MEMBERS \\       var private = "test";
    var that = this;
    var ctrl = controller;

    var reqChoice = UndergroundCaveBasiPatchChoice.TAKE;
    var reqController = ctrl.basiPatch;
    var subController = ctrl.preContinue;
    var changeController = ctrl.basiTake;

    var continueId = arguments.callee.name + "ButtonOne";
    var next = new UndergroundCaveBasiLeave(ctrl);

    // PRIVATE FUNCTIONS \\     function privateFunction(){}

    /**
     * Builds and returns the content of this section.
     * @returns {string} The content.
     */
    function buildContent() {
        var toReturn = `[p]
                            An eyepatch is useless to a kobold like you.
                            Your night vision is already as good as it's ever going to get.
                            Still, you kind of like the way this thing looks.
                            You're not a fan of losing [i]depth perception[/i], though.
                            But it's so [i]stylish[/i]!
                            It'll make you look like a dashing rogue!
                        [/p]
                        [p]
                            After a bit of thinking, you come up with the perfect way to make use of the eyepatch's good looks without hampering your ability to see.
                            Tugging the strap taut, you pull it over your head.
                            Instead of having the piece of leather cover one of your eyes, you let it rest on your forehead,
                            like the diamond of a tiara, or the gemstone of a circlet.
                            Perfect!
                            Your crocodillian friend seems to nod his head up and down in approval,
                            although you're pretty sure he was just scratching his chin against the ground instead of [i]actually[/i] telling you he likes your new look.
                        [/p]`;
        return global.parser.parse(toReturn);
    }

    /**
     * Builds and returns the choice button.
     */
    function buildNextChoice() {
        var disabled = subController.continued() ? "disabled" : "";
        var isSelected = subController.continued();
        var selected = isSelected ? "selected" : "";
        var button = `<button class="button inlinechoice ${selected}" id="${continueId}" ${disabled}>Continue</button>`;
        return button;
    }

    /**
     * Builds and returns the choice of this section.
     * @returns {string} The choice of this section.
     */
    function buildChoice() {
        var choice = `<div class="choicecontainer">`;
        choice += buildNextChoice();
        choice += `</div>`;
        return choice;
    }

    /**
     * Disables all three buttons.
     */
    function disableButtons() {
        var buttons = [$("#" + continueId)];
        buttons.forEach(function (button) {
            button.unbind();
            button.attr("disabled", true);
        });
    }

    /**
     * Loads and displays the next part.
     * @param {object} part Which part to load.
     */
    function loadNextPart(part) {
        var built = part.build(true);
        global.ui.appendBeforeFinisher(built, global.ui.genericHeaderId);
        $("#" + part.id).fadeIn(400);
        part.registerListeners();
    }

    /**
     * Adds a listener to the button.
     */
    function registerNextListener() {
        $("#" + continueId).click(function () {
            $(this).addClass("selected");
            disableButtons();
            subController.continue();
            loadNextPart(next);
        });
    }

    // PUBLIC MEMBERS \\        this.public = "test";
    this.id = arguments.callee.name;

    // PUBLIC FUNCTIONS \\      this.publicFunction = function(){};

    /**
     * Builds and returns this part.
     * @param {boolean} invisible If passed and true, will give the entire section a display:none style.
     */
    this.build = function (invisible) {
        if (reqController && ((reqChoice && reqController.get() !== reqChoice) || (!reqChoice && !reqController.continued()))) {
            return "";
        }

        var part = `<div id="${that.id}" ${invisible ? 'style="display:none;"' : ""}>`;
        part += buildContent();
        part += (changeController && changeController.change()) || "";
        part += buildChoice();
        part += `</div>`;
        part += next.build();
        return part;
    };

    /**
     * Registers all the required button listeners for this part.
     */
    this.registerListeners = function () {
        if (reqController && ((reqChoice && reqController.get() !== reqChoice) || (!reqChoice && !reqController.continued()))) {
            return;
        }

        next.registerListeners();

        if (subController.continued()) {
            return;
        }

        registerNextListener();
    };
}

// END scenes\HamletDay2\UndergroundCave\avert\still\eyepatch\UndergroundCaveBasiTake.js

// scenes\HamletDay2\UndergroundCave\avert\still\eyepatch\UndergroundCaveBasiPatch.js

/**
 * Doggo section of the Underground Cave.
 * @param {UndergroundCaveController} controller The Underground Cave controller.
 */
function UndergroundCaveBasiPatch(controller) {
    // PRIVATE MEMBERS \\       var private = "test";
    var that = this;
    var ctrl = controller;

    var reqChoice = false;
    var reqController = ctrl.prePatch;
    var subController = ctrl.basiPatch;
    var changeController = false;

    var firstId = arguments.callee.name + "ButtonOne";
    var secondId = arguments.callee.name + "ButtonTwo";

    var firstNext = new UndergroundCaveBasiTake(ctrl);
    var secondNext = new UndergroundCaveBasiDoNot(ctrl);

    var firstChoice = UndergroundCaveBasiPatchChoice.TAKE;
    var secondChoice = UndergroundCaveBasiPatchChoice.DO_NOT;

    // PRIVATE FUNCTIONS \\     function privateFunction(){}

    /**
     * Builds and returns the content of this section.
     * @returns {string} The content.
     */
    function buildContent() {
        var headrubs = ctrl.doggo.get() === ctrl.choices.doggo.PET;
        var toReturn = `[p]
                            With the basilisk befriended, you decide it's time to leave this place.
                            Signalling for the beast to follow you via a simple gesture,
                            you begin to follow the water, to what you hope will be your freedom.
                            The creature seems to understand your intentions.
                            It happily crawls alongside you, like a pet dog being taken for a walk.
                        [/p]
                        [p]
                            You spend a few minutes walking,
                            your gaze shifting between the bumpy ground in front of you,
                            and your pet basilisk at your side.
                            Suddenly, you notice something on the ground.
                            A small, black patch, with a strap attached to it.
                            You reach down to pick it up, your crocodillian friend getting excited,
                            mistakenly thinking it's about to get its head rubbed${headrubs ? ` again` : ``}.
                            You can almost feel the beast's disappointment when you, instead of patting it,
                            pick up an old ${global.kobold.inventory.createItemWithTooltip(new Eyepatch)} off the ground.
                        [/p]
                        [p]
                            You inspect the item for a moment.
                            Odd.
                            This cave must have been used by river-smugglers in the past or something.
                            You'd search around for hidden treasures or stashed booties, but you feel like you've had enough adventure for now.
                        [/p]`;

        return global.parser.parse(toReturn);
    }

    /**
     * Builds and returns the choice button.
     */
    function buildFirstChoice() {
        var disabled = subController.has() ? "disabled" : "";
        var isSelected = subController.get() === firstChoice;
        var selected = isSelected ? "selected" : "";
        var button = `<button class="button inlinechoice ${selected}" id="${firstId}" ${disabled}>Take it</button>`;

        var tooltip = global.parser.parse(`Put on the eyepatch.`);
        var popupContainer = global.ui.makeToolTip(button, tooltip, false, false, "width: 190px;");
        // Re-wrap with proper positioning.
        button = `<div class="inlinechoice">`;
        button += popupContainer;
        button += `</div>`;

        return button;
    }

    /**
     * Builds and returns the choice button.
     */
    function buildSecondChoice() {
        var disabled = subController.has() ? "disabled" : "";
        var isSelected = subController.get() === secondChoice;
        var selected = isSelected ? "selected" : "";
        var button = `<button class="button inlinechoice ${selected}" id="${secondId}" ${disabled}>Do not</button>`;

        var tooltip = global.parser.parse(`Leave it.`);
        var popupContainer = global.ui.makeToolTip(button, tooltip, false, false, "width: 190px;");
        // Re-wrap with proper positioning.
        button = `<div class="inlinechoice">`;
        button += popupContainer;
        button += `</div>`;

        return button;
    }

    /**
     * Builds and returns the choice of this section.
     * @returns {string} The choice of this section.
     */
    function buildChoice() {
        var choice = `<div class="choicecontainer"><div class="inlinechoiceheader">You:</div>`;
        choice += buildFirstChoice();
        choice += `<hr class="inlinechoiceseparator">`;
        choice += buildSecondChoice();
        choice += `</div>`;
        return choice;
    }

    /**
     * Disables all three buttons.
     */
    function disableButtons() {
        var buttons = [$("#" + firstId), $("#" + secondId)];
        buttons.forEach(function (button) {
            button.unbind();
            button.attr("disabled", true);
        });
    }

    /**
     * Loads and displays the next part.
     * @param {object} part Which part to load.
     */
    function loadNextPart(part) {
        var built = part.build(true);
        global.ui.appendBeforeFinisher(built, global.ui.genericHeaderId);
        $("#" + part.id).fadeIn(400);
        part.registerListeners();
    }

    /**
     * Adds a listener to the button.
     */
    function registerFirstListener() {
        $("#" + firstId).click(function () {
            $(this).addClass("selected");
            disableButtons();
            subController.set(firstChoice);
            loadNextPart(firstNext);
        });
    }

    /**
     * Adds a listener to the button.
     */
    function registerSecondListener() {
        $("#" + secondId).click(function () {
            $(this).addClass("selected");
            disableButtons();
            subController.set(secondChoice);
            loadNextPart(secondNext);
        });
    }

    // PUBLIC MEMBERS \\        this.public = "test";
    this.id = arguments.callee.name;

    // PUBLIC FUNCTIONS \\      this.publicFunction = function(){};

    /**
     * Builds and returns this part.
     * @param {boolean} invisible If passed and true, will give the entire section a display:none style.
     */
    this.build = function (invisible) {
        if (reqController && ((reqChoice && reqController.get() !== reqChoice) || (!reqChoice && !reqController.continued()))) {
            return "";
        }

        var part = `<div id="${that.id}" ${invisible ? 'style="display:none;"' : ""}>`;
        part += buildContent();
        part += (changeController && changeController.change()) || "";
        part += buildChoice();
        part += `</div>`;
        part += firstNext.build();
        part += secondNext.build();
        return part;
    };

    /**
     * Registers all the required button listeners for this part.
     */
    this.registerListeners = function () {
        if (reqController && ((reqChoice && reqController.get() !== reqChoice) || (!reqChoice && !reqController.continued()))) {
            return;
        }

        firstNext.registerListeners();
        secondNext.registerListeners();

        if (subController.has()) {
            return;
        }

        registerFirstListener();
        registerSecondListener();
    };
}

var UndergroundCaveBasiPatchChoice = {
    TAKE: 1,
    DO_NOT: 2
};

// END scenes\HamletDay2\UndergroundCave\avert\still\eyepatch\UndergroundCaveBasiPatch.js

// scenes\HamletDay2\UndergroundCave\avert\still\pet\UndergroundCaveScratch.js

/**
 * Doggo section of the Underground Cave.
 * @param {UndergroundCaveController} controller The Underground Cave controller.
 */
function UndergroundCaveScratch(controller) {
    // PRIVATE MEMBERS \\       var private = "test";
    var that = this;
    var ctrl = controller;

    var reqChoice = UndergroundCavePetChoice.SCRATCH;
    var reqController = ctrl.pet;
    var subController = ctrl.prePatch;
    var changeController = ctrl.scratch;

    var continueId = arguments.callee.name + "ButtonOne";
    var next = new UndergroundCaveBasiPatch(ctrl);

    // PRIVATE FUNCTIONS \\     function privateFunction(){}

    /**
     * Builds and returns the content of this section.
     * @returns {string} The content.
     */
    function buildContent() {
        var toReturn = `[p]
                            While you give the beast one more pat on its head, you move your other hand towards its chin.
                            Partly with your claws, partly with your fingers, and partly with the palm of your hand,
                            you begin to gently rub the bottom of the fearsome creature's maw.
                            It [b]definitely[/b] likes this, the crocodillian's incessant, cat-like purring intensifying.
                            It lifts its head just a little bit higher, its maw opening slightly out of sheer delight.
                        [/p]
                        [p]
                            You intensively pet the basilisk's head, while continually scratching underneath its muzzle,
                            giving it the most thorough rubbing you bet the beast has ever had!
                            After nearly an entire minute of working your hands along its rocky scales, you finally relent.
                            Pulling back, the creature keeps its head lifted, seemingly wanting more.
                            A few moments pass, and then its eyes open once more.
                            Realizing it's not being pet anymore, the basilisk submissively lies down at your feet.
                        [/p]
                        [p]
                            [c]
                                [b]You have befriended the basilisk![/b]
                            [/c]
                        [/p]`;
        return global.parser.parse(toReturn);
    }

    /**
     * Builds and returns the choice button.
     */
    function buildNextChoice() {
        var disabled = subController.continued() ? "disabled" : "";
        var isSelected = subController.continued();
        var selected = isSelected ? "selected" : "";
        var button = `<button class="button inlinechoice ${selected}" id="${continueId}" ${disabled}>Continue</button>`;
        return button;
    }

    /**
     * Builds and returns the choice of this section.
     * @returns {string} The choice of this section.
     */
    function buildChoice() {
        var choice = `<div class="choicecontainer">`;
        choice += buildNextChoice();
        choice += `</div>`;
        return choice;
    }

    /**
     * Disables all three buttons.
     */
    function disableButtons() {
        var buttons = [$("#" + continueId)];
        buttons.forEach(function (button) {
            button.unbind();
            button.attr("disabled", true);
        });
    }

    /**
     * Loads and displays the next part.
     * @param {object} part Which part to load.
     */
    function loadNextPart(part) {
        var built = part.build(true);
        global.ui.appendBeforeFinisher(built, global.ui.genericHeaderId);
        $("#" + part.id).fadeIn(400);
        part.registerListeners();
    }

    /**
     * Adds a listener to the button.
     */
    function registerNextListener() {
        $("#" + continueId).click(function () {
            $(this).addClass("selected");
            disableButtons();
            subController.continue();
            loadNextPart(next);
        });
    }

    // PUBLIC MEMBERS \\        this.public = "test";
    this.id = arguments.callee.name;

    // PUBLIC FUNCTIONS \\      this.publicFunction = function(){};

    /**
     * Builds and returns this part.
     * @param {boolean} invisible If passed and true, will give the entire section a display:none style.
     */
    this.build = function (invisible) {
        if (reqController && ((reqChoice && reqController.get() !== reqChoice) || (!reqChoice && !reqController.continued()))) {
            return "";
        }

        var part = `<div id="${that.id}" ${invisible ? 'style="display:none;"' : ""}>`;
        part += buildContent();
        part += (changeController && changeController.change()) || "";
        part += buildChoice();
        part += `</div>`;
        part += next.build();
        return part;
    };

    /**
     * Registers all the required button listeners for this part.
     */
    this.registerListeners = function () {
        if (reqController && ((reqChoice && reqController.get() !== reqChoice) || (!reqChoice && !reqController.continued()))) {
            return;
        }

        next.registerListeners();

        if (subController.continued()) {
            return;
        }

        registerNextListener();
    };
}

// END scenes\HamletDay2\UndergroundCave\avert\still\pet\UndergroundCaveScratch.js

// scenes\HamletDay2\UndergroundCave\avert\still\pet\UndergroundCaveStrikeLoot.js

/**
 * Doggo section of the Underground Cave.
 * @param {UndergroundCaveController} controller The Underground Cave controller.
 */
function UndergroundCaveStrikeLoot(controller) {
    // PRIVATE MEMBERS \\       var private = "test";
    var that = this;
    var ctrl = controller;

    var reqChoice = false;
    var reqController = ctrl.preContinue;
    var changeController = ctrl.throatLoot;

    var continueId = arguments.callee.name + "ButtonOne";

    // PRIVATE FUNCTIONS \\     function privateFunction(){}

    /**
     * Builds and returns the content of this section.
     * @returns {string} The content.
     */
    function buildContent() {
        var toReturn = `[p]
                            You did it!
                            You killed a deadly monster, all by yourself!
                            Just like a knight would do!
                            Somehow, you don't feel very [i]knightly[/i], though.
                            You should be proud of yourself, but for some reason, you aren't.
                            Maybe your actions weren't as [i]chivalrous[/i] as you would have liked,
                            but it's the outcome that matters, and not how you achieved it, right?
                            The ends justify the means.
                        [/p]
                        [p]
                            But then again, the basilisk was just minding its own business.
                            It wasn't hurting anyone.
                            It rubbed up against you and even let you pat its head.
                            Now you're confused.
                            Did you do the right thing?
                        [/p]
                        [p]
                            You honestly don't know anymore.
                            Does it even matter?
                            What's done is done.
                            If you hadn't killed the creature, some pompous knight in shining armor
                            -- with nothing left to prove, neither to himself, nor to the world --
                            would have strolled into this cave to add another tally to his already impressive list of slain monsters.
                            For someone properly armed and armored, this would have been a [b]chore[/b], a menial task barely even worthy of mention.
                            But for you, this is a feat you'll remember until the day you die.
                        [/p]
                        [p]
                            Your conviction bolstered, you wait for a few more minutes to make sure it's really [b]dead[/b], before approaching the giant lizard once again.
                            Kneeling besides it, you figure it's time to take a trophy.
                            Something to remember this day by.
                            Something you can show to people, so they'll believe you when you tell them you singlehandedly killed a basilisk.
                            But what?
                        [/p]
                        [p]
                            While pondering, you run one of your hands over the deceased basilisk's back.
                            Some of its scales seem to be rather [i]loose[/i].
                            You take hold of one with both of your hands, and with surprising ease, you manage to [b]tear[/b] the scale from the monster's backside.
                            Like plucking a chicken.
                            You repeat the process a couple of times,
                            until you have collected a suitable handful of ${global.kobold.inventory.createItemWithTooltip(new BasiliskScales())}
                            to take with as your prize for ridding the world of this horrible monstrosity.
                        [/p]
                        [p]
                            Your trophies collected, you decide it's time to find a way out of the cave.
                            Following the river-branch should lead you to some kind of exit.
                            Without the threat of the basilisk around, you don't even need to [b]swim[/b].
                            You leisurely stroll alongside the water, until daylight comes into sight.
                            As you expected: the water was a stale branch of the river!
                            Climbing out of the cave, you sit your butt down on the riverside dirt, and take a breather.
                            You feel like you've earned one.
                        [/p]
                        [p]
                            You've defied death more than once today.
                            You should consider yourself lucky to be alive.
                            The trip into the well was a harrowing experience.
                            You nearly got crushed, almost drowned, and after all of that, you managed to kill a basilisk.
                            It might not have been the most [i]honorable[/i] way of slaying the beast, but it was slain nonetheless.
                        [/p]
                        [p]
                            Besides the ${global.kobold.inventory.createItemWithTooltip(new BasiliskScales())} you [i]harvested[/i],
                            you've gained a few awesome stories to tell once you've grown old and wise.
                            Stories like the ones Seki used to tell you when you were little.
                            You went through all that trouble to get your mind off of him, and here you are reminiscing once more.
                            You just can't help yourself from clinging to times long gone.
                            Things were so much simpler back then.
                            You miss those days.
                        [/p]
                        [p]
                            The sun is slowly starting to set.
                            You drag yourself to your feet.
                            It's time to go.
                            Varanar isn't [i]that[/i] far off.
                            If your legs don't give out from underneath you, you might still make it there before nightfall.
                        [/p]`;

        return global.parser.parse(toReturn);
    }

    /**
     * Builds and returns the continue button.
     */
    function buildChoice() {
        var disabled = ctrl.continued();
        var choice = `<div class="choicecontainer">`;
        choice += `<button class="button bigbutton continuebutton" id="${continueId}" ${disabled ? "disabled" : ""}>`;
        choice += `Continue &gt;&gt`;
        choice += `</button>`;
        choice += `</div>`;
        return choice;
    }

    /**
     * Disables all three buttons.
     */
    function disableButtons() {
        var buttons = [$("#" + continueId)];
        buttons.forEach(function (button) {
            button.unbind();
            button.attr("disabled", true);
        });
    }

    /**
     * Loads and displays the next scene.
     * @param {string} sceneName Name of the scene to load.
     * @param {string} folder Folder of the scene to load.
     */
    function loadNextPart(sceneName, folder) {
        global.ui.fadeOutContent(function () {
            global.sceneEnd();
            global.sceneLoader.loadScene(sceneName, folder);
        });
    }

    /**
     * Adds a listener to the button.
     */
    function registerContinueListener() {
        $("#" + continueId).click(function () {
            $(this).addClass("selected");
            disableButtons();
            ctrl.continue();
            loadNextPart(ctrl.nextSceneName, ctrl.nextFolderName);
        });
    }

    // PUBLIC MEMBERS \\        this.public = "test";
    this.id = arguments.callee.name;

    // PUBLIC FUNCTIONS \\      this.publicFunction = function(){};

    /**
     * Builds and returns this part.
     * @param {boolean} invisible If passed and true, will give the entire section a display:none style.
     */
    this.build = function (invisible) {
        if (reqController && ((reqChoice && reqController.get() !== reqChoice) || (!reqChoice && !reqController.continued()))) {
            return "";
        }

        ctrl.bgm.stopLoop();
        global.ui.applyTheme("hamlet_day");
        var part = `<div id="${that.id}" ${invisible ? 'style="display:none;"' : ""}>`;
        part += buildContent();
        part += (changeController && changeController.change()) || "";
        part += buildChoice();
        if (!ctrl.nextSceneReady) {
            part += `<span class="todo">There is no content beyond this point.</span>`;
        }
        part += `</div>`;
        return part;
    };

    /**
     * Registers all the required button listeners for this part.
     */
    this.registerListeners = function () {
        if (reqController && ((reqChoice && reqController.get() !== reqChoice) || (!reqChoice && !reqController.continued()))) {
            return;
        }

        if (ctrl.continued()) {
            return;
        }

        if (ctrl.nextSceneReady) {
            registerContinueListener();
        }
    };
}

// END scenes\HamletDay2\UndergroundCave\avert\still\pet\UndergroundCaveStrikeLoot.js

// scenes\HamletDay2\UndergroundCave\avert\still\pet\UndergroundCaveStrike.js

/**
 * Doggo section of the Underground Cave.
 * @param {UndergroundCaveController} controller The Underground Cave controller.
 */
function UndergroundCaveStrike(controller) {
    // PRIVATE MEMBERS \\       var private = "test";
    var that = this;
    var ctrl = controller;

    var reqChoice = UndergroundCavePetChoice.THROAT;
    var reqController = ctrl.pet;
    var subController = ctrl.preContinue;
    var changeController = ctrl.throat;

    var continueId = arguments.callee.name + "ButtonOne";
    var next = new UndergroundCaveStrikeLoot(ctrl);

    // PRIVATE FUNCTIONS \\     function privateFunction(){}

    /**
     * Builds and returns the content of this section.
     * @returns {string} The content.
     */
    function buildContent() {
        global.kobold.history.shared.well.basiliskKilled = true;
        var toReturn = `[p]
                            Seeing an opportunity for greatness, you decide to act on it.
                            While you give the creature one more pat on its head, you move your other hand onto its throat.
                            Expecting more pleasant rubbing,
                            the basilisk's knows not what to do as you instead sink your sharp claws into its tender throat,
                            and rake open its windpipe in a single vicious [b]tear[/b].
                        [/p]
                        [p]
                            The monster's eyes shoot open wide.
                            It wildly thrashes its limbs around, hoping to mangle you, to take you down along with it,
                            but you manage to avoid most of its rage by taking a quick step back.
                            While it continues to blindly rampage about, despite you having long cleared its imminent vicinity,
                            the basilisk's struggles soon die down.
                            Running out of air, its body slumps lifelessly down on the ground, in a pool of its own blood.
                            After one last, bloody gurgle, the big crocodillian closes its eyes, and drifts away into the afterlife.
                        [/p]
                        [p]
                            [c]
                                [b]You have killed the basilisk![/b]
                            [/c]
                        [/p]`;
        return global.parser.parse(toReturn);
    }

    /**
     * Builds and returns the choice button.
     */
    function buildNextChoice() {
        var disabled = subController.continued() ? "disabled" : "";
        var isSelected = subController.continued();
        var selected = isSelected ? "selected" : "";
        var button = `<button class="button inlinechoice ${selected}" id="${continueId}" ${disabled}>Continue</button>`;
        return button;
    }

    /**
     * Builds and returns the choice of this section.
     * @returns {string} The choice of this section.
     */
    function buildChoice() {
        var choice = `<div class="choicecontainer">`;
        choice += buildNextChoice();
        choice += `</div>`;
        return choice;
    }

    /**
     * Disables all three buttons.
     */
    function disableButtons() {
        var buttons = [$("#" + continueId)];
        buttons.forEach(function (button) {
            button.unbind();
            button.attr("disabled", true);
        });
    }

    /**
     * Loads and displays the next part.
     * @param {object} part Which part to load.
     */
    function loadNextPart(part) {
        var built = part.build(true);
        global.ui.appendBeforeFinisher(built, global.ui.genericHeaderId);
        $("#" + part.id).fadeIn(400);
        part.registerListeners();
    }

    /**
     * Adds a listener to the button.
     */
    function registerNextListener() {
        $("#" + continueId).click(function () {
            $(this).addClass("selected");
            disableButtons();
            subController.continue();
            loadNextPart(next);
        });
    }

    // PUBLIC MEMBERS \\        this.public = "test";
    this.id = arguments.callee.name;

    // PUBLIC FUNCTIONS \\      this.publicFunction = function(){};

    /**
     * Builds and returns this part.
     * @param {boolean} invisible If passed and true, will give the entire section a display:none style.
     */
    this.build = function (invisible) {
        if (reqController && ((reqChoice && reqController.get() !== reqChoice) || (!reqChoice && !reqController.continued()))) {
            return "";
        }

        var part = `<div id="${that.id}" ${invisible ? 'style="display:none;"' : ""}>`;
        part += buildContent();
        part += (changeController && changeController.change()) || "";
        part += buildChoice();
        part += `</div>`;
        part += next.build();
        return part;
    };

    /**
     * Registers all the required button listeners for this part.
     */
    this.registerListeners = function () {
        if (reqController && ((reqChoice && reqController.get() !== reqChoice) || (!reqChoice && !reqController.continued()))) {
            return;
        }

        next.registerListeners();

        if (subController.continued()) {
            return;
        }

        registerNextListener();
    };
}

// END scenes\HamletDay2\UndergroundCave\avert\still\pet\UndergroundCaveStrike.js

// scenes\HamletDay2\UndergroundCave\avert\still\pet\UndergroundCavePet.js

/**
 * Doggo section of the Underground Cave.
 * @param {UndergroundCaveController} controller The Underground Cave controller.
 */
function UndergroundCavePet(controller) {
    // PRIVATE MEMBERS \\       var private = "test";
    var that = this;
    var ctrl = controller;

    var reqChoice = ctrl.choices.doggo.PET;
    var reqController = ctrl.doggo;
    var subController = ctrl.pet;
    var changeController = false;

    var firstId = arguments.callee.name + "ButtonOne";
    var secondId = arguments.callee.name + "ButtonTwo";

    var firstNext = new UndergroundCaveStrike(ctrl);
    var secondNext = new UndergroundCaveScratch(ctrl);

    var firstChoice = UndergroundCavePetChoice.THROAT;
    var secondChoice = UndergroundCavePetChoice.SCRATCH;

    // PRIVATE FUNCTIONS \\     function privateFunction(){}

    /**
     * Builds and returns the content of this section.
     * @returns {string} The content.
     */
    function buildContent() {
        var toReturn = `[p]
                            Still wary of the beast, you decide to try something.
                            You wait for the basilisk to finish circling around you, then you slowly reach for its head,
                            calmly laying your palm down atop of the hard, stone-like surface that constitutes his forehead.
                            The creature stops dead in its tracks, closing its eyes and uttering a deep rumbling noise remotely reminiscent of a [i]purr[/i].
                        [/p]
                        [p]
                            Taking the throaty sound as a request for more, you rub your hand along the top of the basilisk's head.
                            It [b]definitely[/b] seems to be enjoying this.
                            One of its hind legs starts to scrape against the floor, like a thumping little rabbit.
                            You go in for a second stroke, and then a third.
                            Fully relaxed, the big stony lizard raises its head, exposing the most fragile part of its entire body for some affectionate attention.
                        [/p]`;

        return global.parser.parse(toReturn);
    }

    /**
     * Builds and returns the choice button.
     */
    function buildFirstChoice() {
        var disabled = subController.has() ? "disabled" : "";
        var isSelected = subController.get() === firstChoice;
        var selected = isSelected ? "selected" : "";
        var button = `<button class="button inlinechoice ${selected}" id="${firstId}" ${disabled}>Strike throat</button>`;

        var tooltip = global.parser.parse(`The beast has exposed a weak spot. If you strike it now, you might be able to fell it in one swift blow.`);
        var popupContainer = global.ui.makeToolTip(button, tooltip, false, false, "width: 190px;");
        // Re-wrap with proper positioning.
        button = `<div class="inlinechoice">`;
        button += popupContainer;
        button += `</div>`;

        return button;
    }

    /**
     * Builds and returns the choice button.
     */
    function buildSecondChoice() {
        var disabled = subController.has() ? "disabled" : "";
        var isSelected = subController.get() === secondChoice;
        var selected = isSelected ? "selected" : "";
        var button = `<button class="button inlinechoice ${selected}" id="${secondId}" ${disabled}>Scratch chin</button>`;

        var tooltip = global.parser.parse(`Rub the basilisk's chin.`);
        var popupContainer = global.ui.makeToolTip(button, tooltip, false, false, "width: 190px;");
        // Re-wrap with proper positioning.
        button = `<div class="inlinechoice">`;
        button += popupContainer;
        button += `</div>`;

        return button;
    }

    /**
     * Builds and returns the choice of this section.
     * @returns {string} The choice of this section.
     */
    function buildChoice() {
        var choice = `<div class="choicecontainer"><div class="inlinechoiceheader">You:</div>`;
        choice += buildFirstChoice();
        choice += `<hr class="inlinechoiceseparator">`;
        choice += buildSecondChoice();
        choice += `</div>`;
        return choice;
    }

    /**
     * Disables all three buttons.
     */
    function disableButtons() {
        var buttons = [$("#" + firstId), $("#" + secondId)];
        buttons.forEach(function (button) {
            button.unbind();
            button.attr("disabled", true);
        });
    }

    /**
     * Loads and displays the next part.
     * @param {object} part Which part to load.
     */
    function loadNextPart(part) {
        var built = part.build(true);
        global.ui.appendBeforeFinisher(built, global.ui.genericHeaderId);
        $("#" + part.id).fadeIn(400);
        part.registerListeners();
    }

    /**
     * Adds a listener to the button.
     */
    function registerFirstListener() {
        $("#" + firstId).click(function () {
            $(this).addClass("selected");
            disableButtons();
            subController.set(firstChoice);
            loadNextPart(firstNext);
        });
    }

    /**
     * Adds a listener to the button.
     */
    function registerSecondListener() {
        $("#" + secondId).click(function () {
            $(this).addClass("selected");
            disableButtons();
            subController.set(secondChoice);
            loadNextPart(secondNext);
        });
    }

    // PUBLIC MEMBERS \\        this.public = "test";
    this.id = arguments.callee.name;

    // PUBLIC FUNCTIONS \\      this.publicFunction = function(){};

    /**
     * Builds and returns this part.
     * @param {boolean} invisible If passed and true, will give the entire section a display:none style.
     */
    this.build = function (invisible) {
        if (reqController && ((reqChoice && reqController.get() !== reqChoice) || (!reqChoice && !reqController.continued()))) {
            return "";
        }

        var part = `<div id="${that.id}" ${invisible ? 'style="display:none;"' : ""}>`;
        part += buildContent();
        part += (changeController && changeController.change()) || "";
        part += buildChoice();
        part += `</div>`;
        part += firstNext.build();
        part += secondNext.build();
        return part;
    };

    /**
     * Registers all the required button listeners for this part.
     */
    this.registerListeners = function () {
        if (reqController && ((reqChoice && reqController.get() !== reqChoice) || (!reqChoice && !reqController.continued()))) {
            return;
        }

        firstNext.registerListeners();
        secondNext.registerListeners();

        if (subController.has()) {
            return;
        }

        registerFirstListener();
        registerSecondListener();
    };
}

var UndergroundCavePetChoice = {
    THROAT: 1,
    SCRATCH: 2
};

// END scenes\HamletDay2\UndergroundCave\avert\still\pet\UndergroundCavePet.js

// scenes\HamletDay2\UndergroundCave\avert\still\fetch\UndergroundCaveFetch.js

/**
 * Doggo section of the Underground Cave.
 * @param {UndergroundCaveController} controller The Underground Cave controller.
 */
function UndergroundCaveFetch(controller) {
    // PRIVATE MEMBERS \\       var private = "test";
    var that = this;
    var ctrl = controller;

    var reqChoice = ctrl.choices.doggo.FETCH;
    var reqController = ctrl.doggo;
    var subController = ctrl.prePatch;
    var changeController = ctrl.fetch;

    var continueId = arguments.callee.name + "ButtonOne";
    var next = new UndergroundCaveBasiPatch(ctrl);

    // PRIVATE FUNCTIONS \\     function privateFunction(){}

    /**
     * Builds and returns the content of this section.
     * @returns {string} The content.
     */
    function buildContent() {
        var branch = ctrl.misc.weapon();
        var toReturn = `[p]
                            Still wary of the beast, you decide to try something.
                            You slowly reach for your ${global.kobold.inventory.createItemWithTooltip(branch)} while the basilisk circles around you.
                            As it reaches your front-end once more, you prudently wave the stick in front of its face.
                            The creature seems captivated, its eyes following the branch's every move.
                            Having captured its attention, you throw your ${global.kobold.inventory.createItemWithTooltip(branch)} as far as you can.
                        [/p]
                        [p]
                            The basilisk instantly gives chase, bursting out into a sprint,
                            moving far faster than you'd have imagined a beast of its [i]size[/i] to be capable of,
                            let alone one completely covered in weighty stone scales.
                            What an odd creature.
                            It [i]acts[/i] like a mixture between a dog and a cat,
                            but it [b]looks[/b] like an oversized alligator with a bunch of aesthetically-shaped stones attached to its back.
                        [/p]
                        [p]
                            Arriving at the stick, the massive lizard comes to a halt, its massive talons digging into the rock-like ground itself to slow it down.
                            Curious, you curl your toes in an attempt to mimic its motions,
                            yet your own claws can barely even [b]scratch[/b] the stone surface you're standing on.
                            It must be [b]really[/b] strong.
                            Or maybe it has razor-sharp talons.
                            Or both.
                        [/p]
                        [p]
                            The basilisk, having stopped directly in front of the branch you threw, is [i]staring[/i] at it.
                            At first, you wonder what the crocodilian is doing, but then you notice the stick slowly starting to change.
                            Its color changes from tree-brown to a deep grey, while simultaneously its texture visibly alters from vibrant wood to dull stone.
                            The creature is petrifying your weapon!
                        [/p]
                        [p]
                            The branch fully turned to stone, the lizard takes in its mouth, and happily carries it back over to you,
                            its tail wagging excitedly from side to side while dragging along the rock-floor.
                            You gingerly take your new, [i]enhanced[/i] club from the returning basilisk's mouth.
                            While a bit more [i]clumsy[/i] to wield,
                            you suppose the combined power of wood and stone make for a far more capable weapon than what you had before.
                            Once it realizes you don't intend on throwing the now-far-too-heavy stick a second time,
                            the basilisk submissively lies down at your feet.
                        [/p]
                        [p]
                            [c]
                                [b]You have befriended the basilisk![/b]
                            [/c]
                        [/p]`;
        return global.parser.parse(toReturn);
    }

    /**
     * Builds and returns the choice button.
     */
    function buildNextChoice() {
        var disabled = subController.continued() ? "disabled" : "";
        var isSelected = subController.continued();
        var selected = isSelected ? "selected" : "";
        var button = `<button class="button inlinechoice ${selected}" id="${continueId}" ${disabled}>Continue</button>`;
        return button;
    }

    /**
     * Builds and returns the choice of this section.
     * @returns {string} The choice of this section.
     */
    function buildChoice() {
        var choice = `<div class="choicecontainer">`;
        choice += buildNextChoice();
        choice += `</div>`;
        return choice;
    }

    /**
     * Disables all three buttons.
     */
    function disableButtons() {
        var buttons = [$("#" + continueId)];
        buttons.forEach(function (button) {
            button.unbind();
            button.attr("disabled", true);
        });
    }

    /**
     * Loads and displays the next part.
     * @param {object} part Which part to load.
     */
    function loadNextPart(part) {
        var built = part.build(true);
        global.ui.appendBeforeFinisher(built, global.ui.genericHeaderId);
        $("#" + part.id).fadeIn(400);
        part.registerListeners();
    }

    /**
     * Adds a listener to the button.
     */
    function registerNextListener() {
        $("#" + continueId).click(function () {
            $(this).addClass("selected");
            disableButtons();
            subController.continue();
            loadNextPart(next);
        });
    }

    // PUBLIC MEMBERS \\        this.public = "test";
    this.id = arguments.callee.name;

    // PUBLIC FUNCTIONS \\      this.publicFunction = function(){};

    /**
     * Builds and returns this part.
     * @param {boolean} invisible If passed and true, will give the entire section a display:none style.
     */
    this.build = function (invisible) {
        if (reqController && ((reqChoice && reqController.get() !== reqChoice) || (!reqChoice && !reqController.continued()))) {
            return "";
        }

        var part = `<div id="${that.id}" ${invisible ? 'style="display:none;"' : ""}>`;
        part += buildContent();
        part += (changeController && changeController.change()) || "";
        part += buildChoice();
        part += `</div>`;
        part += next.build();
        return part;
    };

    /**
     * Registers all the required button listeners for this part.
     */
    this.registerListeners = function () {
        if (reqController && ((reqChoice && reqController.get() !== reqChoice) || (!reqChoice && !reqController.continued()))) {
            return;
        }

        next.registerListeners();

        if (subController.continued()) {
            return;
        }

        registerNextListener();
    };
}

// END scenes\HamletDay2\UndergroundCave\avert\still\fetch\UndergroundCaveFetch.js

// scenes\HamletDay2\UndergroundCave\avert\still\feed\UndergroundCaveFeed.js

/**
 * Doggo section of the Underground Cave.
 * @param {UndergroundCaveController} controller The Underground Cave controller.
 */
function UndergroundCaveFeed(controller) {
    // PRIVATE MEMBERS \\       var private = "test";
    var that = this;
    var ctrl = controller;

    var reqChoice = ctrl.choices.doggo.FEED;
    var reqController = ctrl.doggo;
    var subController = ctrl.prePatch;
    var changeController = ctrl.feed;

    var continueId = arguments.callee.name + "ButtonOne";
    var next = new UndergroundCaveBasiPatch(ctrl);

    // PRIVATE FUNCTIONS \\     function privateFunction(){}

    /**
     * Builds and returns the content of this section.
     * @returns {string} The content.
     */
    function buildContent() {
        var toReturn = `[p]
                            Still wary of the beast, you decide to try something.
                            You slowly reach for your ${global.kobold.inventory.createItemWithTooltip(new HeartyMeal())} while the basilisk circles around you.
                            As it reaches your front-end once more, you prudently set the basket down on the floor.
                            The creature seems captivated, its tongue rapidly flicking in and out of its mouth.
                            It turns its head towards the basket.
                            It can [b]smell[/b] the food.
                        [/p]
                        [p]
                            Having captured the crocodilian's attention, you open the lid of the wooden container.
                            The beast immediately [b]pounces[/b] on the basket, [b]ramming[/b] its head inside and [b]feasting[/b] on the soggy contents within,
                            like it's been starved for [b]weeks[/b].
                            Then again, maybe this is just how basilisks eat.
                            From what you can gather, they are [b]fierce[/b] creatures.
                            If it really was hungry, you have no doubt it would be eating [b]you[/b] right now.
                        [/p]
                        [p]
                            The contents of the ${global.kobold.inventory.createItemWithTooltip(new HeartyMeal())} are devoured wholly in less than a minute,
                            the monster [b]gorging[/b] and [b]feasting[/b] on them like there's no tomorrow.
                            At one point, you even fear it's going to eat the basket itself, the loud crunching of wood reverberating across the cavern.
                            Luckily, the beast seems smart enough to realize that's [b]not[/b] part of its meal.
                            It must have [i]accidentally[/i] chomped it a little.
                            Well, as long as it doesn't [i]accidentally[/i] chomp [b]you[/b], you're fine with that.
                        [/p]
                        [p]
                            Once finished with its meal, the basilisk retracts its face from the basket.
                            It looks up at you, as though begging for more, its forked tongue picking off some of the scraps clinging to the gaps in between his teeth.
                            Realizing you're out of food, it shoves the slightly damaged wooden basket to the side.
                            Taking the food container's place, the beast submissively lays itself down at your feet.
                        [/p]
                        [p]
                            [c]
                                [b]You have befriended the basilisk![/b]
                            [/c]
                        [/p]`;
        return global.parser.parse(toReturn);
    }

    /**
     * Builds and returns the choice button.
     */
    function buildNextChoice() {
        var disabled = subController.continued() ? "disabled" : "";
        var isSelected = subController.continued();
        var selected = isSelected ? "selected" : "";
        var button = `<button class="button inlinechoice ${selected}" id="${continueId}" ${disabled}>Continue</button>`;
        return button;
    }

    /**
     * Builds and returns the choice of this section.
     * @returns {string} The choice of this section.
     */
    function buildChoice() {
        var choice = `<div class="choicecontainer">`;
        choice += buildNextChoice();
        choice += `</div>`;
        return choice;
    }

    /**
     * Disables all three buttons.
     */
    function disableButtons() {
        var buttons = [$("#" + continueId)];
        buttons.forEach(function (button) {
            button.unbind();
            button.attr("disabled", true);
        });
    }

    /**
     * Loads and displays the next part.
     * @param {object} part Which part to load.
     */
    function loadNextPart(part) {
        var built = part.build(true);
        global.ui.appendBeforeFinisher(built, global.ui.genericHeaderId);
        $("#" + part.id).fadeIn(400);
        part.registerListeners();
    }

    /**
     * Adds a listener to the button.
     */
    function registerNextListener() {
        $("#" + continueId).click(function () {
            $(this).addClass("selected");
            disableButtons();
            subController.continue();
            loadNextPart(next);
        });
    }

    // PUBLIC MEMBERS \\        this.public = "test";
    this.id = arguments.callee.name;

    // PUBLIC FUNCTIONS \\      this.publicFunction = function(){};

    /**
     * Builds and returns this part.
     * @param {boolean} invisible If passed and true, will give the entire section a display:none style.
     */
    this.build = function (invisible) {
        if (reqController && ((reqChoice && reqController.get() !== reqChoice) || (!reqChoice && !reqController.continued()))) {
            return "";
        }

        var part = `<div id="${that.id}" ${invisible ? 'style="display:none;"' : ""}>`;
        part += buildContent();
        part += (changeController && changeController.change()) || "";
        part += buildChoice();
        part += `</div>`;
        part += next.build();
        return part;
    };

    /**
     * Registers all the required button listeners for this part.
     */
    this.registerListeners = function () {
        if (reqController && ((reqChoice && reqController.get() !== reqChoice) || (!reqChoice && !reqController.continued()))) {
            return;
        }

        next.registerListeners();

        if (subController.continued()) {
            return;
        }

        registerNextListener();
    };
}

// END scenes\HamletDay2\UndergroundCave\avert\still\feed\UndergroundCaveFeed.js

// scenes\HamletDay2\UndergroundCave\avert\still\UndergroundCaveLick.js

/**
 * Doggo section of the Underground Cave.
 * @param {UndergroundCaveController} controller The Underground Cave controller.
 */
function UndergroundCaveLick(controller) {
    // PRIVATE MEMBERS \\       var private = "test";
    var that = this;
    var ctrl = controller;

    var reqChoice = false;
    var reqController = false;
    var subController = ctrl.doggo;
    var changeController = ctrl.lick;

    var firstId = arguments.callee.name + "ButtonOne";
    var secondId = arguments.callee.name + "ButtonTwo";
    var thirdId = arguments.callee.name + "ButtonThree";

    var firstNext = new UndergroundCavePet(ctrl);
    var secondNext = new UndergroundCaveFetch(ctrl);
    var thirdNext = new UndergroundCaveFeed(ctrl);

    var firstChoice = ctrl.choices.doggo.PET;
    var secondChoice = ctrl.choices.doggo.FETCH;
    var thirdChoice = ctrl.choices.doggo.FEED;

    // PRIVATE FUNCTIONS \\     function privateFunction(){}

    /**
     * Builds and returns the content of this section.
     * @returns {string} The content.
     */
    function buildContent() {
        global.kobold.history.shared.well.basiliskFriend = true;
        var shirt = ctrl.misc.shirt();
        var toReturn = `[p]
                            You stand perfectly still, hoping to make yourself invisible to the beast.
                            At first, your strategy appears to be working.
                            The basilisk looks off to the left, then to the right.
                            Its eyes return to you, but you imagine it's just gazing at where it [i]last saw you[/i] or something.
                            The lizard may be leering directly at you, but that doesn't mean it can [b]see you[/b], right?
                            Clinging to the hope that remaining motionless will prevent the monster from noticing you,
                            you refuse to move an inch even as it crawls closer.
                            You tremble in fright,
                            knowing fully well that the creature approaching you is more than capable of [b]ripping your throat out[/b] should it judge you a threat.
                        [/p]
                        [p]
                            The basilisk hisses, sending shivers of fear down your spine.
                            Part of your brain wants to [b]run[/b], to flee and hope it won't be able to catch up to you.
                            But it's already too late.
                            The beast is too near now.
                            If you turn tail, it'll [b]snap[/b] one of your legs in between its powerful jaws and
                            [b]drag[/b] you down to the ground before [b]tearing your guts out[/b].
                            You've chosen your strategy, and no matter how much you regret it, you can't back out now.
                        [/p]
                        [p]
                            The crocodillian creeps closer and closer, until it's directly in front of you.
                            It tilts its head upwards, its eyes staring into yours.
                            Still, you do not move.
                            The basilisk extends its front legs, lifting its upper body off the ground, raising its head to about your waist-height.
                            You close your eyes, fearing your end is near, thinking the monster'll bite down
                            and [b]mangle[/b] your delicate belly${shirt ? ` through your ${global.kobold.inventory.createItemWithTooltip(shirt)}` : ``}.
                        [/p]
                        [p]
                            Instead of the [b]horrible pain[/b] you were anticipating, suddenly, you feel a slight [i]bump[/i] against your right hand.
                            You open your eyes, and quizzically stare down to find the rock-scaled beast pressing its stony snout into your palm,
                            affectionately nuzzling your soft scales like a friendly, oversized cat.
                            Absolutely dumbfounded, you watch as the creature ceases in its attempts to get you to pet it,
                            and instead lowers its muzzle to your thigh, hovering in front of the painful cut you sustained while diving in the well.
                        [/p]
                        [p]
                            After a couple of loud sniffs, the basilisk's maw opens, and its forked, snake-like tongue rolls out.
                            You wince as the monster laps at your injury, seemingly [b]tasting[/b] your [b]blood[/b].
                            It stings a bit, at first, but the more the crocodillian licks, the less it hurts.
                            Its saliva is seemingly mending your wound, patching the gash by slightly petrifiying your flesh.
                            Once the laceration is patched, the gentle creature steps besides you to rub its coarse, scaled side against your leg,
                            with a force strong enough to nearly [b]topple[/b] you over.
                        [/p]
                        [p]
                            The basilisk lets out a pleased, rumbling growl while it uses your leg as a scratching post,
                            grinding its rock-hard body against your scales.
                            You're beginning to think this beast isn't as much of a threat as you initially believed it to be.
                            While this might all still be some kind of [i]trick[/i], you're starting to think the lizard is [i]friendly[/i].
                        [/p]`;

        return global.parser.parse(toReturn);
    }

    /**
     * Builds and returns the choice button.
     */
    function buildFirstChoice() {
        var disabled = subController.has() ? "disabled" : "";
        var isSelected = subController.get() === firstChoice;
        var selected = isSelected ? "selected" : "";
        var button = `<button class="button inlinechoice ${selected}" id="${firstId}" ${disabled}>Pet it</button>`;

        var tooltip = global.parser.parse(`Rub your hand along the basilisk's stony carapace.`);
        var popupContainer = global.ui.makeToolTip(button, tooltip, false, false, "width: 190px;");
        // Re-wrap with proper positioning.
        button = `<div class="inlinechoice">`;
        button += popupContainer;
        button += `</div>`;

        return button;
    }

    /**
     * Builds and returns the choice button.
     */
    function buildSecondChoice() {
        var weapon = ctrl.misc.weapon();
        var req = weapon && weapon.id === ItemEnum.BRANCH;
        var disabled = subController.has() || !req ? "disabled" : "";
        var isSelected = subController.get() === secondChoice;
        var selected = isSelected ? "selected" : "";
        var button = `<button class="button inlinechoice ${selected}" id="${secondId}" ${disabled}>Play fetch</button>`;

        var tooltip = global.parser.parse(`Throw your branch and hope the basilisk will retrieve it for you.`);
        if (!req) {
            tooltip = global.parser.parse(`You don't have a stick to play fetch with.`);
        }

        var popupContainer = global.ui.makeToolTip(button, tooltip, false, false, "width: 190px;");
        // Re-wrap with proper positioning.
        button = `<div class="inlinechoice">`;
        button += popupContainer;
        button += `</div>`;

        return button;
    }

    /**
     * Builds and returns the choice button.
     */
    function buildThirdChoice() {
        var req = ctrl.misc.hasConsumable(ItemEnum.HEARTY_MEAL);
        var disabled = subController.has() || !req ? "disabled" : "";
        var isSelected = subController.get() === thirdChoice;
        var selected = isSelected ? "selected" : "";
        var button = `<button class="button inlinechoice ${selected}" id="${thirdId}" ${disabled}>Feed it</button>`;

        var tooltip = global.parser.parse(`Give the basilisk some food.`);
        if (!req) {
            tooltip = global.parser.parse(`You don't have any food that could interest a basilisk.`);
        }

        var popupContainer = global.ui.makeToolTip(button, tooltip, false, false, "width: 190px;");
        // Re-wrap with proper positioning.
        button = `<div class="inlinechoice">`;
        button += popupContainer;
        button += `</div>`;

        return button;
    }

    /**
     * Builds and returns the choice of this section.
     * @returns {string} The choice of this section.
     */
    function buildChoice() {
        var choice = `<div class="choicecontainer"><div class="inlinechoiceheader">You:</div>`;
        choice += buildFirstChoice();
        choice += `<hr class="inlinechoiceseparator">`;
        choice += buildSecondChoice();
        choice += `<hr class="inlinechoiceseparator">`;
        choice += buildThirdChoice();
        choice += `</div>`;
        return choice;
    }

    /**
     * Disables all three buttons.
     */
    function disableButtons() {
        var buttons = [$("#" + firstId), $("#" + secondId), $("#" + thirdId)];
        buttons.forEach(function (button) {
            button.unbind();
            button.attr("disabled", true);
        });
    }

    /**
     * Loads and displays the next part.
     * @param {object} part Which part to load.
     */
    function loadNextPart(part) {
        var built = part.build(true);
        global.ui.appendBeforeFinisher(built, global.ui.genericHeaderId);
        $("#" + part.id).fadeIn(400);
        part.registerListeners();
    }

    /**
     * Adds a listener to the button.
     */
    function registerFirstListener() {
        $("#" + firstId).click(function () {
            $(this).addClass("selected");
            disableButtons();
            subController.set(firstChoice);
            loadNextPart(firstNext);
        });
    }

    /**
     * Adds a listener to the button.
     */
    function registerSecondListener() {
        $("#" + secondId).click(function () {
            $(this).addClass("selected");
            disableButtons();
            subController.set(secondChoice);
            loadNextPart(secondNext);
        });
    }

    /**
     * Adds a listener to the button.
     */
    function registerThirdListener() {
        $("#" + thirdId).click(function () {
            $(this).addClass("selected");
            disableButtons();
            subController.set(thirdChoice);
            loadNextPart(thirdNext);
        });
    }

    // PUBLIC MEMBERS \\        this.public = "test";
    this.id = arguments.callee.name;

    // PUBLIC FUNCTIONS \\      this.publicFunction = function(){};

    /**
     * Builds and returns this part.
     * @param {boolean} invisible If passed and true, will give the entire section a display:none style.
     */
    this.build = function (invisible) {
        if (reqController && ((reqChoice && reqController.get() !== reqChoice) || (!reqChoice && !reqController.continued()))) {
            return "";
        }

        var part = `<div id="${that.id}" ${invisible ? 'style="display:none;"' : ""}>`;
        part += buildContent();
        part += (changeController && changeController.change()) || "";
        part += buildChoice();
        part += `</div>`;
        part += firstNext.build();
        part += secondNext.build();
        part += thirdNext.build();
        return part;
    };

    /**
     * Registers all the required button listeners for this part.
     */
    this.registerListeners = function () {
        if (reqController && ((reqChoice && reqController.get() !== reqChoice) || (!reqChoice && !reqController.continued()))) {
            return;
        }

        firstNext.registerListeners();
        secondNext.registerListeners();
        thirdNext.registerListeners();

        if (subController.has()) {
            return;
        }

        registerFirstListener();
        registerSecondListener();
        registerThirdListener();
    };
}

// END scenes\HamletDay2\UndergroundCave\avert\still\UndergroundCaveLick.js

// scenes\HamletDay2\UndergroundCave\avert\still\UndergroundCaveNuzzle.js

/**
 * Doggo section of the Underground Cave.
 * @param {UndergroundCaveController} controller The Underground Cave controller.
 */
function UndergroundCaveNuzzle(controller) {
    // PRIVATE MEMBERS \\       var private = "test";
    var that = this;
    var ctrl = controller;

    var reqChoice = false;
    var reqController = false;
    var subController = ctrl.doggo;
    var changeController = ctrl.nuzzle;

    var firstId = arguments.callee.name + "ButtonOne";
    var secondId = arguments.callee.name + "ButtonTwo";
    var thirdId = arguments.callee.name + "ButtonThree";

    var firstNext = new UndergroundCavePet(ctrl);
    var secondNext = new UndergroundCaveFetch(ctrl);
    var thirdNext = new UndergroundCaveFeed(ctrl);

    var firstChoice = ctrl.choices.doggo.PET;
    var secondChoice = ctrl.choices.doggo.FETCH;
    var thirdChoice = ctrl.choices.doggo.FEED;

    // PRIVATE FUNCTIONS \\     function privateFunction(){}

    /**
     * Builds and returns the content of this section.
     * @returns {string} The content.
     */
    function buildContent() {
        global.kobold.history.shared.well.basiliskFriend = true;
        var shirt = ctrl.misc.shirt();
        var pants = ctrl.misc.pants();
        var toReturn = `[p]
                            You stand perfectly still, hoping to make yourself invisible to the beast.
                            At first, your strategy appears to be working.
                            The basilisk looks off to the left, then to the right.
                            Its eyes return to you, but you imagine it's just gazing at where it [i]last saw you[/i] or something.
                            The lizard may be leering directly at you, but that doesn't mean it can [b]see you[/b], right?
                            Clinging to the hope that remaining motionless will prevent the monster from noticing you,
                            you refuse to move an inch even as it crawls closer.
                            You tremble in fright,
                            knowing fully well that the creature approaching you is more than capable of [b]ripping your throat out[/b] should it judge you a threat.
                        [/p]
                        [p]
                            The basilisk hisses, sending shivers of fear down your spine.
                            Part of your brain wants to [b]run[/b], to flee and hope it won't be able to catch up to you.
                            But it's already too late.
                            The beast is too near now.
                            If you turn tail, it'll [b]snap[/b] one of your legs in between its powerful jaws and
                            [b]drag[/b] you down to the ground before [b]tearing your guts out[/b].
                            You've chosen your strategy, and no matter how much you regret it, you can't back out now.
                        [/p]
                        [p]
                            The crocodillian creeps closer and closer, until it's directly in front of you.
                            It tilts its head upwards, its eyes staring into yours.
                            Still, you do not move.
                            The basilisk extends its front legs, lifting its upper body off the ground, raising its head to about your waist-height.
                            You close your eyes, fearing your end is near, thinking the monster'll bite down
                            and [b]mangle[/b] your delicate belly${shirt ? ` through your ${global.kobold.inventory.createItemWithTooltip(shirt)}` : ``}.
                        [/p]
                        [p]
                            Instead of the [b]horrible pain[/b] you were anticipating, suddenly, you feel a slight [i]bump[/i] against your right hand.
                            You open your eyes, and quizzically stare down to find the rock-scaled beast pressing its stony snout into your palm,
                            affectionately nuzzling your soft scales like a friendly, oversized cat.
                            Absolutely dumbfounded, you watch as the creature ceases in its attempts to get you to pet it,
                            and instead steps besides you to rub its coarse, scaled side against your ${pants ? `exposed` : ``} leg,
                            with a force strong enough to nearly [b]topple[/b] you over.
                        [/p]
                        [p]
                            The basilisk lets out a pleased, rumbling growl while it uses your leg as a scratching post,
                            grinding its rock-like body against your ${pants ? `${global.kobold.inventory.createItemWithTooltip(pants)}` : `scales`}.
                            You're beginning to think this beast isn't as much of a threat as you initially believed it to be.
                            While this might all still be some kind of [i]trick[/i], you're starting to think the lizard is [i]friendly[/i].
                        [/p]`;

        return global.parser.parse(toReturn);
    }

    /**
     * Builds and returns the choice button.
     */
    function buildFirstChoice() {
        var disabled = subController.has() ? "disabled" : "";
        var isSelected = subController.get() === firstChoice;
        var selected = isSelected ? "selected" : "";
        var button = `<button class="button inlinechoice ${selected}" id="${firstId}" ${disabled}>Pet it</button>`;

        var tooltip = global.parser.parse(`Rub your hand along the basilisk's stony carapace.`);
        var popupContainer = global.ui.makeToolTip(button, tooltip, false, false, "width: 190px;");
        // Re-wrap with proper positioning.
        button = `<div class="inlinechoice">`;
        button += popupContainer;
        button += `</div>`;

        return button;
    }

    /**
     * Builds and returns the choice button.
     */
    function buildSecondChoice() {
        var weapon = ctrl.misc.weapon();
        var req = weapon && weapon.id === ItemEnum.BRANCH;
        var disabled = subController.has() || !req ? "disabled" : "";
        var isSelected = subController.get() === secondChoice;
        var selected = isSelected ? "selected" : "";
        var button = `<button class="button inlinechoice ${selected}" id="${secondId}" ${disabled}>Play fetch</button>`;

        var tooltip = global.parser.parse(`Throw your branch and hope the basilisk will retrieve it for you.`);
        if (!req) {
            tooltip = global.parser.parse(`You don't have a stick to play fetch with.`);
        }

        var popupContainer = global.ui.makeToolTip(button, tooltip, false, false, "width: 190px;");
        // Re-wrap with proper positioning.
        button = `<div class="inlinechoice">`;
        button += popupContainer;
        button += `</div>`;

        return button;
    }

    /**
     * Builds and returns the choice button.
     */
    function buildThirdChoice() {
        var req = ctrl.misc.hasConsumable(ItemEnum.HEARTY_MEAL);
        var disabled = subController.has() || !req ? "disabled" : "";
        var isSelected = subController.get() === thirdChoice;
        var selected = isSelected ? "selected" : "";
        var button = `<button class="button inlinechoice ${selected}" id="${thirdId}" ${disabled}>Feed it</button>`;

        var tooltip = global.parser.parse(`Give the basilisk some food.`);
        if (!req) {
            tooltip = global.parser.parse(`You don't have any food that could interest a basilisk.`);
        }

        var popupContainer = global.ui.makeToolTip(button, tooltip, false, false, "width: 190px;");
        // Re-wrap with proper positioning.
        button = `<div class="inlinechoice">`;
        button += popupContainer;
        button += `</div>`;

        return button;
    }

    /**
     * Builds and returns the choice of this section.
     * @returns {string} The choice of this section.
     */
    function buildChoice() {
        var choice = `<div class="choicecontainer"><div class="inlinechoiceheader">You:</div>`;
        choice += buildFirstChoice();
        choice += `<hr class="inlinechoiceseparator">`;
        choice += buildSecondChoice();
        choice += `<hr class="inlinechoiceseparator">`;
        choice += buildThirdChoice();
        choice += `</div>`;
        return choice;
    }

    /**
     * Disables all three buttons.
     */
    function disableButtons() {
        var buttons = [$("#" + firstId), $("#" + secondId), $("#" + thirdId)];
        buttons.forEach(function (button) {
            button.unbind();
            button.attr("disabled", true);
        });
    }

    /**
     * Loads and displays the next part.
     * @param {object} part Which part to load.
     */
    function loadNextPart(part) {
        var built = part.build(true);
        global.ui.appendBeforeFinisher(built, global.ui.genericHeaderId);
        $("#" + part.id).fadeIn(400);
        part.registerListeners();
    }

    /**
     * Adds a listener to the button.
     */
    function registerFirstListener() {
        $("#" + firstId).click(function () {
            $(this).addClass("selected");
            disableButtons();
            subController.set(firstChoice);
            loadNextPart(firstNext);
        });
    }

    /**
     * Adds a listener to the button.
     */
    function registerSecondListener() {
        $("#" + secondId).click(function () {
            $(this).addClass("selected");
            disableButtons();
            subController.set(secondChoice);
            loadNextPart(secondNext);
        });
    }

    /**
     * Adds a listener to the button.
     */
    function registerThirdListener() {
        $("#" + thirdId).click(function () {
            $(this).addClass("selected");
            disableButtons();
            subController.set(thirdChoice);
            loadNextPart(thirdNext);
        });
    }

    // PUBLIC MEMBERS \\        this.public = "test";
    this.id = arguments.callee.name;

    // PUBLIC FUNCTIONS \\      this.publicFunction = function(){};

    /**
     * Builds and returns this part.
     * @param {boolean} invisible If passed and true, will give the entire section a display:none style.
     */
    this.build = function (invisible) {
        if (reqController && ((reqChoice && reqController.get() !== reqChoice) || (!reqChoice && !reqController.continued()))) {
            return "";
        }

        var part = `<div id="${that.id}" ${invisible ? 'style="display:none;"' : ""}>`;
        part += buildContent();
        part += (changeController && changeController.change()) || "";
        part += buildChoice();
        part += `</div>`;
        part += firstNext.build();
        part += secondNext.build();
        part += thirdNext.build();
        return part;
    };

    /**
     * Registers all the required button listeners for this part.
     */
    this.registerListeners = function () {
        if (reqController && ((reqChoice && reqController.get() !== reqChoice) || (!reqChoice && !reqController.continued()))) {
            return;
        }

        firstNext.registerListeners();
        secondNext.registerListeners();
        thirdNext.registerListeners();

        if (subController.has()) {
            return;
        }

        registerFirstListener();
        registerSecondListener();
        registerThirdListener();
    };
}

// END scenes\HamletDay2\UndergroundCave\avert\still\UndergroundCaveNuzzle.js

// scenes\HamletDay2\UndergroundCave\avert\still\UndergroundCaveStandStill.js

/**
 * Doggo section of the Underground Cave.
 * @param {UndergroundCaveController} controller The Underground Cave controller.
 */
function UndergroundCaveStandStill(controller) {
    // PRIVATE MEMBERS \\       var private = "test";
    var that = this;
    var ctrl = controller;

    var reqChoice = UndergroundCaveAvertChoice.STAND;
    var reqController = ctrl.avert;

    var toFail = new UndergroundCaveNuzzle(ctrl);
    var toSuccess = new UndergroundCaveLick(ctrl);

    // PRIVATE FUNCTIONS \\     function privateFunction(){}

    /**
     * Checks whether the choice succeeded or failed.
     */
    function successCheck() {
        return global.kobold.history.shared.well.scrapedThigh;
    }

    // PUBLIC MEMBERS \\        this.public = "test";
    this.id = arguments.callee.name;

    // PUBLIC FUNCTIONS \\      this.publicFunction = function(){};

    /**
     * Builds and returns this part.
     * @param {boolean} invisible If passed and true, will give the entire section a display:none style.
     */
    this.build = function (invisible) {
        if (reqController && ((reqChoice && reqController.get() !== reqChoice) || (!reqChoice && !reqController.continued()))) {
            return "";
        }

        var part = `<div id="${that.id}" ${invisible ? 'style="display:none;"' : ""}>`;
        if (successCheck()) {
            part += toSuccess.build();
        } else {
            part += toFail.build();
        }
        part += `</div>`;
        return part;
    };

    /**
     * Registers all the required button listeners for this part.
     */
    this.registerListeners = function () {
        if (reqController && ((reqChoice && reqController.get() !== reqChoice) || (!reqChoice && !reqController.continued()))) {
            return;
        }

        if (successCheck()) {
            toSuccess.registerListeners();
        } else {
            toFail.registerListeners();
        }
    };
}

// END scenes\HamletDay2\UndergroundCave\avert\still\UndergroundCaveStandStill.js

// scenes\HamletDay2\UndergroundCave\avert\UndergroundCaveAvert.js

/**
 * Avert section of the Underground Cave.
 * @param {UndergroundCaveController} controller The Underground Cave controller.
 */
function UndergroundCaveAvert(controller) {
    // PRIVATE MEMBERS \\       var private = "test";
    var that = this;
    var ctrl = controller;

    var reqChoice = UndergroundCaveSurfaceChoice.AVERT;
    var reqController = ctrl.surface;
    var subController = ctrl.avert;
    var changeController = ctrl.avert;

    var firstId = arguments.callee.name + "ButtonOne";
    var secondId = arguments.callee.name + "ButtonTwo";

    var firstNext = new UndergroundCaveStandStill(ctrl);
    var secondNext = ctrl.fragments.fight;

    var firstChoice = UndergroundCaveAvertChoice.STAND;
    var secondChoice = UndergroundCaveAvertChoice.FIGHT;

    // PRIVATE FUNCTIONS \\     function privateFunction(){}

    /**
     * Builds and returns the content of this section.
     * @returns {string} The content.
     */
    function buildContent() {
        global.kobold.history.shared.well.basiliskMet = true;
        var toReturn = `[p]
                            You may be a kobold, but even [i]you[/i] know that blankly staring into a monster's eyes is a bad idea.
                            It might take it as a sign of aggression, a challenge to its reign over this cave.
                            You wisely avert your gaze, occasionally glancing back out of the corners of your eyes to prevent any nasty [i]surprises[/i].
                            After about half a minute of you not looking at it, the creature begins to [i]move[/i].
                            Its bright green eyes shift closer towards you as it crawls out of the dark hole it was concealed in.
                            Stepping out into the cavern proper, the monster is revealed.
                        [/p]
                        [p]
                            Before you stands a feral, quadrupedal lizard with large, protruding, rock-like scales and a sizeable maw filled with sharp, pointy teeth.
                            A crocodilian with a stony hide.
                            You think Seki once told you a story about a beast like this.
                            Could it be...[b]a basilisk[/b]?!
                        [/p]
                        [p]
                            Startled, you rise to your feet.
                            Thank goodness you decided to look away from it!
                            If Seki's tales are to be trusted, these creatures have the ability to petrify all those who look at them!
                            No wonder it has such [i]enchanting[/i] eyes.
                            Mere trickery, to lure innocent saps like yourself to get lost in their unrivalled depth while slowly turning to stone.
                        [/p]
                        [p]
                            The basilisk flicks out its tongue.
                            You [i]think[/i] that's how they [i]smell[/i], but you aren't exactly sure.
                            You should have paid more attention when the old bird was recounting his tales!
                            Who knew that his life stories could one day come in handy?
                        [/p]`;

        return global.parser.parse(toReturn);
    }

    /**
     * Builds and returns the choice button.
     */
    function buildFirstChoice() {
        var disabled = subController.has() ? "disabled" : "";
        var isSelected = subController.get() === firstChoice;
        var selected = isSelected ? "selected" : "";
        var button = `<button class="button inlinechoice ${selected}" id="${firstId}" ${disabled}>Stand still</button>`;

        var tooltip = global.parser.parse(`Maybe basilisks can't see things that aren't moving?`);
        var popupContainer = global.ui.makeToolTip(button, tooltip, false, false, "width: 190px;");
        // Re-wrap with proper positioning.
        button = `<div class="inlinechoice">`;
        button += popupContainer;
        button += `</div>`;

        return button;
    }

    /**
     * Builds and returns the choice button.
     */
    function buildSecondChoice() {
        var disabled = subController.has() ? "disabled" : "";
        var isSelected = subController.get() === secondChoice;
        var selected = isSelected ? "selected" : "";
        var button = `<button class="button inlinechoice ${selected}" id="${secondId}" ${disabled}>Fight</button>`;

        var tooltip = global.parser.parse(`If this thing wants a fight, it can bring it on.`);
        var popupContainer = global.ui.makeToolTip(button, tooltip, false, false, "width: 190px;");
        // Re-wrap with proper positioning.
        button = `<div class="inlinechoice">`;
        button += popupContainer;
        button += `</div>`;

        return button;
    }

    /**
     * Builds and returns the choice of this section.
     * @returns {string} The choice of this section.
     */
    function buildChoice() {
        var choice = `<div class="choicecontainer"><div class="inlinechoiceheader">You:</div>`;
        choice += buildFirstChoice();
        choice += `<hr class="inlinechoiceseparator">`;
        choice += buildSecondChoice();
        choice += `</div>`;
        return choice;
    }

    /**
     * Disables all three buttons.
     */
    function disableButtons() {
        var buttons = [$("#" + firstId), $("#" + secondId)];
        buttons.forEach(function (button) {
            button.unbind();
            button.attr("disabled", true);
        });
    }

    /**
     * Loads and displays the next part.
     * @param {object} part Which part to load.
     */
    function loadNextPart(part) {
        var built = part.build(true);
        global.ui.appendBeforeFinisher(built, global.ui.genericHeaderId);
        $("#" + part.id).fadeIn(400);
        part.registerListeners();
    }

    /**
     * Adds a listener to the button.
     */
    function registerFirstListener() {
        $("#" + firstId).click(function () {
            $(this).addClass("selected");
            disableButtons();
            subController.set(firstChoice);
            loadNextPart(firstNext);
        });
    }

    /**
     * Adds a listener to the button.
     */
    function registerSecondListener() {
        $("#" + secondId).click(function () {
            $(this).addClass("selected");
            disableButtons();
            subController.set(secondChoice);
            loadNextPart(secondNext);
        });
    }

    // PUBLIC MEMBERS \\        this.public = "test";
    this.id = arguments.callee.name;

    // PUBLIC FUNCTIONS \\      this.publicFunction = function(){};

    /**
     * Builds and returns this part.
     * @param {boolean} invisible If passed and true, will give the entire section a display:none style.
     */
    this.build = function (invisible) {
        if (reqController && ((reqChoice && reqController.get() !== reqChoice) || (!reqChoice && !reqController.continued()))) {
            return "";
        }

        global.ui.imageBackground.hide();
        var part = `<div id="${that.id}" ${invisible ? 'style="display:none;"' : ""}>`;
        part += buildContent();
        part += (changeController && changeController.change()) || "";
        part += buildChoice();
        part += `</div>`;
        part += firstNext.build();
        part += secondNext.build();
        return part;
    };

    /**
     * Registers all the required button listeners for this part.
     */
    this.registerListeners = function () {
        if (reqController && ((reqChoice && reqController.get() !== reqChoice) || (!reqChoice && !reqController.continued()))) {
            return;
        }

        firstNext.registerListeners();
        secondNext.registerListeners();

        if (subController.has()) {
            return;
        }

        registerFirstListener();
        registerSecondListener();
    };
}

var UndergroundCaveAvertChoice = {
    STAND: 1,
    FIGHT: 2
};

// END scenes\HamletDay2\UndergroundCave\avert\UndergroundCaveAvert.js

// scenes\HamletDay2\UndergroundCave\stare\petrified\UndergroundCaveRegain.js

/**
 * Stare section of the Underground Cave.
 * @param {UndergroundCaveController} controller The Underground Cave controller.
 */
function UndergroundCaveRegain(controller) {
    // PRIVATE MEMBERS \\       var private = "test";
    var that = this;
    var ctrl = controller;

    var reqChoice = false;
    var reqController = ctrl.preContinue;
    var changeController = ctrl.regain;

    var continueId = arguments.callee.name + "ButtonOne";

    // PRIVATE FUNCTIONS \\     function privateFunction(){}

    function buildEnjoyed() {
        var dick = ctrl.misc.dick();
        var shirt = ctrl.misc.shirt();
        var pants = ctrl.misc.pants();
        var underwear = ctrl.misc.underwear();
        var underwearMale = underwear && underwear.coversRear();
        var underwearFemale = underwear && underwear.coversGroin();
        var clothingMale = underwearMale ? underwear : false;
        clothingMale = pants ? pants : clothingMale;
        var clothingFemale = underwearFemale ? underwear : false;
        clothingFemale = pants ? pants : clothingFemale;
        var toReturn = ``;
        if (dick) {
            if (clothingMale) {
                toReturn += `
                        [p]
                            Your brain [b]flooded[/b] with the strong smell of basilisk cock,
                            your nostrils inhaling more with every breath you take,
                            you can't help [b]but[/b] imagine the various ways the beast could have taken you,
                            were you not turned to stone.
                            Your dirty thoughts keep your trapped member at attention, and your mind occupied, while your limbs slowly return to normal.
                        [/p]
                        [p]
                            About half a lust-filled hour later, you finally regain some form of control over your arms.
                            The stony texture that had overtaken your limbs has given way to smooth scales once more.
                            Alas, it's already too late to sate your desire.
                            Most of the once-pungent scent of the basilisk's arousal has faded, much like the beast itself.
                            Along with it, went your cock's pheromone-fueled need for attention.
                            The once steamy puddle of cum below you is now but a mere [i]stain[/i] on the cavern's stony floor.
                        [/p]
                        [p]
                            Your muzzle in working order again, you sigh loudly in sexual frustration.
                            You aren't even going to [b]try[/b] to rub one out.
                            That could have been [b]so[/b] much fun, 
                            if only you'd remembered to take off your ${global.kobold.inventory.createItemWithTooltip(clothingMale)} first.
                            But then again, you didn't even [b]know[/b] you were being petrified, let alone that the beast wanted to [b]fuck[/b].
                            While you can't really blame yourself for what happened, you are still left somewhat upset.
                        [/p]
                        [p]
                            Your extremities still stiff, you roll onto your side, away from the basilisk's [i]fluids[/i].
                            You mindlessly stare up at the stalactite-laden roof of the cave, while you stretch your limbs every which way.
                            Understandably, you feel somewhat more [i]sluggish[/i] than you did before this entire ordeal.
                            You think your scales might have permanently [i]hardened[/i] a bit.
                            Once you feel like you're fit enough to walk, you slowly rise to your feet, and start making your way [i]out[/i] of the damp cave.
                        [/p]
                        [p]
                            You follow the water, hoping it'll lead you to some kind of exit.
                            Your legs still somewhat unresponsive, the journey is slow, and you nearly fall down more than once.
                            As you go, your stride improves, going from a half-limp to a decent walk alongside the water, until daylight comes into sight.
                            As you expected: it was a stale branch of the river.
                            Climbing out of the cave, you sit your butt down on the riverside dirt, and take a breather.
                            You feel like you've earned one.
                        [/p]
                        [p]
                            You've defied death more than once today.
                            You should consider yourself lucky to be alive.
                            The trip into the well was a harrowing experience.
                            You nearly got crushed, almost drowned, and missed a once-in-a-lifetime opportunity for some steamy basilisk sex.
                            A shame, but at least you made it out alive.
                        [/p]
                        [p]
                            You've gained a couple of memories you'll undoubtedly be masturbating to later,
                            along with a few awesome stories to tell once you've grown old and wise.
                            Stories like the ones Seki used to tell you when you were little.
                            You went through all that trouble to get your mind off of him, and here you are reminiscing once more.
                            You just can't help yourself from clinging to times long gone.
                            Things were so much simpler back then.
                            You miss those days.
                        [/p]
                        [p]
                            The sun is slowly starting to set.
                            You drag yourself to your feet.
                            It's time to go.
                            Varanar isn't [i]that[/i] far off.
                            If your legs don't give out from underneath you, you might still make it there before nightfall.
                        [/p]`;
            } else {
                toReturn += `
                        [p]
                            Your brain [b]flooded[/b] with the strong smell of basilisk jizz,
                            your nostrils inhaling more with every breath you take,
                            you can't help [b]but[/b] imagine the various ways the beast could have taken you,
                            were you not turned to stone.
                            Your dirty thoughts keep your trapped member at attention, and your mind occupied, while your limbs slowly return to normal.
                        [/p]
                        [p]
                            About half a lust-filled hour later, you finally regain some form of control over your arms.
                            The stony texture that had overtaken your limbs has given way to smooth scales once more.
                            Alas, it's already too late to sate your desire.
                            Most of the once-pungent scent of the basilisk's arousal has faded, much like the beast itself.
                            Along with it, went your cock's pheromone-fueled need for attention.
                            Your tailhole gapes no longer, and your insides feel even more empty than [i]before[/i] the intense romp.
                        [/p]
                        [p]
                            Your muzzle in working order again, you sigh loudly in sexual frustration.
                            You aren't even going to [b]try[/b] to rub one out.
                            You'd have cummed your brains out during the basilisk's pounding, if your cockslit hadn't been petrified shut.
                            A missed opportunity, for sure, but despite not reaching your end, you feel like this was a memorable experience regardless.
                        [/p]
                        [p]
                            Your extremities still stiff, you roll onto your side, away from the basilisk's [i]fluids[/i].
                            You mindlessly stare up at the stalactite-laden roof of the cave, while you stretch your limbs every which way.
                            Understandably, you feel somewhat more [i]sluggish[/i] than you did before this entire ordeal.
                            You think your scales might have permanently [i]hardened[/i] a bit.
                            Once you feel like you're fit enough to walk, you slowly rise to your feet, and start making your way [i]out[/i] of the damp cave.
                        [/p]
                        [p]
                            You follow the water, hoping it'll lead you to some kind of exit.
                            Your legs still somewhat unresponsive, the journey is slow, and you nearly fall down more than once.
                            As you go, your stride improves, going from a half-limp to a decent walk alongside the water, until daylight comes into sight.
                            As you expected: it was a stale branch of the river.
                            Climbing out of the cave, you sit your sore butt down on the riverside dirt, and take a breather.
                            You feel like you've earned one.
                        [/p]
                        [p]
                            You've defied death more than once today.
                            You should consider yourself lucky to be alive.
                            The trip into the well was a harrowing experience.
                            You nearly got crushed, almost drowned, and got some steamy basilisk sex, although you didn't quite manage to get off to it.
                            A shame, but at least you made it out alive.
                        [/p]
                        [p]
                            You've gained a couple of memories you'll undoubtedly be masturbating to later,
                            along with a few awesome stories to tell once you've grown old and wise.
                            Stories like the ones Seki used to tell you when you were little.
                            You went through all that trouble to get your mind off of him, and here you are reminiscing once more.
                            You just can't help yourself from clinging to times long gone.
                            Things were so much simpler back then.
                            You miss those days.
                        [/p]
                        [p]
                            The sun is slowly starting to set.
                            You drag yourself to your feet.
                            It's time to go.
                            Varanar isn't [i]that[/i] far off.
                            If your legs don't give out from underneath you, you might still make it there before nightfall.
                        [/p]`;
            }
        } else {
            if (clothingFemale) {
                toReturn += `
                        [p]
                            Your brain [b]flooded[/b] with the strong smell of basilisk cock,
                            your nostrils inhaling more with every breath you take,
                            you can't help [b]but[/b] imagine the various ways the beast could have taken you,
                            were you not turned to stone.
                            Your dirty thoughts keep your loins burning with desire, and your mind occupied, while your limbs slowly return to normal.
                        [/p]
                        [p]
                            About half a lust-filled hour later, you finally regain some form of control over your arms.
                            The stony texture that had overtaken your limbs has given way to smooth scales once more.
                            Alas, it's already too late to sate your desire.
                            Most of the once-pungent scent of the basilisk's arousal has faded, much like the beast itself.
                            Along with it, went your slit's pheromone-fueled need for attention.
                            The once steamy puddle of cum below you is now but a mere [i]stain[/i] on the cavern's stony floor.
                        [/p]
                        [p]
                            Your muzzle in working order again, you sigh loudly in sexual frustration.
                            You aren't even going to [b]try[/b] to rub one out.
                            That could have been [b]so[/b] much fun, 
                            if only you'd remembered to take off your ${global.kobold.inventory.createItemWithTooltip(clothingFemale)} first.
                            But then again, you didn't even [b]know[/b] you were being petrified, let alone that the beast wanted to [b]fuck[/b].
                            While you can't really blame yourself for what happened, you are still left somewhat upset.
                        [/p]
                        [p]
                            Your extremities still stiff, you roll onto your side, away from the basilisk's [i]fluids[/i].
                            You mindlessly stare up at the stalactite-laden roof of the cave, while you stretch your limbs every which way.
                            Understandably, you feel somewhat more [i]sluggish[/i] than you did before this entire ordeal.
                            You think your scales might have permanently [i]hardened[/i] a bit.
                            Once you feel like you're fit enough to walk, you slowly rise to your feet, and start making your way [i]out[/i] of the damp cave.
                        [/p]
                        [p]
                            You follow the water, hoping it'll lead you to some kind of exit.
                            Your legs still somewhat unresponsive, the journey is slow, and you nearly fall down more than once.
                            As you go, your stride improves, going from a half-limp to a decent walk alongside the water, until daylight comes into sight.
                            As you expected: it was a stale branch of the river.
                            Climbing out of the cave, you sit your butt down on the riverside dirt, and take a breather.
                            You feel like you've earned one.
                        [/p]
                        [p]
                            You've defied death more than once today.
                            You should consider yourself lucky to be alive.
                            The trip into the well was a harrowing experience.
                            You nearly got crushed, almost drowned, and missed a once-in-a-lifetime opportunity for some steamy basilisk sex.
                            A shame, but at least you made it out alive.
                        [/p]
                        [p]
                            You've gained a couple of memories you'll undoubtedly be masturbating to later,
                            along with a few awesome stories to tell once you've grown old and wise.
                            Stories like the ones Seki used to tell you when you were little.
                            You went through all that trouble to get your mind off of him, and here you are reminiscing once more.
                            You just can't help yourself from clinging to times long gone.
                            Things were so much simpler back then.
                            You miss those days.
                        [/p]
                        [p]
                            The sun is slowly starting to set.
                            You drag yourself to your feet.
                            It's time to go.
                            Varanar isn't [i]that[/i] far off.
                            If your legs don't give out from underneath you, you might still make it there before nightfall.
                        [/p]`;
            } else {
                toReturn += `
                        [p]
                            Your brain [b]flooded[/b] with the strong smell of basilisk jizz,
                            your nostrils inhaling more with every breath you take,
                            you can't help [b]but[/b] imagine the various ways the beast could have taken you,
                            were you not turned to stone.
                            Your dirty thoughts keep your cunt wet, and your mind occupied, while your limbs slowly return to normal.
                        [/p]
                        [p]
                            About half a lust-filled hour later, you finally regain some form of control over your arms.
                            The stony texture that had overtaken your limbs has given way to smooth scales once more.
                            Alas, it's already too late to sate your desire.
                            Most of the once-pungent scent of the basilisk's arousal has faded, much like the beast itself.
                            Along with it, went your twat's pheromone-fueled need for attention.
                            Your slit gapes no longer, and your insides feel even more empty than [i]before[/i] the intense romp.
                        [/p]
                        [p]
                            Your muzzle in working order again, you sigh loudly in sexual frustration.
                            You came [i]once[/i], but had the beast had the stamina for just a minute more, you would have been able to reach a second climax.
                            Oh well.
                            One is more than none.
                            A missed opportunity, for sure, but you feel like this was a very memorable experience regardless.
                        [/p]
                        [p]
                            Your extremities still stiff, you roll onto your side, away from the basilisk's [i]fluids[/i].
                            You mindlessly stare up at the stalactite-laden roof of the cave, while you stretch your limbs every which way.
                            Understandably, you feel somewhat more [i]sluggish[/i] than you did before this entire ordeal.
                            You think your scales might have permanently [i]hardened[/i] a bit.
                            Once you feel like you're fit enough to walk, you slowly rise to your feet, and start making your way [i]out[/i] of the damp cave.
                        [/p]
                        [p]
                            You follow the water, hoping it'll lead you to some kind of exit.
                            Your legs still somewhat unresponsive, the journey is slow, and you nearly fall down more than once.
                            As you go, your stride improves, going from a half-limp to a decent walk alongside the water, until daylight comes into sight.
                            As you expected: it was a stale branch of the river.
                            Climbing out of the cave, you sit your tender butt down on the riverside dirt, and take a breather.
                            You feel like you've earned one.
                        [/p]
                        [p]
                            You've defied death more than once today.
                            You should consider yourself lucky to be alive.
                            The trip into the well was a harrowing experience.
                            You nearly got crushed, almost drowned, and got some steamy basilisk sex, although you wish it would have lasted a bit longer.
                            A shame, but at least you managed to get off a single time.
                        [/p]
                        [p]
                            You've gained a couple of memories you'll undoubtedly be remembering for the rest of your life,
                            along with a few awesome stories to tell once you've grown old and wise.
                            Stories like the ones Seki used to tell you when you were little.
                            You went through all that trouble to get your mind off of him, and here you are reminiscing once more.
                            You just can't help yourself from clinging to times long gone.
                            Things were so much simpler back then.
                            You miss those days.
                        [/p]
                        [p]
                            The sun is slowly starting to set.
                            You drag yourself to your feet.
                            It's time to go.
                            Varanar isn't [i]that[/i] far off.
                            If your legs don't give out from underneath you, you might still make it there before nightfall.
                        [/p]`;
            }
        }
        return toReturn;
    }

    function buildHated() {
        var dick = ctrl.misc.dick();
        var shirt = ctrl.misc.shirt();
        var pants = ctrl.misc.pants();
        var underwear = ctrl.misc.underwear();
        var underwearMale = underwear && underwear.coversRear();
        var underwearFemale = underwear && underwear.coversGroin();
        var clothingMale = underwearMale ? underwear : false;
        clothingMale = pants ? pants : clothingMale;
        var clothingFemale = underwearFemale ? underwear : false;
        clothingFemale = pants ? pants : clothingFemale;
        var toReturn = ``;
        if (dick) {
            if (clothingMale) {
                toReturn += `
                        [p]
                            You hate this.
                            As though it wasn't enough for the beast to use your body like a cheap fucktoy,
                            now you're stuck above a pool of fresh basilisk cum, with no way out.
                            Your limbs show no sign of regaining motion any time soon.
                            The scent of the monster's cooling semen reminds you of what happened with every breath you take through your nose,
                            constantly making your mind re-live the indignation [com]and the pain[/com] over and over again.
                            You try to breathe through your mouth, but your muzzle is petrified shut, sealing your fate.
                        [/p]
                        [p]
                            About half an hour of wallowing in self-pity later,
                            you finally regain some form of control over your arms.
                            The stony texture that had overtaken your limbs has given way to smooth scales once more.
                            Your muzzle, too, can open once again.
                            Alas, there's no longer a need to breathe through your mouth.
                            Most of the once-pungent scent of the basilisk's arousal has faded, the puddle of cum now but a mere [i]stain[/i] on the cavern's stony floor.
                        [/p]
                        [p]
                            While your encounter with the monster didn't quite go as planned, it could have gone worse.
                            [b]Far[/b] worse.
                            Your pride is severely dented,
                            but you should be grateful that you didn't get [b]hurt[/b].
                            Plus, thanks to your trusty ${global.kobold.inventory.createItemWithTooltip(clothingMale)},
                            you even managed to refrain from getting fucked by the beast.
                        [/p]
                        [p]
                            Your extremities still stiff, you roll onto your side, away from the basilisk's [i]fluids[/i].
                            After wiping your tears, you mindlessly stare up at the stalactite-laden roof of the cave.
                            You sigh loudly.
                            At long last, you've hit rock bottom,
                            being used against your will as a stress relief toy by a feral, who came inches away from [i]actually[/i] fucking you.
                            On the bright side, you doubt there's much worse that can force itself upon you than a mindless beast.
                            At least you [b]hope[/b] so.
                        [/p]
                        [p]
                            You stretch your aching limbs every which way.
                            Understandably, you feel somewhat more [i]sluggish[/i] than you did before this entire ordeal.
                            You think your scales might have permanently [i]hardened[/i] a bit.
                            Once you feel like you're fit enough to walk, you slowly rise to your feet, and start making your way [i]out[/i] of the damp cave,
                            before the beast returns for sloppy seconds.
                        [/p]
                        [p]
                            You follow the water, hoping it'll lead you to some kind of exit.
                            Your legs still somewhat unresponsive, the journey is slow, and you nearly fall down more than once.
                            As you go, your stride improves, going from a half-limp to a decent walk alongside the water, until daylight comes into sight.
                            As you expected: it was a stale branch of the river.
                            Climbing out of the cave, you sit your butt down on the riverside dirt, and take a breather.
                            You feel like you've earned one.
                        [/p]
                        [p]
                            You've defied death more than once today.
                            You should consider yourself lucky to be alive.
                            The trip into the well was a harrowing experience.
                            You nearly got crushed, almost drowned, and got raped by a basilisk, even if it didn't manage to shove its dick inside of you.
                        [/p]
                        [p]
                            You've gained a couple of bad memories you wish you could forget.
                            Some parts of the experience, though, could make for a few awesome stories to tell once you've grown old and wise.
                            Stories like the ones Seki used to tell you when you were little.
                            You went through all that trouble to get your mind off of him, and here you are reminiscing once more.
                            You just can't help yourself from clinging to times long gone.
                            Things were so much simpler back then.
                            You miss those days.
                        [/p]
                        [p]
                            The sun is slowly starting to set.
                            You drag yourself to your feet.
                            It's time to go.
                            Varanar isn't [i]that[/i] far off.
                            If your legs don't give out from underneath you, you might still make it there before nightfall.
                        [/p]`;
            } else {
                toReturn += `
                        [p]
                            You hate this.
                            As though it wasn't enough for the beast to use your body like a cheap fucktoy,
                            now you're stuck while its cum oozes from your gaping hole.
                            Your limbs show no sign of regaining motion any time soon.
                            The scent of the monster's cooling semen reminds you of what happened with every breath you take,
                            constantly making your mind re-live the indignation and the pain over and over again.
                            You try to breathe through your mouth, but your muzzle is petrified shut, sealing your fate.
                        [/p]
                        [p]
                            About half an hour of wallowing in self-pity later,
                            you finally regain some form of control over your arms.
                            The stony texture that had overtaken your limbs has given way to smooth scales once more.
                            Your muzzle, too, can open once again.
                            Alas, there's no longer a need to breathe through your mouth.
                            Most of the once-pungent scent of the basilisk's arousal has faded, the puddle of cum now but a mere [i]stain[/i] on the cavern's stony floor.
                        [/p]
                        [p]
                            While your encounter with the monster didn't quite go as planned, it could have gone worse.
                            [b]Far[/b] worse.
                            Your pride is severely dented,
                            and your ass thoroughly [b]rutted[/b],
                            but you should be grateful that you didn't get [b]hurt[/b] any more than you did.
                            The creature could have easily killed you after it finished, if it wanted to.
                            Or even [b]before[/b] it got started.
                            You don't want to think about your corpse being defiled right now.
                        [/p]
                        [p]
                            Your extremities still stiff, you roll onto your side, away from the basilisk's [i]fluids[/i].
                            After wiping your tears, you mindlessly stare up at the stalactite-laden roof of the cave.
                            You sigh loudly.
                            At long last, you've hit rock bottom, being used against your will as a fucktoy by a feral.
                            On the bright side, you doubt there's much worse that can force itself upon you than a mindless beast.
                            At least you [b]hope[/b] so.
                        [/p]
                        [p]
                            You stretch your aching limbs every which way.
                            Understandably, you feel somewhat more [i]sluggish[/i] than you did before this entire ordeal.
                            You think your scales might have permanently [i]hardened[/i] a bit.
                            Once you feel like you're fit enough to walk, you slowly rise to your feet, and start making your way [i]out[/i] of the damp cave,
                            before the beast returns for sloppy seconds.
                        [/p]
                        [p]
                            You follow the water, hoping it'll lead you to some kind of exit.
                            Your legs still somewhat unresponsive, the journey is slow, and you nearly fall down more than once.
                            As you go, your stride improves, going from a half-limp to a decent walk alongside the water, until daylight comes into sight.
                            As you expected: it was a stale branch of the river.
                            Climbing out of the cave, you sit your sore butt down on the riverside dirt, and take a breather.
                            You feel like you've earned one.
                        [/p]
                        [p]
                            You've defied death more than once today.
                            You should consider yourself lucky to be alive.
                            The trip into the well was a harrowing experience.
                            You nearly got crushed, almost drowned, and then got raped by a basilisk, even if it didn't manage to shove its [i]entire[/i] dick inside of you.
                        [/p]
                        [p]
                            You've gained a couple of bad memories you wish you could forget.
                            Some parts of the experience, though, could make for a few awesome stories to tell once you've grown old and wise.
                            Stories like the ones Seki used to tell you when you were little.
                            You went through all that trouble to get your mind off of him, and here you are reminiscing once more.
                            You just can't help yourself from clinging to times long gone.
                            Things were so much simpler back then.
                            You miss those days.
                        [/p]
                        [p]
                            The sun is slowly starting to set.
                            You drag yourself to your feet.
                            It's time to go.
                            Varanar isn't [i]that[/i] far off.
                            If your legs don't give out from underneath you, you might still make it there before nightfall.
                        [/p]`;
            }
        } else {
            if (clothingFemale) {
                toReturn += `
                        [p]
                            You hate this.
                            As though it wasn't enough for the beast to use your body like a cheap fucktoy,
                            now you're stuck above a pool of fresh basilisk cum, with no way out.
                            Your limbs show no sign of regaining motion any time soon.
                            The scent of the monster's cooling semen reminds you of what happened with every breath you take through your nose,
                            constantly making your mind re-live the indignation [com]and the pain[/com] over and over again.
                            You try to breathe through your mouth, but your muzzle is petrified shut, sealing your fate.
                        [/p]
                        [p]
                            About half an hour of wallowing in self-pity later,
                            you finally regain some form of control over your arms.
                            The stony texture that had overtaken your limbs has given way to smooth scales once more.
                            Your muzzle, too, can open once again.
                            Alas, there's no longer a need to breathe through your mouth.
                            Most of the once-pungent scent of the basilisk's arousal has faded, the puddle of cum now but a mere [i]stain[/i] on the cavern's stony floor.
                        [/p]
                        [p]
                            While your encounter with the monster didn't quite go as planned, it could have gone worse.
                            [b]Far[/b] worse.
                            Your pride is severely dented,
                            but you should be grateful that you didn't get [b]hurt[/b].
                            Plus, thanks to your trusty ${global.kobold.inventory.createItemWithTooltip(clothingFemale)},
                            you even managed to refrain from getting fucked by the beast.
                        [/p]
                        [p]
                            Your extremities still stiff, you roll onto your side, away from the basilisk's [i]fluids[/i].
                            After wiping your tears, you mindlessly stare up at the stalactite-laden roof of the cave.
                            You sigh loudly.
                            At long last, you've hit rock bottom,
                            being used against your will as a stress relief toy by a feral, who came inches away from [i]actually[/i] fucking you.
                            On the bright side, you doubt there's much worse that can force itself upon you than a mindless beast.
                            At least you [b]hope[/b] so.
                        [/p]
                        [p]
                            You stretch your aching limbs every which way.
                            Understandably, you feel somewhat more [i]sluggish[/i] than you did before this entire ordeal.
                            You think your scales might have permanently [i]hardened[/i] a bit.
                            Once you feel like you're fit enough to walk, you slowly rise to your feet, and start making your way [i]out[/i] of the damp cave,
                            before the beast returns for sloppy seconds.
                        [/p]
                        [p]
                            You follow the water, hoping it'll lead you to some kind of exit.
                            Your legs still somewhat unresponsive, the journey is slow, and you nearly fall down more than once.
                            As you go, your stride improves, going from a half-limp to a decent walk alongside the water, until daylight comes into sight.
                            As you expected: it was a stale branch of the river.
                            Climbing out of the cave, you sit your butt down on the riverside dirt, and take a breather.
                            You feel like you've earned one.
                        [/p]
                        [p]
                            You've defied death more than once today.
                            You should consider yourself lucky to be alive.
                            The trip into the well was a harrowing experience.
                            You nearly got crushed, almost drowned, and got raped by a basilisk, even if it didn't manage to shove its dick inside of you.
                        [/p]
                        [p]
                            You've gained a couple of bad memories you wish you could forget.
                            Some parts of the experience, though, could make for a few awesome stories to tell once you've grown old and wise.
                            Stories like the ones Seki used to tell you when you were little.
                            You went through all that trouble to get your mind off of him, and here you are reminiscing once more.
                            You just can't help yourself from clinging to times long gone.
                            Things were so much simpler back then.
                            You miss those days.
                        [/p]
                        [p]
                            The sun is slowly starting to set.
                            You drag yourself to your feet.
                            It's time to go.
                            Varanar isn't [i]that[/i] far off.
                            If your legs don't give out from underneath you, you might still make it there before nightfall.
                        [/p]`;
            } else {
                toReturn += `
                        [p]
                            You hate this.
                            As though it wasn't enough for the beast to use your body like a cheap fucktoy,
                            now you're stuck while its cum oozes from your gaping cunt.
                            Your limbs show no sign of regaining motion any time soon.
                            The scent of the monster's cooling semen reminds you of what happened with every breath you take,
                            constantly making your mind re-live the indignation and the pain over and over again.
                            You try to breathe through your mouth, but your muzzle is petrified shut, sealing your fate.
                        [/p]
                        [p]
                            About half an hour of wallowing in self-pity later,
                            you finally regain some form of control over your arms.
                            The stony texture that had overtaken your limbs has given way to smooth scales once more.
                            Your muzzle, too, can open once again.
                            Alas, there's no longer a need to breathe through your mouth.
                            Most of the once-pungent scent of the basilisk's arousal has faded, the puddle of cum now but a mere [i]stain[/i] on the cavern's stony floor.
                        [/p]
                        [p]
                            While your encounter with the monster didn't quite go as planned, it could have gone worse.
                            [b]Far[/b] worse.
                            Your pride is severely dented,
                            and your loins thoroughly [b]bred[/b],
                            but you should be grateful that you didn't get [b]hurt[/b] any more than you did.
                            The creature could have easily killed you after it finished, if it wanted to.
                            Or even [b]before[/b] it got started.
                            You don't want to think about your corpse being defiled right now.
                        [/p]
                        [p]
                            Your extremities still stiff, you roll onto your side, away from the basilisk's [i]fluids[/i].
                            After wiping your tears, you mindlessly stare up at the stalactite-laden roof of the cave.
                            You sigh loudly.
                            At long last, you've hit rock bottom, being used against your will as a fucktoy by a feral.
                            On the bright side, you doubt there's much worse that can force itself upon you than a mindless beast.
                            At least you [b]hope[/b] so.
                        [/p]
                        [p]
                            You stretch your aching limbs every which way.
                            Understandably, you feel somewhat more [i]sluggish[/i] than you did before this entire ordeal.
                            You think your scales might have permanently [i]hardened[/i] a bit.
                            Once you feel like you're fit enough to walk, you slowly rise to your feet, and start making your way [i]out[/i] of the damp cave,
                            before the beast returns for sloppy seconds.
                        [/p]
                        [p]
                            You follow the water, hoping it'll lead you to some kind of exit.
                            Your legs still somewhat unresponsive, the journey is slow, and you nearly fall down more than once.
                            As you go, your stride improves, going from a half-limp to a decent walk alongside the water, until daylight comes into sight.
                            As you expected: it was a stale branch of the river.
                            Climbing out of the cave, you sit your butt down on the riverside dirt, and take a breather.
                            You feel like you've earned one.
                        [/p]
                        [p]
                            You've defied death more than once today.
                            You should consider yourself lucky to be alive.
                            The trip into the well was a harrowing experience.
                            You nearly got crushed, almost drowned, and then got raped by a basilisk, even if it didn't manage to shove its [i]entire[/i] dick inside of you.
                        [/p]
                        [p]
                            You've gained a couple of bad memories you wish you could forget.
                            Some parts of the experience, though, could make for a few awesome stories to tell once you've grown old and wise.
                            Stories like the ones Seki used to tell you when you were little.
                            You went through all that trouble to get your mind off of him, and here you are reminiscing once more.
                            You just can't help yourself from clinging to times long gone.
                            Things were so much simpler back then.
                            You miss those days.
                        [/p]
                        [p]
                            The sun is slowly starting to set.
                            You drag yourself to your feet.
                            It's time to go.
                            Varanar isn't [i]that[/i] far off.
                            If your legs don't give out from underneath you, you might still make it there before nightfall.
                        [/p]`;
            }
        }
        return toReturn;
    }

    /**
     * Builds and returns the content of this section.
     * @returns {string} The content.
     */
    function buildContent() {

        var toReturn = ``;

        if (ctrl.relent.get() === UndergroundCaveRelentChoice.ENJOY) {
            toReturn += buildEnjoyed();
        } else {
            toReturn += buildHated();
        }

        return global.parser.parse(toReturn);
    }

    /**
     * Builds and returns the continue button.
     */
    function buildChoice() {
        var disabled = ctrl.continued();
        var choice = `<div class="choicecontainer">`;
        choice += `<button class="button bigbutton continuebutton" id="${continueId}" ${disabled ? "disabled" : ""}>`;
        choice += `Continue &gt;&gt`;
        choice += `</button>`;
        choice += `</div>`;
        return choice;
    }

    /**
     * Disables all three buttons.
     */
    function disableButtons() {
        var buttons = [$("#" + continueId)];
        buttons.forEach(function (button) {
            button.unbind();
            button.attr("disabled", true);
        });
    }

    /**
     * Loads and displays the next scene.
     * @param {string} sceneName Name of the scene to load.
     * @param {string} folder Folder of the scene to load.
     */
    function loadNextPart(sceneName, folder) {
        global.ui.fadeOutContent(function () {
            global.sceneEnd();
            global.sceneLoader.loadScene(sceneName, folder);
        });
    }

    /**
     * Adds a listener to the button.
     */
    function registerContinueListener() {
        $("#" + continueId).click(function () {
            $(this).addClass("selected");
            disableButtons();
            ctrl.continue();
            loadNextPart(ctrl.nextSceneName, ctrl.nextFolderName);
        });
    }

    // PUBLIC MEMBERS \\        this.public = "test";
    this.id = arguments.callee.name;

    // PUBLIC FUNCTIONS \\      this.publicFunction = function(){};

    /**
     * Builds and returns this part.
     * @param {boolean} invisible If passed and true, will give the entire section a display:none style.
     */
    this.build = function (invisible) {
        if (reqController && ((reqChoice && reqController.get() !== reqChoice) || (!reqChoice && !reqController.continued()))) {
            return "";
        }

        ctrl.bgm.stopLoop();
        global.ui.applyTheme("hamlet_day");
        var part = `<div id="${that.id}" ${invisible ? 'style="display:none;"' : ""}>`;
        part += buildContent();
        part += (changeController && changeController.change()) || "";
        part += buildChoice();
        if (!ctrl.nextSceneReady) {
            part += `<span class="todo">There is no content beyond this point.</span>`;
        }
        part += `</div>`;
        return part;
    };

    /**
     * Registers all the required button listeners for this part.
     */
    this.registerListeners = function () {
        if (reqController && ((reqChoice && reqController.get() !== reqChoice) || (!reqChoice && !reqController.continued()))) {
            return;
        }

        if (ctrl.continued()) {
            return;
        }

        if (ctrl.nextSceneReady) {
            registerContinueListener();
        }
    };
}

// END scenes\HamletDay2\UndergroundCave\stare\petrified\UndergroundCaveRegain.js

// scenes\HamletDay2\UndergroundCave\stare\petrified\UndergroundCaveEnjoy.js

/**
 * Stare section of the Underground Cave.
 * @param {UndergroundCaveController} controller The Underground Cave controller.
 */
function UndergroundCaveEnjoy(controller) {
    // PRIVATE MEMBERS \\       var private = "test";
    var that = this;
    var ctrl = controller;

    var reqChoice = UndergroundCaveRelentChoice.ENJOY;
    var reqController = ctrl.relent;
    var subController = ctrl.preContinue;
    var changeController = ctrl.enjoy;

    var continueId = arguments.callee.name + "ButtonOne";
    var next = new UndergroundCaveRegain(ctrl);

    // PRIVATE FUNCTIONS \\     function privateFunction(){}

    /**
     * Builds and returns the content of this section.
     * @returns {string} The content.
     */
    function buildContent() {
        global.kobold.history.shared.well.basiliskEnjoyed = true;
        var analVirgin = ctrl.misc.analVirgin();
        var cuntVirgin = ctrl.misc.cuntVirgin();
        var dick = ctrl.misc.dick();
        var shirt = ctrl.misc.shirt();
        var pants = ctrl.misc.pants();
        var underwear = ctrl.misc.underwear();
        var underwearMale = underwear && underwear.coversRear();
        var underwearFemale = underwear && underwear.coversGroin();
        var clothingMale = underwearMale ? underwear : false;
        clothingMale = pants ? pants : clothingMale;
        var clothingFemale = underwearFemale ? underwear : false;
        clothingFemale = pants ? pants : clothingFemale;
        var toReturn = `[p]
                            While you didn't exactly [i]ask[/i] for this, you can't deny that something about this entire situation [i]turns you on[/i].
                            The feeling of being [b]helpless[/b] while a large, feral,
                            predatory animal is about to have its way with you scratches a certain kind of itch you didn't even know you had.
                            You guess you're just submissive at heart.
                            Or maybe you have a [i]thing[/i] for petrification.
                            Either way, ${dick ? "you can already feel your length stirring within your cockslit" : "your slit is already dampening in anticipation"}.
                        [/p]
                        [p]
                            Despite the basilisk having moved outside of your field of view, the image of the its loins remains burned in your brain.
                            You've witnessed plenty of males of varying species naked, but you've never before seen a dick quite like [i]this[/i].
                            It's not the [i]biggest[/i] around, especially not when compared to [b]horses[/b] or other [i]large[/i] species,
                            but the shape is unlike anything you've ever seen.
                            The closest thing you have to compare it to is a painting of a dragon's genitals you once saw while breaking into a manor.
                            Perhaps basilisks and dragons are related somehow?
                        [/p]
                        [p]
                            You try to shift your tail out of the way, to ensure the beast has proper access to your groin,
                            but before you manage to move the stiff, near-petrified appendage, the basilisk has already reached your rear.
                            It lifts up its upper body, and deftly mounts your backside, resting most of its massive weight on top of your frail frame, 
                            its front two legs ending up directly behind your arms, its muzzle right next to your face.
                            If you weren't petrified, you're certain your legs and arms would [b]buckle[/b] under the pressure.
                        [/p]`;

        if (dick) {
            if (clothingMale) {
                toReturn += `
                        [p]
                            Despite most of your butt being completely numb, you can feel the creature's
                            member pressing against your still somewhat sensitive
                            slit${clothingFemale ? `, even through your ${global.kobold.inventory.createItemWithTooltip(clothingFemale)}` : ``}.
                            It's so [b]warm[/b] and [b]thick[/b].
                            [b]Definitely[/b] dragon-like.
                            You [b]want[/b] it.
                        [/p]
                        [p]
                            After a few moments of resting idly, the reptile pulls its length back.
                            It begins to hump against your rear, prodding and poking your petrified butt, looking for a hole to [b]fuck[/b].
                            Alas, your ${global.kobold.inventory.createItemWithTooltip(clothingMale)},
                            which cover [com]Should be "covers" in case of "loincloth". Singular/multiplicative in items?[/com]
                            your stone-turned-scales, are in the creature's way.
                            Incapable of tearing through the fabric with its genitals alone,
                            the beast relents in its efforts to find a suitable hole to pound after a few more tries.
                        [/p]
                        [p]
                            Both it and you disappointed, the basilisk resorts to instead fucking the gap between your petrified thighs,
                            grinding its ridged length against your
                            ${clothingFemale ? `${global.kobold.inventory.createItemWithTooltip(clothingFemale)}-clad` : ` bare`} cockslit.
                            The crocodillian appears to be entirely unfazed by the coarse texture of your once-soft upper legs.
                            As their kind is partly composed out of stone-like material,
                            you imagine basilisk sex must [b]always[/b] feel like ramming your dick into a rock-hewn hole.
                        [/p]
                        [p]
                            The basilisk's considerable length, pumping deftly from the back of your legs all the way up to your belly button,
                            occasionally squirts a heady glob of precum, a small puddle of which is forming on the ground beneath you.
                            Its strong, pheromone-laden scent clouds your mind.
                            It's almost as [b]hypnotizing[/b] as the beast's eyes were.
                            You find yourself eagerly taking in deep breaths through your nose,
                            in an attempt to inhale as much of the [b]delectable[/b] fragrance as you possibly can.
                        [/p]
                        [p]
                            While far less pleasurable than the intense, bestial pounding you had hoped for,
                            you find yourself growing exceedingly aroused still,
                            the constant frotting against your cockslit,
                            combined with the undeniably [b]masculine[/b] smell permeating every breath you take,
                            causing your member to rapidly harden.
                            As your shaft grows erect, however, you experience something you've never felt before.
                        [/p]
                        [p]
                            Your slit feels [b]tight[/b].
                            Filled to the very brim.
                            Your loins petrified, your manhood is trapped inside of your cockslit,
                            stuck in a state between being flaccid and fully erect,
                            constrained like a bird in a far too small cage,
                            unable to fly free.
                        [/p]
                        [p]
                            It's a weird feeling, to be aroused to no end by oh-so-little stimulation,
                            yet being denied the full pleasure you hoped you would receive from this situation.
                            Despite desperately wanting to get off, some part of you actually [i]enjoys[/i] the pseudo-cock-cage formed by your petrified loins.
                            It reinforces the notion that this entire thing is [b]not[b] about [i]you[/i].
                            It's about a large, uncaring [b]monster[/b] sating its [b]animalistic lust[/b] on your body, in whatever way it can.
                            And [b]that[/b] turns you on more than anything else.
                        [/p]
                        [p]
                            The basilisk, uncaring about your pleasure (or the lack thereof),
                            continues to hump away at your thighs, its ridged shaft grinding along your bustling cockslit and your stone-turned belly both.
                            Being an animal, however, it doesn't last long.
                            No more than five minutes after crawling on your back, you can already [b]sense[/b] its approaching orgasm.
                            Its movements become more erratic, a small growl rumbles from the back of its throat, and its large maw opens ever so slightly,
                            the creature seemingly [b]huffing[/b] and [b]panting[/b] through its mouth the same way a dog would.
                        [/p]
                        [p]
                            A few moments later, the monster reaches its end, 
                            its incessant thigh-fucking giving way to a series of fierce thrusts,
                            while squirt after squirt of thick basilisk spunk covers the stone floor and
                            your ${shirt ? `${global.kobold.inventory.createItemWithTooltip(shirt)}` : `lower body`},
                            the heavy scent adding to the lingering odor of bestial masculinity hanging in the air, driving your mind [b]wild[/b] with unsated desire.
                        [/p]
                        [p]
                            Once its climax starts to fade, the large reptillian slowly shifts its weight off of your back.
                            Its member receding into its body, the creature crawls back towards the hole it came from,
                            and before you even have the [b]chance[/b] to [b]try[/b] to [b]beg[/b] it to continue,
                            the basilisk disappears back into the darkness, leaving you trapped and aroused,
                            unable to get off while constantly being tempted by the aroma of the puddle of feral cum directly below you.
                        [/p]`;
            } else {
                global.kobold.history.shared.well.basiliskPenetrated = true;
                toReturn += `
                        [p]
                            Despite most of your butt being completely numb, you can feel the creature's
                            member pressing against your still somewhat sensitive
                            slit${clothingFemale ? `, even through your ${global.kobold.inventory.createItemWithTooltip(clothingFemale)}` : ``}.
                            It's so [b]warm[/b] and [b]thick[/b].
                            [b]Definitely[/b] dragon-like.
                            You [b]want[/b] it.
                        [/p]
                        [p]
                            After a few moments of resting idly, the reptile pulls its length back.
                            It begins to hump against your rear, prodding and poking your petrified butt, looking for a hole to [b]fuck[/b].
                            After the third or fourth try, it hits its mark,
                            its thick, tapered cock [b]ramming[/b] into your unlubed${analVirgin ? `, virginal` : ``} tailhole.
                            Once firmly lodged inside of you, the beast immediately begins to thrust in and out of your body,
                            its rapid pace only matched by its feral ferocity.
                        [/p]
                        [p]
                            While your buttcheeks are numb from petrification, your stretched insides are not.
                            Your ass [b]hurts[/b] from the slightly oversized insertion,
                            although the pain quickly gets drowned out by the pleasure of being [b]taken[/b] by a feral [b]beast[/b],
                            your own dick rapidly swelling in your slit.
                            The crocodillian appears to be entirely unfazed by the coarse texture of your buttcheeks.
                            As their kind is partly composed out of stone-like material,
                            you imagine basilisk sex must [b]always[/b] feel like ramming your dick into a rock-hewn hole.
                        [/p]
                        [p]
                            You aren't sure exactly [i]how much[/i] of the creature's length is being forced inside of you,
                            but you figure it must be at least more than half.
                            It [b]feels[/b] like a lot, anyway.
                            Each of the individual ridges lining its shaft pop into and out of your rear, sending waves of pure [b]pleasure[/b] coursing down your spine.
                            Every few thrusts, a squirt of thick, warm precum shoots from the tip of the monster's draconic member, slickening your insides.
                            The lubrication allows the beast to fuck you [b]harder[/b] and [b]faster[/b],
                            its cock going just [i]slightly[/i], but [b]noticeably[/b] deeper than before.
                        [/p]
                        [p]
                            The smell of pure, bestial [b]sex[/b] spreads throughout the cave,
                            the strong and masculine-pheromone laden scent of the self-exerting basilisk clouding your mind.
                            It's almost as [b]hypnotizing[/b] as the beast's eyes were.
                            You find yourself eagerly taking in deep breaths through your nose,
                            in an attempt to inhale as much of the [b]delectable[/b] fragrance as you possibly can.
                        [/p]
                        [p]
                            The intense, feral rutting is every bit as pleasurable as you imagined it to be.
                            Your member rapidly grows more and more erect, until suddenly, you experience something you've never felt before. 
                            Your slit feels [b]tight[/b].
                            Filled to the very brim.
                            Your loins petrified, your manhood is trapped inside of your cockslit,
                            stuck in a state between being flaccid and fully erect,
                            constrained like a bird in a far too small cage,
                            unable to fly free.
                        [/p]
                        [p]
                            It's a weird feeling, to be aroused to no end, yet still being denied [b]full[/b] pleasure.
                            Despite desperately wanting to get off, some part of you actually [i]enjoys[/i] the pseudo-cock-cage formed by your petrified loins.
                            It reinforces the notion that this entire thing is [b]not[b] about [i]you[/i].
                            It's about a large, uncaring [b]monster[/b] sating its [b]animalistic lust[/b] on your body.
                            And [b]that[/b] turns you on more than anything else.
                        [/p]
                        [p]
                            The basilisk, uncaring about your pleasure (or the lack thereof),
                            continues to hump away, its ridged shaft almost bottoming out inside of you.
                            Your belly would be bulging ever-so-slightly if not turned to stone.
                            While the rough rutting is one of the best things you've ever experienced,
                            your animal partner fails to last for more than a few minutes,
                            the tight confines of your ${analVirgin ? `virginal` : ``} tailhole proving far more pleasurable than the loins of its own kind.
                        [/p]
                        [p]
                            You can already [b]sense[/b] its approaching orgasm.
                            Its movements become more erratic, a small growl rumbles from the back of its throat, and its large maw opens ever so slightly,
                            the creature seemingly [b]huffing[/b] and [b]panting[/b] through its mouth the same way a dog would.
                            Its incessant buttfucking gives way to a series of fierce thrusts, a clear indicator of what is to come.
                            A few moments later, the monster reaches its end,
                            wave after wave of hot, thick basilisk spunk flooding your body, filling up your insides to the [b]brim[/b].
                        [/p]
                        [p]
                            Once its climax starts to fade, the large reptillian slowly shifts its weight off of your back,
                            and pulls its length from your rear.
                            A [b]flood[/b] of heady feral cum leaks from your slightly gaping ass,
                            the heavy scent of the stuff adding to the lingering odor of bestial masculinity hanging in the air,
                            driving your mind [b]wild[/b] with unsated desire.
                        [/p]
                        [p]
                            Its member receding into its body, the creature crawls back towards the hole it came from,
                            and before you even have the [b]chance[/b] to [b]try[/b] to [b]beg[/b] it for more,
                            the monster disappears back into the darkness, leaving you freshly fucked, trapped and aroused,
                            unable to get off while constantly being tempted by the aroma of the puddle of feral cum dripping from your tailhole.
                        [/p]`;
                if (analVirgin) {
                    toReturn += `
                        [p]
                            [c]
                                [b]You are no longer a virgin.[/b]
                            [/c]
                        [/p]`;
                }
            }
        } else {
            if (clothingFemale) {
                toReturn += `
                        [p]
                            Despite most of your rear end being completely numb, you can feel the creature's
                            member pressing against your still sensitive
                            slit, even through your ${global.kobold.inventory.createItemWithTooltip(clothingFemale)}.
                            It's so [b]warm[/b] and [b]thick[/b].
                            [b]Definitely[/b] dragon-like.
                            You [b]want[/b] it.
                        [/p]
                        [p]
                            After a few moments of resting idly, the reptile pulls its length back.
                            It begins to hump against your groin, prodding and poking your petrified loins, looking for a hole to [b]fuck[/b].
                            Alas, your ${global.kobold.inventory.createItemWithTooltip(clothingFemale)},
                            which cover [com]Should be "covers" in case of "loincloth". Singular/multiplicative in items?[/com]
                            your stone-turned-scales, are in the creature's way.
                            Incapable of tearing through the fabric with its genitals alone,
                            the beast relents in its efforts to find a suitable hole to pound after a few more tries.
                        [/p]
                        [p]
                            Both it and you disappointed, the basilisk resorts to instead fucking the gap between your petrified thighs,
                            grinding its ridged length against your ${global.kobold.inventory.createItemWithTooltip(clothingFemale)}-clad cunt.
                            The crocodillian appears to be entirely unfazed by the coarse texture of your once-soft upper legs.
                            As their kind is partly composed out of stone-like material,
                            you imagine basilisk sex must [b]always[/b] be like ramming a dick into a rock-hewn hole.
                        [/p]
                        [p]
                            The basilisk's considerable length, pumping deftly from the back of your legs all the way up to your belly button,
                            occasionally squirts a heady glob of precum, a small puddle of which is forming on the ground beneath you.
                            Its strong, pheromone-laden scent clouds your mind.
                            It's almost as [b]hypnotizing[/b] as the beast's eyes were.
                            You find yourself eagerly taking in deep breaths through your nose,
                            in an attempt to inhale as much of the [b]delectable[/b] fragrance as you possibly can.
                        [/p]
                        [p]
                            While far less pleasurable than the intense, bestial pounding you had hoped for,
                            you find yourself growing exceedingly aroused still,
                            the constant frotting against your slit,
                            combined with the undeniably [b]masculine[/b] smell permeating every breath you take,
                            causes your cunt to rapidly moisten.
                            A large spot of feminine excitement forms on your ${global.kobold.inventory.createItemWithTooltip(clothingFemale)},
                            the slick feeling of which spurs the creature on further.
                        [/p]
                        [p]
                            It's a weird feeling, to be aroused to no end by oh-so-little stimulation,
                            yet being denied the full pleasure you hoped you would receive from this situation.
                            Despite desperately wanting to get off, some part of you actually [i]enjoys[/i] the fact you aren't being fucked directly.
                            It reinforces the notion that this entire thing is [b]not[b] about [i]you[/i].
                            It's about a large, uncaring [b]monster[/b] sating its [b]animalistic lust[/b] on your body, in whatever way it can.
                            And [b]that[/b] turns you on more than anything else.
                        [/p]
                        [p]
                            The basilisk, uncaring about your pleasure,
                            continues to hump away at your thighs, its ridged shaft grinding along your twat and your stone-turned belly both.
                            Being an animal, however, it doesn't last long.
                            No more than five minutes after crawling on your back, you can already [b]sense[/b] its approaching orgasm.
                            Its movements become more erratic, a small growl rumbles from the back of its throat, and its large maw opens ever so slightly,
                            the creature seemingly [b]huffing[/b] and [b]panting[/b] through its mouth the same way a dog would.
                        [/p]
                        [p]
                            A few moments later, the monster reaches its end, 
                            its incessant thigh-fucking giving way to a series of fierce thrusts,
                            while squirt after squirt of thick basilisk spunk covers the stone floor and
                            your ${shirt ? `${global.kobold.inventory.createItemWithTooltip(shirt)}` : `lower body`},
                            the heavy scent adding to the lingering odor of bestial masculinity hanging in the air, driving your mind [b]wild[/b] with unsated desire.
                        [/p]
                        [p]
                            Once its climax starts to fade, the large reptillian slowly shifts its weight off of your back.
                            Its member receding into its body, the creature crawls back towards the hole it came from,
                            and before you even have the [b]chance[/b] to [b]try[/b] to [b]beg[/b] it to continue,
                            the basilisk disappears back into the darkness, leaving you trapped and aroused,
                            unable to get off while constantly being tempted by the aroma of the puddle of feral cum directly below you.
                        [/p]`;
            } else {
                global.kobold.history.shared.well.basiliskPenetrated = true;
                toReturn += `
                        [p]
                            Despite most of your rear end being completely numb, you can feel the creature's
                            member pressing against your still sensitive slit.
                            It's so [b]warm[/b] and [b]thick[/b].
                            [b]Definitely[/b] dragon-like.
                            You [b]want[/b] it.
                        [/p]
                        [p]
                            After a few moments of resting idly, the reptile pulls its length back.
                            It begins to hump against your groin, prodding and poking your petrified loins, looking for a hole to [b]fuck[/b].
                            After the third or fourth try, it hits its mark,
                            its thick, tapered cock [b]ramming[/b] into your cunt.
                            ${cuntVirgin ? `A small amount of blood leaks from your slit, signifying the loss of your virginity, to a monster in a cave no less.` : ``}
                            Once firmly lodged inside of you, the beast immediately begins to thrust in and out of your body,
                            its rapid pace only matched by its feral ferocity.
                        [/p]
                        [p]
                            While your folds are numb from petrification, your stretched insides are not.
                            Your twat [b]hurts[/b] from the slightly oversized insertion,
                            although the pain quickly gets drowned out by the pleasure of being [b]taken[/b] by a feral [b]beast[/b].
                            The crocodillian appears to be entirely unfazed by the coarse texture of your folds.
                            As their kind is partly composed out of stone-like material,
                            you imagine basilisk sex must [b]always[/b] feel like ramming a dick into a rock-hewn hole.
                        [/p]
                        [p]
                            You aren't sure exactly [i]how much[/i] of the creature's length is being forced inside of you,
                            but you figure it must be at least more than half.
                            It [b]feels[/b] like a lot, anyway.
                            Each of the individual ridges lining its shaft pop into and out of your cunt, sending waves of pure [b]pleasure[/b] coursing down your spine.
                            Every few thrusts, a squirt of thick, warm precum shoots from the tip of the monster's draconic member,
                            which combined with your own arousal, slickens your insides.
                            The extra lubrication allows the beast to fuck you [b]harder[/b] and [b]faster[/b],
                            its cock going just [i]slightly[/i], but [b]noticeably[/b] deeper than before.
                        [/p]
                        [p]
                            The smell of pure, bestial [b]sex[/b] spreads throughout the cave,
                            the strong and masculine-pheromone laden scent of the self-exerting basilisk clouding your mind.
                            It's almost as [b]hypnotizing[/b] as the beast's eyes were.
                            You find yourself eagerly taking in deep breaths through your nose,
                            in an attempt to inhale as much of the [b]delectable[/b] fragrance as you possibly can.
                        [/p]
                        [p]
                            The intense, feral [b]rutting[/b] is every bit as pleasurable as you imagined it to be.
                            Less than a minute in, you can already feel your end approaching.
                            Your insides quiver and spasm, [b]milking[/b] the beast for all he has.
                            If your mouth would open, you'd [b]scream[/b] in pleasure, but all you manage is a muffled moan.
                            Your toes, one of the few parts of your body that you can actually [i]move[/i],
                            curl up from sheer orgasmic bliss as a world-rocking climax hits your body hard.
                        [/p]
                        [p]
                            Your feminine fluids drip down to the ground, but the crocodillian isn't done yet.
                            You slowly curl your stiff tail around it, pulling it in just a little bit closer while it continues to hump away.
                            It is then that you realize that this entire thing is [b]not[b] about [i]you[/i].
                            It's about a large, uncaring [b]monster[/b] sating its [b]animalistic lust[/b] on your body.
                            And [b]that[/b] turns you on more than anything else.
                        [/p]
                        [p]
                            The basilisk's ridged shaft almost completely bottoms out inside of you.
                            Your belly would be bulging ever-so-slightly if not turned to stone.
                            While the rough [b]breeding[/b] is one of the best things you've ever experienced,
                            your animal partner fails to last long enough to rock your world more than once,
                            the tight confines of your ${cuntVirgin ? `virginal` : ``} cunt proving far more pleasurable than the loins of its own kind.
                        [/p]
                        [p]
                            You can already [b]sense[/b] its approaching orgasm.
                            Its movements become more erratic, a small growl rumbles from the back of its throat, and its large maw opens ever so slightly,
                            the creature seemingly [b]huffing[/b] and [b]panting[/b] through its mouth the same way a dog would.
                            Its incessant rutting giving way to a series of fierce thrusts, a clear indicator of what is to come.
                            A few moments later, the monster reaches its end,
                            wave after wave of hot, thick, [b]fertile[/b] basilisk spunk flooding your insides, filling you to the [b]brim[/b].
                        [/p]
                        [p]
                            Once its climax starts to fade, the large reptillian slowly shifts its weight off of your back,
                            and pulls its length from your slit.
                            A [b]flood[/b] of heady feral cum leaks from your slightly gaping twat,
                            the heavy scent of the stuff adding to the lingering odor of bestial masculinity hanging in the air,
                            driving your mind [b]wild[/b] with desire.
                        [/p]
                        [p]
                            Its member receding into its body, the creature crawls back towards the hole it came from,
                            and before you even have the [b]chance[/b] to [b]try[/b] to [b]beg[/b] it for more,
                            the monster disappears back into the darkness, leaving you freshly fucked, trapped and aroused,
                            unable to get off a second time, no matter how much you want to,
                            all the while being tempted by the aroma of the puddle of fragrant cum dripping from your well-bred slit.
                        [/p]`;
                if (cuntVirgin) {
                    toReturn += `
                        [p]
                            [c]
                                [b]You are no longer a virgin.[/b]
                            [/c]
                        [/p]`;
                }
            }
        }

        return global.parser.parse(toReturn);
    }

    /**
     * Builds and returns the choice button.
     */
    function buildNextChoice() {
        var disabled = subController.continued() ? "disabled" : "";
        var isSelected = subController.continued();
        var selected = isSelected ? "selected" : "";
        var button = `<button class="button inlinechoice ${selected}" id="${continueId}" ${disabled}>Continue</button>`;
        return button;
    }

    /**
     * Builds and returns the choice of this section.
     * @returns {string} The choice of this section.
     */
    function buildChoice() {
        var choice = `<div class="choicecontainer">`;
        choice += buildNextChoice();
        choice += `</div>`;
        return choice;
    }

    /**
     * Disables all three buttons.
     */
    function disableButtons() {
        var buttons = [$("#" + continueId)];
        buttons.forEach(function (button) {
            button.unbind();
            button.attr("disabled", true);
        });
    }

    /**
     * Loads and displays the next part.
     * @param {object} part Which part to load.
     */
    function loadNextPart(part) {
        var built = part.build(true);
        global.ui.appendBeforeFinisher(built, global.ui.genericHeaderId);
        $("#" + part.id).fadeIn(400);
        part.registerListeners();
    }

    /**
     * Adds a listener to the button.
     */
    function registerNextListener() {
        $("#" + continueId).click(function () {
            $(this).addClass("selected");
            disableButtons();
            subController.continue();
            loadNextPart(next);
        });
    }

    // PUBLIC MEMBERS \\        this.public = "test";
    this.id = arguments.callee.name;

    // PUBLIC FUNCTIONS \\      this.publicFunction = function(){};

    /**
     * Builds and returns this part.
     * @param {boolean} invisible If passed and true, will give the entire section a display:none style.
     */
    this.build = function (invisible) {
        if (reqController && ((reqChoice && reqController.get() !== reqChoice) || (!reqChoice && !reqController.continued()))) {
            return "";
        }

        var part = `<div id="${that.id}" ${invisible ? 'style="display:none;"' : ""}>`;
        part += buildContent();
        part += (changeController && changeController.change()) || "";
        part += buildChoice();
        part += `</div>`;
        part += next.build();
        return part;
    };

    /**
     * Registers all the required button listeners for this part.
     */
    this.registerListeners = function () {
        if (reqController && ((reqChoice && reqController.get() !== reqChoice) || (!reqChoice && !reqController.continued()))) {
            return;
        }

        next.registerListeners();

        if (subController.continued()) {
            return;
        }

        registerNextListener();
    };
}

// END scenes\HamletDay2\UndergroundCave\stare\petrified\UndergroundCaveEnjoy.js

// scenes\HamletDay2\UndergroundCave\stare\petrified\UndergroundCaveHate.js

/**
 * Stare section of the Underground Cave.
 * @param {UndergroundCaveController} controller The Underground Cave controller.
 */
function UndergroundCaveHate(controller) {
    // PRIVATE MEMBERS \\       var private = "test";
    var that = this;
    var ctrl = controller;

    var reqChoice = UndergroundCaveRelentChoice.HATE;
    var reqController = ctrl.relent;
    var subController = ctrl.preContinue;
    var changeController = ctrl.hate;

    var continueId = arguments.callee.name + "ButtonOne";
    var next = new UndergroundCaveRegain(ctrl);

    // PRIVATE FUNCTIONS \\     function privateFunction(){}

    /**
     * Builds and returns the content of this section.
     * @returns {string} The content.
     */
    function buildContent() {
        var analVirgin = ctrl.misc.analVirgin();
        var cuntVirgin = ctrl.misc.cuntVirgin();
        var dick = ctrl.misc.dick();
        var shirt = ctrl.misc.shirt();
        var pants = ctrl.misc.pants();
        var underwear = ctrl.misc.underwear();
        var underwearMale = underwear && underwear.coversRear();
        var underwearFemale = underwear && underwear.coversGroin();
        var clothingMale = underwearMale ? underwear : false;
        clothingMale = pants ? pants : clothingMale;
        var clothingFemale = underwearFemale ? underwear : false;
        clothingFemale = pants ? pants : clothingFemale;
        var toReturn = `[p]
                            Despite the basilisk having moved outside of your field of view, the image of the its loins remains burned in your brain.
                            You've witnessed plenty of males of varying species naked, but you've never before seen a dick quite like [i]this[/i].
                            It's not the [i]biggest[/i] around, especially not when compared to [b]horses[/b] or other [i]large[/i] species,
                            but the shape is unlike anything you've ever seen.
                            The closest thing you have to compare it to is a painting of a dragon's genitals you once saw while breaking into a manor.
                            Perhaps basilisks and dragons are related somehow?
                        [/p]
                        [p]
                            Panic wells up inside of you.
                            You can't let this happen!
                            Those ridges'll tear your insides apart!
                            You struggle and strain, desperately trying, but failing to move [b]any[/b] of your limbs.
                            They've all turned to hard, unmoving stone.
                            You use every ounce of concentration you can muster try to shift your tail 
                            -- one of the last few parts of your body you can actually still move -- in between your legs,
                            to at least [b]try[/b] to guard your ${dick ? `butt` : `loins`} from the basilisk's...[i]thing[/i].
                        [/p]
                        [p]
                            Even when trying your very hardest,
                            you still fail to move the near-petrified appendage more than a few inches before the basilisk reaches your rear.
                            It lifts up its upper body, and deftly mounts your backside, resting most of its massive weight on top of your frail frame, 
                            its front two legs ending up directly behind your arms, its muzzle right next to your face.
                            If you weren't petrified, you're certain your legs and arms would [b]buckle[/b] under the pressure.
                            Your tail gets trapped between its underbelly and your back, effectively nullifying your attempt to preserve your dignity.
                        [/p]`;

        if (dick) {
            if (clothingMale) {
                toReturn += `
                        [p]
                            Despite most of your butt being completely numb, you can feel the creature's
                            member pressing against your still somewhat sensitive
                            slit${clothingFemale ? `, even through your ${global.kobold.inventory.createItemWithTooltip(clothingFemale)}` : ``}.
                            It's [b]disgustingly[/b] warm, and the [b]thickness[/b] of it [b]worries you[/b].
                            You can't take something of that size, not to mention the ridges!
                        [/p]
                        [p]
                            After a few seconds of the reptile resting idly, the moment you've feared arrives.
                            It pulls its length back, and begins to hump against your rear, prodding and poking your petrified butt, looking for a hole to [b]fuck[/b].
                            Thank goodness, your ${global.kobold.inventory.createItemWithTooltip(clothingMale)},
                            which cover [com]Should be "covers" in case of "loincloth". Singular/multiplicative in items?[/com]
                            your stone-turned-scales, are in the creature's way.
                            Incapable of tearing through the fabric with its genitals alone,
                            the beast relents in its efforts to find a suitable hole to pound after a few more tries.
                        [/p]
                        [p]
                            It disappointed, and you relieved, the basilisk resorts to instead fucking the gap between your petrified thighs,
                            grinding its ridged length against your
                            ${clothingFemale ? `${global.kobold.inventory.createItemWithTooltip(clothingFemale)}-clad` : ` bare`} cockslit.
                            The crocodillian appears to be entirely unfazed by the coarse texture of your once-soft upper legs.
                            As their kind is partly composed out of stone-like material,
                            you imagine basilisk sex must [b]always[/b] feel like ramming your dick into a rock-hewn hole.
                        [/p]
                        [p]
                            While the worst of your fears have been avoided,
                            getting your thighs fucked by a humping basilisk is still more than a little degrading.
                            You felt deeply ashamed for having fallen for its [i]trap[/i] in the first,
                            but now you feel like a piece of petrified [b]meat[/b],
                            being used by a large, uncaring [b]monster[/b] interested only in sating its [b]animalistic lust[/b] on your body,
                            in whatever way it can.
                            Your pride is severely dented, and that hurts not your body, but your soul.
                        [/p]
                        [p]
                            The basilisk's considerable length, pumping deftly from the back of your legs all the way up to your belly button,
                            occasionally squirts a heady glob of precum, a small puddle of which is forming on the ground beneath you.
                            The strong, pheromone-laden scent of the stuff sickens you to your very core.
                            It doesn't smell [i]too[/i] bad,
                            but the sheer concentration of [b]testosterone[/b] makes every breath you take feel like a [i]challenge[/i] to your masculinity.
                            Even worse is the realization that you'll be stuck, forced to inhale the unwanted smell of basilisk pre -- and ultimately actual -- cum,
                            until your limbs regain their mobility, which you fear might be a long time still.
                        [/p]
                        [p]
                            Despite hating [b]everything[/b] about the situation you find yourself in,
                            you can't say the constant frotting against your cockslit [i]doesn't[/i] feel somewhat [i]good[/i].
                            Still, you find the slight pleasant sensation to be more [b]embarrassing[/b] than it is arousing.
                            What kind of [b]freak[/b] would feel even the tiniest bit of [i]pleasure[/i] while getting [b]abused[/b] by a [b]feral beast?![/b]
                            Not you, that's who.
                            At least so you tell yourself, in an effort to retain [b]some[/b] of your remaining self-esteem.
                        [/p]
                        [p]
                            The basilisk, uncaring about your pleasure (or the lack thereof),
                            continues to hump away at your thighs, its ridged shaft grinding along your cockslit and your stone-turned belly both.
                            Being an animal, it luckily doesn't last very long.
                            No more than five minutes after crawling on your back, you can already [b]sense[/b] its approaching orgasm.
                            Its movements become more erratic, a small growl rumbles from the back of its throat, and its large maw opens ever so slightly,
                            the creature seemingly [b]huffing[/b] and [b]panting[/b] through its mouth the same way a dog would.
                            As if you needed any more reminders that you're being fucked by nothing more than a lowly, feral [b]beast[/b].
                        [/p]
                        [p]
                            A few moments later, the monster reaches its end, 
                            its incessant thigh-fucking giving way to a series of fierce thrusts,
                            while squirt after squirt of thick basilisk spunk covers the stone floor and
                            your ${shirt ? `${global.kobold.inventory.createItemWithTooltip(shirt)}` : `lower body`},
                            the heavy scent adding to the lingering odor of bestial masculinity hanging in the air,
                            which is almost strong enough to make you [b]retch[/b] and [b]gag[/b].
                            Your eyes water out of sheer disgust, a perfect way to mask the few tears that had been welling up since the start of this entire ordeal.
                        [/p]
                        [p]
                            Once its climax starts to fade, the large reptillian slowly shifts its weight off of your back.
                            Its member receding into its body, the creature crawls back towards the hole it came from,
                            and before you even have the [b]chance[/b] to [b]try[/b] to [b]shout obscenities[/b] at it,
                            the basilisk disappears back into the darkness, leaving you trapped, disgusted and crying,
                            unable to escape while forced to inhale the aroma of the puddle of feral cum directly below you.
                        [/p]`;
            } else {
                global.kobold.history.shared.well.basiliskPenetrated = true;
                toReturn += `
                        [p]
                            Despite most of your butt being completely numb, you can feel the creature's
                            member pressing against your still somewhat sensitive
                            slit${clothingFemale ? `, even through your ${global.kobold.inventory.createItemWithTooltip(clothingFemale)}` : ``}.
                            It's [b]disgustingly[/b] warm, and the [b]thickness[/b] of it [b]worries you[/b].
                            You can't take something of that size, not to mention the ridges!
                        [/p]
                        [p]
                            After a few seconds of the reptile resting idly, the moment you've feared arrives.
                            It pulls its length back, and begins to hump against your rear, prodding and poking your petrified butt, looking for a hole to [b]fuck[/b].
                            After the third or fourth try, it hits its mark,
                            its thick, tapered cock crudely [b]ramming[/b] into your unlubed${analVirgin ? `, virginal` : ``} tailhole.
                            Spikes of pain shoot up your spine.
                            You want to [b]scream[/b] out in agony, yet all can manage to utter is a muffled grunt.
                            Once firmly lodged inside of you, the beast painfully begins to thrust in and out of your body,
                            its rapid pace only matched by its feral ferocity.
                        [/p]
                        [p]
                            While your buttcheeks are numb from petrification, your stretched insides are not.
                            Your ass [b]hurts[/b] from the oversized insertion,
                            the monster's cock far too [i]girthy[/i] for your tender, frail body.
                            The crocodillian appears to be entirely unfazed by the coarse texture of your buttcheeks.
                            As their kind is partly composed out of stone-like material,
                            you imagine basilisk sex must [b]always[/b] feel like ramming your dick into a rock-hewn hole.
                        [/p]
                        [p]
                            You aren't sure exactly [i]how much[/i] of the beast's length is being forced inside of you,
                            but you figure it must be at least more than half.
                            You don't know whether you're too tight for it to push in any deeper,
                            or if the creature is showing you some kind of [i]mercy[/i] by not making you take its full length.
                            The ridges, which you dreaded the most, are luckily not as bad as you'd imagined.
                            They don't feel [i]pleasant[/i] popping in and out of your rear, but neither do they [i]hurt[/i].
                        [p]
                        [/p]
                            Every few thrusts, a squirt of thick, warm precum shoots from the tip of the monster's draconic member, slickening your insides.
                            A double edged blade.
                            On one hand, the lubrication eases the beast's thrusts, making the entire ordeal slightly less [b]agonizing[/b].
                            Your tailhole slowly growing accustomed to being stretched to its near-limits,
                            also helps reducing what was once excruciating torment into the mere feeling of constant uncomfortableness,
                            with just a little bit of pain on the side.
                            The other end of the rope is that the crocodillian can now pick up its pace, thoroughly [b]rutting[/b] you like the [b]basilisk bitch[/b] you are.
                            The less your ass hurts, the more your pride does.
                        [/p]
                        [p]
                            The basilisk, uncaring about your pain,
                            continues to dutifully hump away, its ridged shaft uncomfortably forcing itself just a little bit deeper inside of you.
                            Your belly would be bulging ever-so-slightly if not turned to stone.
                            While the rough fucking is one of the most degrading things you've ever experienced,
                            the animal luckily fails to last for more than a few minutes,
                            the tight confines of your ${analVirgin ? `virginal` : ``} tailhole proving far more pleasurable than the loins of its own kind,
                            even if that pleasure is far from mutual.
                        [/p]
                        [p]
                            You can already [b]sense[/b] its approaching orgasm.
                            Its movements become more erratic, a small growl rumbles from the back of its throat, and its large maw opens ever so slightly,
                            the creature seemingly [b]huffing[/b] and [b]panting[/b] through its mouth the same way a dog would.
                            As if you needed any more reminders that you're being rutted by nothing more than a lowly, feral [b]beast[/b].
                            Its incessant buttfucking gives way to a series of fierce thrusts, a clear indicator of what is to come.
                            A few extra-rough pumps later, the monster reaches its end,
                            wave after wave of warm, thick basilisk spunk flooding your body, filling up your insides to the [b]brim[/b].
                        [/p]
                        [p]
                            Once its climax starts to fade, the large reptillian slowly shifts its weight off of your back,
                            and pulls its length from your rear.
                            A [b]flood[/b] of heady feral cum leaks from your slightly gaping ass,
                            the heavy scent of the stuff adding to the lingering odor of bestial masculinity hanging in the air,
                            which is almost strong enough to make you [b]retch[/b] and [b]gag[/b].
                            Your eyes water out of sheer disgust, a perfect way to mask the few tears that had been welling up since the start of this entire ordeal.
                        [/p]
                        [p]
                            Its member receding into its body, the creature crawls back towards the hole it came from,
                            and before you even have the [b]chance[/b] to [b]try[/b] to [b]shout obscenities[/b] at it,
                            the monster disappears back into the darkness, leaving you trapped, disgusted and crying,
                            unable to escape while forced to inhale the aroma of the puddle of feral cum dripping from your abused tailhole.
                        [/p]`;
                if (analVirgin) {
                    toReturn += `
                        [p]
                            [c]
                                [b]You are no longer a virgin.[/b]
                            [/c]
                        [/p]`;
                }
            }
        } else {
            if (clothingFemale) {
                toReturn += `
                        [p]
                            Despite most of your rear end being completely numb, you can feel the creature's
                            member pressing against your still somewhat sensitive
                            slit, even through your ${global.kobold.inventory.createItemWithTooltip(clothingFemale)}.
                            It's [b]disgustingly[/b] warm, and the [b]thickness[/b] of it [b]worries you[/b].
                            You can't take something of that size, not to mention the ridges!
                        [/p]
                        [p]
                            After a few seconds of the reptile resting idly, the moment you've feared arrives.
                            It pulls its length back, and begins to hump against your groin, prodding and poking your petrified loins, looking for a hole to [b]fuck[/b].
                            Thank goodness, your ${global.kobold.inventory.createItemWithTooltip(clothingFemale)},
                            which cover [com]Should be "covers" in case of "loincloth". Singular/multiplicative in items?[/com]
                            your stone-turned-scales, are in the creature's way.
                            Incapable of tearing through the fabric with its genitals alone,
                            the beast relents in its efforts to find a suitable hole to pound after a few more tries.
                        [/p]
                        [p]
                            It disappointed, and you relieved, the basilisk resorts to instead fucking the gap between your petrified thighs,
                            grinding its ridged length against your ${global.kobold.inventory.createItemWithTooltip(clothingFemale)}-clad cunt.
                            The crocodillian appears to be entirely unfazed by the coarse texture of your once-soft upper legs.
                            As their kind is partly composed out of stone-like material,
                            you imagine basilisk sex must [b]always[/b] be like ramming a dick into a rock-hewn hole.
                        [/p]
                        [p]
                            While the worst of your fears have been avoided,
                            getting your thighs fucked by a humping basilisk is still more than a little degrading.
                            You felt deeply ashamed for having fallen for its [i]trap[/i] in the first,
                            but now you feel like a piece of petrified [b]meat[/b],
                            being used by a large, uncaring [b]monster[/b] interested only in sating its [b]animalistic lust[/b] on your body,
                            in whatever way it can.
                            Your pride is severely dented, and that hurts not your body, but your soul.
                        [/p]
                        [p]
                            The basilisk's considerable length, pumping deftly from the back of your legs all the way up to your belly button,
                            occasionally squirts a heady glob of precum, a small puddle of which is forming on the ground beneath you.
                            The strong, pheromone-laden scent of the stuff sickens you to your very core.
                            It doesn't smell [i]too[/i] bad,
                            but the sheer concentration of [b]testosterone[/b] makes every breath you take feel like a
                            [i]challenge[/i] to your natural instinct of [b]submitting[/b] to the powerful, if feral, male on top of you.
                            Even worse is the realization that you'll be stuck, forced to inhale the unwanted smell of basilisk pre -- and ultimately actual -- cum,
                            until your limbs regain their mobility, which you fear might be a long time still.
                        [/p]
                        [p]
                            Despite hating [b]everything[/b] about the situation you find yourself in,
                            you can't say the constant frotting against your slit [i]doesn't[/i] feel somewhat [i]good[/i].
                            Still, you find the slight pleasant sensation to be more [b]embarrassing[/b] than it is arousing.
                            What kind of [b]freak[/b] would feel even the tiniest bit of [i]pleasure[/i] while getting [b]abused[/b] by a [b]feral beast?![/b]
                            Not you, that's who.
                            At least so you tell yourself, in an effort to retain [b]some[/b] of your remaining self-esteem.
                        [/p]
                        [p]
                            The basilisk, uncaring about your pleasure (or the lack thereof),
                            continues to hump away at your thighs, its ridged shaft grinding along your twat and your stone-turned belly both.
                            Being an animal, it luckily doesn't last very long.
                            No more than five minutes after crawling on your back, you can already [b]sense[/b] its approaching orgasm.
                            Its movements become more erratic, a small growl rumbles from the back of its throat, and its large maw opens ever so slightly,
                            the creature seemingly [b]huffing[/b] and [b]panting[/b] through its mouth the same way a dog would.
                            As if you needed any more reminders that you're being fucked by nothing more than a lowly, feral [b]beast[/b].
                        [/p]
                        [p]
                            A few moments later, the monster reaches its end, 
                            its incessant thigh-fucking giving way to a series of fierce thrusts,
                            while squirt after squirt of thick basilisk spunk covers the stone floor and
                            your ${shirt ? `${global.kobold.inventory.createItemWithTooltip(shirt)}` : `lower body`},
                            the heavy scent adding to the lingering odor of bestial masculinity hanging in the air,
                            which is almost strong enough to make you [b]retch[/b] and [b]gag[/b].
                            Your eyes water out of sheer disgust, a perfect way to mask the few tears that had been welling up since the start of this entire ordeal.
                        [/p]
                        [p]
                            Once its climax starts to fade, the large reptillian slowly shifts its weight off of your back.
                            Its member receding into its body, the creature crawls back towards the hole it came from,
                            and before you even have the [b]chance[/b] to [b]try[/b] to [b]shout obscenities[/b] at it,
                            the basilisk disappears back into the darkness, leaving you trapped and disgusted,
                            unable to escape while forced to inhale the aroma of the puddle of feral cum directly below you.
                        [/p]`;
            } else {
                global.kobold.history.shared.well.basiliskPenetrated = true;
                toReturn += `
                        [p]
                            Despite most of your rear end being completely numb, you can feel the creature's
                            member pressing against your still sensitive slit.
                            It's [b]disgustingly[/b] warm, and the [b]thickness[/b] of it [b]worries you[/b].
                            You can't take something of that size, not to mention the ridges!
                        [/p]
                        [p]
                            After a few seconds of the reptile resting idly, the moment you've feared arrives.
                            It begins to hump against your groin, prodding and poking your petrified loins, looking for a hole to [b]fuck[/b].
                            After the third or fourth try, it hits its mark,
                            its thick, tapered cock crudely [b]ramming[/b] into your unlubed cunt.
                            ${cuntVirgin ? `A small amount of blood leaks from your slit, signifying the loss of your virginity, to a monster in a cave no less.` : ``}
                            Once firmly lodged inside of you, the beast immediately begins to thrust in and out of your body,
                            its rapid pace only matched by its feral ferocity.
                        [/p]
                        [p]
                            While your folds are numb from petrification, your stretched insides are not.
                            Your twat [b]hurts[/b] from the oversized insertion,
                            the monster's cock far too [i]girthy[/i] for your tender, frail body.
                            The crocodillian appears to be entirely unfazed by the coarse texture of your folds.
                            As their kind is partly composed out of stone-like material,
                            you imagine basilisk sex must [b]always[/b] feel like ramming a dick into a rock-hewn hole.
                        [/p]
                        [p]
                            You aren't sure exactly [i]how much[/i] of the creature's length is being forced inside of you,
                            but you figure it must be at least more than half.
                            You don't know whether you're too tight for it to push in any deeper,
                            or if the creature is showing you some kind of [i]mercy[/i] by not making you take its full length.
                            The ridges, which you dreaded the most, are luckily not as bad as you'd imagined.
                            They don't feel [i]pleasant[/i] popping in and out of your slit, but neither do they [i]hurt[/i].
                        [/p]
                        [p]
                            Every few thrusts, a squirt of thick, warm precum shoots from the tip of the monster's draconic member, slickening your insides.
                            A double edged blade.
                            On one hand, the lubrication eases the beast's thrusts, making the entire ordeal slightly less [b]agonizing[/b].
                            Your cunt slowly growing accustomed to being stretched to its near-limits,
                            also helps reducing what was once excruciating torment into the mere feeling of constant uncomfortableness,
                            with just a little bit of pain on the side.
                            The other end of the rope is that the crocodillian can now pick up its pace, thoroughly [b]rutting[/b] you like the [b]basilisk bitch[/b] you are.
                            The less your groin hurts, the more your pride does.
                        [/p]
                        [p]
                            The basilisk, uncaring about your pain,
                            continues to dutifully hump away, its ridged shaft uncomfortably forcing itself just a little bit deeper inside of you.
                            Your belly would be bulging ever-so-slightly if not turned to stone.
                            While the rough fucking is one of the most degrading things you've ever experienced,
                            the animal luckily fails to last for more than a few minutes,
                            the tight confines of your ${cuntVirgin ? `virginal` : ``} slit proving far more pleasurable than the loins of its own kind,
                            even if that pleasure is far from mutual.
                        [/p]
                        [p]
                            You can already [b]sense[/b] its approaching orgasm.
                            Its movements become more erratic, a small growl rumbles from the back of its throat, and its large maw opens ever so slightly,
                            the creature seemingly [b]huffing[/b] and [b]panting[/b] through its mouth the same way a dog would.
                            As if you needed any more reminders that you're being rutted by nothing more than a lowly, feral [b]beast[/b].
                            Its incessant humping give way to a series of fierce thrusts, a clear indicator of what is to come.
                            A few moments later, the monster reaches its end,
                            wave after wave of warm, thick, [b]fertile[/b] basilisk spunk flooding your insides, filling you to the [b]brim[/b].
                        [/p]
                        [p]
                            Once its climax starts to fade, the large reptillian slowly shifts its weight off of your back,
                            and pulls its length from your slit.
                            A [b]flood[/b] of heady feral cum leaks from your slightly gaping twat,
                            the heavy scent of the stuff adding to the lingering odor of bestial masculinity hanging in the air,
                            which is almost strong enough to make you [b]retch[/b] and [b]gag[/b].
                            Your eyes water out of sheer disgust, a perfect way to mask the few tears that had been welling up since the start of this entire ordeal.
                        [/p]
                        [p]
                            Its member receding into its body, the creature crawls back towards the hole it came from,
                            and before you even have the [b]chance[/b] to [b]try[/b] to [b]shout obscenities[/b] at it,
                            the monster disappears back into the darkness, leaving you trapped, disgusted and crying,
                            unable to escape while forced to inhale the aroma of the puddle of feral cum dripping from your abused, well-bred slit.
                        [/p]`;
                if (cuntVirgin) {
                    toReturn += `
                        [p]
                            [c]
                                [b]You are no longer a virgin.[/b]
                            [/c]
                        [/p]`;
                }
            }
        }
        return global.parser.parse(toReturn);
    }

    /**
     * Builds and returns the choice button.
     */
    function buildNextChoice() {
        var disabled = subController.continued() ? "disabled" : "";
        var isSelected = subController.continued();
        var selected = isSelected ? "selected" : "";
        var button = `<button class="button inlinechoice ${selected}" id="${continueId}" ${disabled}>Continue</button>`;
        return button;
    }

    /**
     * Builds and returns the choice of this section.
     * @returns {string} The choice of this section.
     */
    function buildChoice() {
        var choice = `<div class="choicecontainer">`;
        choice += buildNextChoice();
        choice += `</div>`;
        return choice;
    }

    /**
     * Disables all three buttons.
     */
    function disableButtons() {
        var buttons = [$("#" + continueId)];
        buttons.forEach(function (button) {
            button.unbind();
            button.attr("disabled", true);
        });
    }

    /**
     * Loads and displays the next part.
     * @param {object} part Which part to load.
     */
    function loadNextPart(part) {
        var built = part.build(true);
        global.ui.appendBeforeFinisher(built, global.ui.genericHeaderId);
        $("#" + part.id).fadeIn(400);
        part.registerListeners();
    }

    /**
     * Adds a listener to the button.
     */
    function registerNextListener() {
        $("#" + continueId).click(function () {
            $(this).addClass("selected");
            disableButtons();
            subController.continue();
            loadNextPart(next);
        });
    }

    // PUBLIC MEMBERS \\        this.public = "test";
    this.id = arguments.callee.name;

    // PUBLIC FUNCTIONS \\      this.publicFunction = function(){};

    /**
     * Builds and returns this part.
     * @param {boolean} invisible If passed and true, will give the entire section a display:none style.
     */
    this.build = function (invisible) {
        if (reqController && ((reqChoice && reqController.get() !== reqChoice) || (!reqChoice && !reqController.continued()))) {
            return "";
        }

        var part = `<div id="${that.id}" ${invisible ? 'style="display:none;"' : ""}>`;
        part += buildContent();
        part += (changeController && changeController.change()) || "";
        part += buildChoice();
        part += `</div>`;
        part += next.build();
        return part;
    };

    /**
     * Registers all the required button listeners for this part.
     */
    this.registerListeners = function () {
        if (reqController && ((reqChoice && reqController.get() !== reqChoice) || (!reqChoice && !reqController.continued()))) {
            return;
        }

        next.registerListeners();

        if (subController.continued()) {
            return;
        }

        registerNextListener();
    };
}

// END scenes\HamletDay2\UndergroundCave\stare\petrified\UndergroundCaveHate.js

// scenes\HamletDay2\UndergroundCave\stare\resist\UndergroundCaveResistFail.js

/**
 * Stare section of the Underground Cave.
 * @param {UndergroundCaveController} controller The Underground Cave controller.
 */
function UndergroundCaveResistFail(controller) {
    // PRIVATE MEMBERS \\       var private = "test";
    var that = this;
    var ctrl = controller;

    var reqChoice = false;
    var reqController = false;
    var subController = ctrl.relent;
    var changeController = false;

    var continueId = arguments.callee.name + "ButtonOne";
    var next = new UndergroundCaveHate(ctrl);

    // PRIVATE FUNCTIONS \\     function privateFunction(){}

    /**
     * Builds and returns the content of this section.
     * @returns {string} The content.
     */
    function buildContent() {
        var toReturn = `[p]
                            [b]No![/b]
                            You can't let this happen!
                            You may have stared into the basilisk's eyes like an [b]idiot[/b], playing right into its cards, but this fight is [b]not[/b] over yet!
                            You begin to focus all of your willpower, all of your energy, [b]everything[/b] you've got on [b]moving[/b] your limbs.
                        [/p]
                        [p]
                            Your hand.
                            That first.
                            If you can move your hand, then you can move [b]anything[/b].
                            You close your eyes.
                            You take deep breaths through your nose.
                            You try to find some inner peace, not an easy task with a huge feral beast drawing near,
                            every scrape of its sharp claws over the stone cavern floor interrupting your meditation.
                            [b]Move, damnit![/b]
                        [/p]
                        ${global.ui.condFail(`Insufficient sanity, intelligence and endurance`)}
                        [p]
                            You try and you try, but your hand remains frozen in place.
                            You can move your fingers, but your palm budges not even an inch.
                            Losing faith, you open your eyes again, only to be greeted by the basilisk's toothy maw, mere inches from your petrified muzzle.
                            You'd be able to feel its warm breath on your scales, were they not turned to numb stone.
                            The creature flicks out its forked tongue, licking your rock-like snout.
                            Perhaps [i]testing[/i] if you're properly turned to stone or just [i]faking it[/i]?
                        [/p]
                        [p]
                            It's too late.
                            Even [b]if[/b] you managed to regain your motion somehow,
                            the beast would probably [b]get startled[/b] and [b]lash out[/b] if you suddenly rose to your feet.
                        [/p]
                        [p]
                            The monster stares deeply into your eyes, but you don't return its inquisitive, probing leer.
                            You've learned [b]not[/b] to peer into a basilisk's eyes, no matter how alluring.
                            Instead, you nervously look away, first to the side, then to the top of the cavern, and finally to the creature's underside.
                            Your sight wandering around the bottom end of the crocodillian's body, you realize that it's definitely [b]male[/b].
                            Its girthy, ridged and draconic-looking member hangs fully erect below its soft underbelly.
                            [i]Oh no.[/i]
                        [/p]
                        [p]
                            After the solemn tongue-flick, the beast lowers its head once more,
                            and begins to crawl around you, towards your backside.
                            Its intentions are [b]very[/b] clear, even to a dumb kobold like yourself.
                        [/p]`;
        return global.parser.parse(toReturn);
    }

    /**
     * Builds and returns the choice button.
     */
    function buildNextChoice() {
        var disabled = subController.continued() ? "disabled" : "";
        var isSelected = subController.continued();
        var selected = isSelected ? "selected" : "";
        var button = `<button class="button inlinechoice ${selected}" id="${continueId}" ${disabled}>Continue</button>`;
        return button;
    }

    /**
     * Builds and returns the choice of this section.
     * @returns {string} The choice of this section.
     */
    function buildChoice() {
        var choice = `<div class="choicecontainer">`;
        choice += buildNextChoice();
        choice += `</div>`;
        return choice;
    }

    /**
     * Disables all three buttons.
     */
    function disableButtons() {
        var buttons = [$("#" + continueId)];
        buttons.forEach(function (button) {
            button.unbind();
            button.attr("disabled", true);
        });
    }

    /**
     * Loads and displays the next part.
     * @param {object} part Which part to load.
     */
    function loadNextPart(part) {
        var built = part.build(true);
        global.ui.appendBeforeFinisher(built, global.ui.genericHeaderId);
        $("#" + part.id).fadeIn(400);
        part.registerListeners();
    }

    /**
     * Adds a listener to the button.
     */
    function registerNextListener() {
        $("#" + continueId).click(function () {
            $(this).addClass("selected");
            disableButtons();
            subController.set(UndergroundCaveRelentChoice.HATE)
            loadNextPart(next);
        });
    }

    // PUBLIC MEMBERS \\        this.public = "test";
    this.id = arguments.callee.name;

    // PUBLIC FUNCTIONS \\      this.publicFunction = function(){};

    /**
     * Builds and returns this part.
     * @param {boolean} invisible If passed and true, will give the entire section a display:none style.
     */
    this.build = function (invisible) {
        if (reqController && ((reqChoice && reqController.get() !== reqChoice) || (!reqChoice && !reqController.continued()))) {
            return "";
        }

        var part = `<div id="${that.id}" ${invisible ? 'style="display:none;"' : ""}>`;
        part += buildContent();
        part += (changeController && changeController.change()) || "";
        part += buildChoice();
        part += `</div>`;
        part += next.build();
        return part;
    };

    /**
     * Registers all the required button listeners for this part.
     */
    this.registerListeners = function () {
        if (reqController && ((reqChoice && reqController.get() !== reqChoice) || (!reqChoice && !reqController.continued()))) {
            return;
        }

        next.registerListeners();

        if (subController.continued()) {
            return;
        }

        registerNextListener();
    };
}

// END scenes\HamletDay2\UndergroundCave\stare\resist\UndergroundCaveResistFail.js

// scenes\HamletDay2\UndergroundCave\stare\resist\UndergroundCaveResistSucceed.js

/**
 * Stare section of the Underground Cave.
 * @param {UndergroundCaveController} controller The Underground Cave controller.
 */
function UndergroundCaveResistSucceed(controller) {
    // PRIVATE MEMBERS \\       var private = "test";
    var that = this;
    var ctrl = controller;

    var reqChoice = false;
    var reqController = false;
    var subController = ctrl.avert;
    var changeController = ctrl.resistSucceed;

    var continueId = arguments.callee.name + "ButtonOne";
    var next = ctrl.fragments.fight;

    // PRIVATE FUNCTIONS \\     function privateFunction(){}

    /**
     * Builds and returns the content of this section.
     * @returns {string} The content.
     */
    function buildContent() {
        var toReturn = `[p]
                            [b]No![/b]
                            You can't let this happen!
                            You may have stared into the basilisk's eyes like an [b]idiot[/b], playing right into its cards, but this fight is [b]not[/b] over yet!
                            You begin to focus all of your willpower, all of your energy, [b]everything[/b] you've got on [b]moving[/b] your limbs.
                        [/p]
                        [p]
                            Your hand.
                            That first.
                            If you can move your hand, then you can move [b]anything[/b].
                            You close your eyes.
                            You take deep breaths through your nose.
                            You try to find some inner peace, not an easy task with a huge feral beast drawing near,
                            every scrape of its sharp claws over the stone cavern floor interrupting your meditation.
                            [b]Move, damnit![/b]
                        [/p]
                        ${global.ui.condSucc(`Sufficient sanity, intelligence and endurance`)}
                        [p]
                            Suddenly, something changes.
                            Your body feels [i]off balance[/i].
                            You open your eyes and look down, to find your right hand lifted ever-so slightly above the ground,
                            no longer supporting the rest of your petrified body.
                            You did it!
                            Through sheer [b]determination[/b] alone, you have managed to raise your hand off of the floor!
                        [/p]
                        [p]
                            Hope rising inside of your mind, you watch as the rocky exterior that had overtaken your limb gives way to your natural scales once more.
                            You realize that the petrification is [b]not[/b] a death sentence.
                            It's like a fast-spreading [b]disease[/b].
                            A [b]blight[/b] brought upon you by staring into the monster's oh-so-alluring eyes.
                            But not an uncurable one.
                            It can be [b]fought[/b].
                            It can be [b]beaten[/b].
                            You just need to [b]concentrate[/b]
                        [/p]`;
        return global.parser.parse(toReturn);
    }

    /**
     * Builds and returns the choice button.
     */
    function buildNextChoice() {
        var disabled = subController.continued() ? "disabled" : "";
        var isSelected = subController.continued();
        var selected = isSelected ? "selected" : "";
        var button = `<button class="button inlinechoice ${selected}" id="${continueId}" ${disabled}>Continue</button>`;
        return button;
    }

    /**
     * Builds and returns the choice of this section.
     * @returns {string} The choice of this section.
     */
    function buildChoice() {
        var choice = `<div class="choicecontainer">`;
        choice += buildNextChoice();
        choice += `</div>`;
        return choice;
    }

    /**
     * Disables all three buttons.
     */
    function disableButtons() {
        var buttons = [$("#" + continueId)];
        buttons.forEach(function (button) {
            button.unbind();
            button.attr("disabled", true);
        });
    }

    /**
     * Loads and displays the next part.
     * @param {object} part Which part to load.
     */
    function loadNextPart(part) {
        var built = part.build(true);
        global.ui.appendBeforeFinisher(built, global.ui.genericHeaderId);
        $("#" + part.id).fadeIn(400);
        part.registerListeners();
    }

    /**
     * Adds a listener to the button.
     */
    function registerNextListener() {
        $("#" + continueId).click(function () {
            $(this).addClass("selected");
            disableButtons();
            subController.set(UndergroundCaveAvertChoice.FIGHT);
            loadNextPart(next);
        });
    }

    // PUBLIC MEMBERS \\        this.public = "test";
    this.id = arguments.callee.name;

    // PUBLIC FUNCTIONS \\      this.publicFunction = function(){};

    /**
     * Builds and returns this part.
     * @param {boolean} invisible If passed and true, will give the entire section a display:none style.
     */
    this.build = function (invisible) {
        if (reqController && ((reqChoice && reqController.get() !== reqChoice) || (!reqChoice && !reqController.continued()))) {
            return "";
        }

        var part = `<div id="${that.id}" ${invisible ? 'style="display:none;"' : ""}>`;
        part += buildContent();
        part += (changeController && changeController.change()) || "";
        part += buildChoice();
        part += `</div>`;
        part += next.build();
        return part;
    };

    /**
     * Registers all the required button listeners for this part.
     */
    this.registerListeners = function () {
        if (reqController && ((reqChoice && reqController.get() !== reqChoice) || (!reqChoice && !reqController.continued()))) {
            return;
        }

        next.registerListeners();

        if (subController.continued()) {
            return;
        }

        registerNextListener();
    };
}

// END scenes\HamletDay2\UndergroundCave\stare\resist\UndergroundCaveResistSucceed.js

// scenes\HamletDay2\UndergroundCave\stare\resist\UndergroundCaveResist.js

/**
 * Stare section of the Underground Cave.
 * @param {UndergroundCaveController} controller The Underground Cave controller.
 */
function UndergroundCaveResist(controller) {
    // PRIVATE MEMBERS \\       var private = "test";
    var that = this;
    var ctrl = controller;

    var reqChoice = UndergroundCaveStareChoice.RESIST;
    var reqController = ctrl.stare;

    var toFail = new UndergroundCaveResistFail(ctrl);
    var toSuccess = new UndergroundCaveResistSucceed(ctrl);

    // PRIVATE FUNCTIONS \\     function privateFunction(){}

    /**
     * Checks whether the choice succeeded or failed.
     */
    function successCheck() {
        var willpower = ctrl.misc.intelligence() + ctrl.misc.endurance();
        var sanityReq = 350 / willpower;
        return ctrl.misc.sanity() > sanityReq;
    }

    // PUBLIC MEMBERS \\        this.public = "test";
    this.id = arguments.callee.name;

    // PUBLIC FUNCTIONS \\      this.publicFunction = function(){};

    /**
     * Builds and returns this part.
     * @param {boolean} invisible If passed and true, will give the entire section a display:none style.
     */
    this.build = function (invisible) {
        if (reqController && ((reqChoice && reqController.get() !== reqChoice) || (!reqChoice && !reqController.continued()))) {
            return "";
        }

        var part = `<div id="${that.id}" ${invisible ? 'style="display:none;"' : ""}>`;
        if (successCheck()) {
            part += toSuccess.build();
        } else {
            part += toFail.build();
        }
        part += `</div>`;
        return part;
    };

    /**
     * Registers all the required button listeners for this part.
     */
    this.registerListeners = function () {
        if (reqController && ((reqChoice && reqController.get() !== reqChoice) || (!reqChoice && !reqController.continued()))) {
            return;
        }

        if (successCheck()) {
            toSuccess.registerListeners();
        } else {
            toFail.registerListeners();
        }
    };
}

// END scenes\HamletDay2\UndergroundCave\stare\resist\UndergroundCaveResist.js

// scenes\HamletDay2\UndergroundCave\stare\relent\UndergroundCaveRelent.js

/**
 * Stare section of the Underground Cave.
 * @param {UndergroundCaveController} controller The Underground Cave controller.
 */
function UndergroundCaveRelent(controller) {
    // PRIVATE MEMBERS \\       var private = "test";
    var that = this;
    var ctrl = controller;

    var reqChoice = UndergroundCaveStareChoice.RELENT;
    var reqController = ctrl.stare;
    var subController = ctrl.relent;
    var changeController = false;

    var firstId = arguments.callee.name + "ButtonOne";
    var secondId = arguments.callee.name + "ButtonTwo";

    var firstNext = new UndergroundCaveHate(ctrl);
    var secondNext = new UndergroundCaveEnjoy(ctrl);

    var firstChoice = UndergroundCaveRelentChoice.HATE;
    var secondChoice = UndergroundCaveRelentChoice.ENJOY;

    // PRIVATE FUNCTIONS \\     function privateFunction(){}

    /**
     * Builds and returns the content of this section.
     * @returns {string} The content.
     */
    function buildContent() {
        global.kobold.history.shared.well.basiliskFucked = true;
        var toReturn = `[p]
                            It's hopeless.
                            You gazed at the basilisk's eyes like an [b]idiot[/b], playing right into its cards.
                            Now most of your body has turned to stone, and you're left completely [b]defenceless[/b].
                            You are at the mercy of the hulking crocodillian, which slowly approaches you from the front.
                        [/p]
                        [p]
                            The creature draws near, crawling over the ground like the reptile it resembles.
                            Once close enough, it raises its upper body off of the ground,
                            positioning its toothy maw mere inches from your petrified muzzle.
                            You'd be able to feel its warm breath on your scales, were they not turned to numb stone.
                            The basilisk flicks out its forked tongue, licking your rock-like snout.
                            Perhaps [i]testing[/i] if you're properly turned to stone or just [i]faking it[/i]?
                        [/p]
                        [p]
                            The monster stares deeply into your eyes, but you don't return its inquisitive, probing leer.
                            While it's too late now, you've learned [b]not[/b] to peer into a basilisk's eyes, no matter how alluring.
                            Instead, you nervously look away, first to the side, then to the top of the cavern, and finally to the creature's underside.
                            Your sight wandering around the bottom end of the crocodillian's body, you realize that it's definitely [b]male[/b].
                            Its girthy, ridged and draconic-looking member hangs fully erect below its soft underbelly.
                            [i]Oh no.[/i]
                        [/p]
                        [p]
                            After the solemn tongue-flick, the beast lowers its head once more,
                            and begins to crawl around you, towards your backside.
                            Its intentions are [b]very[/b] clear, even to a dumb kobold like yourself.
                        [/p]`;

        return global.parser.parse(toReturn);
    }

    /**
     * Builds and returns the choice button.
     */
    function buildFirstChoice() {
        var disabled = subController.has() ? "disabled" : "";
        var isSelected = subController.get() === firstChoice;
        var selected = isSelected ? "selected" : "";
        var button = `<button class="button inlinechoice ${selected}" id="${firstId}" ${disabled}>Hate it</button>`;

        var tooltip = global.parser.parse(`Why the [b]hell[/b] would you enjoy getting fucked by a [b]wild beast[/b]?!`);
        var popupContainer = global.ui.makeToolTip(button, tooltip, false, false, "width: 190px;");
        // Re-wrap with proper positioning.
        button = `<div class="inlinechoice">`;
        button += popupContainer;
        button += `</div>`;

        return button;
    }

    /**
     * Builds and returns the choice button.
     */
    function buildSecondChoice() {
        var disabled = subController.has() ? "disabled" : "";
        var isSelected = subController.get() === secondChoice;
        var selected = isSelected ? "selected" : "";
        var button = `<button class="button inlinechoice ${selected}" id="${secondId}" ${disabled}>Love it</button>`;

        var tooltip = global.parser.parse(`Its member looked [i]exotic[/i]. This might end up being [b]fun[/b].`);
        var popupContainer = global.ui.makeToolTip(button, tooltip, false, false, "width: 190px;");
        // Re-wrap with proper positioning.
        button = `<div class="inlinechoice">`;
        button += popupContainer;
        button += `</div>`;

        return button;
    }

    /**
     * Builds and returns the choice of this section.
     * @returns {string} The choice of this section.
     */
    function buildChoice() {
        var choice = `<div class="choicecontainer"><div class="inlinechoiceheader">You:</div>`;
        choice += buildFirstChoice();
        choice += `<hr class="inlinechoiceseparator">`;
        choice += buildSecondChoice();
        choice += `</div>`;
        return choice;
    }

    /**
     * Disables all three buttons.
     */
    function disableButtons() {
        var buttons = [$("#" + firstId), $("#" + secondId)];
        buttons.forEach(function (button) {
            button.unbind();
            button.attr("disabled", true);
        });
    }

    /**
     * Loads and displays the next part.
     * @param {object} part Which part to load.
     */
    function loadNextPart(part) {
        var built = part.build(true);
        global.ui.appendBeforeFinisher(built, global.ui.genericHeaderId);
        $("#" + part.id).fadeIn(400);
        part.registerListeners();
    }

    /**
     * Adds a listener to the button.
     */
    function registerFirstListener() {
        $("#" + firstId).click(function () {
            $(this).addClass("selected");
            disableButtons();
            subController.set(firstChoice);
            loadNextPart(firstNext);
        });
    }

    /**
     * Adds a listener to the button.
     */
    function registerSecondListener() {
        $("#" + secondId).click(function () {
            $(this).addClass("selected");
            disableButtons();
            subController.set(secondChoice);
            loadNextPart(secondNext);
        });
    }

    // PUBLIC MEMBERS \\        this.public = "test";
    this.id = arguments.callee.name;

    // PUBLIC FUNCTIONS \\      this.publicFunction = function(){};

    /**
     * Builds and returns this part.
     * @param {boolean} invisible If passed and true, will give the entire section a display:none style.
     */
    this.build = function (invisible) {
        if (reqController && ((reqChoice && reqController.get() !== reqChoice) || (!reqChoice && !reqController.continued()))) {
            return "";
        }

        var part = `<div id="${that.id}" ${invisible ? 'style="display:none;"' : ""}>`;
        part += buildContent();
        part += (changeController && changeController.change()) || "";
        part += buildChoice();
        part += `</div>`;
        part += firstNext.build();
        part += secondNext.build();
        return part;
    };

    /**
     * Registers all the required button listeners for this part.
     */
    this.registerListeners = function () {
        if (reqController && ((reqChoice && reqController.get() !== reqChoice) || (!reqChoice && !reqController.continued()))) {
            return;
        }

        firstNext.registerListeners();
        secondNext.registerListeners();

        if (subController.has()) {
            return;
        }

        registerFirstListener();
        registerSecondListener();
    };
}

var UndergroundCaveRelentChoice = {
    HATE: 1,
    ENJOY: 2
};

// END scenes\HamletDay2\UndergroundCave\stare\relent\UndergroundCaveRelent.js

// scenes\HamletDay2\UndergroundCave\stare\UndergroundCaveStare.js

/**
 * Stare section of the Underground Cave.
 * @param {UndergroundCaveController} controller The Underground Cave controller.
 */
function UndergroundCaveStare(controller) {
    // PRIVATE MEMBERS \\       var private = "test";
    var that = this;
    var ctrl = controller;

    var reqChoice = UndergroundCaveSurfaceChoice.STARE;
    var reqController = ctrl.surface;
    var subController = ctrl.stare;
    var changeController = ctrl.stare;

    var firstId = arguments.callee.name + "ButtonOne";
    var secondId = arguments.callee.name + "ButtonTwo";

    var firstNext = new UndergroundCaveResist(ctrl);
    var secondNext = new UndergroundCaveRelent(ctrl);

    var firstChoice = UndergroundCaveStareChoice.RESIST;
    var secondChoice = UndergroundCaveStareChoice.RELENT;

    // PRIVATE FUNCTIONS \\     function privateFunction(){}

    /**
     * Builds and returns the content of this section.
     * @returns {string} The content.
     */
    function buildContent() {
        global.kobold.history.shared.well.basiliskMet = true;
        global.kobold.history.shared.well.basiliskPetrified = true;
        var toReturn = `[p]
                            You can't look away.
                            If this is some kind of predator, then you [b]need[/b] to keep staring at it.
                            Doing anything else'll be seen as a sign of weakness, which might trigger it to attack.
                            Besides, if you stop looking, you might not be able to react in time if it charges you or something.
                        [/p]
                        [p]
                            So you stare.
                            You stare deep into the pair of reptillian eyes, hoping whatever creature is watching you'll just [i]go away[/i].
                            While you may look like it, you are [b]not[/b] a quick bite or an easy prey.
                            You'll fight to your very last breath, in every way you can.
                            Even if that means you have to glare at it for an entire [b]hour[/b], you will not back down, and you will not relent.
                        [/p]
                        [p]
                            Neither the creature, nor you are willing to back down.
                            Minutes pass.
                            You haven't moved an inch.
                            The sight of the alluring, enchanting bright green eyes,
                            combined with the constant sound of dripping of water is sort of [i]hypnotizing[/i].
                            [i]Relaxing[/i], even.
                            If you weren't in the middle of an intense standoff with a lethal monster,
                            you could easily fall asleep to the sound of the splashing droplets.
                        [/p]
                        [p]
                            More time passes.
                            How much more?
                            You don't know.
                            You sort of [i]lost yourself[/i] in the creature's eyes for a while there.
                            Its cold stare is [b]captivating[/b].
                            [b]Enthralling[/b].
                            Maybe this wasn't such a good idea after all.
                            You should, at the very least, change your posture to be better prepared for an eventual [i]attack[/i].
                            You're still on your hands and knees, as you've been ever since you woke up after passing out.
                            Hardly the best stance for [i]combat[/i].
                        [/p]
                        [p]
                            You try to rise to your feet, but for some reason, you [i]can't[/i].
                            Neither your legs, nor your arms seem to be [i]moving[/i].
                            Are your limbs asleep from being on your hands and knees for so long or something?
                            You try to tilt your head downwards to get a better look at your forearms, but even your neck refuses service!
                            Panicking, you break eye contact with the monster.
                            At least your eyeballs can still move.
                        [/p]
                        [p]
                            Looking down, you notice your arms are [i]discolored[/i].
                            Your scales are [i]grey[/i] instead of the usual [b]green[/b].
                            Are you [i]asleep[/i]?
                            Dreaming, perhaps?
                            Is this all a nightmare?
                            You try to open your mouth to scream, but even your muzzle isn't budging.
                            Staring at your own snout, you finally figure out what happened.
                            Stone.
                            Your scales have turned to stone.
                            You've been petrified!
                        [/p]
                        [p]
                            You try every muscle in your body, to see which parts you can still move.
                            Your tongue is still in working order, although your mouth won't open.
                            Your eyes can dart around all they please, but your head itself is unmoving.
                            You retain [i]some[/i] form of control over your tail, the largest of your extremities still in some manner of working order.
                            Fingers are a no-go.
                            Entirely petrified.
                            Your toes, finally.
                            You can wriggle those around slightly, despite both your legs and your feet being locked in place.
                        [/p]
                        [p]
                            While most of your smaller organs and limbs are still fully functional,
                            your body as a whole is completely immobilized.
                            Shocked by this revelation, you barely even notice the creature you were so afraid of leaving its hole,
                            stepping out into the cave proper.
                            Your cross-eyed stare at your own muzzle slowly fading, you become aware of the large,
                            quadrupedal, rock-hided crocodillian standing right in front of you.
                            Your heart nearly skips a beat as you realize what you're dealing with here.
                            A [b]basilisk[/b]!
                        [/p]
                        [p]
                            Seki once told you stories about creatures that could petrify
                            anyone or anything unlucky enough to stare at them for prolonged periods of time,
                            but you thought he was just making things up!
                            You should have listened more carefully to the old bird!
                        [/p]`;

        return global.parser.parse(toReturn);
    }

    /**
     * Builds and returns the choice button.
     */
    function buildFirstChoice() {
        var disabled = subController.has() ? "disabled" : "";
        var isSelected = subController.get() === firstChoice;
        var selected = isSelected ? "selected" : "";
        var button = `<button class="button inlinechoice ${selected}" id="${firstId}" ${disabled}>Resist</button>`;

        var tooltip = global.parser.parse(`You need to break loose from the monster's enchantment!`);
        var popupContainer = global.ui.makeToolTip(button, tooltip, false, false, "width: 190px;");
        // Re-wrap with proper positioning.
        button = `<div class="inlinechoice">`;
        button += popupContainer;
        button += `</div>`;

        return button;
    }

    /**
     * Builds and returns the choice button.
     */
    function buildSecondChoice() {
        var disabled = subController.has() ? "disabled" : "";
        var isSelected = subController.get() === secondChoice;
        var selected = isSelected ? "selected" : "";
        var button = `<button class="button inlinechoice ${selected}" id="${secondId}" ${disabled}>Relent</button>`;

        var tooltip = global.parser.parse(`It's already too late. There's no point to struggling. Let it happen.`);
        var popupContainer = global.ui.makeToolTip(button, tooltip, false, false, "width: 230px;");
        // Re-wrap with proper positioning.
        button = `<div class="inlinechoice">`;
        button += popupContainer;
        button += `</div>`;

        return button;
    }

    /**
     * Builds and returns the choice of this section.
     * @returns {string} The choice of this section.
     */
    function buildChoice() {
        var choice = `<div class="choicecontainer"><div class="inlinechoiceheader">You:</div>`;
        choice += buildFirstChoice();
        choice += `<hr class="inlinechoiceseparator">`;
        choice += buildSecondChoice();
        choice += `</div>`;
        return choice;
    }

    /**
     * Disables all three buttons.
     */
    function disableButtons() {
        var buttons = [$("#" + firstId), $("#" + secondId)];
        buttons.forEach(function (button) {
            button.unbind();
            button.attr("disabled", true);
        });
    }

    /**
     * Loads and displays the next part.
     * @param {object} part Which part to load.
     */
    function loadNextPart(part) {
        var built = part.build(true);
        global.ui.appendBeforeFinisher(built, global.ui.genericHeaderId);
        $("#" + part.id).fadeIn(400);
        part.registerListeners();
    }

    /**
     * Adds a listener to the button.
     */
    function registerFirstListener() {
        $("#" + firstId).click(function () {
            $(this).addClass("selected");
            disableButtons();
            subController.set(firstChoice);
            loadNextPart(firstNext);
        });
    }

    /**
     * Adds a listener to the button.
     */
    function registerSecondListener() {
        $("#" + secondId).click(function () {
            $(this).addClass("selected");
            disableButtons();
            subController.set(secondChoice);
            loadNextPart(secondNext);
        });
    }

    // PUBLIC MEMBERS \\        this.public = "test";
    this.id = arguments.callee.name;

    // PUBLIC FUNCTIONS \\      this.publicFunction = function(){};

    /**
     * Builds and returns this part.
     * @param {boolean} invisible If passed and true, will give the entire section a display:none style.
     */
    this.build = function (invisible) {
        if (reqController && ((reqChoice && reqController.get() !== reqChoice) || (!reqChoice && !reqController.continued()))) {
            return "";
        }

        global.ui.imageBackground.hide();
        var part = `<div id="${that.id}" ${invisible ? 'style="display:none;"' : ""}>`;
        part += buildContent();
        part += (changeController && changeController.change()) || "";
        part += buildChoice();
        part += `</div>`;
        part += firstNext.build();
        part += secondNext.build();
        return part;
    };

    /**
     * Registers all the required button listeners for this part.
     */
    this.registerListeners = function () {
        if (reqController && ((reqChoice && reqController.get() !== reqChoice) || (!reqChoice && !reqController.continued()))) {
            return;
        }

        firstNext.registerListeners();
        secondNext.registerListeners();

        if (subController.has()) {
            return;
        }

        registerFirstListener();
        registerSecondListener();
    };
}

var UndergroundCaveStareChoice = {
    RESIST: 1,
    RELENT: 2
};

// END scenes\HamletDay2\UndergroundCave\stare\UndergroundCaveStare.js

// scenes\HamletDay2\UndergroundCave\run\UndergroundCaveRunContinue.js

/**
 * Run section of the Underground Cave.
 * @param {UndergroundCaveController} controller The Underground Cave controller.
 */
function UndergroundCaveRunContinue(controller) {
    // PRIVATE MEMBERS \\       var private = "test";
    var that = this;
    var ctrl = controller;

    var reqChoice = false;
    var reqController = ctrl.run;
    var changeController = ctrl.run;

    var continueId = arguments.callee.name + "ButtonOne";

    // PRIVATE FUNCTIONS \\     function privateFunction(){}

    /**
     * Builds and returns the content of this section.
     * @returns {string} The content.
     */
    function buildContent() {
        var toReturn = `[p]
                            Swimming in this condition is tough.
                            Your entire body feels [i]stiff[/i], probably due to all the stuff you've been through already.
                            Progress is slow, but the at least the beast isn't following you.
                            After a few minutes of tiring progress, your knackered limbs seem to [i]loosen[/i] a bit more,
                            slightly easing your journey to the entrance of the cave.
                        [/p]
                        [p]
                            A while later, you finally reach the grotto's ingress.
                            As you expected: the waterway led you straight to the river.
                            You swim to the riverbank, and clamber out of water one last time.
                            Sitting your butt down on the dirt, you take a breather.
                            You feel like you've earned one.
                        [/p]
                        [p]
                            You find yourself close to the road to Varanar.
                            In fact, you believe you passed this very place earlier, when heading for the hamlet.
                            You never knew there was a cave here, but then again,
                            you've never really bothered to scour the edge of the river for points of interest.
                        [/p]
                        [p]
                            You've defied death more than once today.
                            You should consider yourself lucky to be alive.
                            The trip into the well was a harrowing experience.
                            You aren't too sure what to take away from all of this.
                            All you know is that you never want to be stuck in another watering hole for the rest of your life.
                        [/p]
                        [p]
                            If nothing else, you've gained a few awesome stories to tell once you've grown old and wise.
                            Stories like the ones Seki used to tell you when you were little.
                            You went through all that trouble to get your mind off of him, and here you are reminiscing once more.
                            You just can't help yourself from clinging to times long gone.
                            Things were so much simpler back then.
                            You miss those days.
                        [/p]
                        [p]
                            The sun is slowly starting to set.
                            You drag yourself to your feet.
                            It's time to go.
                            Varanar isn't [i]that[/i] far off.
                            If your legs don't give out from underneath you, you might still make it there before nightfall.
                        [/p]`;

        return global.parser.parse(toReturn);
    }

    /**
     * Builds and returns the continue button.
     */
    function buildChoice() {
        var disabled = ctrl.continued();
        var choice = `<div class="choicecontainer">`;
        choice += `<button class="button bigbutton continuebutton" id="${continueId}" ${disabled ? "disabled" : ""}>`;
        choice += `Continue &gt;&gt`;
        choice += `</button>`;
        choice += `</div>`;
        return choice;
    }

    /**
     * Disables all three buttons.
     */
    function disableButtons() {
        var buttons = [$("#" + continueId)];
        buttons.forEach(function (button) {
            button.unbind();
            button.attr("disabled", true);
        });
    }

    /**
     * Loads and displays the next scene.
     * @param {string} sceneName Name of the scene to load.
     * @param {string} folder Folder of the scene to load.
     */
    function loadNextPart(sceneName, folder) {
        global.ui.fadeOutContent(function () {
            global.sceneEnd();
            global.sceneLoader.loadScene(sceneName, folder);
        });
    }

    /**
     * Adds a listener to the button.
     */
    function registerContinueListener() {
        $("#" + continueId).click(function () {
            $(this).addClass("selected");
            disableButtons();
            ctrl.continue();
            loadNextPart(ctrl.nextSceneName, ctrl.nextFolderName);
        });
    }

    // PUBLIC MEMBERS \\        this.public = "test";
    this.id = arguments.callee.name;

    // PUBLIC FUNCTIONS \\      this.publicFunction = function(){};

    /**
     * Builds and returns this part.
     * @param {boolean} invisible If passed and true, will give the entire section a display:none style.
     */
    this.build = function (invisible) {
        if (reqController && ((reqChoice && reqController.get() !== reqChoice) || (!reqChoice && !reqController.continued()))) {
            return "";
        }

        ctrl.bgm.stopLoop();
        global.ui.applyTheme("hamlet_day");
        var part = `<div id="${that.id}" ${invisible ? 'style="display:none;"' : ""}>`;
        part += buildContent();
        part += (changeController && changeController.change()) || "";
        part += buildChoice();
        if (!ctrl.nextSceneReady) {
            part += `<span class="todo">There is no content beyond this point.</span>`;
        }
        part += `</div>`;
        return part;
    };

    /**
     * Registers all the required button listeners for this part.
     */
    this.registerListeners = function () {
        if (reqController && ((reqChoice && reqController.get() !== reqChoice) || (!reqChoice && !reqController.continued()))) {
            return;
        }

        if (ctrl.continued()) {
            return;
        }

        if (ctrl.nextSceneReady) {
            registerContinueListener();
        }
    };
}

// END scenes\HamletDay2\UndergroundCave\run\UndergroundCaveRunContinue.js

// scenes\HamletDay2\UndergroundCave\run\UndergroundCaveRun.js

/**
 * Run section of the Underground Cave.
 * @param {UndergroundCaveController} controller The Underground Cave controller.
 */
function UndergroundCaveRun(controller) {
    // PRIVATE MEMBERS \\       var private = "test";
    var that = this;
    var ctrl = controller;

    var reqChoice = UndergroundCaveSurfaceChoice.SWIM;
    var reqController = ctrl.surface;
    var subController = ctrl.run;
    var changeController = false;

    var continueId = arguments.callee.name + "ButtonOne";
    var next = new UndergroundCaveRunContinue(ctrl);

    // PRIVATE FUNCTIONS \\     function privateFunction(){}

    /**
     * Builds and returns the content of this section.
     * @returns {string} The content.
     */
    function buildContent() {
        var toReturn = `[p]
                            Nope.
                            You nearly got crushed, and then you almost drowned, but [b]mysterious cave creatures[/b] is where you draw the line.
                            You are [b]not[/b] ready for this, neither physically nor mentally.
                            It's time to do what kobolds do best: running the fuck away.
                            You may be tired, you may be worn out, you may have gone through [b]hell[/b] already,
                            but you figure you have a tiny [i]smidgen[/i] of adrenaline left, just enough for you to hightail it out of here.
                        [/p]
                        [p]
                            That creature, whatever it is, was here before you, so this must be its home or its nest or whatever you want to call it.
                            If you leave it be, it should have no business pursuing you.
                            Keeping your eyes on it to watch for any sudden movements, you slowly back away, towards the water.
                            You [i]could[/i] run alongside the river-branch, but you think you can move quicker while swimming,
                            plus you won't have to worry about falling down.
                            You crawl into the cold water once again, and breaking eye-contact, you begin to swim away.
                        [/p]`;
        return global.parser.parse(toReturn);
    }

    /**
     * Builds and returns the choice button.
     */
    function buildNextChoice() {
        var disabled = subController.continued() ? "disabled" : "";
        var isSelected = subController.continued();
        var selected = isSelected ? "selected" : "";
        var button = `<button class="button inlinechoice ${selected}" id="${continueId}" ${disabled}>Continue</button>`;
        return button;
    }

    /**
     * Builds and returns the choice of this section.
     * @returns {string} The choice of this section.
     */
    function buildChoice() {
        var choice = `<div class="choicecontainer">`;
        choice += buildNextChoice();
        choice += `</div>`;
        return choice;
    }

    /**
     * Disables all three buttons.
     */
    function disableButtons() {
        var buttons = [$("#" + continueId)];
        buttons.forEach(function (button) {
            button.unbind();
            button.attr("disabled", true);
        });
    }

    /**
     * Loads and displays the next part.
     * @param {object} part Which part to load.
     */
    function loadNextPart(part) {
        var built = part.build(true);
        global.ui.appendBeforeFinisher(built, global.ui.genericHeaderId);
        $("#" + part.id).fadeIn(400);
        part.registerListeners();
    }

    /**
     * Adds a listener to the button.
     */
    function registerNextListener() {
        $("#" + continueId).click(function () {
            $(this).addClass("selected");
            disableButtons();
            subController.continue();
            loadNextPart(next);
        });
    }

    // PUBLIC MEMBERS \\        this.public = "test";
    this.id = arguments.callee.name;

    // PUBLIC FUNCTIONS \\      this.publicFunction = function(){};

    /**
     * Builds and returns this part.
     * @param {boolean} invisible If passed and true, will give the entire section a display:none style.
     */
    this.build = function (invisible) {
        if (reqController && ((reqChoice && reqController.get() !== reqChoice) || (!reqChoice && !reqController.continued()))) {
            return "";
        }

        global.ui.imageBackground.hide();
        var part = `<div id="${that.id}" ${invisible ? 'style="display:none;"' : ""}>`;
        part += buildContent();
        part += (changeController && changeController.change()) || "";
        part += buildChoice();
        part += `</div>`;
        part += next.build();
        return part;
    };

    /**
     * Registers all the required button listeners for this part.
     */
    this.registerListeners = function () {
        if (reqController && ((reqChoice && reqController.get() !== reqChoice) || (!reqChoice && !reqController.continued()))) {
            return;
        }

        next.registerListeners();

        if (subController.continued()) {
            return;
        }

        registerNextListener();
    };
}

// END scenes\HamletDay2\UndergroundCave\run\UndergroundCaveRun.js

// scenes\HamletDay2\UndergroundCave\arrival\UndergroundCaveSurface.js

/**
 * Arrival section of the Underground Cave.
 * @param {UndergroundCaveController} controller The Underground Cave controller.
 */
function UndergroundCaveSurface(controller) {
    // PRIVATE MEMBERS \\       var private = "test";
    var that = this;
    var ctrl = controller;

    var reqChoice = false;
    var reqController = ctrl.arrival;
    var subController = ctrl.surface;
    var changeController = ctrl.surface;

    var firstId = arguments.callee.name + "ButtonOne";
    var secondId = arguments.callee.name + "ButtonTwo";
    var thirdId = arguments.callee.name + "ButtonThree";
    var fourthId = arguments.callee.name + "ButtonFour";

    var firstNext = new UndergroundCaveRun(ctrl);
    var secondNext = new UndergroundCaveAvert(ctrl);
    var thirdNext = new UndergroundCaveStare(ctrl);
    var fourthNext = new UndergroundCaveReflection(ctrl);

    var firstChoice = UndergroundCaveSurfaceChoice.SWIM;
    var secondChoice = UndergroundCaveSurfaceChoice.AVERT;
    var thirdChoice = UndergroundCaveSurfaceChoice.STARE;
    var fourthChoice = UndergroundCaveSurfaceChoice.MIRROR;

    // PRIVATE FUNCTIONS \\     function privateFunction(){}

    /**
     * Builds and returns the content of this section.
     * @returns {string} The content.
     */
    function buildContent() {
        var toReturn = `[p]
                            With a throbbing head, and still-hurting lungs, you wearily awaken from your unpleasant slumber.
                            Your heavy eyelids are slow to open, the cave's dim lighting luckily not [i]too[/i] taxing on your semi-functional brain.
                            You don't know how long you were out for.
                            Heck, you can't even remember getting out of the flooded tunnel.
                            For a few minutes, you lie motionlessly, your mind and body both still recovering from the near-death experience.
                        [/p]
                        [p]
                            While your oxygen intake is steady, every breath you take causes serious chestpains.
                            You feel like you've ingested a box of rusty nails down your windpipe,
                            your respiratory system sore from the back of your throat to the depths of your lungs.
                            Your entire body aches, having been pushed to its very limits and beyond.
                            By all accounts, you should have been long dead,
                            yet through some miraculous combination of luck and determination,
                            or perhaps some kind of divine intervention, you have managed to make it out alive.
                        [/p]
                        [p]
                            You sigh loudly.
                            [b]Everything[/b] hurts.
                            All the oxygen deprivation has taken a hefty toll on your body, not to mention the physical strain.
                            You don't think you can stand up just yet.
                            But you can't keep lying here, either.
                            At the very least, you need to figure out where you are.
                        [/p]
                        [p]
                            You slowly get onto your unsteady hands and knees, and begin to look around.
                            You are definitely in a [i]cave[/i] of some sorts.
                            There's some faint traces of natural light, so there must be an exit somewhere.
                            The body of water you crawled out of stretches along the entire length of the cavern.
                            Must be an offshoot of the river, which means it [i]might[/i] lead back to the outside world.
                        [/p]
                        [p]
                            Besides the water, there isn't much to see.
                            A few holes line the cavern's walls, most of them too tiny -- or too [i]scary[/i] -- for you to squeeze into.
                            You figure they're tunnels, like the one you crawled in through, although yours was [i]submerged[/i].
                            Not that [i]adventure[/i] is on your mind after nearly [b]dying[/b].
                        [/p]
                        [p]
                            While tracing the walls of the cave looking for any [i]danger[/i], your eyes suddenly fall upon a pair of strange, twinkling, sparkling things.
                            Two green lights in the dark depths of one of the many holes.
                            Like wicked braziers in a sea of blackness.
                            They captivate you, their inherent beauty alluring you to stare mindlessly at them.
                            What could they be?
                            Wet, green stones?
                            Emeralds?
                            Jade crystals?
                        [/p]
                        [p]
                            Suddenly, the lights fade.
                            They flicker, if only for half a second.
                            Then you realize.
                            They're not gemstones or rocks.
                            They're [b]eyes[/b].
                            Something is staring at you from the darkness.
                            And it just blinked.
                        [/p]`;

        return global.parser.parse(toReturn);
    }

    /**
     * Builds and returns the choice button.
     */
    function buildFirstChoice() {
        var disabled = subController.has() ? "disabled" : "";
        var isSelected = subController.get() === firstChoice;
        var selected = isSelected ? "selected" : "";
        var button = `<button class="button inlinechoice ${selected}" id="${firstId}" ${disabled}>Swim away</button>`;

        var tooltip = global.parser.parse(`You can probably swim faster than you can run in the dark.`);
        var popupContainer = global.ui.makeToolTip(button, tooltip, false, false, "width: 190px;");
        // Re-wrap with proper positioning.
        button = `<div class="inlinechoice">`;
        button += popupContainer;
        button += `</div>`;

        return button;
    }

    /**
     * Builds and returns the choice button.
     */
    function buildSecondChoice() {
        var disabled = subController.has() ? "disabled" : "";
        var isSelected = subController.get() === secondChoice;
        var selected = isSelected ? "selected" : "";
        var button = `<button class="button inlinechoice ${selected}" id="${secondId}" ${disabled}>Look away</button>`;

        var tooltip = global.parser.parse(`Whatever this thing is, you don't trust its beady eyes.`);
        var popupContainer = global.ui.makeToolTip(button, tooltip, false, false, "width: 190px;");
        // Re-wrap with proper positioning.
        button = `<div class="inlinechoice">`;
        button += popupContainer;
        button += `</div>`;

        return button;
    }

    /**
     * Builds and returns the choice button.
     */
    function buildThirdChoice() {
        var disabled = subController.has() ? "disabled" : "";
        var isSelected = subController.get() === thirdChoice;
        var selected = isSelected ? "selected" : "";
        var button = `<button class="button inlinechoice ${selected}" id="${thirdId}" ${disabled}>Stare</button>`;

        var tooltip = global.parser.parse(`If a staring contest is what this thing wants, you're going to give it one!`);
        var popupContainer = global.ui.makeToolTip(button, tooltip, false, false, "width: 190px;");
        // Re-wrap with proper positioning.
        button = `<div class="inlinechoice">`;
        button += popupContainer;
        button += `</div>`;

        return button;
    }

    /**
     * Builds and returns the choice button.
     */
    function buildFourthChoice() {
        var check = ctrl.misc.hasMisc(new SmallMirror());
        var disabled = subController.has() || !check ? "disabled" : "";
        var isSelected = subController.get() === fourthChoice;
        var selected = isSelected ? "selected" : "";
        var button = `<button class="button inlinechoice ${selected}" id="${fourthId}" ${disabled}>Reflect</button>`;

        var tooltip = global.parser.parse(`Use your mirror to reflect the glare.`);
        if (!check) {
            tooltip = global.parser.parse(`You don't have a mirror to reflect the glare with.`);
        }

        var popupContainer = global.ui.makeToolTip(button, tooltip, false, false, "width: 150px;");
        // Re-wrap with proper positioning.
        button = `<div class="inlinechoice">`;
        button += popupContainer;
        button += `</div>`;

        return button;
    }

    /**
     * Builds and returns the choice of this section.
     * @returns {string} The choice of this section.
     */
    function buildChoice() {
        var choice = `<div class="choicecontainer"><div class="inlinechoiceheader">You:</div>`;
        choice += `<div class="choicerow" style="margin-bottom: 10px;">`;
        choice += buildFirstChoice();
        choice += `<hr class="inlinechoiceseparator">`;
        choice += buildSecondChoice();
        choice += `</div>`;
        choice += `<div class="choicerow">`;
        choice += buildThirdChoice();
        choice += `<hr class="inlinechoiceseparator">`;
        choice += buildFourthChoice();
        choice += `</div>`;
        choice += `</div>`;
        return choice;
    }

    /**
     * Disables all three buttons.
     */
    function disableButtons() {
        var buttons = [$("#" + firstId), $("#" + secondId), $("#" + thirdId), $("#" + fourthId)];
        buttons.forEach(function (button) {
            button.unbind();
            button.attr("disabled", true);
        });
    }

    /**
     * Loads and displays the next part.
     * @param {object} part Which part to load.
     */
    function loadNextPart(part) {
        var built = part.build(true);
        global.ui.appendBeforeFinisher(built, global.ui.genericHeaderId);
        $("#" + part.id).fadeIn(400);
        part.registerListeners();
    }

    /**
     * Adds a listener to the button.
     */
    function registerFirstListener() {
        $("#" + firstId).click(function () {
            $(this).addClass("selected");
            disableButtons();
            subController.set(firstChoice);
            loadNextPart(firstNext);
        });
    }

    /**
     * Adds a listener to the button.
     */
    function registerSecondListener() {
        $("#" + secondId).click(function () {
            $(this).addClass("selected");
            disableButtons();
            subController.set(secondChoice);
            loadNextPart(secondNext);
        });
    }

    /**
     * Adds a listener to the button.
     */
    function registerThirdListener() {
        $("#" + thirdId).click(function () {
            $(this).addClass("selected");
            disableButtons();
            subController.set(thirdChoice);
            loadNextPart(thirdNext);
        });
    }

    /**
     * Adds a listener to the button.
     */
    function registerFourthListener() {
        $("#" + fourthId).click(function () {
            $(this).addClass("selected");
            disableButtons();
            subController.set(fourthChoice);
            loadNextPart(fourthNext);
        });
    }

    // PUBLIC MEMBERS \\        this.public = "test";
    this.id = arguments.callee.name;

    // PUBLIC FUNCTIONS \\      this.publicFunction = function(){};

    /**
     * Builds and returns this part.
     * @param {boolean} invisible If passed and true, will give the entire section a display:none style.
     */
    this.build = function (invisible) {
        if (reqController && ((reqChoice && reqController.get() !== reqChoice) || (!reqChoice && !reqController.continued()))) {
            return "";
        }

        global.ui.imageBackground.show("scenes/HamletDay2/UndergroundCave/img/eyes.gif");
        var part = `<div id="${that.id}" ${invisible ? 'style="display:none;"' : ""}>`;
        part += buildContent();
        part += (changeController && changeController.change()) || "";
        part += buildChoice();
        part += `</div>`;
        part += firstNext.build();
        part += secondNext.build();
        part += thirdNext.build();
        part += fourthNext.build();
        return part;
    };

    /**
     * Registers all the required button listeners for this part.
     */
    this.registerListeners = function () {
        if (reqController && ((reqChoice && reqController.get() !== reqChoice) || (!reqChoice && !reqController.continued()))) {
            return;
        }

        firstNext.registerListeners();
        secondNext.registerListeners();
        thirdNext.registerListeners();
        fourthNext.registerListeners();

        if (subController.has()) {
            return;
        }

        registerFirstListener();
        registerSecondListener();
        registerThirdListener();
        registerFourthListener();
    };
}

var UndergroundCaveSurfaceChoice = {
    SWIM: 1,
    AVERT: 2,
    STARE: 3,
    MIRROR: 4
};

// END scenes\HamletDay2\UndergroundCave\arrival\UndergroundCaveSurface.js

// scenes\HamletDay2\UndergroundCave\arrival\UndergroundCaveArrival.js

/**
 * Arrival section of the Underground Cave.
 * @param {UndergroundCaveController} controller The Underground Cave controller.
 */
function UndergroundCaveArrival(controller) {
    // PRIVATE MEMBERS \\       var private = "test";
    var that = this;
    var ctrl = controller;

    var reqChoice = false;
    var reqController = false;
    var subController = ctrl.arrival;
    var changeController = ctrl.arrival;

    var continueId = arguments.callee.name + "ButtonOne";
    var next = ctrl.fragments.surface;

    // PRIVATE FUNCTIONS \\     function privateFunction(){}

    /**
     * Builds and returns the content of this section.
     * @returns {string} The content.
     */
    function buildContent() {
        var drowned = global.kobold.history.shared.well.drowned;
        var toReturn = `[p]
                            You keep moving forwards through the tiny, cramped tunnel flooded with water,
                            your motions more akin to [b]crawling[/b] than swimming.
                            The shaft is far too small for you to practice any proper swimming strokes.
                            You end up digging the claws of both your hands and your feet into the submerged,
                            muddy dirt surrounding you on all sides, using it to propel you forwards, to clamber onwards.
                        [/p]
                        [p]
                            While the well was dark, there was still [i]some[/i] natural light shining in from the hole at the top.
                            No such luck here.
                            In the submerged pitch-blackness of these claustrophobic depths, not even your perfect night-sight can distinguish rock from mud.
                            Not that you [i]need[/i] to see much.
                            There's only one way to go.
                            And if your head bumps into something, you'll know you've reached the end, of not only the tunnel, but of your life.
                        [/p]
                        [p]
                            You crawl onwards for nearly an entire minute,
                            driven only by the will to live and the fading hope that there will be light at the end of the tunnel.
                            Your lungs ache.
                            They burn, desperately in [b]need[/b] of fresh air${drowned ? ", a feeling you are not entirely unfamiliar with" : ""}.
                            Moving is getting harder.
                            Your limbs begin to slow down.
                            Your extremities grow numb.
                            Your consciousness is fading.
                            The tunnel is widening.
                            Just a little further.
                        [/p]
                        [hl]
                        [p]
                            With a loud [b]splash[/b], you emerge from the water,
                            your half-gone mind barely even [b]registering[/b] the fact that you can breathe once more.
                            Through basic survival instinct, and nothing else, you take a first, small breath,
                            the tiniest sliver of oxygen breathing new life into your fading form.
                            Your eyes shoot open, greeted by the scarcely illuminated sight of a rock-hewn cave,
                            no doubt carved out by the elongated body of water you find yourself in.
                        [/p]
                        [p]
                            But where exactly you are is a concern for later.
                            For now, you greedily gulp down the precious gift of air, savoring it like a fine meal after being starved for [b]months[/b] on end.
                            It fans the flickering flame of your very existence, a fire which came [b]very[/b] close to being extinguished for good.
                            Feeling very lightheaded, like you might pass out still, you meekly swim to the water's stony edge,
                            and with your last ounce of energy, you pull yourself from the liquid, onto dry land.
                            Once secured on the stony cavern floor, your overexerted body collapses, and your weary mind slips into unconsciousness.
                        [/p]`;
        return global.parser.parse(toReturn);
    }

    /**
     * Builds and returns the choice button.
     */
    function buildNextChoice() {
        var disabled = subController.continued() ? "disabled" : "";
        var isSelected = subController.continued();
        var selected = isSelected ? "selected" : "";
        var button = `<button class="button inlinechoice ${selected}" id="${continueId}" ${disabled}>Continue</button>`;
        return button;
    }

    /**
     * Builds and returns the choice of this section.
     * @returns {string} The choice of this section.
     */
    function buildChoice() {
        var choice = `<div class="choicecontainer">`;
        choice += buildNextChoice();
        choice += `</div>`;
        return choice;
    }

    /**
     * Disables all three buttons.
     */
    function disableButtons() {
        var buttons = [$("#" + continueId)];
        buttons.forEach(function (button) {
            button.unbind();
            button.attr("disabled", true);
        });
    }

    /**
     * Loads and displays the next part.
     * @param {object} part Which part to load.
     */
    function loadNextPart(part) {
        var built = part.build(true);
        global.ui.appendBeforeFinisher(built, global.ui.genericHeaderId);
        $("#" + part.id).fadeIn(400);
        part.registerListeners();
    }

    /**
     * Adds a listener to the button.
     */
    function registerNextListener() {
        $("#" + continueId).click(function () {
            $(this).addClass("selected");
            disableButtons();
            subController.continue();
            loadNextPart(next);
        });
    }

    // PUBLIC MEMBERS \\        this.public = "test";
    this.id = arguments.callee.name;

    // PUBLIC FUNCTIONS \\      this.publicFunction = function(){};

    /**
     * Builds and returns this part.
     * @param {boolean} invisible If passed and true, will give the entire section a display:none style.
     */
    this.build = function (invisible) {
        if (reqController && ((reqChoice && reqController.get() !== reqChoice) || (!reqChoice && !reqController.continued()))) {
            return "";
        }

        ctrl.bgm.loop();
        global.ui.applyTheme("hamlet_cave");
        var part = `<div id="${that.id}" ${invisible ? 'style="display:none;"' : ""}>`;
        part += buildContent();
        part += (changeController && changeController.change()) || "";
        part += buildChoice();
        part += `</div>`;
        part += next.build();
        return part;
    };

    /**
     * Registers all the required button listeners for this part.
     */
    this.registerListeners = function () {
        if (reqController && ((reqChoice && reqController.get() !== reqChoice) || (!reqChoice && !reqController.continued()))) {
            return;
        }

        next.registerListeners();

        if (subController.continued()) {
            return;
        }

        registerNextListener();
    };
}

// END scenes\HamletDay2\UndergroundCave\arrival\UndergroundCaveArrival.js

// scenes\HamletDay2\UndergroundCave\UndergroundCaveController.js

/**
 * Controller for the Underground Cave scene.
 * @param {string} sceneId The id of the scene.
 */
function UndergroundCaveController(sceneId) {
    // PRIVATE MEMBERS \\       var private = "test";
    var that = this;
    var id = sceneId;
    SceneController.call(this, id);

    // PRIVATE FUNCTIONS \\     function privateFunction(){}

    // PUBLIC MEMBERS \\        this.public = "test";
    this.nextSceneReady = true;
    this.nextSceneName = "NightTwo";
    this.nextFolderName = "Varanar";

    this.misc = new MiscController(id, "misc");

    this.arrival = new ChangeController(id, "arrival", function () {
        global.kobold.status.physical.decrease(10, "Drowning");
        global.kobold.status.mental.decrease(9, "Near-death experience");
        global.kobold.status.stamina.decrease(10, "Drowning");
    }, function () {
        return global.ui.change.buildNotification([
            new Change("Drowning", "Health", -10),
            new Change("Near-death experience", "Sanity", -10),
            new Change("Still alive", "Sanity", +1),
            new Change("Underwater crawling", "Stamina", -5),
            new Change("Drowning", "Stamina", -5)
        ]);
    });

    // Actually a reset controller.
    this.surface = new UndoController(id, "surface", function change() {
        var healthBacklog = new ChoiceController(id, "surfaceHealthBacklog");
        var sanityBacklog = new ChoiceController(id, "surfaceSanityBacklog");
        var staminaBacklog = new ChoiceController(id, "surfaceStaminaBacklog");
        var exertionBacklog = new ChoiceController(id, "surfaceExertionBacklog");
        var healthLHBacklog = new ChoiceController(id, "surfaceLHHealthBacklog");
        var sanityLHBacklog = new ChoiceController(id, "surfaceLHSanityBacklog");
        var staminaLHBacklog = new ChoiceController(id, "surfaceLHStaminaBacklog");
        var exertionLHBacklog = new ChoiceController(id, "surfaceLHExertionBacklog");
        healthBacklog.set(global.kobold.status.physical.get());
        sanityBacklog.set(global.kobold.status.mental.get());
        staminaBacklog.set(global.kobold.status.stamina.get());
        exertionBacklog.set(global.kobold.status.exertion.get());
        healthLHBacklog.set(global.kobold.status.physical.lasthit);
        sanityLHBacklog.set(global.kobold.status.mental.lasthit);
        staminaLHBacklog.set(global.kobold.status.stamina.lasthit);
        exertionLHBacklog.set(global.kobold.status.exertion.lasthit);
    }, function changeNote() {
        return "";
    }, function undoChange() {
        var healthBacklog = new ChoiceController(id, "surfaceHealthBacklog");
        var sanityBacklog = new ChoiceController(id, "surfaceSanityBacklog");
        var staminaBacklog = new ChoiceController(id, "surfaceStaminaBacklog");
        var exertionBacklog = new ChoiceController(id, "surfaceExertionBacklog");
        var healthLHBacklog = new ChoiceController(id, "surfaceLHHealthBacklog");
        var sanityLHBacklog = new ChoiceController(id, "surfaceLHSanityBacklog");
        var staminaLHBacklog = new ChoiceController(id, "surfaceLHStaminaBacklog");
        var exertionLHBacklog = new ChoiceController(id, "surfaceLHExertionBacklog");
        global.kobold.status.physical.set(healthBacklog.get());
        global.kobold.status.physical.lasthit = healthLHBacklog.get();
        global.kobold.status.mental.set(sanityBacklog.get());
        global.kobold.status.mental.lasthit = sanityLHBacklog.get();
        global.kobold.status.stamina.set(staminaBacklog.get());
        global.kobold.status.stamina.lasthit = staminaLHBacklog.get();
        global.kobold.status.exertion.set(exertionBacklog.get());
        global.kobold.status.exertion.lasthit = exertionLHBacklog.get();
        global.kobold.history.shared.well.basiliskMet = false;
        global.kobold.history.shared.well.basiliskFought = false;
        global.kobold.history.shared.well.basiliskKilled = false;
        global.kobold.history.shared.well.basiliskFriend = false;
        global.kobold.history.shared.well.basiliskPetrified = false;
        global.kobold.history.shared.well.basiliskFucked = false;
        global.kobold.history.shared.well.basiliskPenetrated = false;
        global.kobold.history.shared.well.basiliskEnjoyed = false;
        global.kobold.history.shared.well.basiliskFingerDislocated = false;
        global.kobold.history.shared.well.basiliskDominated = false;
        global.kobold.history.shared.well.basiliskPeed = false;
        global.kobold.history.shared.well.basiliskOral = false;
        global.kobold.history.shared.well.basiliskDomFucked = false;
    });

    this.run = new ChangeController(id, "run", function () {
        global.kobold.status.mental.increase(3, "Escaped the cave");
        global.kobold.status.stamina.decrease(7, "Swimming while exerted");
    }, function () {
        return global.ui.change.buildNotification([
            new Change("Escaped the cave", "Sanity", +3),
            new Change("Swimming", "Stamina", -10),
            new Change("Minor reprieve", "Stamina", +3)
        ]);
    });

    this.stare = new UndoController(id, "stare", function () {
        global.kobold.status.mental.decrease(10, "Being petrified");
    }, function () {
        return global.ui.change.buildNotification([
            new Change("Petrification", "Sanity", -6),
            new Change("Panic", "Sanity", -4)
        ]);
    });

    this.relent = new ChoiceController(id, "relent");

    this.enjoy = new ChangeController(id, "enjoy", function () {
        var dick = that.misc.dick();
        var pants = that.misc.pants();
        var underwear = that.misc.underwear();
        var underwearMale = underwear && underwear.coversRear();
        var underwearFemale = underwear && underwear.coversGroin();
        var clothingMale = underwearMale ? underwear : false;
        clothingMale = pants ? pants : clothingMale;
        var clothingFemale = underwearFemale ? underwear : false;
        clothingFemale = pants ? pants : clothingFemale;
        if (dick) {
            if (clothingMale) {
                that.misc.shirt() && global.kobold.inventory.equipment.shirt.stain("Basilisk Cum");
                global.kobold.status.mental.decrease(3, "Thighfucked by basilisk");
                global.kobold.status.exertion.increase(8, "Thighfucked by basilisk");
            } else {
                global.kobold.body.analVirgin = false;
                global.kobold.status.mental.increase(4, "Basilisk buttsex");
                global.kobold.status.exertion.increase(20, "Basilisk buttsex");
            }
        } else {
            if (clothingFemale) {
                that.misc.shirt() && global.kobold.inventory.equipment.shirt.stain("Basilisk Cum");
                global.kobold.status.mental.decrease(3, "Thighfucked by basilisk");
                global.kobold.status.exertion.increase(8, "Thighfucked by basilisk");
            } else {
                global.kobold.body.vaginalVirgin = false;
                global.kobold.status.mental.increase(10, "Basilisk sex");
                global.kobold.status.exertion.increase(25, "Basilisk sex");
            }
        }
    }, function () {
        var dick = that.misc.dick();
        var pants = that.misc.pants();
        var underwear = that.misc.underwear();
        var underwearMale = underwear && underwear.coversRear();
        var underwearFemale = underwear && underwear.coversGroin();
        var clothingMale = underwearMale ? underwear : false;
        clothingMale = pants ? pants : clothingMale;
        var clothingFemale = underwearFemale ? underwear : false;
        clothingFemale = pants ? pants : clothingFemale;
        if (dick) {
            if (clothingMale) {
                return global.ui.change.buildNotification([
                    new Change("Excitement", "Sanity", +2),
                    new Change("Pleasure denied", "Sanity", -5),
                    new Change("Petrified-thigh-fucked", "Sexual exhaustion", +8, true)
                ]);
            } else {
                return global.ui.change.buildNotification([
                    new Change("Excitement", "Sanity", +2),
                    new Change("Thoroughly rutted", "Sanity", +7),
                    new Change("Pleasure denied", "Sanity", -5),
                    new Change("Ferally buttfucked", "Sexual exhaustion", +20, true)
                ]);
            }
        } else {
            if (clothingFemale) {
                return global.ui.change.buildNotification([
                    new Change("Excitement", "Sanity", +2),
                    new Change("Pleasure denied", "Sanity", -5),
                    new Change("Petrified-thigh-fucked", "Sexual exhaustion", +8, true)
                ]);
            } else {
                return global.ui.change.buildNotification([
                    new Change("Excitement", "Sanity", +2),
                    new Change("Thoroughly rutted", "Sanity", +5),
                    new Change("Reached climax", "Sanity", +5),
                    new Change("Only one orgasm", "Sanity", -2),
                    new Change("Bestially bred", "Sexual exhaustion", +20, true),
                    new Change("Reached orgasm", "Sexual exhaustion", +5, true)
                ]);
            }
        }
    });

    this.hate = new ChangeController(id, "hate", function () {
        var dick = that.misc.dick();
        var pants = that.misc.pants();
        var underwear = that.misc.underwear();
        var underwearMale = underwear && underwear.coversRear();
        var underwearFemale = underwear && underwear.coversGroin();
        var clothingMale = underwearMale ? underwear : false;
        clothingMale = pants ? pants : clothingMale;
        var clothingFemale = underwearFemale ? underwear : false;
        clothingFemale = pants ? pants : clothingFemale;
        if (dick) {
            if (clothingMale) {
                that.misc.shirt() && global.kobold.inventory.equipment.shirt.stain("Basilisk Cum");
                global.kobold.status.mental.decrease(12, "Thighfucked by basilisk");
                global.kobold.status.exertion.increase(8, "Thighfucked by basilisk");
            } else {
                global.kobold.body.analVirgin = false;
                global.kobold.status.physical.decrease(5, "Raped by basilisk");
                global.kobold.status.mental.decrease(20, "Raped by basilisk");
                global.kobold.status.exertion.increase(25, "Raped by basilisk");
            }
        } else {
            if (clothingFemale) {
                that.misc.shirt() && global.kobold.inventory.equipment.shirt.stain("Basilisk Cum");
                global.kobold.status.mental.decrease(12, "Thighfucked by basilisk");
                global.kobold.status.exertion.increase(8, "Thighfucked by basilisk");
            } else {
                global.kobold.body.vaginalVirgin = false;
                global.kobold.status.physical.decrease(5, "Raped by basilisk");
                global.kobold.status.mental.decrease(20, "Raped by basilisk");
                global.kobold.status.exertion.increase(25, "Raped by basilisk");
            }
        }
    }, function () {
        var dick = that.misc.dick();
        var pants = that.misc.pants();
        var underwear = that.misc.underwear();
        var underwearMale = underwear && underwear.coversRear();
        var underwearFemale = underwear && underwear.coversGroin();
        var clothingMale = underwearMale ? underwear : false;
        clothingMale = pants ? pants : clothingMale;
        var clothingFemale = underwearFemale ? underwear : false;
        clothingFemale = pants ? pants : clothingFemale;
        if (dick) {
            if (clothingMale) {
                return global.ui.change.buildNotification([
                    new Change("Defiled", "Sanity", -8),
                    new Change("Thigh-fucked by a feral", "Sanity", -8),
                    new Change("Didn't get penetrated", "Sanity", +4),
                    new Change("Petrified-thigh-raped", "Sexual exhaustion", +8, true)
                ]);
            } else {
                return global.ui.change.buildNotification([
                    new Change("Painful insertion", "Health", -5),
                    new Change("Defiled", "Sanity", -8),
                    new Change("Raped by a beast", "Sanity", -12),
                    new Change("Ferally buttfucked", "Sexual exhaustion", +20, true),
                    new Change("Raped", "Sexual exhaustion", +5, true)
                ]);
            }
        } else {
            if (clothingFemale) {
                return global.ui.change.buildNotification([
                    new Change("Defiled", "Sanity", -8),
                    new Change("Thigh-fucked by a feral", "Sanity", -8),
                    new Change("Didn't get penetrated", "Sanity", +4),
                    new Change("Petrified-thigh-raped", "Sexual exhaustion", +8, true)
                ]);
            } else {
                return global.ui.change.buildNotification([
                    new Change("Painful insertion", "Health", -5),
                    new Change("Defiled", "Sanity", -8),
                    new Change("Raped by a beast", "Sanity", -12),
                    new Change("Ferally bred", "Sexual exhaustion", +20, true),
                    new Change("Raped", "Sexual exhaustion", +5, true)
                ]);
            }
        }
    });

    function regainRelentChange() {
        var dick = that.misc.dick();
        var pants = that.misc.pants();
        var underwear = that.misc.underwear();
        var underwearMale = underwear && underwear.coversRear();
        var underwearFemale = underwear && underwear.coversGroin();
        var clothingMale = underwearMale ? underwear : false;
        clothingMale = pants ? pants : clothingMale;
        var clothingFemale = underwearFemale ? underwear : false;
        clothingFemale = pants ? pants : clothingFemale;

        global.kobold.status.stamina.increase(3, "Minor reprieve");
        global.kobold.stats.decreaseStat(StatsEnum.AGILITY, 1);
        global.kobold.stats.increaseStat(StatsEnum.ENDURANCE, 1);

        if (dick) {
            if (clothingMale) {
                global.kobold.status.mental.decrease(3, "Sexual frustration");
                global.kobold.status.exertion.increase(2, "Sexual frustration");
            } else {
                global.kobold.status.mental.increase(1, "Escaped the cave");
                global.kobold.status.exertion.increase(2, "Sexual frustration");
            }
        } else {
            if (clothingFemale) {
                global.kobold.status.mental.decrease(3, "Sexual frustration");
                global.kobold.status.exertion.increase(2, "Sexual frustration");
            } else {
                global.kobold.status.mental.increase(1, "Escaped the cave");
            }
        }
    }

    function regainRelentNote() {
        var dick = that.misc.dick();
        var pants = that.misc.pants();
        var underwear = that.misc.underwear();
        var underwearMale = underwear && underwear.coversRear();
        var underwearFemale = underwear && underwear.coversGroin();
        var clothingMale = underwearMale ? underwear : false;
        clothingMale = pants ? pants : clothingMale;
        var clothingFemale = underwearFemale ? underwear : false;
        clothingFemale = pants ? pants : clothingFemale;
        if (dick) {
            if (clothingMale) {
                return global.ui.change.buildNotification([
                    new Change("Sexual frustration", "Sanity", -6),
                    new Change("Escaped the cave", "Sanity", +3),
                    new Change("Minor reprieve", "Stamina", +3),
                    new Change("Sexual frustration", "Sexual exhaustion", +2, true),
                    new Change("Petrification after effects", "Agility", -1),
                    new Change("Petrification after effects", "Endurance", +1)
                ]);
            } else {
                return global.ui.change.buildNotification([
                    new Change("Sexual frustration", "Sanity", -2),
                    new Change("Escaped the cave", "Sanity", +3),
                    new Change("Minor reprieve", "Stamina", +3),
                    new Change("Sexual frustration", "Sexual exhaustion", +2, true),
                    new Change("Petrification after effects", "Agility", -1),
                    new Change("Petrification after effects", "Endurance", +1)
                ]);
            }
        } else {
            if (clothingFemale) {
                return global.ui.change.buildNotification([
                    new Change("Sexual frustration", "Sanity", -6),
                    new Change("Escaped the cave", "Sanity", +3),
                    new Change("Minor reprieve", "Stamina", +3),
                    new Change("Sexual frustration", "Sexual exhaustion", +2, true),
                    new Change("Petrification after effects", "Agility", -1),
                    new Change("Petrification after effects", "Endurance", +1)
                ]);
            } else {
                return global.ui.change.buildNotification([
                    new Change("Minor sexual frustration", "Sanity", -2),
                    new Change("Escaped the cave", "Sanity", +3),
                    new Change("Minor reprieve", "Stamina", +3),
                    new Change("Petrification after effects", "Agility", -1),
                    new Change("Petrification after effects", "Endurance", +1)
                ]);
            }
        }
    }

    function regainHateChange() {
        global.kobold.status.mental.decrease(1, "Escaped the cave");
        global.kobold.status.stamina.increase(3, "Minor reprieve");
        global.kobold.stats.decreaseStat(StatsEnum.AGILITY, 1);
        global.kobold.stats.increaseStat(StatsEnum.ENDURANCE, 1);
    }

    function regainHateNote() {
        return global.ui.change.buildNotification([
            new Change("Re-living rape", "Sanity", -2),
            new Change("Self-pity", "Sanity", -2),
            new Change("Escaped the cave", "Sanity", +3),
            new Change("Minor reprieve", "Stamina", +3),
            new Change("Petrification after effects", "Agility", -1),
            new Change("Petrification after effects", "Endurance", +1)
        ]);
    }

    this.regain = new ChangeController(id, "regain", function () {
        if (that.relent.get() === UndergroundCaveRelentChoice.ENJOY) {
            regainRelentChange();
        } else {
            regainHateChange();
        }
    }, function () {
        if (that.relent.get() === UndergroundCaveRelentChoice.ENJOY) {
            return regainRelentNote();
        } else {
            return regainHateNote();
        }
    });

    this.resistFail = new ChoiceController(id, "resistFail");

    this.resistSucceed = new UndoController(id, "resistSucceed", function () {
        global.kobold.status.mental.increase(5, "Resisted petrification");
    }, function () {
        return global.ui.change.buildNotification([
            new Change("Resisted petrification", "Sanity", +5)
        ]);
    });

    this.avert = new UndoController(id, "avert", function () {
        global.kobold.status.mental.decrease(5, "Panicking");
    }, function () {
        return global.ui.change.buildNotification([
            new Change("Panic", "Sanity", -5)
        ]);
    });

    this.nuzzle = new ChangeController(id, "nuzzle", function () {
        global.kobold.status.mental.increase(6, "Cautious optimism");
    }, function () {
        return global.ui.change.buildNotification([
            new Change("Cautious optimism", "Sanity", +6)
        ]);
    });

    this.lick = new ChangeController(id, "lick", function () {
        global.kobold.status.physical.increase(8, "Wound healed");
        global.kobold.status.mental.increase(8, "Cautious optimism");
    }, function () {
        return global.ui.change.buildNotification([
            new Change("Wound healed", "Health", +8),
            new Change("Pain fading", "Sanity", +2),
            new Change("Cautious optimism", "Sanity", +6)
        ]);
    });

    this.doggo = new ChoiceController(id, "doggo");

    this.pet = new ChoiceController(id, "pet");

    this.scratch = new ChangeController(id, "scratch", function () {
        global.kobold.status.mental.increase(9, "Intensive petting");
    }, function () {
        return global.ui.change.buildNotification([
            new Change("Pet the basilisk", "Sanity", +5),
            new Change("Made a friend", "Sanity", +4)
        ]);
    });

    this.throat = new ChangeController(id, "throat", function () {
        global.kobold.status.mental.decrease(5, "Killing the basilisk");
    }, function () {
        return global.ui.change.buildNotification([
            new Change("Killed a vicious creature?", "Sanity", +3),
            new Change("Murdered an animal", "Sanity", -4),
            new Change("Betrayed trust", "Sanity", -4)
        ]);
    });

    this.throatLoot = new ChangeController(id, "throatLoot", function () {
        global.kobold.status.mental.increase(3, "Escaped the cave");
        global.kobold.status.stamina.increase(3, "Minor reprieve");
        global.kobold.inventory.bag.addMisc(new BasiliskScales());
    }, function () {
        return global.ui.change.buildNotification([
            new Change("Escaped the cave", "Sanity", +3),
            new Change("Minor reprieve", "Stamina", +3),
            new Change("Trophies", global.kobold.inventory.createItemWithTooltip(new BasiliskScales(), true), +1)
        ]);
    });

    this.fetch = new ChangeController(id, "fetch", function () {
        that.misc.weapon();
        global.kobold.status.mental.increase(6, "Awkward game of fetch");
        global.kobold.inventory.equipment.strip(SlotEnum.WEAPON);
        global.kobold.inventory.equipment.wear(new PetrifiedBranch());
    }, function () {
        return global.ui.change.buildNotification([
            new Change("Played fetch", "Sanity", +2),
            new Change("Made a friend", "Sanity", +4),
            new Change("Branch petrified", global.kobold.inventory.createItemWithTooltip(that.misc.weapon(), true), -1),
            new Change("New weapon", global.kobold.inventory.createItemWithTooltip(new PetrifiedBranch(), true), +1)
        ]);
    });

    this.feed = new ChangeController(id, "feed", function () {
        global.kobold.status.mental.increase(6, "Fed animal");
        global.kobold.inventory.bag.removeConsumable(new HeartyMeal());
    }, function () {
        return global.ui.change.buildNotification([
            new Change("Fed animal", "Sanity", +2),
            new Change("Made a friend", "Sanity", +4),
            new Change("Lost a meal", global.kobold.inventory.createItemWithTooltip(new HeartyMeal(), true), -1)
        ]);
    });

    this.prePatch = new ChoiceController(id, "prePatch");

    this.basiPatch = new ChoiceController(id, "basiPatch");

    this.basiTake = new ChangeController(id, "basiTake", function () {
        global.kobold.inventory.equipment.wear(new Eyepatch());
    }, function () {
        return global.ui.change.buildNotification([
            new Change("Took eyepatch", global.kobold.inventory.createItemWithTooltip(new Eyepatch(), true), +1)
        ]);
    });

    this.basiLeave = new ChangeController(id, "basiLeave", function () {
        global.kobold.status.mental.decrease(1, "Left friend behind");
        global.kobold.status.stamina.increase(3, "Minor reprieve");
    }, function () {
        return global.ui.change.buildNotification([
            new Change("Escaped the cave", "Sanity", +3),
            new Change("Left behind the basilisk", "Sanity", -4),
            new Change("Minor reprieve", "Stamina", +3)
        ]);
    });

    this.fight = new ChoiceController(id, "fight");

    this.defence = new ChangeController(id, "defence", function () {
        global.kobold.status.physical.decrease(10, "Fighting the basilisk");
        global.kobold.status.mental.increase(5, "Scared off basilisk");
        global.kobold.status.stamina.decrease(10, "Defensive combat");
    }, function () {
        return global.ui.change.buildNotification([
            new Change("Broke hand", "Health", -10),
            new Change("Broke hand", "Sanity", -5),
            new Change("Scared off the basilisk", "Sanity", +10),
            new Change("Defensive combat", "Stamina", -10)
        ]);
    });

    /*this.defencePatch = new ChoiceController(id, "defencePatch");
     
     this.defencePatchTake = new ChangeController(id, "defencePatchTake", function () {
     
     }, function () {
     return global.ui.change.buildNotification([
     new Change("TODO", "CHANGE", +1)
     ]);
     });*/

    this.defenceLeave = new ChangeController(id, "defenceLeave", function () {
        global.kobold.status.physical.increase(2, "Fixed hand");
        global.kobold.status.mental.decrease(3, "Escaping the cave");
        global.kobold.status.stamina.increase(3, "Minor reprieve");
    }, function () {
        return global.ui.change.buildNotification([
            new Change("Fixed hand", "Health", +2),
            new Change("Intense pain", "Sanity", -6),
            new Change("Escaped the cave", "Sanity", +3),
            new Change("Minor reprieve", "Stamina", +3)
        ]);
    });

    this.offenceWin = new ChangeController(id, "offenceWin", function () {
        global.kobold.status.mental.decrease(6, "Killing the basilisk");
        global.kobold.status.stamina.decrease(8, "Combat");
    }, function () {
        return global.ui.change.buildNotification([
            new Change("Killed a monster", "Sanity", +4),
            new Change("Became the monster?", "Sanity", -10),
            new Change("Combat", "Stamina", -8)
        ]);
    });

    this.offenceLoot = new ChangeController(id, "offenceLoot", function () {
        global.kobold.status.mental.increase(3, "Escaped the cave");
        global.kobold.status.stamina.increase(3, "Minor reprieve");
        global.kobold.inventory.bag.addMisc(new BasiliskScales());
    }, function () {
        return global.ui.change.buildNotification([
            new Change("Escaped the cave", "Sanity", +3),
            new Change("Minor reprieve", "Stamina", +3),
            new Change("Trophies", global.kobold.inventory.createItemWithTooltip(new BasiliskScales(), true), +1)
        ]);
    });

    this.wrestleWin = new UndoController(id, "wrestleWin", function () {
        global.kobold.status.physical.decrease(18, "Repeatedly crushed");
        global.kobold.status.mental.decrease(4, "Head crushed");
        global.kobold.status.stamina.decrease(15, "Intense struggle");
    }, function () {
        return global.ui.change.buildNotification([
            new Change("Repeatedly crushed", "Health", -18),
            new Change("Head crushed", "Sanity", -4),
            new Change("Intense struggle", "Stamina", -15)
        ]);
    });

    this.snap = new ChangeController(id, "snap", function () {
        global.kobold.status.mental.decrease(6, "Killing the basilisk");
    }, function () {
        return global.ui.change.buildNotification([
            new Change("Killed a monster", "Sanity", +4),
            new Change("Became the monster?", "Sanity", -10)
        ]);
    });

    this.snapLeave = new ChangeController(id, "snapLeave", function () {
        global.kobold.status.mental.increase(3, "Escaped the cave");
        global.kobold.status.stamina.increase(3, "Minor reprieve");
        global.kobold.inventory.bag.addMisc(new BasiliskScales());
    }, function () {
        return global.ui.change.buildNotification([
            new Change("Escaped the cave", "Sanity", +3),
            new Change("Minor reprieve", "Stamina", +3),
            new Change("Trophies", global.kobold.inventory.createItemWithTooltip(new BasiliskScales(), true), +1)
        ]);
    });

    this.letGo = new ChangeController(id, "letGo", function () {
        global.kobold.status.physical.increase(3, "Drinking water");
        global.kobold.status.mental.increase(8, "Sparing the basilisk");
        global.kobold.status.stamina.increase(3, "Drinking water");
    }, function () {
        return global.ui.change.buildNotification([
            new Change("Fresh water", "Health", +3),
            new Change("Spared a life", "Sanity", +8),
            new Change("Fresh water", "Stamina", +3)
        ]);
    });

    this.letGoLeave = new ChangeController(id, "letGoLeave", function () {
        global.kobold.status.mental.increase(3, "Escaping the cave");
        global.kobold.status.stamina.increase(3, "Minor reprieve");
    }, function () {
        return global.ui.change.buildNotification([
            new Change("Escaped the cave", "Sanity", +3),
            new Change("Minor reprieve", "Stamina", +3)
        ]);
    });

    this.dominance = new UndoController(id, "dominance", function () {
        // Unused.
    }, function () {
        return global.ui.change.buildNotification([
            new Change("TODO", "CHANGE", +1)
        ]);
    });

    this.pee = new ChangeController(id, "pee", function () {
        global.kobold.status.mental.increase(6, "Peeing on a basilisk");
        global.kobold.status.stamina.increase(5, "Relaxing whizz");
    }, function () {
        return global.ui.change.buildNotification([
            new Change("Dominated foe", "Sanity", +10),
            new Change("Peeing on a feral", "Sanity", -4),
            new Change("Relaxing whizz", "Stamina", +5)
        ]);
    });

    this.oral = new ChangeController(id, "oral", function () {
        if (that.misc.dick()) {
            global.kobold.status.mental.increase(14, "Facefucked a basilisk");
            global.kobold.status.exertion.increase(16, "Facefucked a basilisk");
            global.kobold.body.dickVirgin = false;

        } else {
            global.kobold.status.mental.increase(14, "Eaten out by a basilisk");
            global.kobold.status.exertion.increase(16, "Eaten out by a basilisk");
        }
    }, function () {
        if (that.misc.dick()) {
            return global.ui.change.buildNotification([
                new Change("Dominated foe", "Sanity", +12),
                new Change("Tempted fate", "Sanity", -2),
                new Change("Fucked a feral", "Sanity", -4),
                new Change("Reached climax", "Sanity", +8),
                new Change("Facefucked the basilisk", "Sexual exhaustion", +12, true),
                new Change("Reached climax", "Sexual exhaustion", +4, true)
            ]);
        } else {
            return global.ui.change.buildNotification([
                new Change("Dominated foe", "Sanity", +12),
                new Change("Tempted fate", "Sanity", -2),
                new Change("Fucked a feral", "Sanity", -4),
                new Change("Reached climax", "Sanity", +8),
                new Change("Eaten out by the basilisk", "Sexual exhaustion", +12, true),
                new Change("Reached climax", "Sexual exhaustion", +4, true)
            ]);
        }
    });

    this.sex = new ChangeController(id, "sex", function () {
        if (that.misc.dick()) {
            global.kobold.status.mental.increase(14, "Fucking a basilisk");
            global.kobold.status.stamina.decrease(7, "Fucking a basilisk");
            global.kobold.status.exertion.increase(24, "Fucking a basilisk");
            global.kobold.body.dickVirgin = false;
        } else {
            global.kobold.status.mental.increase(6, "Abusing a basilisk");
            global.kobold.status.exertion.increase(5, "Abusing a basilisk");
        }
    }, function () {
        if (that.misc.dick()) {
            return global.ui.change.buildNotification([
                new Change("Dominated foe", "Sanity", +12),
                new Change("Tempted fate", "Sanity", -2),
                new Change("Fucked a feral", "Sanity", -4),
                new Change("Reached climax", "Sanity", +8),
                new Change("Intense sex", "Stamina", -7),
                new Change("Fucked the basilisk", "Sexual exhaustion", +20, true),
                new Change("Reached climax", "Sexual exhaustion", +4, true)
            ]);
        } else {
            return global.ui.change.buildNotification([
                new Change("Dominated foe", "Sanity", +12),
                new Change("Tempted fate", "Sanity", -2),
                new Change("Fingered a feral", "Sanity", -2),
                new Change("Rimmed a feral", "Sanity", -2),
                new Change("Abused basilisk", "Sexual exhaustion", +3, true),
                new Change("Smell of cum", "Sexual exhaustion", +2, true)
            ]);
        }
    });

    this.dominanceLeave = new ChangeController(id, "dominanceLeave", function () {
        global.kobold.status.mental.increase(3, "Escaped the cave");
        global.kobold.status.stamina.increase(3, "Minor reprieve");
    }, function () {
        return global.ui.change.buildNotification([
            new Change("Escaped the cave", "Sanity", +3),
            new Change("Minor reprieve", "Stamina", +3)
        ]);
    });

    this.preContinue = new ChoiceController(id, "preContinue");

    this.choices = {
        doggo: {
            PET: 1,
            FETCH: 2,
            FEED: 3
        }
    };

    this.reflectFail = new ChangeController(id, "reflectFail", function () {
        global.kobold.status.physical.decrease(2, "Cut hand");
        global.kobold.status.mental.decrease(10, "Being petrified");
        global.kobold.inventory.bag.removeMisc(ItemEnum.SMALL_MIRROR, 1);
    }, function () {
        return global.ui.change.buildNotification([
            new Change("Cut hand", "Health", -6),
            new Change("Wound petrified", "Health", +4),
            new Change("Petrification", "Sanity", -6),
            new Change("Panic", "Sanity", -4),
            new Change("Mirror broke", global.kobold.inventory.createItemWithTooltip(new SmallMirror(), true), -1)
        ]);
    });

    this.reflectSucceed = new ChangeController(id, "reflectSucceed", function () {
        global.kobold.status.physical.decrease(6, "Cut hand");
        global.kobold.status.mental.increase(6, "Besting the basilisk");
        global.kobold.inventory.bag.removeMisc(ItemEnum.SMALL_MIRROR, 1);
    }, function () {
        return global.ui.change.buildNotification([
            new Change("Cut hand", "Health", -6),
            new Change("Panic", "Sanity", -4),
            new Change("Heroism", "Sanity", +5),
            new Change("Bested basilisk", "Sanity", +5),
            new Change("Mirror broke", global.kobold.inventory.createItemWithTooltip(new SmallMirror(), true), -1)
        ]);
    });

    this.reflectStrike = new ChangeController(id, "reflectStrike", function () {
        global.kobold.status.mental.decrease(5, "Killing the basilisk");
    }, function () {
        return global.ui.change.buildNotification([
            new Change("Killed a vicious creature?", "Sanity", +3),
            new Change("Murdered an animal", "Sanity", -4),
            new Change("Did not accept surrender", "Sanity", -4)
        ]);
    });

    this.reflectStrikeContinue = new ChangeController(id, "reflectStrikeContinue", function () {
        global.kobold.status.mental.increase(3, "Escaped the cave");
        global.kobold.status.stamina.increase(3, "Minor reprieve");
        global.kobold.inventory.bag.addMisc(new BasiliskScales());
    }, function () {
        return global.ui.change.buildNotification([
            new Change("Escaped the cave", "Sanity", +3),
            new Change("Minor reprieve", "Stamina", +3),
            new Change("Trophies", global.kobold.inventory.createItemWithTooltip(new BasiliskScales(), true), +1)
        ]);
    });

    this.reflectLeave = new ChangeController(id, "reflectLeave", function () {
        global.kobold.status.mental.increase(4, "Refrained from violence");
    }, function () {
        return global.ui.change.buildNotification([
            new Change("Refrained from violence", "Sanity", +4)
        ]);
    });

    this.reflectLeaveContinue = new ChangeController(id, "reflectLeaveContinue", function () {
        global.kobold.status.mental.increase(3, "Escaped the cave");
        global.kobold.status.stamina.increase(3, "Minor reprieve");
    }, function () {
        return global.ui.change.buildNotification([
            new Change("Escaped the cave", "Sanity", +3),
            new Change("Minor reprieve", "Stamina", +3)
        ]);
    });

    this.reflectPetrify = new ChangeController(id, "reflectPetrify", function () {
        global.kobold.status.mental.decrease(2, "Petrifying the basilisk");
    }, function () {
        return global.ui.change.buildNotification([
            new Change("Killed a vicious creature?", "Sanity", +3),
            new Change("Murdered an animal", "Sanity", -4),
            new Change("Did not accept surrender", "Sanity", -4),
            new Change("Delicious irony", "Sanity", +3)
        ]);
    });

    this.reflectPetrifyContinue = new ChangeController(id, "reflectPetrifyContinue", function () {
        global.kobold.status.mental.increase(3, "Escaped the cave");
        global.kobold.status.stamina.increase(3, "Minor reprieve");
    }, function () {
        return global.ui.change.buildNotification([
            new Change("Escaped the cave", "Sanity", +3),
            new Change("Minor reprieve", "Stamina", +3)
        ]);
    });

    this.reflectDominance = new ChoiceController(id, "reflectDominance");

    this.reflectOral = new ChangeController(id, "reflectOral", function () {
        if (that.misc.dick()) {
            global.kobold.status.mental.increase(14, "Facefucked a basilisk");
            global.kobold.status.exertion.increase(16, "Facefucked a basilisk");
            global.kobold.body.dickVirgin = false;

        } else {
            global.kobold.status.mental.increase(14, "Eaten out by a basilisk");
            global.kobold.status.exertion.increase(16, "Eaten out by a basilisk");
        }
    }, function () {
        if (that.misc.dick()) {
            return global.ui.change.buildNotification([
                new Change("Served by basilisk", "Sanity", +12),
                new Change("Tempted fate", "Sanity", -2),
                new Change("Fucked a feral", "Sanity", -4),
                new Change("Reached climax", "Sanity", +8),
                new Change("Facefucked the basilisk", "Sexual exhaustion", +12, true),
                new Change("Reached climax", "Sexual exhaustion", +4, true)
            ]);
        } else {
            return global.ui.change.buildNotification([
                new Change("Served by basilisk", "Sanity", +12),
                new Change("Tempted fate", "Sanity", -2),
                new Change("Fucked a feral", "Sanity", -4),
                new Change("Reached climax", "Sanity", +8),
                new Change("Eaten out by the basilisk", "Sexual exhaustion", +12, true),
                new Change("Reached climax", "Sexual exhaustion", +4, true)
            ]);
        }
    });

    this.reflectOralContinue = new ChangeController(id, "reflectOralContinue", function () {
        global.kobold.status.mental.increase(3, "Escaped the cave");
        global.kobold.status.stamina.increase(3, "Minor reprieve");
    }, function () {
        return global.ui.change.buildNotification([
            new Change("Escaped the cave", "Sanity", +3),
            new Change("Minor reprieve", "Stamina", +3)
        ]);
    });

    this.reflectSex = new ChangeController(id, "reflectSex", function () {
        global.kobold.body.oralVirgin = false;
        if (that.misc.dick()) {
            global.kobold.status.mental.increase(14, "Fucking a basilisk");
            global.kobold.status.stamina.decrease(7, "Fucking a basilisk");
            global.kobold.status.exertion.increase(28, "Fucking a basilisk");
            global.kobold.body.dickVirgin = false;
        } else {
            global.kobold.status.mental.increase(4, "Fingering a basilisk");
            global.kobold.status.exertion.increase(11, "Fingering a basilisk");
            global.kobold.body.vaginalVirgin = false;
        }
    }, function () {
        if (that.misc.dick()) {
            return global.ui.change.buildNotification([
                new Change("Buttfucked basilisk", "Sanity", +12),
                new Change("Tempted fate", "Sanity", -2),
                new Change("Fucked a feral", "Sanity", -2),
                new Change("Sucked a feral", "Sanity", -2),
                new Change("Reached climax", "Sanity", +8),
                new Change("Intense sex", "Stamina", -7),
                new Change("Fucked the basilisk", "Sexual exhaustion", +20, true),
                new Change("Sucked the basilisk", "Sexual exhaustion", +4, true),
                new Change("Reached climax", "Sexual exhaustion", +4, true)
            ]);
        } else {
            return global.ui.change.buildNotification([
                new Change("Basilisk blowjob", "Sanity", +12),
                new Change("Tempted fate", "Sanity", -2),
                new Change("Fingered a feral", "Sanity", -2),
                new Change("Rimmed a feral", "Sanity", -2),
                new Change("Sucked a feral", "Sanity", -2),
                new Change("Fingered basilisk", "Sexual exhaustion", +3, true),
                new Change("Sucked basilisk", "Sexual exhaustion", +4, true),
                new Change("Smell of cum", "Sexual exhaustion", +2, true),
                new Change("Taste of cum", "Sexual exhaustion", +2, true)
            ]);
        }
    });

    this.reflectSexContinue = new ChangeController(id, "reflectSexContinue", function () {
        global.kobold.status.mental.increase(3, "Escaped the cave");
        global.kobold.status.stamina.increase(3, "Minor reprieve");
    }, function () {
        return global.ui.change.buildNotification([
            new Change("Escaped the cave", "Sanity", +3),
            new Change("Minor reprieve", "Stamina", +3)
        ]);
    });

    this.reflectSub = new ChoiceController(id, "reflectSub");

    this.reflectOutside = new ChangeController(id, "reflectOutside", function () {
        var shirt = global.kobold.inventory.equipment.shirt;
        shirt && shirt.stain("Basilisk Cum");
        if (that.misc.dick()) {
            global.kobold.status.physical.decrease(4, "Riding a basilisk");
            global.kobold.status.mental.increase(20, "Riding a basilisk");
            global.kobold.status.stamina.decrease(13, "Riding a basilisk");
            global.kobold.status.exertion.increase(30, "Riding a basilisk");
            global.kobold.body.analVirgin = false;
        } else {
            global.kobold.status.physical.decrease(4, "Riding a basilisk");
            global.kobold.status.mental.increase(20, "Riding a basilisk");
            global.kobold.status.stamina.decrease(13, "Riding a basilisk");
            global.kobold.status.exertion.increase(30, "Riding a basilisk");
            global.kobold.body.vaginalVirgin = false;
        }
    }, function () {
        if (that.misc.dick()) {
            return global.ui.change.buildNotification([
                new Change("Very sore", "Health", -4),
                new Change("Rode basilisk", "Sanity", +10),
                new Change("Fucked a feral", "Sanity", -4),
                new Change("Kissed a feral", "Sanity", -2),
                new Change("Immense climax", "Sanity", +10),
                new Change("Scaly lover", "Sanity", +6),
                new Change("Overly intense sex", "Stamina", -13),
                new Change("Rode basilisk", "Sexual exhaustion", +26, true),
                new Change("Reached climax", "Sexual exhaustion", +4, true)
            ]);
        } else {
            return global.ui.change.buildNotification([
                new Change("Very sore", "Health", -4),
                new Change("Rode basilisk", "Sanity", +10),
                new Change("Fucked a feral", "Sanity", -4),
                new Change("Kissed a feral", "Sanity", -2),
                new Change("Intense climax", "Sanity", +8),
                new Change("Scaly lover", "Sanity", +6),
                new Change("Overly intense sex", "Stamina", -13),
                new Change("Rode basilisk", "Sexual exhaustion", +26, true),
                new Change("Reached climax", "Sexual exhaustion", +4, true)
            ]);
        }
    });

    this.reflectInside = new ChangeController(id, "reflectInside", function () {
        var shirt = global.kobold.inventory.equipment.shirt;
        shirt && shirt.stain("Basilisk Cum");
        if (that.misc.dick()) {
            global.kobold.status.physical.decrease(4, "Riding a basilisk");
            global.kobold.status.mental.increase(20, "Riding a basilisk");
            global.kobold.status.stamina.decrease(13, "Riding a basilisk");
            global.kobold.status.exertion.increase(35, "Riding a basilisk");
            global.kobold.body.analVirgin = false;
        } else {
            global.kobold.status.physical.decrease(4, "Riding a basilisk");
            global.kobold.status.mental.increase(16, "Riding a basilisk");
            global.kobold.status.stamina.decrease(13, "Riding a basilisk");
            global.kobold.status.exertion.increase(35, "Riding a basilisk");
            global.kobold.body.vaginalVirgin = false;
        }
    }, function () {
        if (that.misc.dick()) {
            return global.ui.change.buildNotification([
                new Change("Very sore", "Health", -4),
                new Change("Rode basilisk", "Sanity", +10),
                new Change("Fucked a feral", "Sanity", -4),
                new Change("Kissed a feral", "Sanity", -2),
                new Change("Immense climax", "Sanity", +10),
                new Change("Scaly lover", "Sanity", +6),
                new Change("Overly intense sex", "Stamina", -13),
                new Change("Rode basilisk", "Sexual exhaustion", +26, true),
                new Change("Reached climax", "Sexual exhaustion", +4, true),
                new Change("It came inside", "Sexual exhaustion", +5, true)
            ]);
        } else {
            return global.ui.change.buildNotification([
                new Change("Very sore", "Health", -4),
                new Change("Rode basilisk", "Sanity", +10),
                new Change("Fucked a feral", "Sanity", -4),
                new Change("Kissed a feral", "Sanity", -2),
                new Change("Double climax", "Sanity", +10),
                new Change("Scaly lover", "Sanity", +6),
                new Change("Pregnant?", "Sanity", -4),
                new Change("Overly intense sex", "Stamina", -13),
                new Change("Rode basilisk", "Sexual exhaustion", +26, true),
                new Change("Reached climax", "Sexual exhaustion", +4, true),
                new Change("It came inside", "Sexual exhaustion", +5, true)
            ]);
        }
    });

    this.reflectSubContinue = new ChangeController(id, "reflectSubContinue", function () {
        global.kobold.status.mental.increase(3, "Escaped the cave");
        global.kobold.status.stamina.increase(3, "Minor reprieve");
    }, function () {
        return global.ui.change.buildNotification([
            new Change("Escaped the cave", "Sanity", +3),
            new Change("Minor reprieve", "Stamina", +3)
        ]);
    });

    this.fragments = {};
    this.fragments.fight = new UndergroundCaveFight(this);
    this.fragments.surface = new UndergroundCaveSurface(this); // Needs to be separate or else can't access the fragments variable itself.

    this.bgm = new AudioController(id, "res/audio/effects/cave.mp3", 70);

    // PUBLIC FUNCTIONS \\      this.publicFunction = function(){};

}

// END scenes\HamletDay2\UndergroundCave\UndergroundCaveController.js

// scenes\HamletDay2\UndergroundCave\UndergroundCave.js

/**
 * Underground cave after the well.
 */
function UndergroundCave() {
    // PRIVATE MEMBERS \\       var private = "test";
    var that = this;
    var sceneId = "UndergroundCave";
    var sceneName = "Underground Cave";
    var sceneSubfolder = "HamletDay2";
    var ctrl = new UndergroundCaveController(sceneId);
    var arrival = new UndergroundCaveArrival(ctrl);

    // PRIVATE FUNCTIONS \\     function privateFunction(){}

    /**
     * Sets all the required global variables such as scene id, scene name,
     * scene stack and theme.
     */
    function setGlobals() {
        global.currentScene = that.id;
        global.currentSceneName = that.name;
        global.currentSceneFolder = that.subfolder ? that.subfolder : "";
        global.kobold.history.addToSceneStack(that.id);
    }

    /**
     * Builds the tab as a HTML string.
     * @returns {string} The tab, as a HTML string.
     */
    function buildTab() {
        var tab = global.ui.buildGenericHeader();
        tab += global.parser.parse(`[t]the CaVe[/t]`);
        tab += global.parser.parse(`[st]Underwater tunnel[/st]`);
        tab += arrival.build();
        tab += global.ui.buildGenericFooter();
        return tab;
    }

    // PUBLIC MEMBERS \\        this.public = "test";
    this.id = sceneId;
    this.name = sceneName;
    this.subfolder = sceneSubfolder;

    // PUBLIC FUNCTIONS \\      this.publicFunction = function(){};

    /**
     * Loads this scene.
     */
    this.load = function () {
        setGlobals();
        var tab = buildTab();
        global.ui.loadToMain(tab);
        arrival.registerListeners();
        ctrl.autosave();
    };
}

global.sceneLoader.queueRegister(function () {
    var scene = new UndergroundCave();
    global.sceneLoader.registerScene(scene.id, scene);
});

// END scenes\HamletDay2\UndergroundCave\UndergroundCave.js



// END SCENE UndergroundCave

